angular.module('selae.bets.controllers')
  .controller('MyBetDetailCtrl', ['config', 'opSrv', 'popupSrv', 'requestSrv', '$filter', '$scope', '$rootScope', '$ionicScrollDelegate', '$ionicHistory', '$state', 'analyticsSrv', 'gamesProvider',
    function (config, opSrv, popupSrv, requestSrv, $filter, $scope, $rootScope, $ionicScrollDelegate, $ionicHistory, $state, analyticsSrv, gamesProvider) {

      $scope.getBetTemplateUrl = function (myBet) {
        return "bets/templates/my-bet-detail-game-" + myBet.ApuestaDto.idJuego + ".html";
      };

      $scope.bets = [];
      $scope.resultado = [];
      $scope.dates = "";
      var hola = 0;
      var vueltas = 0;

      $scope.formatResult = function () {
        $scope.precio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].precioBoletoEuros;
        $scope.betId = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestaId;
        switch ($rootScope.viewMoreBet.ApuestaDto.idJuego) {
          case 1:
            $scope.formatPrimitiva();
            break;
          case 2:
            $scope.formatQuiniela();
            break;
          case 3:
            $scope.formatEuromillon();
            break;
          case 4:
            $scope.formatBonoloto();
            break;
          case 5:
            $scope.formatElgordo();
            break;
          case 6:
            $scope.formatQuinigol();
            break;
          case 7:
            $scope.formatLototurf();
            break;
          case 8:
            $scope.formatQuintupleplus();
            break;
          case 9:
            $scope.formatLoterianacionaljueves();
            break;
          case 10:
            $scope.formatLoterianacionaljueves();
            break;
          default:
            console.log("Recibida una apuesta no reconocida");
        }
      };

      $scope.formatPrimitiva = function () {
        $scope.bets = [];
        $scope.reintegro = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].reintegro;
        $scope.joker = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].combinacionAsociado;
        $scope.estado = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].estado;
        $scope.estadoPremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.estado;
        $scope.importePremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.importeBruto / 100;
        // $scope.categorias = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.listaPremioDetalle;

        var detallesApuesta = $rootScope.viewMoreBet.detalleApuesta.categoriaApuestas[0].listaCategorias;
       
        if ( $rootScope.viewMoreBet.detalleApuesta.categoriaApuestas[1] ) {
          detallesApuesta = detallesApuesta.concat($rootScope.viewMoreBet.detalleApuesta.categoriaApuestas[1].listaCategorias);
        }
        $scope.categorias = betCategory(detallesApuesta);
        //Formateamos la apuesta del usuario
        angular.forEach($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestasFormateadas, function (value, key) {
          this.push(value.split(","));
        }, $scope.bets);
      };

      $scope.formatQuiniela = function () {
        $scope.bets = [];
        $scope.matches = [];
        $scope.estado = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].estado;
        $scope.estadoPremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.estado;
        $scope.importePremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.importeBruto / 100;
        $scope.categorias = betCategory($rootScope.viewMoreBet.detalleApuesta.categoriaApuestas[0].listaCategorias);

        $scope.playElige8 = $rootScope.viewMoreBet.playElige8;
        $scope.arrayElige8 = $rootScope.viewMoreBet.arrayElige8;

        if($scope.playElige8) {
          $scope.precioElige8 = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestaJuegoAsociado.importe / 100;
        }
        //TODO como ahora en la pantalla de confirmación de la apuesta, los pronósticos de elige8 los coge del rootscope, los metemos ahí.
        //Esto habría que hacerlo de alguna manera más elegante.
        $rootScope.pronosticoElige8 = false;
        if($scope.arrayElige8 !== undefined) {
          $rootScope.pronosticoElige8 = $scope.arrayElige8.map(function(value) {
            return String(value);
          });
        }

        angular.forEach($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestasFormateadas, function (value, key) {
          this.push(value.split(","));
        }, $scope.bets);

        angular.forEach($rootScope.viewMoreBet.detalleApuesta.partidos, function (value, key) {
          this.push(value.nombreLocal + "-" + value.nombreVisitante);
        }, $scope.matches);

        $scope.plenoMatch = $scope.matches[14];
        if ($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].metodo == 'Condicionadas') {
          $scope.pleno = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].combinacion.split(':')[1].split('/')[0].split('=')[1];
          $scope.condiciones = {
            V: $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].combinacion.split(':')[1].split('/')[1].split('*')[1].split('=')[1],
            X: $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].combinacion.split(':')[1].split('/')[1].split('*')[2].split('=')[1],
            D: $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].combinacion.split(':')[1].split('/')[1].split('*')[3].split('=')[1]
          };
        } else {
          $scope.pleno = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].combinacion.split(":")[1].split("=")[1];
        }
        $scope.matches.splice(14, 14);
        $scope.plenoAl15Data = matchPlenos($scope.pleno);

					function matchPlenos (data) {
						var saveData = {
							'firstTeam' : [],
							'secondTeam' : []
						};
						var games = data.split(',');
						games.forEach(function(element) {
							element = element.split('-');
							if ( saveData.firstTeam.indexOf(element[0]) === -1 ) {
								saveData.firstTeam.push(element[0]);
							}
							if ( saveData.secondTeam.indexOf(element[1]) === -1 ) {
								saveData.secondTeam.push(element[1]);
							}
						});
						return saveData;
					};
      };

      $scope.formatEuromillon = function () {
        $scope.bets = [];
        var asociado = $filter('filter')($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].rifas, {
          idJuego: 11
        });
        $scope.millon = asociado.length > 0 ? asociado[0].rangos : undefined;
        asociado = $filter('filter')($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].rifas, {
          idJuego: 12
        });
        $scope.lluvia = asociado.length > 0 ? asociado[0].rangos : undefined;
        $scope.estado = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].estado;
        $scope.estadoPremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.estado;
        $scope.importePremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.importeBruto / 100;
        $scope.categorias = betCategory($rootScope.viewMoreBet.detalleApuesta.categoriaApuestas[0].listaCategorias);


        //Comprobamos que la lluvia de millones y el millon no es solo un número. Si es solo un número y no una serie se muestra un solo número.
        try {
          var res = $scope.millon.split("-");
          if (res[0] === res[1]) {
            $scope.millon = res[0];
          }
        } catch (err) {
          console.log("Millon undefined");
        }
        try {
          var lluv = $scope.lluvia.split("-");
          if (lluv[0] === lluv[1]) {
            $scope.lluvia = lluv[0];
          }
        } catch (err) {
          console.log("Millon undefined");
        }

        angular.forEach($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestasFormateadas, function (value, key) {
          var bet = {
            numbers: value.split(":")[0].split(','),
            stars: value.split(":")[1].split(',')
          };
          $scope.bets.push(bet);
        });
      };

      $scope.formatBonoloto = function () {
        $scope.bets = [];
        $scope.reintegro = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].reintegro;
        $scope.estado = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].estado;
        $scope.estadoPremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.estado;
        $scope.importePremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.importeBruto / 100;
        $scope.categorias = betCategory($rootScope.viewMoreBet.detalleApuesta.categoriaApuestas[0].listaCategorias);

        //Formateamos la apuesta del usuario
        angular.forEach($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestasFormateadas, function (value, key) {
          this.push(value.split(","));
        }, $scope.bets);
      };

      $scope.formatElgordo = function () {
        $scope.bets = [];
        $scope.clave = getClave($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].combinacion);
        $scope.estado = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].estado;
        $scope.estadoPremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.estado;
        $scope.importePremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.importeBruto / 100;
        $scope.categorias = betCategory($rootScope.viewMoreBet.detalleApuesta.categoriaApuestas[0].listaCategorias);

        //Formateamos la apuesta del usuario
        angular.forEach($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestasFormateadas, function (value, key) {
            if ($rootScope.viewMoreBet.gordoV2) {
                var gCombination = value.split(':');
                this.push(gCombination[0].split(","));
            } else {
            this.push(value.split(","));
          }
        }, $scope.bets);

        function getClave (combinacion) {
            if ($rootScope.viewMoreBet.gordoV2) {
            return combinacion.split('=').map(function(value){
                if (value.indexOf(':')!== -1) {
                    return value.slice(value.indexOf(':')+1,value.indexOf(':')+2);
                }}).filter(Boolean)}
          return $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].reintegro;
        }
      };

      $scope.formatQuinigol = function () {
        $scope.bets = [];
        $scope.matches = [];
        $scope.estado = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].estado;
        $scope.estadoPremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.estado;
        $scope.importePremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.importeBruto / 100;
        $scope.categorias = betCategory($rootScope.viewMoreBet.detalleApuesta.categoriaApuestas[0].listaCategorias);

        angular.forEach($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestasFormateadas, function (value, key) {
          this.push(value.split(","));
        }, $scope.bets);

        angular.forEach($rootScope.viewMoreBet.detalleApuesta.partidos, function (value, key) {
          this.push(value.nombreLocal + "-" + value.nombreVisitante);
        }, $scope.matches);
      };

      $scope.formatLototurf = function () {
        $scope.bets = [];
        $scope.reintegro = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].reintegro;
        $scope.estado = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].estado;
        $scope.estadoPremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.estado;
        $scope.importePremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.importeBruto / 100;
        $scope.categorias = betCategory($rootScope.viewMoreBet.detalleApuesta.categoriaApuestas[0].listaCategorias);

        //Formateamos la apuesta del usuario
        angular.forEach($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestasFormateadas, function (value, key) {
          var bet = {
            numbers: value.split(":")[0].split(','),
            horses: value.split(":")[1].split(';')[0].split(',')
          };
          this.push(bet);
        }, $scope.bets);
      };

      $scope.formatQuintupleplus = function () {
        $scope.bets = [];
        var races = [
          $filter('translate')('horseRace1'),
          $filter('translate')('horseRace2'),
          $filter('translate')('horseRace3'),
          $filter('translate')('horseRace4'),
          $filter('translate')('horseRace51'),
          $filter('translate')('horseRace52')
        ];
        $scope.estado = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].estado;
        $scope.estadoPremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.estado;
        $scope.importePremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.importeBruto / 100;
        $scope.categorias = betCategory($rootScope.viewMoreBet.detalleApuesta.categoriaApuestas[0].listaCategorias);

        angular.forEach($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestasFormateadas, function (value, key) {
          var bet = {
            horses: value.split(","),
            race: races[key]
          };
          this.push(bet);
        }, $scope.bets);
      };

      $scope.formatLoterianacionaljueves = function () {
        $scope.estado = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].estado;
        $scope.estadoPremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.estado;
        $scope.importePremio = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].PremioDTO.importeBruto / 100;
        $scope.categorias = betCategory($rootScope.viewMoreBet.detalleApuesta.categoriaApuestas[0].listaCategorias);
        $scope.number = "";
        $scope.fraction = "";
        $scope.serie = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestasFormateadas[0].split(':')[1];

        angular.forEach($rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].apuestasFormateadasParaResguardo, function (value, key) {
          $scope.number = $scope.number + value;
        });
        console.log($scope.number);

        var combinaciones = $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].combinacionCentral.split(".");

        angular.forEach(combinaciones, function (value, key) {
          if (value !== "") {
            var combinacionAux = value.split(":");
            $scope.fraction = $scope.fraction + combinacionAux[2];
            if (key != combinaciones.length - 1) {
              $scope.fraction = $scope.fraction + ", ";
            }
          }
        });
        console.log($scope.fraction, "bucle");
      };



      function comprobarAciertosPrimitiva () {
          try {
          var ganador = $scope.hits.map(function (i) {
            return Number(i);
          });
        } catch (e) {
          console.info("Aún no tenemos los datos de la apuesta ganadora");
        }
        resultadoReintegro = false;
          var resultado = [];
          var resultadoComplementario;
          var complementarioHit = [];
          for (i = 0; i < $scope.bets.length; i++) {
            var apuesta = $scope.bets[i];
            apuesta = apuesta.map(function(i){return Number(i); });
            resultadoActual = apuesta.checkHitse(ganador);
            resultado = resultado.concat(resultadoActual);
            console.log("resultadoActual", resultadoActual);
            console.log("resultado",resultado);
          }
          if ($scope.reintegro && (parseInt($scope.reintegro) === parseInt($scope.reintegroHit))) {
            resultadoReintegro = true;
            console.log("resultadoReintegro", resultadoReintegro);
          }
          if ($scope.complementarioHit) {
            complementarioHit = complementarioHit.concat(parseInt($scope.complementarioHit));
                var apuestaAr = [];
                for (i = 0; i < $scope.bets.length; i++) {
                  apuestaAr = apuestaAr.concat($scope.bets[i]);
                }
              apuestaAr = apuestaAr.map(function(i){return Number(i); });
              resultadoComplementario = apuestaAr.checkHitse(complementarioHit);
          }
          if (!resultado.length && !resultadoReintegro && !resultadoComplementario.length) {
            popupSrv.showErrorPopup($filter('translate')("noAciertos"));
          } else {console.log("Tenemos aciertos");}
        }

        function comprobarAciertosQuiniela () {
          try {
          var ganador = $scope.hits;
        } catch (e) {
          console.info("Aún no tenemos los datos de la apuesta ganadora");
        }
        console.log("apuesta ganadora",ganador);
          // Comparamos nuestra combinación con la ganadora
          var apuesta = $scope.bets;
          console.log("$scope.bets",apuesta);
          
           // comprobamos los partidos
          var resultadoCombi = false;
           for (i=0; i<apuesta.length; i++) {
            var ar = apuesta[i];
             for (j=0; j<ar.length; j++) {
              var comprobar = ar[j].indexOf(ganador[j]);
               if (comprobar !== -1) {
                 resultadoCombi = true;
               }
             }
           }

           //comprobamos el pleno al 15
          var pleno = $scope.pleno.split(",");
           console.log("$scope.pleno",pleno);
          var plenoHit = $scope.plenoHit;
           console.log("$scope.plenoHit",plenoHit);
           var resultadoPleno = pleno.indexOf(plenoHit);
           console.log("resultadoPleno",resultadoPleno);
          if (!resultadoCombi && resultadoPleno === -1) {
            popupSrv.showErrorPopup($filter('translate')("noAciertos"));
          } else {console.log("Tenemos aciertos");}
        }

        function comprobarAciertosEuromillon () {
          try {
          var ganador = $scope.hits.map(function (i) {
            return Number(i);
          });
        } catch (e) {
          console.info("Aún no tenemos los datos de la apuesta ganadora");
        }

          var apuesta = [];
          var resultadoStars = [];
           for (i = 0; i < $scope.bets.length; i++) {
            apuesta = apuesta.concat($scope.bets[i].numbers);
            resultadoStars = resultadoStars.concat($scope.bets[i].stars);
          }
          
          apuesta = apuesta.map(function(i){return Number(i); });
          resultado = apuesta.checkHitse(ganador);
          resultadoStars = resultadoStars.map(function(i){return Number(i); });
          var starsGanadoras = $scope.starHits;
          starsGanadoras = starsGanadoras.map(function(i){return Number(i); });
          resultadoStars = resultadoStars.checkHitse(starsGanadoras);          
          if (!resultado.length && !resultadoStars.length) {
            popupSrv.showErrorPopup($filter('translate')("noAciertos"));
          } else {console.log("Tenemos aciertos");}
        }

        function comprobarAciertosBonoloto () {
        console.log("Entra al general");
        console.log("<<<<<<<<<<<<$scope.hits>>>>>>>>>>>>>>>");
        console.log($scope.hits);
          try {
          var ganador = $scope.hits.map(function (i) {
            return Number(i);
          });
        } catch (e) {
          console.info("Aún no tenemos los datos de la apuesta ganadora");
        }

        resultadoReintegro = false;
          var apuesta = [];
          var complementarioHit = [];
          for (i = 0; i < $scope.bets.length; i++) {
            apuesta = apuesta.concat($scope.bets[i]);
          }
            apuesta = apuesta.map(function(i){return Number(i); });
            resultado = apuesta.checkHitse(ganador);
          if ($scope.reintegro && (parseInt($scope.reintegro) === parseInt($scope.reintegroHit))) {
            resultadoReintegro = true;
            console.log("resultadoReintegro", resultadoReintegro);
          }
          if ($scope.complementarioHit) {
            complementarioHit = complementarioHit.concat(parseInt($scope.complementarioHit));
                var apuestaAr = [];
                for (i = 0; i < $scope.bets.length; i++) {
                  apuestaAr = apuestaAr.concat($scope.bets[i]);
                }
              apuestaAr = apuestaAr.map(function(i){return Number(i); });
              resultadoComplementario = apuestaAr.checkHitse(complementarioHit);
          }
          if (!resultado.length && !resultadoReintegro && !resultadoComplementario.length) {
            popupSrv.showErrorPopup($filter('translate')("noAciertos"));
          } else {console.log("Tenemos aciertos");}
        }

        function comprobarAciertosElgordo () {
          try {
          var ganador = $scope.hits.map(function (i) {
            return Number(i);
          });
        } catch (e) {
          console.info("Aún no tenemos los datos de la apuesta ganadora");
        }
        
        var apuesta = [];
        var resultado = [];
        var resultadoReintegro = false;
          // Comparamos nuestra combinación con la ganadora
          for (i = 0; i < $scope.bets.length; i++) {
            apuesta = apuesta.concat($scope.bets[i]);
          }
          apuesta = apuesta.map(function(i){return Number(i); });
          resultado = apuesta.checkHitse(ganador);
          console.log("resultado",resultado)

          //hay que tener en cuenta que en el gordo podemos tener más de una clave. hay que comprobar todo el array
          if( $scope.clave && $rootScope.viewMoreBet.gordoV2 === true ) {
            for (i=0; i < $scope.clave.length; i++) {
              if(parseInt($scope.clave[i]) === parseInt($scope.reintegroHit)) {
                  resultadoReintegro = true;
              }
            }
          } else if ($scope.clave && (parseInt($scope.clave) === parseInt($scope.reintegroHit))) {
            resultadoReintegro = true;
          }
         
          if (!resultado.length && !resultadoReintegro) {
            popupSrv.showErrorPopup($filter('translate')("noAciertos"));
          } else {console.log("Tenemos aciertos");}
        }

        function comprobarAciertosQuinigol () {
          try {
          var ganador = $scope.hits;
        } catch (e) {
          console.info("Aún no tenemos los datos de la apuesta ganadora");
        }
          var apuesta = $scope.bets;
          console.log("$scope.bets",apuesta);

          var resultadoCombi = false;
           for (i=0; i<apuesta.length; i++) {
            var ar = apuesta[i];
             for (j=0; j<ar.length; j++) {
              var comprobar = ar[j].replace('-','').indexOf(ganador[i]);
              if (comprobar !== -1){
                resultadoCombi = true;
              }
             }
           }
          if (!resultadoCombi) {
            popupSrv.showErrorPopup($filter('translate')("noAciertos"));
          } else {console.log("Tenemos aciertos");}
        }

      function comprobarAciertosLototurf () {
        try {
          var ganador = $scope.hits;
        } catch (e) {
          console.info("Aún no tenemos los datos de la apuesta ganadora");
        }
          var apuesta = [];
          var caballos = [];
          var caballoHit = [];
          for (i = 0; i < $scope.bets.length; i++) {
            apuesta = apuesta.concat($scope.bets[i].numbers);
            caballos = caballos.concat($scope.bets[i].horses);
          }
          ganador = ganador.map(function(i){return Number(i); });
          apuesta = apuesta.map(function(i){return Number(i); });
          caballoHit = caballoHit.concat(parseInt($scope.horseHits));
          caballoHit = caballoHit.map(function(i){return Number(i); });
          caballos = caballos.map(function(i){return Number(i); });
          console.log("apuesta",apuesta);
          console.log("caballos",caballos);
          resultado = apuesta.checkHitse(ganador);
          resultadoCaballos = caballos.checkHitse(caballoHit);

          var resultadoReintegro = false;
          if ($scope.reintegro === parseInt($scope.reintegroHit)) {
            resultadoReintegro = true;
          }  

          if (!resultado.length && !resultadoCaballos.length && !resultadoReintegro) {
            popupSrv.showErrorPopup($filter('translate')("noAciertos"));
          } else {console.log("Tenemos aciertos");}
        }

        function comprobarAciertosQuintupleplus () {
          try {
          var ganador = $scope.hits;
        } catch (e) {
          console.info("Aún no tenemos los datos de la apuesta ganadora");
        }
          var apuesta = $scope.bets;
          var resultadoCombi = false;
           for (i=0; i<apuesta.length; i++) {
            var ar = apuesta[i].horses;
             for (j=0; j<ar.length; j++) {
              var comprobar = ar[j].indexOf(ganador[i]);
              if (comprobar !== -1){
                resultadoCombi = true;
              }
             }
           }
          if (!resultadoCombi) {
            popupSrv.showErrorPopup($filter('translate')("noAciertos"));
          } else {console.log("Tenemos aciertos");}
        }

       var betCategory = function (categoria) {
        return categoria.map(function(i) {
          if (i.CategoriasPorApuestaDto.numeroApuestasPremiadas > 0) {
            return {
              categoria : i.CategoriasPorApuestaDto.descripcionCategoria,
              apuestasPremiadas: i.CategoriasPorApuestaDto.numeroApuestasPremiadas
            }
          }
        }).filter(Boolean);
      }
      


      var formatResultPrimitiva = function (primitiva) {
        if (primitiva.combinacion !== null) {
          $scope.hits = [];
          var combinacion = primitiva.combinacion;
          var combinacionGanadora = combinacion.split(" - ");
          var ultimaposicion = combinacionGanadora[5].split(" ");
          combinacionGanadora[5] = ultimaposicion[0];
          var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
          var reintegro = ultimaposicion[2].replace("R(", "").replace(")", "");

          angular.forEach(combinacionGanadora, function (value, key) {
            this.push(value.replace(/^(?!0$)0+/, ''));
          }, $scope.hits);

          $scope.reintegroHit = reintegro;
          $scope.complementarioHit = complementario.replace(/^(?!0$)0+/, '');
        }

        if (primitiva.joker !== null && primitiva.joker.hasOwnProperty('combinacion') && primitiva.joker.combinacion !== null) {
          $scope.jokerResult = primitiva.joker.combinacion;
        }

        comprobarAciertosPrimitiva ();
      };

      var formatResultEuromillon = function (euromillon) {
        if (euromillon.combinacion !== null) {
          $scope.hits = [];
          $scope.starHits = [];
          var combinacion = euromillon.combinacion.trim();
          var combinacionGanadora = combinacion.split(" - ");

          $scope.starHits.push(combinacionGanadora[5].replace(/^(?!0$)0+/, ''));
          $scope.starHits.push(combinacionGanadora[6].replace(/^(?!0$)0+/, ''));

          combinacionGanadora.splice(5, 6);

          angular.forEach(combinacionGanadora, function (value, key) {
            this.push(value.replace(/^(?!0$)0+/, ''));
          }, $scope.hits);

          $scope.million = euromillon.millon;
          comprobarAciertosEuromillon ();
        }
      };

      var formatResultBonoloto = function (bonoloto) {
        if (bonoloto.combinacion !== null) {
          $scope.hits = [];
          var combinacion = bonoloto.combinacion;
          var combinacionGanadora = combinacion.split(" - ");
          var ultimaposicion = combinacionGanadora[5].split(" ");
          combinacionGanadora[5] = ultimaposicion[0];
          var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
          var reintegro = ultimaposicion[2].replace("R(", "").replace(")", "");

          angular.forEach(combinacionGanadora, function (value, key) {
            this.push(value.replace(/^(?!0$)0+/, ''));
          }, $scope.hits);

          $scope.reintegroHit = reintegro;
          $scope.complementarioHit = complementario.replace(/^(?!0$)0+/, '');
          comprobarAciertosBonoloto ();
        }
      };

      var formatResultElGordo = function (gordo) {
        if (gordo.combinacion !== null) {
          $scope.hits = [];
          var combinacion = gordo.combinacion;
          var combinacionGanadora = combinacion.split(" - ");
          var ultimaposicion = combinacionGanadora[4].split(" ");
          combinacionGanadora[4] = ultimaposicion[0];
          var reintegro = ultimaposicion[1].replace("R(", "").replace(")", "");

          angular.forEach(combinacionGanadora, function (value, key) {
            this.push(value.replace(/^(?!0$)0+/, ''));
          }, $scope.hits);

          $scope.reintegroHit = reintegro;
          comprobarAciertosElgordo ();
        }
      };

      var formatResultLototurf = function (lototurf) {
        if (lototurf.combinacion !== null && lototurf.combinacion !== undefined) {
          $scope.hits = [];
          $scope.horseHits = [];
          var combinacion = lototurf.combinacion;
          var combinacionGanadora = combinacion.split(" - ");

          var ultimaposicion = combinacionGanadora[5].split(" ");
          combinacionGanadora[5] = ultimaposicion[0];
          var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
          var reintegro = ultimaposicion[2].replace("R(", "").replace(")", "");

          $scope.horseHits.push(complementario);

          angular.forEach(combinacionGanadora, function (value, key) {
            this.push(value.replace(/^(?!0$)0+/, ''));
          }, $scope.hits);

          $scope.reintegroHit = reintegro;
          comprobarAciertosLototurf();
        }
      };

      var formatResultQuintuple = function (quintuple) {
        if (quintuple.combinacion !== null && quintuple.combinacion !== undefined) {
          $scope.hits = [];
          var combinacion = quintuple.combinacion;
          var combinacionGanadora = combinacion.split(" - ");

          var ultimaposicion = combinacionGanadora[4].split(" ");
          combinacionGanadora[4] = ultimaposicion[0];
          var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
          combinacionGanadora[5] = complementario;

          angular.forEach(combinacionGanadora, function (value, key) {
            this.push(value.replace(/^(?!0$)0+/, ''));
          }, $scope.hits);
          comprobarAciertosQuintupleplus();
        }
      };

      var formatResultQuiniela = function (quiniela) {
        if (quiniela.combinacion !== null && quiniela.combinacion !== undefined) {
          $scope.hits = [];
          var combinacion = quiniela.combinacion;
          var combinacionGanadora = combinacion.split(" - ");

          $scope.plenoHit = combinacionGanadora[14];
          $scope.plenoHit = $scope.plenoHit.slice(0, 1) + "-" + $scope.plenoHit.slice(1);

          combinacionGanadora.splice(14, 14);

          angular.forEach(combinacionGanadora, function (value, key) {
            this.push(value.replace(/^(?!0$)0+/, ''));
          }, $scope.hits);
          comprobarAciertosQuiniela();
        }
      };

      var formatResultQuinigol = function (quinigol) {
        if (quinigol.combinacion !== null && quinigol.combinacion !== undefined) {
          $scope.hits = [];
          var combinacion = quinigol.combinacion;
          var combinacionGanadora = combinacion.split(" - ");

          $scope.plenoHit = combinacionGanadora[14];

          combinacionGanadora.splice(14, 14);

          angular.forEach(combinacionGanadora, function (value, key) {
            var partido = value.replace(" ", "");
            partido = partido.length > 2 ? partido.replace(/^(?!0$)0+/, '') : partido;
            this.push(partido);
          }, $scope.hits);
          comprobarAciertosQuinigol();
        }
      };

      $scope.getHits = function (sorteo) {
        if (window.ga) {
          var anaGameName = analyticsSrv.setName(sorteo.idJuego);
          analyticsSrv.trackEvent('Mis_Apuestas_Detalle', 'Aciertos', anaGameName);
        }
        $scope.dateOfTheDraw = sorteo;

        var date = sorteo.hasOwnProperty("fecha") ? sorteo.fecha : sorteoDto;
        //Para prevenir el bug de GMT que causa que al convertir el dato nos quedemos con una fecha distinta:
        date = date.split("T")[0];
        var params = [{
            name: 'game_id',
            value: $filter('filter')(gamesProvider.getGames(), {
              idJuego: $rootScope.viewMoreBet.ApuestaDto.idJuego
            })[0].text
          },
          {
            name: 'fecha_sorteo',
            value: $filter('date')(date, "yyyyMMdd")
            //value: "20161009"
          }
        ];

        var url = config.services.cmsHost + config.services.fechav3;
        popupSrv.showLoading("checkingBet");
        requestSrv.request(url, "get", params)
          .then(function (e) {
            var resultado = e.data;
            switch ($rootScope.viewMoreBet.ApuestaDto.idJuego) {
              case 1:
                formatResultPrimitiva(resultado[0]);
                break;
              case 2:
                formatResultQuiniela(resultado[0]);
                break;
              case 3:
                formatResultEuromillon(resultado[0]);
                break;
              case 4:
                formatResultBonoloto(resultado[0]);
                break;
              case 5:
                formatResultElGordo(resultado[0]);
                break;
              case 6:
                formatResultQuinigol(resultado[0]);
                break;
              case 7:
                formatResultLototurf(resultado[0]);
                break;
              case 8:
                formatResultQuintuple(resultado[0]);
                break;
              default:
            }
            $scope.checkHits();
            $ionicScrollDelegate.scrollTop(true);
          })
          .finally(function () {
            popupSrv.hideLoading();
          })
          .catch(function (err) {
            popupSrv.hideLoading();
            popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
          });
      };

      //funcion para comprobar resultados 
      $scope.checkHits = function () {
        
        console.log("$scope",$rootScope.viewMoreBet.ApuestaDto.idJuego);



        $scope.checkHit = function (array, number) {
          if ($rootScope.viewMoreBet.ApuestaDto.idJuego === 8) {

            var hit = false;
            var apuesta = number;
            var ganador = array;
            apuesta = parseInt(apuesta);
            ganador = parseInt(ganador);

          angular.forEach(array, function (value, key) {
            if (apuesta === ganador) {
              hit = true;
              $scope.hites = true;
            }
          });
          return hit;


          } else {
            var hit = false;

            angular.forEach(array, function (value, key) {
              if (number == value) {
                hit = true;
                $scope.hites = true;
              }
            });
            return hit;
          }
        };


        $scope.checkHitQuiniela = function (hit, number) {

          if (hit !== undefined && number.indexOf(hit) !== -1) {
            return true;
          }
          return false;
        };

        $scope.checkHitQuinigol = function (hit, number) {

        if (hit !== undefined && number.replace('-', '') == hit) {
          $scope.hites = true;
        }

          if (hit !== undefined && number.replace('-', '') == hit) {
            return true;
          }
          return false;
        };    
      };

      $scope.formatResult();

              // Funcion para ver si tenemos elige8
      $scope.enableElige8 = function(ele) {
        if ( $scope.playElige8 ) {
            return $scope.arrayElige8.includes(ele+1);
        } else { 
            return false;
        }
      };

      $scope.playAgain = function (betId, gameId, aditionalInfo ) {
          if ( $rootScope.selae.properties.elGordoV2Service == 'true' && gameId == 5 && !$rootScope.viewMoreBet.gordoV2) {
            return popupSrv.showErrorPopup($filter('translate')('oldGordoNoReplayTxt'));
          }
        if (window.ga) {
          anaGameName = analyticsSrv.setName(gameId)
          analyticsSrv.trackEvent('Mis_Apuestas_Detalle', 'Jugar', anaGameName)
        }
        requestSrv.cancelAll();

        if (gameId == 10) {gameId = 9}

        $state.go("app.summaryBet", {
            game_id: gameId,
            type: "replay",
            bet_id: betId,
            combination: $rootScope.viewMoreBet.detalleApuesta.detalleApuesta[0].combinacion,
            serviceV2: $rootScope.viewMoreBet.gordoV2
        });
      };
    }]);