angular.module('selae.bets.controllers')

  .filter('first3chars', function () {
    return function (input) {
      input = input || '';

      out = input.substring(0, 3);

      return out;
    };
  })

  .controller('MyBetsCtrl', ['config', '$location', 'popupSrv', 'requestSrv', '$scope', '$rootScope', 'htmlModalSrv', '$state', '$ionicScrollDelegate', '$timeout', '$filter', 'LoteriaNacional', '$ionicHistory', '$ionicPlatform', 'analyticsSrv', 'gamesProvider',
    function (config, $location, popupSrv, requestSrv, $scope, $rootScope, htmlModalSrv, $state, $ionicScrollDelegate, $timeout, $filter, LoteriaNacional, $ionicHistory, $ionicPlatform, analyticsSrv, gamesProvider) {

      var deregisterHardBack = $ionicPlatform.registerBackButtonAction($rootScope.selaeGoBack, 101);
			$scope.$on('$destroy', deregisterHardBack);

      angular.element(".carousel-active").removeClass("carousel-active");
      //variables locales
      var lastItemRequested = 0;

      // variables para la API y el paginador
      var paginaActual = 0;
      var paginaSiguiente = 0;
      var tipoJuego = 0;
      var tamanoPagina = 5;

      //inicializamos a false la variable que determina si hay que volver al ticket tras la recarga de lotobolsa
			if ($rootScope.ticket === true){
				$rootScope.ticket = false;
			}


      if(window.ga !== undefined) {analyticsSrv.trackView('Mis apuestas');}

      $scope.loteriaNacional = LoteriaNacional;

      // Variables a compartir con la vista
      $scope.listadoApuestas = [];
      $scope.errorCargandoHistorico = false;
      $scope.userHasLeftView = false;
      $scope.historicoIsLoading = true;
      $scope.itemSeleccionado = itemSelected();
      $scope.gamesData = gamesProvider.getGames();

      $scope.swiper = {};

      function itemSelected() {
        if ( $rootScope.myBetsSaveFilter === null ) {
          return -1;
        } else {
          return $rootScope.myBetsSaveFilter;
        }
      }

      $scope.onReadySwiper = function (swiper) {
        console.log('%c rootscope: '+$rootScope.myBetsSaveFilter,'color: black; background-color: yellow;');
        if ($rootScope.myBetsSaveFilter !== null && $rootScope.myBetsSaveFilter !== undefined) {
          angular.element(".carousel-active").removeClass("carousel-active");
          angular.element(".swiper-slide-active").addClass("carousel-active");
          $scope.filtrar();
        }
        swiper.on('tap', function () {
          $scope.itemSeleccionado = swiper.activeIndex;
          angular.element(".carousel-active").removeClass("carousel-active");
          angular.element(".swiper-slide-active").addClass("carousel-active");
          $rootScope.myBetsSaveFilter = swiper.activeIndex;
          console.log('%c rootscope: '+$rootScope.myBetsSaveFilter,'color: black; background-color: yellow;');
          $scope.filtrar();
          $scope.$apply();
          $timeout(function () {
            $ionicScrollDelegate.resize();
          }, 100);

        });
      };

      function calculateInitPositionCarousel() {
        if($rootScope.myBetsSaveFilter !== null && $rootScope.myBetsSaveFilter !== undefined) {
          return $rootScope.myBetsSaveFilter;
        } else {
          return $scope.gamesData.length > 4 ? 2 : $scope.gamesData.length == 4 ? 1 : $scope.gamesData.length == 2 ? 0 : $scope.gamesData.length/2;
        }
      }

      $scope.carouselConfig = {
        'initialSlide': calculateInitPositionCarousel(),
        'slidesPerView': $(window).width() <= 320 ? 3 : $(window).width() > 480 ? 5 : 4,
        'freeMode': 'true',
        'centeredSlides': 'true',
        'freeModeSticky': 'true',
        'slideToClickedSlide': 'true',
        'speed': 300
      };

      $scope.unfilter = function () {
        requestSrv.cancelAll();
        $rootScope.myBetsSaveFilter = null;
        angular.element(".carousel-active").removeClass("carousel-active");
        $scope.itemSeleccionado = -1;
        tipoJuego = 0;
        paginaActual = 0;
        paginaSiguiente = 0;
        lastItemRequested = 0;
        $scope.listadoApuestas = [];
        $scope.getHistorico(tipoJuego);
      };

      $scope.filtrar = function () {
        requestSrv.cancelAll();
        tipoJuego = ($rootScope.myBetsSaveFilter !== null && $rootScope.myBetsSaveFilter !== undefined) ? gamesProvider.getGames()[$rootScope.myBetsSaveFilter].idJuego : 0;
        paginaActual = 0;
        paginaSiguiente = 0;
        lastItemRequested = 0;

        $scope.listadoApuestas = [];

        $scope.getHistorico(tipoJuego);
      };

      $scope.getHistorico = function (idJuego) {
        console.log('ide del juego',idJuego);
        $scope.errorCargandoHistorico = false;
        $scope.historicoIsLoading = true;

        var params = [{
          name: "tamanoPagina",
          value: tamanoPagina
        }, {
          name: "accionController",
          value: "paginarListado"
        }, {
          name: "paginaActual",
          value: paginaActual
        }, {
          name: "paginaSiguiente",
          value: paginaSiguiente
        }, {
          name: "tipo-juego",
          value: idJuego
        }, {
          name: "tipo-canal",
          value: "0"
        }
        ];

        popupSrv.showLoading("loadingMyBets");

        var url = config.services.host + config.services.getHistorico;

        requestSrv.request(url, "post", params)
        .then(function (e) {
          if (e.data.listadoApuestas !== undefined && e.data.listadoApuestas !== null) {
            // RESPUESTA OK
            $scope.listadoApuestas = $scope.listadoApuestas.concat(e.data.listadoApuestas);

            // Miro si es la ultima pagina
            if (e.data.pagina >= e.data.totalPaginas - 1) {
              $scope.allItemsLoaded = true;
              // console.log($scope.allItemsLoaded, "items a true");
            } else if($scope.allItemsLoaded === true){
              $scope.allItemsLoaded = false;
              // console.log($scope.allItemsLoaded = false,"prueba");
            }

            //Pido los detalles de las apuestas
            $scope.getNextDetalleRecursivo();
          }
          else {
            throw e;
          }
        })
        .finally(function(){
          popupSrv.hideLoading();
        })
        .catch(function (e) {
          $scope.errorCargandoHistorico = true;
          if (e.status === -1){
            return;
          }
          popupSrv.hideLoading();
          popupSrv.showErrorPopup(requestSrv.errorHandler2(e));
        });
      };

      $scope.getNextDetalleRecursivo = function () {
        // Si no hemos pedido todos pedimos el siguiente
        // También comprobamos que el user no haya cambiado de vista
        if (lastItemRequested < $scope.listadoApuestas.length && !$scope.userHasLeftView) {

          //Cojemos el ID de la siguiente apuesta y lo ponemos en la URL
          var nextApuestaId = $scope.listadoApuestas[lastItemRequested].ApuestaDto.apuestaId;

          var url = config.services.host + config.services.getDetalleHistorico;
          url = url.replace("{idApuesta}", nextApuestaId);
          var params = "";

          requestSrv.request(url, "post", params)
          .then(function (e) {
            // MOCK de el gordo
            //e.data = {"precioPorApuesta":["1,5"],"permitirCompartir":[true],"sorteo":[{"SorteoDto":{"idExtFechaSorteo":"040 17 MAY 13","estado":"ACTIVO","fechaInicioVentas":"2020-05-17T00:00:00+02:00","cdc":10934,"nombreJuego":"GORDO PRIMITIVA","secuencia":"40","ventaDiariaPermitida":true,"esPrincipioEncadenado":true,"tieneLluvia":false,"fecha":"2020-06-06T00:00:00+02:00","sorteoCentralId":"24","ventaEstaHabilitada":true,"tieneMillon":false,"sorteoId":15,"fechaFinVentas":"2020-06-06T21:00:00+02:00","tipoSorteo":"ORDINARIO","precioApuestaSencilla":"150","idJuego":"5"}}],"grupoCompraDto":{"aportacionComprador":0,"sePuedeComprar":false},"apuestaCompartida":[false],"detalleApuesta":[{"compradoPorFavorita":false,"numeroSerie":"10919-4848-06559-57949-95204-75396-96538","estado":"ACTIVA","nombreJuego":"GORDO PRIMITIVA","fechasSorteos":[" 17 MAY 13"],"combinacion":".1=4,15,25,35,38:2.2=4,5,37,38,40:4","importePremio":0,"apuestasFormateadas":["4,15,25,35,38:2","4,5,37,38,40:4"],"combinacionCentral":".1=4,15,25,35,38:2.2=4,5,37,38,40:4","nombreJuegoSecundario":"","precio":300,"metodo":"Sencillo","canal":"APP_MOVIL","precioBoletoEuros":"3,00","compartida":false,"apuestasFormateadasParaResguardo":[],"napuestas":2,"jugadorId":5520,"solicitaJuegoAsociado":false,"juegoId":5,"ApuestaModoGeneracion":"AUTOMATICA","ApuestaTipoSorteo":"DIARIA","fechaCompra":"2020-05-22T12:42:57+02:00","apuestaId":21184,"listaSorteos":[],"PremioDTO":{"listaPremioDetalle":[],"solicitud":{}},"rifas":[],"puntoVenta":"101","fechaCreacion":"2020-05-22T12:42:57+02:00","reintegro":0,"compradoPorSuscripcion":false}],"origen":["historico"],"pendienteDeVerificacionDocumental":[{"msgErrorFiltro":"","error":false,"urlFiltroDestino":"","urlActual":"","filtroErrorNombre":"filtroPendienteVerificacion"}],"permitirRechazar":[true],"listaSorteos":[{"SorteoDto":{"idExtFechaSorteo":"040 17 MAY 13","estado":"ACTIVO","fechaInicioVentas":"2020-05-17T00:00:00+02:00","cdc":0,"nombreJuego":"GORDO PRIMITIVA","urlCms":"https://www.loteriasyapuestas.es/es/gordo-primitiva/sorteos/2020/1093405040","drawId":"1093405040","ventaDiariaPermitida":true,"esPrincipioEncadenado":true,"tieneLluvia":false,"fecha":"2020-06-06T00:00:00+02:00","sorteoCentralId":"24","ventaEstaHabilitada":true,"tieneMillon":false,"sorteoId":15,"fechaFinVentas":"2020-06-06T21:00:00+02:00","tipoSorteo":"ORDINARIO","precioApuestaSencilla":"150","idJuego":"5"}}],"tieneClubConmigoOnline":[true],"categoriaApuestas":[{"nombreJuego":"Gordo primitiva","listaCategorias":[{"CategoriasPorApuestaDto":{"numeroApuestasPremiadas":0,"categoria":"1","descripcionCategoria":"1ª (5 + 1)","idCategoria":151,"juegoSecundario":false}},{"CategoriasPorApuestaDto":{"numeroApuestasPremiadas":0,"categoria":"2","descripcionCategoria":"2ª (5 + 0)","idCategoria":152,"juegoSecundario":false}},{"CategoriasPorApuestaDto":{"numeroApuestasPremiadas":0,"categoria":"3","descripcionCategoria":"3ª (4 + 1)","idCategoria":153,"juegoSecundario":false}},{"CategoriasPorApuestaDto":{"numeroApuestasPremiadas":0,"categoria":"4","descripcionCategoria":"4ª (4 + 0)","idCategoria":154,"juegoSecundario":false}},{"CategoriasPorApuestaDto":{"numeroApuestasPremiadas":0,"categoria":"5","descripcionCategoria":"5ª (3 + 1)","idCategoria":155,"juegoSecundario":false}},{"CategoriasPorApuestaDto":{"numeroApuestasPremiadas":0,"categoria":"6","descripcionCategoria":"6ª (3 + 0)","idCategoria":156,"juegoSecundario":false}},{"CategoriasPorApuestaDto":{"numeroApuestasPremiadas":0,"categoria":"7","descripcionCategoria":"7ª (2 + 1)","idCategoria":157,"juegoSecundario":false}},{"CategoriasPorApuestaDto":{"numeroApuestasPremiadas":0,"categoria":"8","descripcionCategoria":"8ª (2 + 0)","idCategoria":158,"juegoSecundario":false}},{"CategoriasPorApuestaDto":{"numeroApuestasPremiadas":0,"categoria":"9","descripcionCategoria":"Reintegro","idCategoria":159,"juegoSecundario":false}}],"idJuego":0}],"urlActual":"/jugar/cas/apuestas/historicos/detalle/21184.json"};
            // debugger;
            // MOCK
            // aqui viene el array a cambiar y donde mockear los datos de la apuesta
            // detalleApuesta.detalleApuesta[0].apuestasFormateadas[0]
            // apuesta mock de elige8 [(X),1,(X),X,2,(1),X,(2),(X),X,(X),(2),X,X]
            // detalleApuesta.detalleApuesta[0].apuestasFormateadas[0]
           
            // e.data.detalleApuesta[0].apuestasFormateadas[0]="(X),1,(X),X,2,(1),X,(2),(X),X,(X),(2),X,(X)";
            // COMPROBAMOS EL SERVICIO DEL GORDO
            if (e.data.detalleApuesta[0].juegoId == 5 && $filter('translate')('elGordoV2Service')) {$scope.gordoV2Service=true;}

            // Seguimos con el elige8
            $scope.listadoApuestas[lastItemRequested].detalleApuesta = e.data;
            $scope.listadoApuestas[lastItemRequested].logoTexto = String(gamesProvider.getTextIcons(e.data.detalleApuesta[0].juegoId));
            $scope.listadoApuestas[lastItemRequested].finishedLoadingDetail = true;
            // Creamos el array elige8 si la apuesta contiene datos del elige8
            if ($scope.listadoApuestas[lastItemRequested].detalleApuesta.detalleApuesta[0].apuestasFormateadas[0].indexOf("(") !== -1) {
              // recorremos la apuesta y guardamos el indice del array en nuestra variable arrayElige8
              var arrayElige8 = [];
              var betArray = $scope.listadoApuestas[lastItemRequested].detalleApuesta.detalleApuesta[0].apuestasFormateadas[0].split(',');
              for (i=0; i<betArray.length; i++) {
                if (betArray[i].indexOf("(") !== -1) {
                  arrayElige8.push(i + 1);
                }
              }
              // expresion regular para eliminar corchetes /[()]/g de todas las apuestas
              $scope.listadoApuestas[lastItemRequested].detalleApuesta.detalleApuesta[0].apuestasFormateadas[0] = $scope.listadoApuestas[lastItemRequested].detalleApuesta.detalleApuesta[0].apuestasFormateadas[0].replace(/[()]/g,'');
              $scope.listadoApuestas[lastItemRequested].detalleApuesta.detalleApuesta[0].apuestasFormateadas[0] = $scope.listadoApuestas[lastItemRequested].detalleApuesta.detalleApuesta[0].apuestasFormateadas[0].replace(/[()]/g,'');
              $scope.listadoApuestas[lastItemRequested].arrayElige8 = arrayElige8;
              $scope.listadoApuestas[lastItemRequested].playElige8 = true;
            }
            // para el nuevo gordo
            if ($scope.listadoApuestas[lastItemRequested].detalleApuesta.detalleApuesta[0].juegoId === 5) {
              var toSplit = $scope.listadoApuestas[lastItemRequested].detalleApuesta.detalleApuesta[0].apuestasFormateadas[0].indexOf(":") !== -1 ? ':' : ';';
              if (toSplit === ';') {
                  $scope.listadoApuestas[lastItemRequested].gordoV2combinacion = {
                      'combinacion' : $scope.listadoApuestas[lastItemRequested].detalleApuesta.detalleApuesta[0].apuestasFormateadas[0].split(','),
                      'numClave' : $scope.listadoApuestas[lastItemRequested].detalleApuesta.detalleApuesta[0].reintegro
                  }
              } else {
                  $scope.listadoApuestas[lastItemRequested].gordoV2 = true;
                  var apuesta = $scope.listadoApuestas[lastItemRequested].detalleApuesta.detalleApuesta[0].apuestasFormateadas[0].split(':');
                  var gordoNumClave = apuesta.pop();
                  var gordoApuesta = apuesta[0].split(',');
                  $scope.listadoApuestas[lastItemRequested].gordoV2combinacion = {'combinacion' : gordoApuesta,
                                                                                  'numClave' : gordoNumClave
                                                                                }
                }
            }
              // fin del nuevo gordo

            // Pedimos siguiente elemento
            lastItemRequested++;
            $scope.getNextDetalleRecursivo();
            $timeout(function () {
              $ionicScrollDelegate.resize();
            }, 100);
          })
          .catch(function (e) {
            if (e.status !== -1) {
              popupSrv.hideLoading();
              popupSrv.showErrorPopup(requestSrv.errorHandler2(e));
              
              //Mostramos un error en la vista y quitamos los loading
              $scope.listadoApuestas[lastItemRequested].error = true;
              $scope.listadoApuestas[lastItemRequested].finishedLoadingDetail = true;

              // Pedimos siguiente elemento
              lastItemRequested++;
              $scope.getNextDetalleRecursivo();
            }
          });
        }
        else {
          $scope.historicoIsLoading = false;
        }
      };

      $scope.getDetalleApuestaIndividual = function (myBet) {
        //Mostramos el cargando nuevamente
        myBet.finishedLoadingDetail = false;
        myBet.error = false;

        //Cojemos el ID de la siguiente apuesta y lo ponemos en la URL
        var nextApuestaId = myBet.ApuestaDto.apuestaId;

        var url = config.services.host + config.services.getDetalleHistorico;
        url = url.replace("{idApuesta}", nextApuestaId);
        var params = "";

        requestSrv.request(url, "post", params)
        .then(function (e) {
          myBet.detalleApuesta = e.data;
          myBet.finishedLoadingDetail = true;
        })
        .catch(function (e) {
          if (e.status !== -1) {
            popupSrv.hideLoading();
            popupSrv.showErrorPopup(requestSrv.errorHandler2(e));

            //Mostramos un error en la vista y quitamos los loading
            myBet.error = true;
            myBet.finishedLoadingDetail = true;
          }
        });
      };

      $scope.loadMoreBets = function () {
        paginaSiguiente++;
        paginaActual++;
        $scope.getHistorico(tipoJuego);
      };

      $scope.getBetTemplateUrl = function (myBet) {
        return "bets/templates/my-bet-summary-game-" + myBet.ApuestaDto.idJuego + ".html";
      };

      $scope.getHits = function (sorteoDto) {

        var date = sorteoDto.hasOwnProperty("fecha") ? sorteoDto.fecha : sorteoDto;
        var gameId = $rootScope.viewMoreBet.ApuestaDto.idJuego == 10 ? 9 : $rootScope.viewMoreBet.ApuestaDto.idJuego;
        var params = [
          {
            name: 'game_id',
            value: $filter('filter')(gamesProvider.getGames(), {idJuego: gameId})[0].text
          },
          {
            name: 'fecha_sorteo',
            value: $filter('date')(date, "yyyyMMdd")
            //value: "20161009"
          }
        ];

        var url = config.services.cmsHost + config.services.fecha2;
        popupSrv.showLoading("checkingBet");
        requestSrv.request(url, "get", params)
        .then(function (e) {
          var resultado = e.data;
          formatResultLoteria(resultado[0]);

          popupSrv.hideLoading();
          $ionicScrollDelegate.scrollTop(true);
        })
        .catch(function (e) {
          popupSrv.hideLoading();
          popupSrv.showErrorPopup(requestSrv.errorHandler2(e));
        });
      };

      var formatResultLoteria = function (loteria) {
        if (loteria.combinacion !== null) {
          $rootScope.loteriaNacional = {
            primerPremio: loteria.combinacion.primer_premio,
            segundoPremio: loteria.combinacion.Segundo_premio,
            reintegros: loteria.reintegros
          };
        }
      };
      //console.log($scope.loteriaNacional.primerPremio,"primer");
      //console.log($scope.loteriaNacional.segundoPremio,"segund");
      //console.log($scope.loteriaNacional.reintegros,"reint");


      $scope.viewMoreBet = function (myBet) {
        //debugger;
        if (window.ga !== undefined) {
          var anaGameName = analyticsSrv.setName(myBet.ApuestaDto.idJuego);
          analyticsSrv.trackView('Mis Apuestas-Detalle-'+anaGameName);
          analyticsSrv.trackEvent('Mis_Apuestas', 'Información', anaGameName);
        }
        $rootScope.viewMoreBet = myBet;

        if (myBet.ApuestaDto.idJuego == 9 || myBet.ApuestaDto.idJuego == 10) {
          $scope.getHits(myBet.ApuestaDto.fechaSorteo);
        }
        $location.path("/app/bets/my-bets/my-bet-detail/" + myBet.ApuestaDto.idJuego);
      };

      $scope.viewTicket = function (myBet) {

        if (window.ga !== undefined) {
          var anaGameName = analyticsSrv.setName(myBet.ApuestaDto.idJuego);
          analyticsSrv.trackEvent('Mis_Apuestas', 'Resguardo', anaGameName);
        }
        htmlModalSrv.show($scope, "ticket", null, myBet);
      };

      $scope.goHome = function () {
        $state.go("app.home");
      };

      $scope.$on('$destroy', function () {
        // El usuario abandona la vista
        $scope.userHasLeftView = true;
      });

        if ($rootScope.myBetsSaveFilter === null) {
          $scope.getHistorico(tipoJuego);
        } else {  console.log("no recarga"); }

    }]);
