angular.module('selae.bets.controllers')
	.controller('MyFavouritesCtrl', ['config', '$scope', '$timeout', '$http', '$ionicScrollDelegate', '$location', 'requestSrv', 'popupSrv', '$rootScope', '$filter', '$ionicHistory', '$ionicPlatform', 'analyticsSrv', 'gamesProvider', '$state',
		function (config, $scope, $timeout, $http, $ionicScrollDelegate, $location, requestSrv, popupSrv, $rootScope, $filter, $ionicHistory, $ionicPlatform, analyticsSrv , gamesProvider, $state) {

			var deregisterHardBack = $ionicPlatform.registerBackButtonAction($rootScope.selaeGoBack, 101);
			$scope.$on('$destroy', deregisterHardBack);


			angular.element(".carousel-active").removeClass("carousel-active");
			popupSrv.showLoading('Cargando resultados');

			var data;
			//inicializamos a false la variable que determina si hay que volver al ticket tras la recarga de lotobolsa
			if ($rootScope.ticket === true){
				$rootScope.ticket = false;
			}
				

			//$ionicHistory.clearHistory();
			if(window.ga !== undefined) {analyticsSrv.trackView('Favoritas');}

			var service = initServiceFavoritas(config.services, gamesProvider.getGames());
			service.then(function (res) {
				$scope.data = data = res;
				console.log('Servicio formateado', res);
				console.log('%c rootscope: ' + $rootScope.favouritesSaveFilter, 'color: black; background-color: yellow;');
				//console.log(angular.element(".carousel-active"));

				if ($rootScope.favouritesSaveFilter !== null && $rootScope.favouritesSaveFilter !== undefined) {
					angular.element(".carousel-active").removeClass("carousel-active");
					angular.element(".swiper-slide-active").addClass("carousel-active");
					$scope.data = filtrar($rootScope.favouritesSaveFilter);
				}
				popupSrv.hideLoading();
				if (res) {
					console.info('<==================================Favoritas: OK===========================================>');
				}

			});

			$scope.favPlayAgain = function (bet) {
				// si está activado el nuevo gordo, no se pueden rejugar apuestas, para saber si la apuesta es nueva o vieja utilizamos este parametro bet.combination.details.serviceVersion === 'false'
				if ($rootScope.selae.properties.elGordoV2Service == 'true' && bet.gameId === 5 && bet.combination.details.serviceVersion === 'false') {
					return popupSrv.showErrorPopup($filter('translate')('oldGordoNoReplayTxt'));
				}
				analyticsFavPlayAgain(bet.gameId);
				return $state.go('app.myFavouritesPlayAgain', {dataTransfer: bet})
			}


			function analyticsFavPlayAgain (id) {
				if (window.ga) {
					var anaGameName = analyticsSrv.setName(id);
					analyticsSrv.trackView('Favoritas-Detalle-'+ anaGameName);
					analyticsSrv.trackEvent('Favoritas', 'Jugar', anaGameName);
				}
			}

			$scope.analyticsFavDetails = function (id) {
				// console.log('evento informacion');
				if (window.ga) {
					var anaGameName = analyticsSrv.setName(id);
					analyticsSrv.trackView('Favorita-Información-'+anaGameName);
					analyticsSrv.trackEvent('Favoritas_Detalle', 'Información', anaGameName);
				}
			};

			//*************************************************** //
			$scope.gamesData = gamesProvider.getGames();
			$scope.swiper = {};
			//Configuracion del swiper, como debe mostrarse

			$scope.onReadySwiper = function (swiper) {
				swiper.on('tap', function () {
					angular.element(".carousel-active").removeClass("carousel-active");
					angular.element(".swiper-slide-active").addClass("carousel-active");
					$rootScope.favouritesSaveFilter = swiper.activeIndex;
					console.log('%c rootscope: ' + $rootScope.favouritesSaveFilter, 'color: black; background-color: yellow;');
					$scope.data = filtrar(swiper.activeIndex);
					$timeout(function () {
						$ionicScrollDelegate.resize();
					});
					return true;
				});
			};

			function calculateInitPositionCarousel() {
				if ($rootScope.favouritesSaveFilter !== null && $rootScope.favouritesSaveFilter !== undefined) {
					return $rootScope.favouritesSaveFilter;
				} else {
					return $scope.gamesData.length > 4 ? 2 : $scope.gamesData.length == 4 ? 1 : $scope.gamesData.length == 2 ? 0 : $scope.gamesData.length / 2;
				}
			}

			$scope.carouselConfig = {
				'initialSlide': calculateInitPositionCarousel(),
				'slidesPerView': $(window).width() <= 320 ? 3 : $(window).width() > 480 ? 5 : 4,
				'freeMode': 'true',
				'centeredSlides': 'true',
				'freeModeSticky': 'true',
				'slideToClickedSlide': 'true',
				'speed': 300
			};



			$scope.unfilter = function () {
				angular.element(".carousel-active").removeClass("carousel-active");
				angular.element(".icon-cerrar_ayuda").addClass("hide");
				$scope.data = data;
			};

			//Funcion para filtrar resultados
			function filtrar(number) {
				angular.element(".icon-cerrar_ayuda").removeClass("hide");
				var index = gamesProvider.getGames()[number].idJuego;
				return data.filter(function (j) {
					if (index == 9) {
						return j.gameId >= 9;
					} else {
						return j.gameId == index;
					}
				});
			}

			//*********************************************************//
			// funcion general, llamada al servicio y formateo de datos
			function initServiceFavoritas(servicesUrl, games) {
				if (!games) {
					throw 'El servicio initServiceFavoritas necesita como parametro un array con los tipos de juego (gamesProvider.getGames())';
				}
				if (!servicesUrl) {
					throw 'El servicio initServiceFavoritas necesita como parametro un objeto con las url de los servicios (config.services)';
				}
				if (!Array.isArray(games)) {
					throw 'El servicio initServiceFavoritas necesita como parametro un array y lo que le has pasado no es un array';
				}

				// Peticion al servicio
				var url = servicesUrl.host + servicesUrl.favoritas;
				console.info('<================================Favoritas: Pending========================================>');
				return $http({
						method: 'POST',
						url: url
					})
					.then(function (res) {
						console.log('Respuesta servicio', res); //Activar para ver lo que devuelve el servicio
						try {
							if (res.data.filtro || res.data.Filtro || res.data.error) {
								throw res;
							}
							return res.data.listaFavoritas.map(function (i) {
								return formatData(i.FavoritaDTO);
							});

						} catch (err) {
							popupSrv.hideLoading();
							popupSrv.showErrorPopup(requestSrv.errorHandler2(res)); //Sistema de errores el servicio requestSrv
							$rootScope.selaeGoBack();
						}

					}, function (err) {
						popupSrv.hideLoading();
						popupSrv.showErrorPopup(requestSrv.errorHandler2(err)); //Sistema de errores el servicio requestSrv
						$rootScope.selaeGoBack();
					});

				//*********************************************************//
				// Funcion de formateo de datos
				function formatData(data) {
					return {
						Id: parseInt(data.favoritaId),
						Name: data.nombre,
						betType: data.metodo,
						asociatedGameName: data.juegoSecundario,
						haveasociatedGame: data.tieneJuegoAsociado,
						favoritaJuegoAsociado: data.favoritaJuegoAsociadoDTO,
						gameId: parseInt(data.juegoId),
						gameTitle: getTitleGame(games, data.juegoId),
						gameType: getGameType(games, data.juegoId),
						gameImg: getGameImg(games, data.juegoId),
						gameHeaderImg: getGameHeaderImg(data.juegoId),
						originalCombination: data.combinacionPrincipal,
						combination: getCombinationFormat(data),
						bloques: getBloques(data),
						fechaCreacion: getDateCreation(data)
					};


					//*********************************************************//

					//Funcion para formatear las combinaciones
					function getCombinationFormat(data) {
						switch (parseInt(data.juegoId)) {

							//Completado
							case 4:
							return result = {
								simple: {
									combi: getSimple1()[0],
									extra: null
								},
								details: {
									combi: getDetails1(),
									extra: null
								}
							};

							case 1:
								return result = {
									simple: {
										combi: getSimple1()[0],
										extra: null
									},
									details: {
										combi: getDetails1(),
										extra: null
									},
									reintegro : getReintegro()
								};

								function getSimple1() {
									return data.combinacionPrincipal.split(';')[0].split('.').map(function (i) {
										if (i.search('1=') !== -1) {
											return i.substring(2).split(',');
										}
									}).filter(Boolean);
								}

								function getDetails1() {
									return data.combinacionPrincipal.split(';')[0].split('.').map(function (i) {
										if (i) {
											return i.substring(2).split(',');
										}
									}).filter(Boolean);
								}

								function getReintegro() {
									var reint = Number(data.combinacionPrincipal.split(';')[1]);
									if (reint === 0) {
										return String(reint)
									}
									return reint || false
								}

								//Completado
							case 2:
								return result = {
									simple: {
										combi: getSimple2()[0],
										extra: getExtra2()[0],
										condition: getCondition2()[0]
									},
									details: {
										combi: getDetails2(),
										extra: getDetailsExtra2(),
										condition: getConditionExtra2()[0]
									}
								};

								function getSimple2() {
									return data.combinacionPrincipal.split(':')[0].split('.').map(function (i) {
										if (i.search(/1=/) !== -1) {
											return i.substring(2).split(',');
										}
									}).filter(Boolean);
								}

								function getExtra2() {
									return data.combinacionPrincipal.split(':')[1].split('.').map(function (i) {
										if (i.search(/1=/) !== -1) {
											return i.substring(2).split('/')[0].split(',');
										}
									}).filter(Boolean);
								}

								function getCondition2() {
									return data.combinacionPrincipal.split('/').map(function (i) {
										if (i.search(/\*/) !== -1) {
											return i.split('*').map(function (i) {
												if (i) {
													return i.substring(2);
												}
											})
										}
									}).filter(Boolean);
								}

								function getDetails2() {
									return data.combinacionPrincipal.split(':')[0].split('.').map(function (i) {
										if (i) {
											return i.substring(2).split(',');
										}
									}).filter(Boolean);
								}

								function getDetailsExtra2() {

									function matchPlenos (plenoData) {

										var saveData = {
											'firstTeam' : [],
											'secondTeam' : []
										};
										plenoData.forEach(function(element) {
											element = element.split('-');
											if ( saveData.firstTeam.indexOf(element[0]) === -1 ) {
												saveData.firstTeam.push(element[0]);
											}
											if ( saveData.secondTeam.indexOf(element[1]) === -1 ) {
												saveData.secondTeam.push(element[1]);
											}
										});

										return saveData;
									};

									var extraCombi = data.combinacionPrincipal.split(':')[1].split('.').map(function (i) {
										if (i) {
											return i.substring(2).split('/')[0].split(',');
										}
									}).filter(Boolean);

									return matchPlenos(extraCombi[0]);
								}

								function getConditionExtra2() {
									return data.combinacionPrincipal.split('/').map(function (i) {
										if (i.search(/\*/) !== -1) {
											return i.split('*').map(function (i) {
												if (i) {
													return i.substring(2);
												}
											})
										}
									}).filter(Boolean);
								}

								//Completado
							case 3:
								return result = {
									simple: {
										combi: getSimple3()[0],
										extra: getExtra3()[0]
									},
									details: {
										combi: getDetails3(),
										extra: getDetailsExtra3()
									}
								};

								function getSimple3() {
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i.search('1=') !== -1) {
											return i.substring(2).split(':')[0].split(',');
										}
									}).filter(Boolean);
								}

								function getExtra3() {
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i.search('1=') !== -1) {
											return i.substring(2).split(':')[1].split(',');
										}
									}).filter(Boolean);
								}

								function getDetails3() {
									var i = data.combinacionPrincipal.split('.').map(function (i) {
										return i.substring(2).split(':')[0];
									}).filter(Boolean);
									return i.map(function (j) {
										return j.split(',');
									});
								}

								function getDetailsExtra3() {
									var i = data.combinacionPrincipal.split('.').map(function (i) {
										return i.substring(2).split(':')[1];
									}).filter(Boolean);
									return i.map(function (j) {
										return j.split(',');
									});
								}

								//Completado
							case 5:
								return result = {
									simple: {
										combi: getSimple5()[0],
										extra: getExtra5()[0],
										serviceVersion: (data.combinacionPrincipal.search(';') !== -1) ? 'false' : 'true'
									},
									details: {
										combi: getDetails5(),
										extra: getDetailsExtra5(),
										serviceVersion: (data.combinacionPrincipal.search(';') !== -1) ? 'false' : 'true'
									}
								};

								function getSimple5() {
									var toSplit = (data.combinacionPrincipal.search(';') !== -1) ? ';' : ':';
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i.search('1=') !== -1) {
											return i.substring(2).split(toSplit)[0].split(',');
										}
									}).filter(Boolean);
								}

								function getExtra5() {
									var toSplit = (data.combinacionPrincipal.search(';') !== -1) ? ';' : ':';
									return data.combinacionPrincipal.split('.').map(function (i) {
										return i.substring(2).split(toSplit)[1];
									}).filter(Boolean);
								}

								function getDetails5() {
									var toSplit = (data.combinacionPrincipal.search(';') !== -1) ? ';' : ':';
									var i = data.combinacionPrincipal.split('.').map(function (i) {
										return i.substring(2).split(toSplit)[0];
									}).filter(Boolean);
									return i.map(function (j) {
										return j.split(',');
									});
								}

								function getDetailsExtra5() {
									var toSplit = (data.combinacionPrincipal.search(';') !== -1) ? ';' : ':';
									return data.combinacionPrincipal.split('.').map(function (i) {
										return i.substring(2).split(toSplit)[1];
									}).filter(Boolean);
								}

								//Completado
							case 6:
								return result = {
									simple: {
										combi: getSimple6()[0],
										extra: null
									},
									details: {
										combi: getDetails6(),
										extra: null,
										quiniAgain: getQuiniAgain()
									}
								};

								function getSimple6() {
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i.search('1=') !== -1) {
											return i.substring(2).split(':').map(function (i) {
												return i.split(',')[0].split('-');
											}).filter(Boolean);
										}
									}).filter(Boolean);
								}

								function getDetails6() {
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i) {
											return i.substring(2).split(':').map(function (i) {
												return i.split(',').map(function (i) {
													if (i) {
														return i;
													}
												}).filter(Boolean);
											}).filter(Boolean);
										}
									}).filter(Boolean);
								}

								function getQuiniAgain() {
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i) {
											return i.substring(2).split(':').map(function (i) {
												return i.split(',').map(function (i) {
													if (i) {
														return i.split('-');
													}
												}).filter(Boolean);
											}).filter(Boolean);
										}
									}).filter(Boolean);
								}

								//Completado
							case 7:
								return result = {
									simple: {
										combi: getSimple7()[0],
										extra: getExtra7()[0]
									},
									details: {
										combi: getDetails7(),
										extra: getDetailsExtra7()
									}
								};

								function getSimple7() {
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i.search('1=') !== -1) {
											return i.substring(2).split(':')[0].split(',');
										}
									}).filter(Boolean);
								}

								function getExtra7() {
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i.search('1=') !== -1) {
											return i.substring(2).split(':')[1].split(',');
										}
									}).filter(Boolean);
								}

								function getDetails7() {
									var i = data.combinacionPrincipal.split('.').map(function (i) {
										return i.substring(2).split(':')[0];
									}).filter(Boolean);
									return i.map(function (j) {
										return j.split(',');
									});
								}

								function getDetailsExtra7() {
									var i = data.combinacionPrincipal.split('.').map(function (i) {
										return i.substring(2).split(':')[1];
									}).filter(Boolean);
									return i.map(function (j) {
										return j.split(',');
									});
								}

								//Completado
							case 8:
								return result = {
									simple: {
										combi: getSimple8()[0],
										extra: null
									},
									details: {
										combi: getDetails8(),
										extra: null
									}
								};

								function getSimple8() {
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i.search('1=') !== -1) {
											return i.substring(2).split(':').map(function (i) {
												return i.split(',')[0];
											}).filter(Boolean);
										}
									}).filter(Boolean);
								}

								function getDetails8() {
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i) {
											return i.substring(2).split(':').map(function (i) {
												return i.split(',');
											}).filter(Boolean);
										}
									}).filter(Boolean);
								}

								//Completado
							case 9:
							case 10:
								return result = {
									simple: {
										combi: getSimple10()[0],
										extra: getDecimos()
									},
									details: {
										combi: getDetails10(),
										extra: getDecimos()
									}
								};

								function getSimple10() {
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i.search('1=') !== -1) {
											return i.substring(2).split('');
										}
									}).filter(Boolean);
								}

								function getDetails10() {
									return data.combinacionPrincipal.split('.').map(function (i) {
										if (i.search('1=') !== -1) {
											return i.substring(2).split('');
										}
									}).filter(Boolean);
								}

								function getDecimos() {
									return data.combinacionPrincipal.split('.').filter(Boolean).length;
								}

							default:
								return 'Combinacion no reconocida';
						}
					}
					//Funcion traer los titulos del Game
					function getTitleGame(array, data) {
						var store;
						if (data == 10) {
							data = 9;
						}
						array.forEach(function (i) {
							if (i.idJuego == data) {
								store = i.text;
							}
						});
						return traductor(store);

						//Funcion para buscar en el properties la traduccion
						function traductor(data) {
							return $filter('translate')(data);
						}
					}

					//Funcion para traer el tipo de juego
					function getGameType(array, data) {
						var rest;
						if (data == 10) {
							data = 9;
						}
						array.forEach(function (i) {
							if (i.idJuego == data) {
								rest = i.text.toLowerCase();
							}
						});
						return rest;
					}
					//Funcion para traer el logo del juego
					function getGameImg(array, data) {
						var rest;
						if (data == 10) {
							data = 9;
						}
						array.forEach(function (i) {
							if (i.idJuego == data) {
								rest = i.imgText;
							}
						});
						return rest;
					}
					//Funcion para traer la imagen de cabecera del juego
					function getGameHeaderImg(data) {
						return gamesProvider.getHeaderIcon(parseInt(data));
					}
					//Funcion para formatear la fecha de creación de la apuesta
					function getDateCreation(data) {
						var date = data.fechaCreacion;
						if (date.search(" CET") !== -1) {
							return new Date(date.replace(" CET", "")).toDateString();
						} else if (date.search(" CEST") !== -1) {
							return new Date(date.replace(" CEST", "")).toDateString();
						} else return null;
					}
					// Funcion para saber si tenemos más de un bloque de apuesta
					function getBloques(data) {
						if (data.juegoId === 8 || data.juegoId === 6) {
							return data.combinacionPrincipal.search(",");
						} else {
							return data.combinacionPrincipal.search(".2=");
						}
					}
					//*********************************************************//
				}
				//*********************************************************//
			}
			//*********************************************************//


		}
	]);
