angular.module('selae.bets.controllers')
.controller('MyFavouritesPlayAgainCtrl', ['$scope','$stateParams','config','$http','$rootScope','popupSrv','requestSrv','$state','$filter','$ionicHistory', '$ionicPlatform','analyticsSrv', '$q',
function ($scope,$stateParams,config,$http,$rootScope,popupSrv,requestSrv,$state,$filter,$ionicHistory,$ionicPlatform, analyticsSrv, $q) {
    popupSrv.showLoading('generatingBet');
    
    if ($rootScope.lotoBolsaStore) {
        console.log('Datos importados de la lotobolsa',$rootScope.lotoBolsaStore);
    }

    var backButtonChange = $ionicPlatform.registerBackButtonAction(function (event) {
        event.preventDefault();
        $rootScope.sorteo_id = $scope.data.service2.sorteo;
        $rootScope.selaeGoBack();
	}, 1000);
	$scope.$on('$destroy', backButtonChange);

    $stateParams.dataTransfer.combination.details.serviceVersion === 'true'?  newConfigFavorite() : configFavorite();

    function newConfigFavorite () {

        var callConfig = {
            headers : {
                "Content-Type": "application/json",
            },
            data : ''
        };

        var params = [{
            name : 'idJuego',
            value : $stateParams.dataTransfer.gameId
        }];

        var replayFavorite = $http.get( config.services.host + config.services.favPlayAgain + $stateParams.dataTransfer.Id + '/rejugar', callConfig )
        .then(function(e) {
            return e;
        });

        var rafflesPromise = requestSrv.request( config.services.host + config.services.genericRaffle ,"get" , params)
        .then(function(e1){
            return e1;
        });

        $q.all([replayFavorite,rafflesPromise])
        .then(function(e) {
                // Los campos comentados del objeto serán para añadir en un futuro, cuando se implementen los demas juegos.
                res = {
                    fecha: getDateBets(e[1].data),
                    // precioElige8: getElige8Price(e.data.ApuestaDto),
                    precio: getPrice(e[0].data.precioBoleto)
                    // partidos: data.partidos || null,
                    // limite: [GDFAL(data.numeroCaballoCarrera0), GDFAL(data.numeroCaballoCarrera1), GDFAL(data.numeroCaballoCarrera2), GDFAL(data.numeroCaballoCarrera3), GDFAL(data.numeroCaballoCarrera4), GDFAL(data.numeroCaballoCarrera5)].filter(Boolean),
                    // sorteo: res.data.idSorteo
                };
                $scope.betType = getBetType(e[0].data.metodo);
                $scope.data = { service1: $stateParams.dataTransfer, service2: res };
                popupSrv.hideLoading();
            })
        .catch(function(err) {
            popupSrv.hideLoading();
            popupSrv.showErrorPopup(requestSrv.errorMapperServiceRest(err));
            $ionicHistory.goBack();
        });
    }

    function configFavorite () {
        var service = initServiceFavoritasAgain($stateParams.dataTransfer);
        service.then(function(res) {
            $scope.data = { service1: $stateParams.dataTransfer, service2: res };
        
            if (res) {
                if($stateParams.dataTransfer.gameId === 8) {
                    try {
                    var text = $filter('translate')('NoAvailableQuintuple') || 'No existen caballos Quintuple';
                    console.log('comprobante quintuple', quintupleAvalible($stateParams.dataTransfer.combination.details, res.limite));
                    quintupleAvalible($stateParams.dataTransfer.combination.details, res.limite)? noAvailable(text) : null;
                    } catch(err) { popupSrv.showErrorPopup(requestSrv.errorHandler2(err)) }
                }
                if($stateParams.dataTransfer.gameId === 7) {
                    try {
                        var text = $filter('translate')('NoAvailableLototurf') || 'No existen caballos lototurf';
                    console.log('comprobante lototurf', lototurfAvalible($stateParams.dataTransfer.combination.details, res.limite));
                    lototurfAvalible($stateParams.dataTransfer.combination.details, res.limite)? noAvailable(text) : null;
                    } catch(err) { popupSrv.showErrorPopup(requestSrv.errorHandler2(err)); }
                }
            }

            function noAvailable(text) {
                popupSrv.showErrorPopup(text);
                $ionicHistory.goBack();
                
            }

            $scope.betType = getBetType($stateParams.dataTransfer.betType);
            $rootScope.titleLogo = $scope.data.service1.gameHeaderImg;
            if($scope.data.service1.gameId == 2) {
                $scope.playElige8 = $scope.data.service1.favoritaJuegoAsociado !== undefined;
                if($scope.playElige8) {
                    $scope.arrayElige8 = $scope.data.service1.favoritaJuegoAsociado.combinacion.bloques[0].rejillas[1].pronosticos;
                }
            }
            console.log('Servicio formateado', $scope.data);
            popupSrv.hideLoading();
            if(res) { console.info('<==============================Rejugar Favoritas: OK=======================================>'); }
        });
    }

    $scope.btnCancel = function() {
        if (window.ga) {
            analyticsSrv.trackEvent('Favoritas_Detalle', 'Volver', analyticsSrv.setName($stateParams.dataTransfer.gameId));
        }
            $rootScope.sorteo_id = $scope.data.service2.sorteo;
        $rootScope.selaeGoBack();
    };

    $scope.btnConfirmBuy = function() {
        popupSrv.showLoading('Cargando resultados');
        if ($stateParams.dataTransfer.combination.details.serviceVersion === 'true') {
            $rootScope.lotoBolsaStore = {data:$scope.data.service1};
            return  $state.go("app.ticket", { game_id: $stateParams.dataTransfer.gameId, serviceV2 : $stateParams.dataTransfer.combination.details.serviceVersion });
        }
        var service = confirmServiceFavoritasPlayAgain($stateParams.dataTransfer);
        service.then(function(res) {
            popupSrv.hideLoading();
            console.log('Servicio formateado', res);
            if(res) {
                $state.go("app.ticket", { game_id: $stateParams.dataTransfer.gameId });
                console.info('<==============================Configurar Apuesta: OK=======================================>');
            }
        });
    };

    function getBetType(data) {
		if (data === 'Sencillo') {
			return 'single';
		} else if (data === 'Multiple') {
			return 'multiple';
		} else { return data; }
    }


    function lototurfAvalible(apuesta, limite) {
        var apuesta = apuesta || 
        { combi: [ ["1", "14", "16", "17", "22", "23", "26", "27", "28", "29"],["1", "14", "16", "17", "22", "23", "26", "27", "28", "29"],["1", "14", "16", "17", "22", "23", "26", "27", "28", "29"] ],
        extra: [ ["A", "A", "A", "A"],["6", "1"],['12'] ] };
        var limite = limite || [31,12];

        var resCombi = apuesta.combi.map(function(res) {
            return res.filter(function(res) {
                return Number(res) > limite[0]
            }).length
        }).filter(Boolean).length

        var resExtra = apuesta.extra.map(function(res) {
            return res.filter(function(res) {
                return Number(res) > limite[1]
            }).length
        }).filter(Boolean).length

        return resCombi + resExtra;
    }

    function quintupleAvalible(apuesta, limite) {
        var apuesta = apuesta || 
        { combi: [[ ["2", "3"], ["2", "3", "6"], ["2", "3", "6", "7"], ["3", "6", "10"], ["2", "5", "8"], ["4", "5", "6", "7", "8"] ]],
        extra: null };
        var limite = limite || [5, 9, 7, 12, 6, 6];

        var resCombi = apuesta.combi.map(function(res) {
            return res.map(function(res, index) {
                return res.filter(function(res) {
                    return Number(res) > limite[index]
                }).length
            }).filter(Boolean).length
        }).filter(Boolean).length

        return resCombi;
    }

    // Funcion para ver si tenemos elige8
    $scope.enableElige8 = function(ele) {
        if ( $scope.playElige8 ) {
            return $scope.arrayElige8.includes(""+(ele+1));
        } else { 
            return false;
        }
    };

    //Funcion para formatear la respuesta del servicio
    function formatData(data) {
        return {
            fecha: getDateBets(data.compraDto[0].ApuestaDto),
            precioElige8: getElige8Price(data.compraDto[0].ApuestaDto),
            precio: getPrice(data.compraDto[0].ApuestaDto.precioBoleto),
            partidos: data.partidos || null,
            limite: [GDFAL(data.numeroCaballoCarrera0), GDFAL(data.numeroCaballoCarrera1), GDFAL(data.numeroCaballoCarrera2), GDFAL(data.numeroCaballoCarrera3), GDFAL(data.numeroCaballoCarrera4), GDFAL(data.numeroCaballoCarrera5)].filter(Boolean),
            sorteo: data.compraDto[0].ApuestaDto.idSorteo
        };}
        //Format array of limite (GetDataFromArrayLimit)
        function GDFAL(array) {
            return array? array[0] : null;
        }
        function getPrice (price) {
            return String((price/100).toFixed(2)).replace('.',',');
        }
        function getElige8Price (apuesta) {
            var precio = false;
            if (apuesta.apuestaJuegoAsociado && apuesta.apuestaJuegoAsociado.importe) {
                precio = apuesta.apuestaJuegoAsociado.importe;
                precio = String((precio/100).toFixed(2)).replace('.',',');
            }
            return precio; 
        }
        //Format lista fecha Sorteo
        function getDateBets(array) {
            var listasorteos = array.listaSorteos ? array.listaSorteos : array;
            return listasorteos.map(function(i) {
                var sorteo = i.SorteoDto? i.SorteoDto.fecha : i.fecha;
                return sorteo
            });}

//*********************************************************//
// Funcion del servicio para inicio controlador
function initServiceFavoritasAgain(data) {
    if (!data) { throw new Error('El servicio initServiceFavoritasAgain necesita como parametro los datos pasados de la pantalla anterior ($stateParams.dataTransfer)'); }
    // Peticion al servicio
    var url = config.services.host + config.services.favouriteAgain;
    var params = formatParams(data);
    console.info('<============================Rejugar Favoritas: Pending====================================>');
    return $http({ method:'POST', url:url, params:params }).then(function(res) {
        console.log('Respuesta servicio',res); //Activar para ver lo que devuelve el servicio
        try {
            $rootScope.cancelBetData = {
                idJ: data.gameId || $rootScope.aJuego.stateParams.game_id,
                metod: data.betType || "sencilla",
                idS: res.data.compraDto[0].ApuestaDto.idSorteo || "no es loteria"
              };
            if(res.data.error) { throw res; }
            if(res.data.filtro) { throw res; }
            if(res.data.Filtro) { throw res; }
            if (res.data.compraDto[0].ApuestaDto.msgError) {throw res;}
            return formatData(res.data);
        }
        catch(err) {
            
            popupSrv.hideLoading();
            popupSrv.showErrorPopup(requestSrv.errorHandler2(res)); //Sistema de errores el servicio requestSrv
			$rootScope.selaeGoBack();
        }
    }, function(err) {
        //Sistema de errores el servicio requestSrv
        popupSrv.hideLoading();
        popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
		$rootScope.selaeGoBack();
    });

    //****** Funciones de ayuda al servcio ****************/
    //Funcion para formatear los parametros de la peticion
    function formatParams(data) {
        var changeableParams = {
            actionController: 'favoritas_rejugar',
            idFavorita: data.Id,
            idJuego: data.gameId,
            pronostico: data.originalCombination,
            juegoAsociado: data.haveasociatedGame,
            metodo: data.betType,
          };

        if ( data.gameId == 1 && data.combination.reintegro ) {
            changeableParams.reintegro = data.combination.reintegro;
        }

      return changeableParams;
    }    
  }
//*********************************************************//



//*********************************************************//
//Funcion para confirmar una apuesta rejugada favorita
function confirmServiceFavoritasPlayAgain(data) {
    if (!data) { throw 'El servicio initServiceFavoritasAgain necesita como parametro los datos pasados de la pantalla anterior ($stateParams.dataTransfer)';}
    var game = getUrlGame(data.gameId);
    var serviceUrl1 = config.services.host + config.services[game.service1]; //Configura la url para la peticion al servicio
    var serviceUrl2 = config.services.host + config.services[game.service2]; //Configura la url para la peticion al servicio
    
    //Peticion al primer servicio
    console.info('<============================Configurar Apuesta: Pending====================================>');
    return $http({ method:'POST', url:serviceUrl1 }).then(function successCallback(res) {
        console.log('Respuesta servicio',res); //Activar para ver lo que devuelve el servicio
        try {
            if(res.data.filtro || res.data.Filtro || res.data.error) { throw res; }
            if (res.data.filtroBean && res.data.filtroBean[0].filtroErrorNombre === 'filtroNoPermiteCarga') {
                requestSrv.cancelBet($rootScope.cancelBetData.idJ,$rootScope.cancelBetData.metod,$rootScope.cancelBetData.idS)
            }
            if (res.data.compraDto[0].ApuestaDto.msgError) {throw res;}
            return res.data.compraDto[0]; //$http({ method:'POST', url:serviceUrl2 });
        } catch(err) {
            popupSrv.hideLoading();
            popupSrv.showErrorPopup(requestSrv.errorHandler2(res, {data:$scope.data.service1, page:'app.myFavouritesPlayAgain'})); //Sistema de errores el servicio requestSrv
        }
    }, function errorCallback(err) {
        popupSrv.hideLoading();
        popupSrv.showErrorPopup(requestSrv.errorHandler2( err)); //Sistema de errores el servicio requestSrv
    });

    function getUrlGame(data) {
        switch(data) {
            case 1: return {
                service1: 'buyStepPrimitiva',
                service2: 'buyPrimitiva'
            }
            case 2: return {
                service1: 'buyStepQuiniela',
                service2: 'buyQuiniela'
            }
            case 3: return {
                service1: 'buyStepEuromillon',
                service2: 'buyEuromillon'
            }
            case 4: return {
                service1: 'buyStepBonoloto',
                service2: 'buyBonoloto'
            }
            case 5: return {
                service1: 'buyStepGordo',
                service2: 'buyGordo'
            }
            case 6: return {
                service1: 'buyStepQuinigol',
                service2: 'buyQuinigol'
            }
            case 7: return {
                service1: 'buyStepLototurf',
                service2: 'buyLototurf'
            }
            case 8: return {
                service1: 'buyStepQuintuple',
                service2: 'buyQuintuple'
            }
            case 9:
            case 10: return {
                service1: 'buyStepLoteria',
                service2: 'buyLoteria'
            }
        }
    }
}
//*********************************************************//
var race = ["Carrera1", "Carrera2", "Carrera3", "Carrera4", "Carrera5(1º)", "Carrera5(2º)"];
var quin = ["Equipo 1-Equipo 2", "Equipo 3-Equipo 4", "Equipo 5-Equipo 6", "Equipo 7-Equipo 8", "Equipo 9-Equipo 10", "Equipo 11-Equipo 12","Equipo 13-Equipo 14", "Equipo 15-Equipo 16", "Equipo 17-Equipo 18", "Equipo 19-Equipo 20", "Equipo 21-Equipo 22", "Equipo 23-Equipo 24", "Equipo 25-Equipo 26", "Equipo 27-Equipo 28"];
$scope.race=race;
$scope.quin=quin;

}]);