angular.module('selae.core.controllers')
.controller('favoritesCtrl', ['$scope', '$state','$ionicHistory','$filter', '$ionicScrollDelegate','$rootScope','storageProvider', 'analyticsSrv',
    function($scope, $state, $ionicHistory, $filter, $ionicScrollDelegate,$rootScope,storageProvider,analyticsSrv) {
        $scope.dragging = false;
        var draggingElement = null;
        var dragOrigin = null;
        var swapOrigin = null;
        var swappedElement = null;
        var lastId = null;
        
        //MAMOV-598
        var promiseGetFirstLogin = storageProvider.getData(storageProvider.KEY_STORAGE_FIRSTLOGIN);
        promiseGetFirstLogin.then(
            function(isFirstLogin){
                $scope.first = (isFirstLogin == null || isFirstLogin === undefined || isFirstLogin);
                if(isFirstLogin && $rootScope.logged === true){
                    var promiseSetFirstLogin = storageProvider.setData(storageProvider.KEY_STORAGE_FIRSTLOGIN, false);
                    promiseSetFirstLogin.then(
                        function(exito){
                            Console.logGreen('Éxito al guardar KEY_STORAGE_FIRSTLOGIN - favourites.js', exito);
                        },
                        function(error){
                            Console.logPurple('Éxito al guardar KEY_STORAGE_FIRSTLOGIN - favourites.js', error);
                        }
                    );
                }
            },
            function(error){
                Console.logPurple('Fracaso al obtener KEY_STORAGE_FIRSTLOGIN - favouritesCtrl.js', error);
                Console.logPurple('Por defecto se pondrá a false', null);
                $scope.first = false;
            }
        );

        if(window.ga !== undefined) {analyticsSrv.trackView('Ajustes Juegos Favoritos');}
        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
            viewData.enableBack = true;
        });

        $scope.$on('draggable:start', function(){
            $ionicScrollDelegate.freezeScroll(true);
        });

        $scope.$on('draggable:end', function(){
            $ionicScrollDelegate.freezeScroll(false);
        });

        //las líneas que estaban aquí, sube al retorno de la promesa de la MAMOV-598 arriba.
        //ya que si no tenemos la promesa resuelta, no podremos acceder al isFirstLogin.

        //MAMOV-598
        var promiseGetGames = storageProvider.getData(storageProvider.KEY_STORAGE_GAMES);
        promiseGetGames.then(
            function(thegames){
                if(thegames != null){
                    try{
                        $scope.games = JSON.parse(thegames);
                    }catch(parseError){
                        //prevención posibles tipados bbdd nativa.
                        $scope.games = thegames;
                    }
                }else{
                    $scope.games = null;
                }
            },
            function(error){
                Console.logPurple('Fracaso al obtener KEY_STORAGE_GAMES - favouritesCtrl.js', error);
                $scope.games = null;
            }
        );
        


        $scope.select = function(index) {
            $scope.games[index].favorite = !$scope.games[index].favorite;
        };

        $scope.selectAll = function() {
            angular.forEach($scope.games, function(item, key){
                item.favorite = true;
            });
        };

        $scope.submit = function(){
            //MAMOV-598
            var promiseSetGames = storageProvider.setData(storageProvider.KEY_STORAGE_GAMES, JSON.stringify($scope.games));
            promiseSetGames.then(
                function(exito){
                    Console.logGreen('Éxito al almacenar KEY_STORAGE_GAMES - favourites.js', exito);
                    $state.go("app.home");
                },
                function(error){
                    Console.logPurple('Fracaso al almacenar KEY_STORAGE_GAMES - favourites.js', error);
                    //TODO: realmente debemos ir a la home si no se puede guardar?
                    $state.go("app.home");
                }
            );
        };

        var swap = function(id1, id2){
            var array = angular.copy($scope.games);
            var aux = array[id1];
            array[id1] = array[id2];
            array[id2] = aux;
            $scope.games = array;
        };

        $scope.onDropComplete= function(destiny, origin){
            swap(origin,destiny);
        };

        $scope.onHold= function(){
            if (navigator.vibrate){
                navigator.vibrate(100);
            }
        };
    }
]);
