
angular.module('selae.core.controllers')

.controller('LandingCtrl', ['$scope', 'gamesProvider','loginSrv','config','$rootScope', '$ionicHistory', '$state','requestSrv','popupSrv','$timeout','htmlModalSrv','storageProvider', 'analyticsSrv',
	function($scope, gamesProvider, loginSrv, config, $rootScope, $ionicHistory, $state, requestSrv, popupSrv, $timeout, htmlModalSrv, storageProvider, analyticsSrv) {

	if(window.ga !== undefined) {analyticsSrv.trackView('Landing');}

	//Ojo, no podemos ejecutar esto sin tener las propiedades, por ello se espera 
	//a que app.js las cargue.
	$rootScope.$watch('lockProperties', function(deboIterar, oldValue) {
		if(!deboIterar){
			// se comprueba si tenemos conexión o no despues de obtener el properties, bien del local o bien del servicio
			var promiseGetLegalAd = storageProvider.getData(storageProvider.KEY_STORAGE_LEGALAD);
			promiseGetLegalAd.then(
				function(legalAdAccepted){
					if ( legalAdAccepted === null || legalAdAccepted == 'null' || legalAdAccepted === undefined ) {
						try {
							htmlModalSrv.show($scope, "legalAdvice", "avisoLegal");
						} catch(e) {
							console.log("no carga aviso legal");
						}
					}
				},
				function(error){
					Console.logPurple('Fracado al recuperar legalAdAccepted - landingCtrl.js ', error);
				}
			);
		}
	});

	gamesProvider.setGames();

	if (ionic.Platform.isAndroid()) {
		$scope.registerButton = true;
	} else {
		$scope.registerButton = false;
	}
	$scope.loginSrv = loginSrv;
	$scope.landingHeightCarousel = 0;
	$scope.textoHome = "";

	$rootScope.$watch('selae.properties', function(newValue, oldValue) {
			$scope.slickConfig.enabled = false;
	   		$scope.landingCarousel = $scope.getLandingItems();
		$timeout(function() {
	   		$scope.slickConfig.enabled = true;
	   	});
   	});

	$scope.slickConfig = {
		enabled: false,
		autoplay: false,
		swipeToSlide: true,
		arrows: false,
		infinite: false,
		dots: true,
		customPaging: function (slider,i){
			return '<div class="landingCarousel__indicator rn-carousel-indicator"><span></span></div>';
		},
		event: {
			init: function(){
				angular.element('.landing__body__bottom').prepend(angular.element('.slick-dots'));
				var x = angular.element(".sl-topContainerLogo").outerHeight();
				$scope.landingHeightCarousel = window.innerHeight-x;
			}
		}
	};

	$scope.getLandingItems = function(){
		if ($rootScope.selae && $rootScope.selae.properties) {
			//Ojo con el tipado de los datos de bbdd nativa, JSON -> String.
			return [
				{
					"img": $rootScope.selae.properties["inicio.imagen1.fuente"],
					"link": $rootScope.selae.properties["inicio.imagen1.url"],
					"dest": $rootScope.selae.properties["inicio.imagen1.destino"],
					"title": $rootScope.selae.properties.landing1,
					"subtitle": $rootScope.selae.properties.landing2
				},
				{
					"img": $rootScope.selae.properties["inicio.imagen2.fuente"],
					"link": $rootScope.selae.properties["inicio.imagen2.url"],
					"dest": $rootScope.selae.properties["inicio.imagen2.destino"],
					"title": $rootScope.selae.properties.landing1,
					"subtitle": $rootScope.selae.properties.landing2
				},{
					"img": $rootScope.selae.properties["inicio.imagen3.fuente"],
					"link": $rootScope.selae.properties["inicio.imagen3.url"],
					"dest": $rootScope.selae.properties["inicio.imagen3.destino"],
					"title": $rootScope.selae.properties.landing1,
					"subtitle": $rootScope.selae.properties.landing2
				}
			].sort(function() {return Math.floor(Math.random()*3)-1;});
		}
	};
	$scope.openLink = function(link,dest){
        if(dest.trim() == "navegador"){
            window.open(link,'_system');
        }
        else{
            $state.go(link.trim());
        }
    };

	$scope.register = function(){
		if ( $rootScope.selae.properties.regWeb === "true" ) { 
			window.open(config.urls.register,'_system');
		 } else { 
			$state.go("app.registerRoute");
		  }
		 
	};

	$scope.goHome = function(){
		$state.go("app.home");
	};


	$scope.showPopup = function() {
		$rootScope.notFirstTime = true;
		if ($rootScope && $rootScope.selae && $rootScope.selae.properties && $rootScope.selae.properties.initPopUp) {
			popupSrv.showErrorPopup($rootScope.selae.properties.initPopUp);
		}
	};

	
	if (!$rootScope.notFirstTime) {
		$scope.showPopup();
	}

	
}]);


