angular.module('selae.core.controllers')

.controller('legalAdviceCtrl', ['$scope', 'htmlModalSrv','$rootScope','$http','$sce', 'popupSrv', 'storageProvider','uuidProvider','$ionicPlatform', 'analyticsSrv',
 function($scope,htmlModalSrv, $rootScope, $http, $sce, popupSrv, storageProvider, uuidProvider, $ionicPlatform, analyticsSrv) {
	$scope.htmlModalSrv = htmlModalSrv;

	var backButtonChange = $ionicPlatform.registerBackButtonAction(function (event) {
		event.preventDefault();
	}, 1000);
	$scope.$on('$destroy', backButtonChange);

	if (window.ga !== undefined) { analyticsSrv.trackView('Aviso Legal'); }

	$scope.submit = function(){
		var promiseGetUUID = uuidProvider.getUUID();
		promiseGetUUID.then(
			function(uuid){
				procesarAvisoLegal(uuid);
			},
			function(error){
				Console.logPurple('No se ha podido obtener un uuid', error);
			}
		);
		
		//TODO: esto no se podrá cerrar hasta que no se invoque a SELAE con el uuid + versión términos.
		//Mover cuando se tenga la API de SELAE.
		htmlModalSrv.close();
	};

	  function procesarAvisoLegal (uuid){
		//TODO: pendiente de SELAE recibir el API de servicios para enviar el uuid + versión del aviso legal.
		var promiseGetLegalAd = storageProvider.getData(storageProvider.KEY_STORAGE_LEGALAD);
		promiseGetLegalAd.then(
			function(legalAdAccepted){
				if ( legalAdAccepted === null || legalAdAccepted == 'null' || legalAdAccepted === undefined ){
					var promiseSetLegalAd = storageProvider.setData(storageProvider.KEY_STORAGE_LEGALAD, true);
					promiseSetLegalAd.then(
						function(valor){
							Console.logGreen('Éxito al guardar estado legal - legalAdviceCtrl.js ', valor);
						},
						function(error){
							Console.logPurple('Fracaso al guardar estado legal - legalAdviceCtrl.js ', error);
						}
					);
				}
			},
			function(error){
				Console.logPurple('Fracado al recupar el legalAdAccepted - legalAdviceCtrl.js', error);
			}
		);
	}

	$scope.loaded = false;

	var obj = {
		withCredentials: false
	};
	
	$http.get($scope.modalContent, obj)
		.then(function(res) {
	    	$scope.modalContent = $sce.trustAsHtml(res.data);
	    	$scope.loaded = true;
		})
		.catch(function(err) {
			popupSrv.showErrorPopup("requestTimeout");
		});
 }]);
