angular.module('selae.core.controllers')

.controller('LoginCtrl', ['$scope','$rootScope','loginSrv','popupSrv','config','$timeout','requestSrv', 'storageProvider','uuidProvider', 'analyticsSrv',
function($scope,$rootScope,loginSrv,popupSrv,config,$timeout,requestSrv,storageProvider,uuidProvider,analyticsSrv) {
	//bandera de control de la pulsación del logado para evitar que haya múltiples pulsaciones.
	//realmente esto debería trabajar con promesas, interceptar la respuesta de la promesa y NO
	//tratarlo con rootScope.
	$rootScope.isLogging = false; 
	if(window.ga !== undefined) {analyticsSrv.trackView('Login');}

	// Se añade para controlar multiples popUps por inactividad
	$rootScope.popUpSessionTimeout = false;

	requestSrv.logOut2();
	//TODO: este fragmento es simplemente para probar que el UUID es el mismo en dtas. ejecuciones.
	//Se puede ver otro ejemplo ya integrado en el legalAdviceCtrl
	var promiseGetUUID = uuidProvider.getUUID();
	promiseGetUUID.then(
		function(uuid){
			// alert(uuid);
		},
		function(error){
			// alert(error);
		}
	);

	$scope.closeLogin = function() {
		window.selae.waitingloginAccenggageParameters('borrar Callback');
		loginSrv.closeLogin();
	};
	
	$scope.errorPassword = false;

	$scope.$watch("loginData.password", function(newValue, oldValue) {
	    $scope.errorPassword = false;
	});

	if (!$scope.loginData) {
		//MAMOV-598
		var promiseGet = storageProvider.getData(storageProvider.KEY_STORAGE_USER);
		promiseGet.then(
			function(storagedUsername){
				$scope.loginData = {
					username: storagedUsername == null ? "" : storagedUsername,
					password: ""
				};
			},
			function(error){
				$scope.loginData = {
					username: "",
					password: ""
				};
			});
	}

	$scope.requestPassword = function() {
	    window.open(config.urls.requestPassword, '_system');
	};


	// Objeto de la huella para validaciones
	$scope.fingerprint = {
		enable: false,
		available: false
	};

	// Comprobacion si el dispositivo tiene huellas registradas o esta disponible.
	try {
		if (ionic.Platform.isAndroid()) {
        	rootdetection.isDeviceRooted(function (result) {
            	if (!result) {
					window.plugins.touchid.isAvailable(function() {
						//MAMOV-598
						var promiseGet = storageProvider.getData(storageProvider.KEY_STORAGE_CLAVE);
						promiseGet.then(
							function(clave){
								console.log(clave);
								window.plugins.touchid.has(clave, 
									function() {
										fingerPrintLogin(clave);
									}, function() {
										$scope.fingerprint.available = true;
									});
							},
							function(error){
								
							});
					}, 
					function(err) { 
						console.warn("No tiene sistema de huellas"); 
					});
            	}
        	}, null);
        } else if (ionic.Platform.isIOS()) {
        	jailbreakdetection.isJailbroken(function (result) {
            	if (!result) {
					window.plugins.touchid.isAvailable(function() {
						//MAMOV-598
						var promiseGet = storageProvider.getData(storageProvider.KEY_STORAGE_CLAVE);
						promiseGet.then(
							function(clave){
								if (!clave) {clave = '';}
								window.plugins.touchid.has(clave, function() {
									fingerPrintLogin(clave);
								}, function() {
									$timeout(function() {
										$scope.fingerprint.available = true;
									});
								});
							},
							function(error){
								Console.logPurple('Fracaso al realizar el get de KEY_STORAGE_CLAVE - loginCtrl.js', error);
							}
						);
					},
				function(error){
					Console.log('Ocurrió un error al ver si la huella está disponible: ' + error);
				});
        		}
        	}, null);
    	}
	} catch(e) {console.error(e);}

	// Funcion que ejecuta al jacer login
	$scope.loginWithCredentials = function() {
		if(!$rootScope.isLogging){
			$rootScope.isLogging = true;
			var user = $scope.loginData.username;
			var pass = $scope.loginData.password;
			if (user && pass) {
				// try {cordova.plugins.Keyboard.close();} catch(e) {console.warn(e);}
				$scope.fingerprint.enable ? fingerPrintSave(user, pass) : login(user, pass);
			} else { 
				//TODO: ver si se pasa al properties.
				popupSrv.showErrorPopup('Debes rellenar tu usario y contraseña'); 
				$rootScope.isLogging = false;
			}
		}
	};

	// Login
	function login(user, pass) {
		try{
			delete $rootScope.viewMoreBet;
			//console.log("Variables borradas");
		}catch(error){
			console.warn("Las variables de la sesion anterior están borradas");
		}

		loginSrv.login($scope, user, pass, "credentials");
	}
	//Autentificacion y guardado por huella
	function fingerPrintSave(user, pass) {
		try {
			var clave = generateToken();
			window.plugins.touchid.save(clave, pass, function() {
				//MAMOV-598
				//Ojo aquí, se sutituye la key 'user' por 'SelaeUsername'
				//localStorage.setItem('user', user);
				//localStorage.setItem('clave', clave);
				var promiseSetUser = storageProvider.setData(storageProvider.KEY_STORAGE_USER, user);
				promiseSetUser.then(
					function(exito){
						Console.logGreen('Éxito en el almacenamiento del usuario - fingerPrintSave', exito);
					},
					function(error){
						Console.logPurple('Fracaso en el almacenamiento del usuario - fingerPrintSave', error);
					}
				);

				var promiseSetClave = storageProvider.setData(storageProvider.KEY_STORAGE_CLAVE, clave);
				promiseSetClave.then(
					function(exito){
						Console.logGreen('Éxito en el almacenamiento de la clave - fingerPrintSave', exito);
					},
					function(error){
						Console.logPurple('Fracaso en el almacenamiento del usuario - fingerPrintSave', error);
					}
				);

				//A este método lo podemos llamar ya, porque lo anterior es un set y ya tenemos los datos.
				login(user, pass);
			}, function(e) { console.error(e); });
		} catch(e) { console.error(e); }
	}

	//Autentificacion con huella guardada
	function fingerPrintLogin(clave) {
		try {
			//TODO: llevar esto fuera al properties.
			window.plugins.touchid.verify(clave, 'Pon aqui tu dedo para el reconocimiento', function(pass) {
				//var user = localStorage.getItem('user', user);
				var promiseGetUser = storageProvider.getData(storageProvider.KEY_STORAGE_USER);
				promiseGetUser.then(
					function(user){
						login(user, pass);
					},
					function(error){
						console.error(e); 
						$scope.fingerprint.available = true;
					}
				);
			}, function(e) { 
				console.error(e); 
				$scope.fingerprint.available = true; 
			});
		} catch(e) { console.error(e); }
	}

	// Funcionalidad para generar tokens aleatorios
	function generateToken() {
    	var text = "";
    	var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    	for( var i=0; i < 50; i++ )
    	    text += possible.charAt(Math.floor(Math.random() * possible.length));
    	return text;
	}

}]);
