angular.module('selae.core.controllers')
.controller('MenuCtrl', ['$scope','$rootScope', '$ionicModal', 'loginSrv', 'htmlModalSrv','$ionicSideMenuDelegate', 'config', '$state', '$filter','$ionicScrollDelegate', '$timeout', '$ionicHistory','storageProvider', 'analyticsSrv',
	function($scope, $rootScope, $ionicModal, loginSrv, htmlModalSrv, $ionicSideMenuDelegate, config, $state, $filter,$ionicScrollDelegate, $timeout, $ionicHistory, storageProvider, analyticsSrv) {
	
	$scope.loginSrv = loginSrv;

	$scope.debug = config.DEBUG;

	$scope.helpShown = false;

	$scope.registerButton = 'true';
	$scope.registerImage = false;
	$scope.version = '';
	$scope.mailto = '';
	$scope.faq = '';

	$rootScope.$watch('lockVersion', function(deboIterar, oldValue) {
		if(!deboIterar){
			$scope.version = $rootScope.version;
		}
	});
	
	$rootScope.$watch('lockProperties', function(deboIterar, oldValue) {
		if (!deboIterar) {
			$scope.registerButton = $rootScope.selae.properties.botonRegistroIos !== undefined? $filter("translate")("botonRegistroIos") : 'true';
			$scope.mailto = $rootScope.selae.properties !== undefined? $rootScope.selae.properties["contacto.enlace"] : "";
			$scope.faq = $rootScope.selae.properties !== undefined? $rootScope.selae.properties["texto.preguntasfrecuentes.nuestrosjuegos"] : "";
		}
	});

	var service={};

	$scope.openFacebook = function(){
		if(window.ga !== undefined) {analyticsSrv.trackEvent('Menú', 'RRSS', "Facebook");}
		window.open($rootScope.selae.properties["facebook.enlace"],'_system');
	};

	$scope.openTwitter = function(){
		if(window.ga !== undefined) {analyticsSrv.trackEvent('Menú', 'RRSS', "Twitter");}
		window.open($rootScope.selae.properties["twitter.enlace"],'_system');
	};

	$scope.openYoutube = function(){
		if(window.ga !== undefined) {analyticsSrv.trackEvent('Menú', 'RRSS', "Youtube");}
		window.open($rootScope.selae.properties["youtube.enlace"],'_system');
	};

	$scope.toggleHelp = function(){
		$scope.helpShown = !$scope.helpShown;
		$timeout(function () {
			$ionicScrollDelegate.resize();
		},100);
	};

	$scope.register = function(location){
		if (!location) {
			$ionicSideMenuDelegate.toggleLeft(); 
		}
		if ( $rootScope.selae.properties.regWeb === "true" ) { 
			if(window.ga !== undefined) {analyticsSrv.trackEvent('Menú', 'Registro', "Registro");}
			window.open(config.urls.register,'_system');
		 } else { 
			$state.go("app.registerRoute", null, "location=replace");
		  }
	};

	$scope.login = function(location){
		if (!location) {
			$ionicSideMenuDelegate.toggleLeft();
		}
		loginSrv.showLogin($scope, "Menú");
		$timeout(function () {
			$ionicScrollDelegate.resize();
		},100);
	};

	$scope.logout = function(){
		loginSrv.logout();
	};

	$scope.loadLotobolsa = function(view){
		if(window.ga !== undefined) { analyticsSrv.trackEvent('Cabecera', 'Cargar Lotobolsa', "Cargar Lotobolsa");}
		$state.go("app.loadLotobolsa", null, "location=replace");
	};

	$scope.legalWarning = function()
	{
		$ionicSideMenuDelegate.toggleLeft();
		htmlModalSrv.show($scope, "legalAdvice","avisoLegal");
	};

	$scope.responsibleGaming = function()
	{
		$ionicSideMenuDelegate.toggleLeft();
		if(window.ga !== undefined) {analyticsSrv.trackView('Ayuda-Juego Responsable');}
		htmlModalSrv.show($scope, "modal","respGaming.enlace");
	};

	$scope.privacyPolicy = function()
	{
		$ionicSideMenuDelegate.toggleLeft();
		if(window.ga !== undefined) {analyticsSrv.trackView('Política Protección Datos');}
		htmlModalSrv.show($scope, "politicaPrivacidad", "politica.enlace");
	};
	
	$scope.editProfile = function(sideMenu) {
		if (sideMenu) {
			$ionicSideMenuDelegate.toggleLeft();
		}

		if ($rootScope.selae.properties.perfilVisible === 'true') {
			$state.go("app.userProfile");
		} else {
			window.open(config.urls.editProfile, '_system');
		}
	};

	$scope.contactlink = function() {
		if(window.ga) { analyticsSrv.trackEvent('Menú', 'Ayuda', "Contacto"); }
		// $state.go("app.contact", null, "location=replace");
		window.open($rootScope.selae.properties.contactURL, '_system','location=no');
	};

	$scope.shareApp = function(){
		if(window.ga !== undefined) {analyticsSrv.trackEvent('Menú', 'Compartir APP', 'Compartir APP');}
		// this is the complete list of currently supported params you can pass to the plugin (all optional)
		
		var options = {
		  message: $rootScope.selae.properties['texto.compartirapp'], // not supported on some apps (Facebook, Instagram)
		  subject: $filter("translate")("shareAppSubjet"), // fi. for email
		  files: [], // an array of filenames either locally or remotely
		  url: (device.platform == 'iOS') ? $rootScope.selae.properties['descarga.ios.enlace'] : $rootScope.selae.properties['descarga.android.enlace'],
		  chooserTitle: $filter("translate")("shareAppTitle") // Android only, you can override the default share sheet title
		};

		var onSuccess = function(result) {
		  console.log("Share completed? " + result.completed); // On Android apps mostly return false even while it's true
		  console.log("Shared to app: " + result.app); // On Android result.app is currently empty. On iOS it's empty when sharing is cancelled (result.completed=false)
		};

		var onError = function(msg) {
		  console.log("Sharing failed with message: " + msg);
		};

		window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
	};


	$scope.menuMyBets = function() {
		$ionicHistory.clearCache().then(function() { $state.go('app.myBets'); });
	};	

}]);
