angular.module('selae.core', ['ionic', 'selae.core.controllers'])
.config(['$stateProvider', '$urlRouterProvider', function($stateProvider, $urlRouterProvider) {
    // Selae app core states
    $stateProvider

    .state('landing', {
        url: '/landing',
        templateUrl: 'core/templates/landing.html',
        controller: 'LandingCtrl'
    })

    .state('app', {
        url: '/app',
        abstract: true,
        templateUrl: 'core/templates/menu.html',
        controller: 'MenuCtrl'
    })

    .state('app.settings', {
        url: '/settings',
        abstract: true,
        views: {
            'menuContent': {
                templateUrl: 'core/templates/settings.html'
            }
        }
    })

    .state('app.settings.favorites', {
        url: '/favorites',
        views: {
            'tab-favorites': {
                templateUrl: 'core/templates/favorites.html',
                controller: 'favoritesCtrl'
            }
        }
    })

    .state('app.settings.notifications', {
        url: '/notifications',
        views: {
            'tab-notifications': {
                templateUrl: 'core/templates/notifications.html',
                controller: 'NotificationsCtrl'
            }
        }
    })

    .state('app.home', {
        url: '/home',
        views: {
            'menuContent': {
                templateUrl: 'core/templates/home.html',
                controller: 'HomeCtrl'
            }
        }
    })

    .state('favoritesInit', {
      url: '/favorites-init',
      templateUrl: 'core/templates/favorites.html',
      controller: 'favoritesCtrl'
    })

    .state('app.respGaming', {
         url: '/respGaming',
        views: {
            'menuContent': {
                templateUrl: 'core/templates/respGaming.html'
            }
        }
    })

    .state('app.faq', {
        url: '/faq',
        abstract: true,
        views: {
            'menuContent': {
                templateUrl: 'core/templates/faq.html',
                controller: 'FaqCtrl'
            }
        }
    })

    .state('app.faq.ourgames', {
        url: '/ourgames/:content/:analytics',
        views: {
            'tab-ourgames': {
                templateUrl: 'core/templates/generic-html.html',
                controller: 'genericHtmlCtrl'
            }
        }
    })

    .state('app.faq.basics', {
        url: '/basics/:content/:analytics',
        views: {
            'tab-basics': {
                templateUrl: 'core/templates/generic-html.html',
                controller: 'genericHtmlCtrl'
            }
        }
    })

    .state('app.faq.playonline', {
        url: '/playonline/:content/:analytics',
        views: {
            'tab-playonline': {
                templateUrl: 'core/templates/generic-html.html',
                controller: 'genericHtmlCtrl'
            }
        }
    })

    .state('app.help', {
        url: '/help',
        abstract: true,
        views: {
            'menuContent': {
                templateUrl: 'core/templates/help.html',
                controller: 'HelpCtrl'
            }
        }
    })

    .state('app.help.step', {
        url: '/step',
        views: {
            'tab-step': {
                templateUrl: 'core/templates/step-play-help.html',
                controller: 'StepPlayHelpCtrl'
            }
        }
    })

    .state('app.help.oneclick', {
        url: '/oneclick/:content/:analytics',
        views: {
            'tab-oneclick': {
                templateUrl: 'core/templates/generic-html.html',
                controller: 'genericHtmlCtrl'
            }
        }
    })

    .state('app.help.voice', {
        url: '/voice/:content/:analytics',
        views: {
            'tab-voice': {
                templateUrl: 'core/templates/generic-html.html',
                controller: 'genericHtmlCtrl'
            }
        }
    })

    .state('app.contact', {
        url: '/contact',
         views: {
            'menuContent': {
                templateUrl: 'core/templates/contact.html',
                controller: 'contactCtrl'
            }
         } 
    });

    // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/app/home');
}]);
