angular.module('selae.core.directives')
.directive('imagesCarouselDrv', [function() {
    return {
        restrict: 'E',
        templateUrl: 'core/templates/images-carousel.html',
        scope:{
            data: '='
        },
        controller: ['$scope','$state','popupSrv','$rootScope','$timeout','$filter','config','analyticsSrv', function($scope, $state, popupSrv, $rootScope,$timeout,$filter,config,analyticsSrv){
            $rootScope.$watch('selae.properties', function(newValue, oldValue) {
                $scope.slickConfig.enabled = false;
                $timeout(function() {
                    $scope.slickConfig.enabled = true;
                });
            });
            var autoplaySpeed = 3000;
            try {
                autoplaySpeed = $rootScope.selae.properties.autoplaySpeedCarousel;
            } catch (e) {
               console.warn("Aun no ha cargado el properties");
            }
            //console.log('autoplaySpeedCarousel',$rootScope.selae.properties.autoplaySpeedCarousel);
            $scope.slickConfig = {
                enabled: true,
                //initialSlide: parseInt(Math.random() * (3 - 0) + 0),
                autoplay: true,
                autoplaySpeed: autoplaySpeed || 3000,
                swipeToSlide: true,
                arrows: false,
                infinite: true,
                dots: true,
                // initialSlide: parseInt(Math.random() * (3 - 0) + 0),
                // autoplaySpeed: parseInt($rootScope.selae.properties.carrouselTime, 10) || 3000,
                dotsClass: 'slideBet-dots',
                event: {
                    init: function(){
                        angular.element('.image-carousel-dots').prepend(angular.element('.slideBet-dots'));
                    }
                }
            };

            $scope.openLink = function(link,dest, game_id){
                if(dest.trim() == "navegador"){
                    window.open(link,'_system');
                }
                else{
                    if (link.trim() == "app.stepBet" || link.trim() == "app.quickBet"){
                        if ($rootScope.logged){
                            $state.go(link.trim(),{game_id: game_id.trim()});
                        } else{
                            popupSrv.showErrorPopup("mustBeLogged");
                        }
                    }
                    else if (link.trim() == "app.loadLotobolsa"){
                        if ($rootScope.logged){
                            $state.go(link.trim());
                        } else{
                            popupSrv.showErrorPopup("mustBeLogged");
                        }
                    }
                    else{
                        $state.go(link.trim());
                    }
                }
            };
        }],
        link: function(scope, element) {
        }
    };
}]);