angular.module('selae.core.filters')
.filter('dateToText', ['$filter','opSrv', function($filter, opSrv) {
    
    /// mode = 0: Incluye año en una sola fecha
    /// mode = 1 : Solo el día
    /// mode = 2 : día númerico + mes texto
    function filterFn(data, mode) {
        var result = "";
        var date= new Date();
        var days = ['sunday', 'monday', 'tuesday', 'wednesday', 'thursday', 'friday', 'saturday'];
        var months = ['january', 'february', 'march', 'april', 'may', 'june', 'july', 'august', 'september', 'october', 'november', 'december'];
        var shortMonths = ['jan', 'feb', 'mar', 'apr', 'mayShort', 'jun', 'jul', 'aug', 'sep', 'oct', 'nov', 'dec'];

        if (data !== undefined && data.constructor === Array){
            angular.forEach (data, function(value, key){
                if (value.indexOf("+") !== -1){
                     date = opSrv.dateFromString(value.substring(0,value.indexOf('+')));
                 }else{
                     date = opSrv.dateFromString(value);
                 }
                result = result + $filter('translate')(days[date.getDay()]) + " " + date.getDate() + " de " + $filter('translate')(months[date.getMonth()]);
                if (key == data.length - 2){
                    result = result + " y ";
                }
                else if (key != data.length - 1){
                    result = result + ", ";
                }
            });
        }
        else{
            if (data !== undefined ){
                var pattern = new RegExp("\\D{3} \\D{3} \\d{2} \\d{4}");
                if (data.indexOf("+") !== -1){
                    date = opSrv.dateFromString(data.substring(0,data.indexOf('+')));
                }else if (pattern.test(data)){
                    date = new Date(data);
                }else{
                    date = opSrv.dateFromString(data);
                }
                result = $filter('translate')(days[date.getDay()]) + " " + date.getDate() + " de " + $filter('translate')(months[date.getMonth()]);
                if (mode === 0){
                    result = result + " de " + date.getFullYear();
                } else if(mode === 1){
                    result = $filter('translate')(days[date.getDay()]);
                } else if (mode === 2){
                    result = date.getDate() + " de " + $filter('translate')(months[date.getMonth()]);
                } else if (mode === 3){
                    result = ("0"+date.getDate()).slice(-2) + " " + $filter('translate')(shortMonths[date.getMonth()]) + " " + date.getFullYear().toString(); 
                }
            }
        }

        return result;
    }

    filterFn.$stateful = true;

    return filterFn;

}]);
