angular
    .module('selae.core.services')
	.factory('gamesProvider',gamesProvider);
	
	gamesProvider.$inject = [
		'$filter'
    ];

    function gamesProvider ($filter) {

		var games = [{
			img: "images/gameIcons/logoPrimitiva.svg",
      		imgText: "images/gameIcons/logoPrimitivaTexto.svg",
      		imgHome: "images/gameIcons/logoPrimitivaTexto.svg",
			text: "LAPR",
			idJuego: "1",
			visible: true,
			ayuda: "texto.comojugar.pasoapaso.primitiva"
		}, {
			img: "images/gameIcons/logoEuromillones.svg",
      		imgText: "images/gameIcons/logoEuromillonesTexto.svg",
      		imgHome:"images/gameIcons/logoEuromillonesTexto.svg",
			text: "EMIL",
			idJuego: "3",
			visible: true,
			ayuda: "texto.comojugar.pasoapaso.euromillon"
		}, {
			img: "images/gameIcons/logoNacional.svg",
      		imgText: "images/gameIcons/logoNacionalTexto.svg",
      		imgHome:"images/gameIcons/logoNacionalTexto.svg",
			text: "LNAC",
			idJuego: "9",
			visible: true,
			ayuda: "texto.comojugar.pasoapaso.loteria"
		}, {
			img: "images/gameIcons/logoBonoloto.svg",
      		imgText: "images/gameIcons/logoBonolotoTexto.svg",
      		imgHome:"images/gameIcons/logoBonolotoTexto.svg",
			text: "BONO",
			idJuego: "4",
			visible: true,
			ayuda: "texto.comojugar.pasoapaso.bonoloto"
		}, {
			img: "images/gameIcons/logoQuiniela.svg",
      		imgText: "images/gameIcons/logoQuinielaTexto.svg",
      		imgHome:"images/gameIcons/logoQuinielaTexto.svg",
			text: "LAQU",
			idJuego: "2",
			visible: true,
			ayuda: "texto.comojugar.pasoapaso.quiniela"
		}, {
			img: "images/gameIcons/logoGordo.svg",
      		imgText: "images/gameIcons/logoGordoTexto.svg",
      		imgHome:"images/gameIcons/logoGordoTexto.svg",
			text: "ELGR",
			idJuego: "5",
			visible: true,
			ayuda: "texto.comojugar.pasoapaso.gordo"
		}, {
			img: "images/gameIcons/logoQuinigol.svg",
      		imgText: "images/gameIcons/logoQuinigolTexto.svg",
      		imgHome:"images/gameIcons/logoQuinigolTexto.svg",
			text: "QGOL",
			idJuego: "6",
			visible: true,
			ayuda: "texto.comojugar.pasoapaso.quinigol"
		}, {
			img: "images/gameIcons/logoLototurf.svg",
      		imgText: "images/gameIcons/logoLototurfTexto.svg",
      		imgHome:"images/gameIcons/logoLototurfTexto.svg",
			text: "LOTU",
			idJuego: "7",
			visible: true,
			ayuda: "texto.comojugar.pasoapaso.lototurf"
		}, {
			img: "images/gameIcons/logoQuintupleplus.svg",
      		imgText: "images/gameIcons/logoQuintupleplusTexto.svg",
      		imgHome:"images/gameIcons/logoQuintupleplusTexto.svg",
			text: "QUPL",
			idJuego: "8",
			visible: true,
			ayuda: "texto.comojugar.pasoapaso.quintuple"
		}];

		var newIcons = false;
		
	this.setGames = function () {	
		var propertiesGames = $filter('translate')('games') || JSON.stringify(games);
		newIcons = $filter('translate')('showNewIconsGames') || 'false';

		// Ordenamos los juegos en un array
		var orderGames = JSON.parse(propertiesGames).map(function(i, index) {
			return games.map(function(j){
				if (i.text === j.text) {
					if (i.visible !== j.visible) {
						j.visible = i.visible;
					}
					return j;
				} else { return false; }
			}).filter(Boolean)[0];
		});

		// Comprobamos visibilidad
		// cambiar los iconos dinamicamente
		var parseGames = [];
			parseGames = orderGames.map(function(i, index) {
				return games.map(function(j){
					if (i.text === j.text) {
						return j;
					} else { return false; }
				}).filter(Boolean)[0];
			});
		
		games = parseGames;
	};

	this.getGames = function () {
		return games;
	};

    this.getTextIcons = function(gameId) {
		if (newIcons === 'false') {
		var gameIcon = {
			'1' : './images/gameIcons/logoPrimitivaTexto.svg',
			'2' : './images/gameIcons/logoQuinielaTexto.svg',
			'3' : './images/gameIcons/logoEuromillonesTexto.svg',
			'4' : './images/gameIcons/logoBonolotoTexto.svg',
			'5' : './images/gameIcons/logoGordoTexto.svg',
			'6' : './images/gameIcons/logoQuinigolTexto.svg',
			'7' : './images/gameIcons/logoLototurfTexto.svg',
			'8' : './images/gameIcons/logoQuintupleplusTexto.svg',
			'9' : './images/gameIcons/logoNacionalTexto.svg',
			'10' : './images/gameIcons/logoNacionalTexto.svg'
		};
		return gameIcon[gameId];
	}
		var newGameIcon = {
			'1' : './images/gameIcons/logoPrimitivaTexto.svg',
			'2' : './images/gameIcons/logoQuinielaTexto.svg',
			'3' : './images/gameIcons/logoEuromillonesTexto.svg',
			'4' : './images/gameIcons/logoBonolotoTexto.svg',
			'5' : './images/gameIcons/logoGordoTexto.svg',
			'6' : './images/gameIcons/logoQuinigolTexto.svg',
			'7' : './images/gameIcons/logoLototurfTexto.svg',
			'8' : './images/gameIcons/logoQuintupleplusTexto.svg',
			'9' : './images/gameIcons/logoNacionalTexto.svg',
			'10' : './images/gameIcons/logoNacionalTexto.svg'
	};
	return newGameIcon[gameId];
	};
	
	this.getHeaderIcon = function (gameId) {
		if (newIcons === 'false') {
			var titleLogo = {
				'1' : './images/header/tituloPrimitiva.svg',
				'2' : './images/header/tituloQuiniela.svg',
				'3' : './images/header/tituloEuromillones.svg',
				'4' : './images/header/tituloBonoloto.svg',
				'5' : './images/header/tituloGordo.svg',
				'6' : './images/header/tituloQuinigol.svg',
				'7' : './images/header/tituloLototurf.svg',
				'8' : './images/header/tituloQuintuple.svg',
				'9' : './images/header/tituloLoteria.svg',
				'10' : './images/header/tituloLoteria.svg'
			};
			return titleLogo[gameId] || './images/logoSelaeizq.png';
		}
		var newTitleLogo = {
			'1' : './images/header/tituloPrimitiva.svg',
			'2' : './images/header/tituloQuiniela.svg',
			'3' : './images/header/tituloEuromillones.svg',
			'4' : './images/header/tituloBonoloto.svg',
			'5' : './images/header/tituloGordo.svg',
			'6' : './images/header/tituloQuinigol.svg',
			'7' : './images/header/tituloLototurf.svg',
			'8' : './images/header/tituloQuintuple.svg',
			'9' : './images/header/tituloLoteria.svg',
			'10' : './images/header/tituloLoteria.svg'
		};
		return newTitleLogo[gameId] || './images/logoSelaeizq.png';	
	};

	this.getTicketIcon = function (gameId) {
		if (newIcons === 'false') {
			var titleLogo = {
				'1' : './images/ticket/game_lapr_ticket.svg',
				'2' : './images/ticket/game_laqu_ticket.svg',
				'3' : './images/ticket/game_emil_ticket.svg',
				'4' : './images/ticket/game_bono_ticket.svg',
				'5' : './images/ticket/game_elgr_ticket.svg',
				'6' : './images/ticket/game_qgol_ticket.svg',
				'7' : './images/ticket/game_lotu_ticket.svg',
				'8' : './images/ticket/game_qupl_ticket.svg'
			};
			return titleLogo[gameId] || './images/logoSelaeizq.png';
		}
		var newTitleLogo = {
			'1' : './images/ticket/game_lapr_ticket.svg',
			'2' : './images/ticket/game_laqu_ticket.svg',
			'3' : './images/ticket/game_emil_ticket.svg',
			'4' : './images/ticket/game_bono_ticket.svg',
			'5' : './images/ticket/game_elgr_ticket.svg',
			'6' : './images/ticket/game_qgol_ticket.svg',
			'7' : './images/ticket/game_lotu_ticket.svg',
			'8' : './images/ticket/game_qupl_ticket.svg'
		};
		return newTitleLogo[gameId] || './images/logoSelaeizq.png';	
	};

    return{
		setGames : this.setGames,
		getGames : this.getGames,
		getTextIcons : this.getTextIcons,
		getHeaderIcon : this.getHeaderIcon,
		getTicketIcon : this.getTicketIcon
    };
}