angular.module('selae.core.services')

.factory('htmlModalSrv', ['config','$ionicModal','$rootScope', '$state', '$timeout',
    function(config, $ionicModal, $rootScope, $state, $timeout) {
    var service = this;

    this.show = function(scope, type, content, extraData){
        if (service.modal !== undefined && service.modal.isShown()){
            service.modal.hide();
        }
        switch(type){
            case "legalAdvice":
                scope.modalContent = $rootScope.selae.properties[content];
                showModal('core/templates/legal-advice.html', scope);
                break;
            case "modal":
                scope.modalContent = $rootScope.selae.properties[content];
                showModal('core/templates/html-modal.html', scope);
                break;
            case "ticket":
                showTicketModal('games/templates/ticket-modal.html', scope, extraData);
                break;
            case "politicaPrivacidad":
                scope.modalContent = $rootScope.selae.properties[content];
                showModal('core/templates/privacidad-modal.html', scope);
                break;
            case "contratoJuegos":
                scope.modalContent = config.services.contratoJuegos;
                showModal('core/templates/privacidad-modal.html', scope);
                break;
            default:
                scope.modalContent = $rootScope.selae.properties[content];
                showModal('core/templates/html-modal.html', scope);
        }
    };

    this.close = function(){
        service.modal.hide();
        $timeout(function() {
            service.modal.remove();
        },250);
    };


    function showModal(template, scope, extraData){
        $ionicModal.fromTemplateUrl(template, {
            scope: scope,
            // backdropClickToClose: false
        }).then(function(modal) {
            service.modal = modal;
            service.modal.show();
        });
    }

    function showTicketModal(template, scope, extraData){
        scope.data = extraData.detalleApuesta;
        scope.data.detalleApuesta[0].listaSorteos = extraData.detalleApuesta.listaSorteos;
        scope.gameId = extraData.ApuestaDto.idJuego.toString();
        $ionicModal.fromTemplateUrl(template, {
            scope: scope,
        }).then(function(modal) {
            service.modal = modal;
            service.modal.show();
        });
    }

    return {
        show: this.show,
        close: this.close       
    };

}]);
