angular.module('selae.core.services')
.factory('loginSrv', ['$ionicModal', 'htmlModalSrv','$rootScope', '$http', 'popupSrv', 'requestSrv', 'config', '$state', '$ionicSideMenuDelegate', '$ionicHistory', '$interval', 'opSrv', '$timeout','$window','storageProvider', 'analyticsSrv',
	function($ionicModal, htmlModalSrv,$rootScope, $http, popupSrv, requestSrv, config, $state, $ionicSideMenuDelegate, $ionicHistory, $interval, opSrv, $timeout, $window, storageProvider, analyticsSrv) {
	var service = this;
	var minCounter = null;

	this.showLogin = function(scope, viewName, callback) {
		$rootScope.viewNameRouter = viewName;
		$rootScope.loginNavigate = callback;
	
		if (service.modal !== undefined && service.modal.isShown()){
			service.modal.hide();
		}
		showLoginModal('core/templates/login.html', scope);
	};

	// Funcion para cerrar la modal, asociado a la icono de la X
	this.closeLogin = function() {
		// console.log(service);
		service.modal.hide();
	};

	// Funcion para deslogear al usuario
	this.logout = function(login) {
		if (!login){
			popupSrv.showLoading('loggingOut');
		}

		console.log('esta abierto?', $ionicSideMenuDelegate.isOpenLeft());
		$ionicSideMenuDelegate.toggleLeft(false);
		var url = config.services.host + config.services.logout;
		console.info('<=================================LogOut: Pending=========================================>');
		$http({ method: 'POST', url: url, withCredentials: false })
			.then(function(res) {
				var url = config.services.host + config.services.logout2ndStep;
				$http({ method: 'POST', url: url, withCredentials: false })
					.then(function(res) {
						window.timerInterval.map(function(i) {
							clearInterval(i);
							console.log('Limpiado intervalo:', i);
							return null;
						}).filter(Boolean);
						
						//deleteTimeInHtml();
						$rootScope.logged = false;
						
						popupSrv.hideLoading();
						$state.go("app.home");
						console.info('<===================================LogOut: OK============================================>');
					}.bind(this), function(err) {
						popupSrv.hideLoading();
						popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
					}.bind(this));
			}.bind(this), function(err) {
				popupSrv.hideLoading();
				popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
			}.bind(this));
			
		function deleteTimeInHtml() {
			var elem = document.querySelectorAll('.iconUserMenu');
			if (elem) {
				for(i=0; i<elem.length; i++) {
					elem[i].setAttribute('style', 'display:none;');
				}
			}
			var elem2 = document.querySelectorAll('.iconLotoBolsaMenu');
			if (elem2) {
				for(i=0; i<elem2.length; i++) {
					elem2[i].setAttribute('style', 'display:none;');
				}
			}
		}

		//====================Servicio anterior de log out========================// 
		/*
		var params = [];
		// Primer paso logout
		requestSrv.request(config.services.host + config.services.logout, "post", params)
		.then(function(e) {
			if (e.data.logout !== undefined && e.data.logout !== null){
				// Segundo paso logout
				requestSrv.request(config.services.host + config.services.logout, "post", params)
				.then(function(e) {
					$rootScope.logged = false;
					$interval.cancel(window.minCounter);
					popupSrv.hideLoading();
					$state.go("app.home");
				}, function(e){
					$interval.cancel(window.minCounter);
					errorHandler(e);
				});
			}
			else{
			  $interval.cancel(window.minCounter);
			  errorHandler(e);
			}
		}, function(e){
			$interval.cancel(window.minCounter);
			errorHandler(e);
		});
		*/
		//=============================================================================// 
	};

	window.jsonpCallback = function(data) {
		$rootScope.lotobolsa = data.saldoLotobolsa/100;
		$rootScope.username = data.nombreUsuario;
		$rootScope.lastAccess = data.loginPrevio;
		$timeout(function() {
			$window.dispatchEvent(new Event("resize"));
		});
	};


	//********************************** Login *********************************************//
	this.login = function(scope, username, password, type) {
		popupSrv.showLoading("loggingIn");
	   
		// Peticion al servicio
		var url = config.services.host + config.services.login;
		var param = formatParam(username, password);
		var transformRequest = function(obj) {
					var str = [];
					for(var p in obj)
					str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
					return str.join("&");
		};
		console.info('<=================================LogIn: Pending=========================================>');
		$http({method:'POST', url: url, data: param, withCredentials: false, headers: {'Content-Type': 'application/x-www-form-urlencoded'}, transformRequest: transformRequest})
			.then(function(res) {
				// console.log('respuesta servicio login', res); //Activar para saber lo que devuelve el servicio
				try {
					if (res.data.filtro || res.data.Filtro || res.data.error || res.data.estadoPlataforma) {throw res;}
					//MAMOV-598
					var promiseSetUsername = storageProvider.setData(storageProvider.KEY_STORAGE_USER, username);
					promiseSetUsername.then(
						function(exito){
							Console.logGreen('Éxito al guardar KEY_STORAGE_USER - loginSrv.js', exito);
						},
						function(error){
							Console.logPurple('Fracaso al guardar KEY_STORAGE_USER - loginSrv.js', error);
						}
					);
					
					$rootScope.logged = true;
					$rootScope.isLogging = false;
					window.timeConnected = Number(0);
					window.timeInitConnectedActivity = Date.now()/60000;
					window.timeInitConnected = Date.now()/60000;
					printTimeInHtml();
					window.timerInterval.push(generateInterval(), generateIntervalWithoutActivity());
					actionFirstLogin(); // Aciones a realizar, primer login
					
					//Si es un login oculto del servicio, no tenemos modal que cerrar.
					if(type!=="registro") {
						service.closeLogin();
					}	
					popupSrv.hideLoading();
					console.info('<===================================LogIn: OK============================================>');
					var url = config.services.host + config.services.header;
					// window.selae.waitingloginAccenggageParameters();

					$http({ method: 'JSONP', url: url })
						.then(function(res) {
							// console.log('respuesta 2º servicio sin format', res); //Activar para saber lo que devuelve el servicio
							console.info('<===================================LogIn2: OK============================================>');
						});
	
				} catch(err) {
					$rootScope.isLogging = false;
					requestSrv.logOut2();
					popupSrv.hideLoading();
					window.selae.waitingloginAccenggageParameters('borrar Callback');
					if(err.data.numeroIntentosRestantes) {
						popupSrv.showLoginErrorPopup(err.data.listaErrores, err.data.numeroIntentosRestantes);
					} else {
						popupSrv.showErrorPopup(requestSrv.errorHandler2(res)); //Sistema de errores el servicio requestSrv
					}
				}
			}, function(err) {
				$rootScope.isLogging = false;
				requestSrv.logOut2();
				popupSrv.hideLoading();
				window.selae.waitingloginAccenggageParameters('borrar Callback');
				popupSrv.showErrorPopup(requestSrv.errorHandler2(err)); //Sistema de errores el servicio requestSrv
		});

		///////////////////////////////////////////////////////////
		//Formateo de los parametros del request
		function formatParam(username, password) {
			return {
				dni_nie: username, 
				password: password    
		};}

		// Funcion que crea el intervalo de actualizacion deltiempo conectado
		function generateInterval() {
			return setInterval(function() {
				window.timeConnected = (Date.now()/60000) - window.timeInitConnected;
				printTimeInHtml();
				// console.log('Tiempo total',window.timeConnected.toMMSS());
				if (window.timeConnected > 59) { // 1190
					try { htmlModalSrv.close(); } catch(e) {console.log("No hay modal que cerrar");}
					console.log('Se ejecuta el cerrado por actividad');
					if (!$rootScope.popUpSessionTimeout) {
						service.logout();
						popupSrv.showErrorPopup("sessionTimeout");
						$rootScope.popUpSessionTimeout = true;
					}
				}
			}, 5000);
		}

		function generateIntervalWithoutActivity() {
			return setInterval(function() {
				window.timeConnectedWithoutActivity = (Date.now()/60000) - window.timeInitConnectedActivity;
				// console.log('Tiempo sin actividad',window.timeConnectedWithoutActivity.toMMSS());
				if (window.timeConnectedWithoutActivity > 19) { // 1190
					try { htmlModalSrv.close(); } catch(e) {console.log("No hay modal que cerrar");}
					console.log('Se ejecuta el cerrado por INactividad');
					if (!$rootScope.popUpSessionTimeout) {
						service.logout();
						popupSrv.showErrorPopup("sessionTimeout");
						$rootScope.popUpSessionTimeout = true;
					}
				}
			}, 5000);
		}

		function printTimeInHtml() {
			var elem3 = document.querySelectorAll('#timeConnect');
			if (elem3) {
				for(var i=0; i<elem3.length; i++) {
					elem3[i].innerHTML = window.timeConnected.toMMSS();
				}
			}
		}

		//Aciones que hacer en el primer login
		function actionFirstLogin() {
			//Es el primer lanzamiento?
			var promiseGetFirstLogin = storageProvider.getData(storageProvider.KEY_STORAGE_FIRSTLOGIN);
			promiseGetFirstLogin.then(
				function(isFirstLogin){
					if ($ionicHistory.currentStateName() === "landing") {
						$ionicHistory.nextViewOptions({ disableBack: true });
					}
					if(isFirstLogin === true || isFirstLogin == 'true' || isFirstLogin == null || isFirstLogin === undefined) {
						//PUSH
						Console.log('Primera ejecución: se activa el PUSH por defecto.');
						//La primera vez se activan las notificaciones PUSH, ya que por defecto se deben habilitar.
						var promiseSetPushEnabled = storageProvider.setData(storageProvider.KEY_STORAGE_PUSHENABLED, true);
						promiseSetPushEnabled.then(
							function(exito){
								BMA4S.setPushEnabled(true);
								Console.logGreen('Éxito al almacenar KEY_STORAGE_PUSHENABLED - loginSrv.js', exito);
							},
							function(error){
								BMA4S.setPushEnabled(false);
								Console.logPurple('Fracaso al almacenar KEY_STORAGE_PUSHENABLED - loginSrv.js', error);
							}
						);
						//Navegación a la home
						if ($rootScope.viewNameRouter === 'Accengage' || $rootScope.viewNameRouter === 'Home') {
							if ($rootScope.loginNavigate) {
								return $rootScope.loginNavigate();
							}
							window.selae.waitingloginAccenggageParameters();
						} else { $state.go("app.home"); }

						//Ya se ha lanzado por primera vez, borramos la bandera de primera ejecución.
						var promiseSetFirstLogin = storageProvider.setData(storageProvider.KEY_STORAGE_FIRSTLOGIN, false);
						promiseSetFirstLogin.then(
							function(exito){
								Console.logGreen('Éxito al almacenar KEY_STORAGE_FIRSTLOGIN - loginSrv.js', exito);
							},
							function(error){
								Console.logPurple('Fracaso al almacenar KEY_STORAGE_FIRSTLOGIN - loginSrv.js', error);
							}
						);
					} else {
						// Cuando no es el primer login
						if ($rootScope.viewNameRouter === 'Accengage' || $rootScope.viewNameRouter === 'Home') {
							if ($rootScope.loginNavigate) {
								return $rootScope.loginNavigate();
							}
							window.selae.waitingloginAccenggageParameters();
						} else {
							$state.go('app.home');
						}
					}
				},
				function(error){
					Console.logPurple('Fracaso al recuperar KEY_STORAGE_FIRSTLOGIN - loginSrv.js', error);
				}
			);
		}
	};
	/********************************************************/


	function showLoginModal(template, scope) {
		$ionicModal.fromTemplateUrl(template, {
			scope: scope
		}).then(function(modal) {
			service.modal = modal;
			service.modal.show();
		});
	}

	function errorHandler(err) {
		popupSrv.hideLoading();
		popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
	}

	return {
		showLogin: this.showLogin,
		showFavorites: this.showFavorites,
		closeLogin: this.closeLogin,
		logout: this.logout,
		login: this.login,
		getScope: this.getScope
	};


}]);