angular.module('selae.core.services')

.factory('mobileSrv', ['config', '$state', '$q', '$rootScope','requestSrv','popupSrv', 'storageProvider',
    function(config, $state, $q, $rootScope, requestSrv ,popupSrv, storageProvider) {
        var service = this;
    	this.initialize = function(){
			document.addEventListener('deviceready', service.onDeviceReady, false);
    	};

    	this.loadPush = function(){
    		window.selae = {};
    		window.selae.push = PushNotification.init({
			    android: {
			        senderID: config.senderId
			    },
			    ios: {
			        alert: "true",
			        badge: "true",
			        sound: "true"
			    }
            });
            
            //MAMOV-598
            //  Función anonima autoejecutable realizada para guardar la versión de la app
            (function() {
                var promiseGetVersion = storageProvider.getData(storageProvider.KEY_STORAGE_VERSION);
                promiseGetVersion.then(
                    function(theversion){
                        $scope.version = theversion;
                    },
                    function(error){
                        Console.logPurple('Fracaso al cargar KEY_STORAGE_VERSION - mobileSrv.js', error);
                    }
                );
            })();

            window.selae.push.on('registration', function(data) {
                $rootScope.$broadcast("notifStateChange");
                if(device !== undefined){
                    var params = [{
                        name: "refCompany",
                        value: "SELAE"
                    }, {
                        name: "refUser",
                        value: device.uuid
                    }, {
                        name: "deviceToken",
                        value: data.registrationId
                    }, {
                        name: "channelProvider",
                        value: device.platform == 'Android' ? 'google' : 'apple'
                    }, {
                        name: "uuid",
                        value: device.uuid
                    }, {
                        name: "application",
                        value: "refselae"
                    }, {
                        name: "appVersion",
                        //MAMOV-598
                        // value: window.localStorage.getItem("version")
                        value: $scope.version
                    }, {
                        name: "osVersion",
                        value: device.version
                    }, {
                        name: "osVendor",
                        value: device.manufacturer
                    }, {
                        name: "devVendor",
                        value: device.manufacturer
                    }, {
                        name: "devModel",
                        value: device.model
                    }];

                    var credentials = config.notifId;
                    var wordArray = CryptoJS.enc.Utf8.parse(credentials);
                    var auth = CryptoJS.enc.Base64.stringify(wordArray);

                    requestSrv.request(config.services.registerNotifications, "post", params, {"Authorization": "Basic " + auth});
                }
            });

            window.selae.push.on('notification', function(data) {
                var params = ( typeof data.additionalData.params != "undefined" )? data.additionalData.params: {};
                if ( data.additionalData.foreground === true ){
                    var buttons = [
                      { text: $filter("translate")( 'close' ) },
                      {
                        text: $filter("translate")( 'show' ),
                        type: 'sl-button',
                        onTap: function(e) {
                            e.preventDefault();
                            popupSrv.close();

                            $state.go('app.home');
                        }
                      }
                    ];
                    popupSrv.showPopup( data.title, "", "", buttons, '<p class="sl-text textCenter">' + data.message + '</p>', "" );
                }else{
                    $state.go('app.home');
                }
            });

            window.selae.push.on('error', function(e) {
                $rootScope.$broadcast("notifStateChange");
                popupSrv.showErrorPopup("enableNotificationError");
                //MAMOV-598
                // window.localStorage.setItem("receiveNotifications", false);
                var promiseSetNotifications = storageProvider.setData(storageProvider.KEY_STORAGE_PUSHENABLED, false);
                promiseSetNotifications.then(
                    function(exito){
                        Console.logGreen('Éxito al almacenar - movileSrv.js - KEY_STORAGE_PUSHENABLED false', exito);
                    },
                    function(error){
                        Console.logPurple('Fracaso al almacenar - movileSrv.js - KEY_STORAGE_PUSHENABLED false', error);
                    }
                );
            });
    	};

    	this.onDeviceReady = function(){
    		service.loadPush();
    	};

        this.unRegister = function(){
            var deferred = $q.defer();
            window.selae.push.unregister(function(){
                window.selae.push = undefined;
                deferred.resolve("Unregistered");
            },
            function(){
                //MAMOV-598
                // window.localStorage.setItem("receiveNotifications", true);
                var promiseSetNotifications = storageProvider.setData(storageProvider.KEY_STORAGE_PUSHENABLED, true);
                promiseSetNotifications.then(
                    function(exito){
                        Console.logGreen('Éxito al almacenar - movileSrv.js - KEY_STORAGE_PUSHENABLED true' , exito);
                    },
                    function(error){
                        Console.logPurple('Fracaso al almacenar - movileSrv.js - KEY_STORAGE_PUSHENABLED true', error);
                    }
                );
                deferred.reject("Error");
            });
            return deferred.promise;
        };

        return {
            initialize: this.initialize,
            loadPush: this.loadPush,
            onDeviceReady: this.onDeviceReady,
            unRegister : this.unRegister
        };
    }]);