angular.module('selae.core.services')

.factory('opSrv', ['config', 'requestSrv', 'popupSrv', '$filter', '$ionicHistory', '$q', '$rootScope', 'analyticsSrv',
function(config, requestSrv, popupSrv, $filter, $ionicHistory,$q,$rootScope,analyticsSrv) {
  var service = this;

  this.dateFromString = function(str) {
    if (str === null){
      return new Date(null);
    }
    var a = $.map(str.split(/[^0-9]/), function(s) {
      return parseInt(s, 10);
    });
    return new Date(a[0], a[1]-1 || 0, a[2] || 1, a[3] || 0, a[4] || 0, a[5] || 0, a[6] || 0);
  };

  this.Block = function() {
    //aqui se insertan los numeros que vayan a ser utilizados, el template añade el parámetro activo o no
    this.item = {};
    //para estrellas, caballos, etc
    this.extraItem = {};
    //control para inhabilitar la edicion del bloque
    this.isBlocked = false;
    //id del bloque, variable de cara a cuando se borra un bloque
    this.nBlock = 0;
  };

  this.checkChanged = function(block, selection, item, index) {
    if (block[index].isBlocked) {
      return false;
    }
    if (block[index].item[selection].selected === false) {
      delete block[index].item[selection];
    }
  };

  this.checkChangedExtra = function(block, selection, item, index, nExtra) {
    if (block[index].isBlocked) {
      return false;
    }
    if (block[index].extraItem[selection].selected === false) {
      delete block[index].extraItem[selection];
    }
  };

  this.checkChangedElige8 = function(block,item,index) {
    if (block[index].isBlocked) {
      return false;
    }
    if (block[index].extraItem['elige8'].values[item].selected === false) {
      delete block[index].extraItem['elige8'].values[item];
    }
  }

  this.checkBlocked = function(block, index, item, status, nNumbers) {
    if (block[index].isBlocked === true) {
      return true;
    } else {
      if (Object.keys(block[index].item).length >= nNumbers) {
        if (block[index].item[item]) {
          if (block[index].item[item].selected === true) {
            return false;
          } else {
            return true;
          }
        } else {
          return true;
        }
      } else {
        return false;
      }
    }
  };

  this.checkBlockedExtra = function(block, index, item, status, nNumbers,gameId) {
    if (block[index].isBlocked === true) {
      return true;
    } else {

      if (gameId !== undefined && gameId == "2") {
        // elige8
        if( block[index].extraItem['elige8'] !== undefined && Object.keys(block[index].extraItem['elige8'].values).length >= nNumbers) {
          if (block[index].extraItem['elige8'].values[item] !== undefined && block[index].extraItem['elige8'].values[item].selected === true) {
            return false;
          } else {
            return true;
          }
        }
        
      } else if (Object.keys(block[index].extraItem).length >= nNumbers) {
        if (block[index].extraItem[item]) {
          if (block[index].extraItem[item].selected === true) {
            return false;
          } else {
            return true;
          }
        } else {
          return true;
        }
      } else {
        return false;
      }
    }
  };

  this.isFull = function(block, index, nNumbers, nExtra, gameId, elige8) {
    var extraItemLength = 0;

    if (gameId !== undefined && gameId == "2"){

      if(block[1].extraItem[1] !== undefined && block[1].extraItem[2] !== undefined) {
        angular.forEach(block[1].extraItem[1].values, function(value, key){
          if (value.selected === true){
            extraItemLength++;
          }
        });
        angular.forEach(block[1].extraItem[2].values, function(value, key){
          if (value.selected === true){
            extraItemLength++;
          }
        });
      }

      if(elige8) {
        nExtra = nExtra + 8;
        if(block[1].extraItem['elige8'] !== undefined) {

          angular.forEach(block[1].extraItem['elige8'].values, function(value,key) {
            if (value.selecter === true) {
              extraItemLength++;
            }
          });
        }
      }
    }
    else{
      extraItemLength = Object.keys(block[index].extraItem).length;
    }

    if (Object.keys(block[index].item).length === nNumbers && block[index].isBlocked === false && extraItemLength >= nExtra) {
      return false;
    } else {
      return true;
    }
  };
  var getConfigGame = function(gameId) {
    var confGame = '';
    switch (gameId) {
      case "1":
      confGame = config.services.configPrimitiva;
      break;
      case "2":
      confGame = config.services.configQuiniela;
      break;
      case "3":
      confGame = config.services.configEuromillon;
      break;
      case "4":
      confGame = config.services.configBonoloto;
      break;
      case "5":
      confGame = config.services.configGordo;
      break;
      case "6":
      confGame = config.services.configQuinigol;
      break;
      case "7":
      confGame = config.services.configLototurf;
      break;
      case "8":
      confGame = config.services.configQuintuple;
      break;
      case "9":
      confGame = config.services.configLoteria;
      break;
      default:
      break;
    }
    return confGame;
  };
  var getvalida = function(gameId) {
    var confGame = '';
    switch (gameId) {
      case "1":
      confGame = "primitiva.valida";
      break;
      case "2":
      confGame = config.services.configQuiniela;
      break;
      case "3":
      confGame = "euromillon.valida";
      break;
      case "4":
      confGame = "bonoloto.valida";
      break;
      case "5":
      confGame = "validaApuesta";
      break;
      case "6":
      confGame = config.services.configQuinigol;
      break;
      case "7":
      confGame = "lototurf.valida";
      break;
      case "8":
      confGame = config.services.configQuintuple;
      break;
      case "9":
      confGame = config.services.configLoteria;
      break;
      default:
      break;
    }
    return confGame;
  };

  var getDelete = function(gameId) {
    var confGame = '';
    switch (gameId) {
      case "1":
      confGame = "primitiva.borrarColumna";
      break;
      case "2":
      confGame = config.services.configQuiniela;
      break;
      case "3":
      confGame = "euromillon.borrarColumna";
      break;
      case "4":
      confGame = "bonoloto.borrarColumna";
      break;
      case "5":
      confGame = "borrarColumna";
      break;
      case "6":
      confGame = config.services.configQuinigol;
      break;
      case "7":
      confGame = "lototurf.borrarColumna";
      break;
      case "8":
      confGame = config.services.configQuintuple;
      break;
      case "9":
      confGame = config.services.configLoteria;
      break;
      default:
      break;
    }
    return confGame;
  };
  this.addBlock = function(block, index, gameId, betConfig, $scope, automatic) {
    var betSorted = Object.keys(block[index].item);
    var extra = "";
    var confGame = this.newGetConfigGame(gameId);
    var valida = getvalida(gameId);
    // var params = [];
    // Configuración de la llamada
    if (gameId == 3 || gameId == 7) {
      extra = Object.keys(block[index].extraItem);
      extra = ":" + extra.toString();
    }

    if (gameId == 5) {
      if (index == 1) {
        extra = (index != 1) ? Object.keys(block[1].extraItem) : Object.keys(block[index].extraItem);
        extra = ";" + extra.toString();
      } else {
        extra = "";
      }
    }

    var params = [{
      name: "pronostico",
      value: betSorted.toString() + extra
    }, {
      name: "automatica",
      value: automatic === true ? "TRUE" : "FALSE"
    }, {
      name: (gameId == 3 || gameId == 7) ? "accionController" : "action",
      value: valida
    }, {
      name: "Sorteo",
      value: betConfig.dateBet == 'semanal' ? "SEMANAL" : "DIARIA"
    }];

    if ( index === 1 && gameId === '1') {
        if ( Object.keys(block[1].extraItem).length > 0 ) {
            var reintegro = Object.keys(block[1].extraItem) || false;
            var reintegroValue = {
                name:'reintegro',
                value: String(reintegro)
            };
        params.push( reintegroValue );
        }
    }

    return requestSrv.request(config.services.host + confGame, "post", params)
    .then(function(e) {
      
      console.log('generic calcelBet', e);
      try {
      console.log('test cancelBet', e.data.compraDto[0].ApuestaDto.idJuego);
      console.log('test cancelBet', e.data.compraDto[0].ApuestaDto.metodo);
      console.log('test cancelBet', e.data.compraDto[0].ApuestaDto.idSorteo);
      $rootScope.cancelBetData = {
        idJ: e.data.compraDto[0].ApuestaDto.idJuego,
        metod: e.data.compraDto[0].ApuestaDto.metodo,
        idS: e.data.compraDto[0].ApuestaDto.idSorteo
      };
      } catch(e) {/**/}
      if (e.data.compraDto[0].ApuestaDto.msgError === undefined || e.data.compraDto[0].ApuestaDto.msgError === "") {
        block[index].isBlocked = true;
        var max = 0;
        angular.forEach(block, function(value, key) {
          if (value.nBlock > max) {max = value.nBlock;}
        });
        block[index].nBlock = max + 1;
        var allOk = true;
        for (var i = 0; i < block.length && allOk !== false; i++) {
          if (i + 1 < block.length) {
            if (block[i + 1].nBlock === 0) {allOk = false;}
          }
        }
        angular.element("#check" + (index - 1)).addClass("check");
        if (allOk === true) {
          return $q.resolve( true );
        }
      }else{
        popupSrv.hideLoading();
        popupSrv.showErrorPopup(e.data.compraDto[0].ApuestaDto.msgError);
        return $q.reject( false );
      }
    }, function(e) {
      popupSrv.hideLoading();
      popupSrv.showErrorPopup(requestSrv.errorHandler2(e, null, function() {
        requestSrv.cancelBet($rootScope.cancelBetData.idJ, $rootScope.cancelBetData.metod, $rootScope.cancelBetData.idS);
      }));
        $ionicHistory.goBack();
      return $q.reject( false );
    });
  };

  this.deleteBlock = function(block, index, gameId, $scope) {
    if (block[index].isBlocked === false) {
      block[index] = new service.Block();
      block[index].nBlock = 0;

      var allOk = true;
      $scope.$parent.continueDisabled = true;
      return;
    }
    var refer = block[index].nBlock;
    popupSrv.showLoading("deletingBlock");
    var confGame = getConfigGame(gameId);
    var deleteColumn = getDelete(gameId);
    var params = [{
      name: "columna",
      value: refer
    }, {
      name: (gameId == 3 || gameId == 7) ? "accionController" : "action",
      value: deleteColumn
    }];
    requestSrv.request(config.services.host + confGame, "post", params)
    .then(function() {
      angular.forEach(block[index].item, function(value, key) {
        $('#number-' + key).prop('checked', false);
        delete block[index].item[key];
      });
      var prev = block[index].nBlock;
      block[index].nBlock = 0;

      angular.forEach(block, function(value, key) {
        if (value.nBlock > 0 && value.nBlock > prev) {value.nBlock--;}
      });

      angular.forEach(block[index].extraItem, function(value, key) {
        $('#number-' + key).prop('checked', false);
        delete block[index].extraItem[key];
      });

      angular.forEach(block, function(value, key) {
        if (value.nBlock > 0 && value.nBlock > prev) {value.nBlock--;}
      });
      block[index].isBlocked = false;
      angular.element("#check" + (index - 1)).removeClass("check");
      $scope.$parent.continueDisabled = true;
      popupSrv.hideLoading();
    }, function(err) {
      popupSrv.hideLoading();
      popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
    });
  };

  var getRandom = function(size, amount) {
    return Array.apply(null, Array(amount)).map(
      function(_, i) {
        return Math.round(Math.random() * size) + 1;
      });
    };

    var checkIfArrayIsUnique = function(array) {
      array.sort(function(a, b) {
        return a - b; });
        for (var i = 1; i < array.length; i++) {
          if (array[i - 1] == array[i]) {return false;}
        }
        return true;
      };

      var extraGordo = [0];
      this.randomPick = function(block, index, betConfig, gameId) {
        console.log(block, index, betConfig, gameId);
        if (block[index].isBlocked === true) {
          return;
        }
        var nNumbersAux = 0;
        var nExtraAux = 0;
        switch (gameId) {
          case "1":
          nNumbersAux = 48;
          nExtraAux = 0;
          break;
          case "2":
          nNumbersAux = 0;
          nExtraAux = 0;
          break;
          case "3":
          nNumbersAux = 49;
          nExtraAux = 11;
          break;
          case "4":
          nNumbersAux = 48;
          nExtraAux = 0;
          break;
          case "5":
          nNumbersAux = 53;
          nExtraAux = 9;
          break;
          case "6":
          nNumbersAux = 0;
          nExtraAux = 0;
          break;
          case "7":
          nNumbersAux = betConfig.caballos[0] - 1;
          nExtraAux = betConfig.caballos[1] - 1;
          break;
          case "8":
          nNumbersAux = 0;
          nExtraAux = 0;
          break;
          case "9":
          nNumbersAux = 0;
          nExtraAux = 0;
          break;
          default:
          break;
        }
        angular.forEach(block[index].item, function(value, key) {
          $('#combo-' + index + '#number-' + key).prop('checked', false);
          delete block[index].item[key];
        });

        var randomArray = getRandom(nNumbersAux, betConfig.nNumbers);
        while (checkIfArrayIsUnique(randomArray) !== true) {
          console.log("array repe, genera otro");
          randomArray = getRandom(nNumbersAux, betConfig.nNumbers);
        }
        console.log('ARRAY number: ', randomArray);

        angular.forEach(randomArray, function(value, key) {
          $('#combo-' + index + '#number-' + key).prop('checked', true);
          if (!block[index].item[value]) {
            block[index].item[value] = {};
          }
          block[index].item[value].selected = true;
        });

        //EXTRA
        if (nExtraAux !== 0) {
          angular.forEach(block[index].extraItem, function(value, key) {
            $('#combo-' + index + '#number-' + key).prop('checked', false);
            delete block[index].extraItem[key];
          });
          // cambiar por variable de roperties
          var elGordoV2serviceCheck = $filter('translate')('elGordoV2Service') || false;
          if (elGordoV2serviceCheck == 'true') {
            var randomArray2 = getRandom(nExtraAux, betConfig.nExtra);
          } else {
            var randomArray2 = (index != 1 && gameId == 5) ? extraGordo : getRandom(nExtraAux, betConfig.nExtra);
          }
          if ((index == 1 || elGordoV2serviceCheck == 'true' ) && gameId == 5 ) {
            randomArray2 = randomArray2.map(function(i,index) {
              return i - 1;
            });
            extraGordo = randomArray2;
          }
          while (checkIfArrayIsUnique(randomArray2) !== true) {
            randomArray2 = getRandom(nExtraAux, betConfig.nExtra);
          }

          console.log('ARRAY EXTRA: ', randomArray2);

          angular.forEach(randomArray2, function(value, key) {
            $('#combo-' + index + '#number-' + key).prop('checked', true);
            if (!block[index].extraItem[value]) {
              block[index].extraItem[value] = {};
            }
            block[index].extraItem[value].selected = true;
          });
        }

        //    itemsSelected[index] = randomArray.sort(function(a, b){return a-b;});

      };

      this.formatDatesForTicket = function(sorteos) {
        var dates = "";

        if (sorteos[0].SorteoDto) {
          angular.forEach(sorteos, function(value, key) {
            if (dates === "") {
              dates = $filter('dateToText')(value.SorteoDto.fecha, 3);
            } else {
              dates = dates + " - " + $filter('dateToText')(value.SorteoDto.fecha, 3);
            }
          }, dates);
        } else {
          // esto se formatea así a peticion del cliente, para futuros juegos hay que meter un for para que recorra el array, pero en el gordo solo tenemos un elemnto
          dates = sorteos[0].slice(4, 11) + 20 + sorteos[0].slice(11, 13);
        }

        return dates;
      };

      this.dhm = function(t, mode) {
        var cd = 24 * 60 * 60 * 1000,
        ch = 60 * 60 * 1000,
        d = Math.floor(t / cd),
        h = Math.floor((t - d * cd) / ch),
        m = Math.round((t - d * cd - h * ch) / 60000),
        pad = function(n) {
          return n < 10 ? '0' + n : n;
        };
        if (m === 60) {
          h++;
          m = 0;
        }
        if (h === 24) {
          d++;
          h = 0;
        }
        if (mode == 1) {
          return "" + (d > 0 ? (d + "d ") : ("")) + pad(h) + "h " + pad(m) + "min";
        }
        return "" + (d > 0 ? (d + "d ") : ("")) + pad(h) + ":" + pad(m);
      };
      /*********************************************************************************
      Creación de funciones para la configuración de las apuestas.

      Esta lógica se crea para desacoplar la configuración de las llamadas de los controladores.
      Se irán implementando funciones conforme nos sean necesarias en el desarrollo.
      Se irá añadiendo el controlador donde desacoplemos la lógica para llevar un mayor control.
      -QuickBet
      -Rejugar favoritas
      
      *********************************************************************************/
     this.newGetConfigGame = function(gameId) {
      var confGame = '';
      switch (String(gameId)) {
        case '1':
          confGame = config.services.configPrimitiva;
          break;
        case '2':
          confGame = config.services.configQuiniela;
          break;
        case '3':
          confGame = config.services.configEuromillon;
          break;
        case '4':
          confGame = config.services.configBonoloto;
          break;
        case '5':
          confGame = config.services.configGordo;
          break;
        case '6':
          confGame = config.services.configQuinigol;
          break;
        case '7':
          confGame = config.services.configLototurf;
          break;
        case '8':
          confGame = config.services.configQuintuple;
          break;
        case '9':
          confGame = config.services.configLoteria;
          break;
        case '10':
          confGame = config.services.configLoteria;
          break;
        default:
          break;
      }
      return confGame;
    };
      

      return {
        Block: this.Block,
        checkChanged: this.checkChanged,
        checkChangedExtra: this.checkChangedExtra,
        checkChangedElige8: this.checkChangedElige8,
        checkBlocked: this.checkBlocked,
        checkBlockedExtra: this.checkBlockedExtra,
        isFull: this.isFull,
        addBlock: this.addBlock,
        deleteBlock: this.deleteBlock,
        randomPick: this.randomPick,
        formatDatesForTicket: this.formatDatesForTicket,
        dhm: this.dhm,
        dateFromString: this.dateFromString,
        newGetConfigGame: this.newGetConfigGame
      };
    }
  ]);
