angular.module('selae.core.services')

    .factory('popupSrv', ['$ionicLoading', '$ionicPlatform', '$ionicPopup', '$filter', 'config', '$interpolate',
        function ($ionicLoading, $ionicPlatform, $ionicPopup, $filter, config, $interpolate) {
            var myPopup,
                unregister,
                myPopupIsActive = false;

            this.showLoading = function (message, n) {
                var treatedMessage = (typeof $filter("translate")(message) !== 'undefined') ? $filter("translate")(message) : message;
                var template = "<div class='play1Click__loading'><div class='play1Click__loading__spinner'><img src='images/bombo-loading.gif' class='spinner'/><span class='play1Click__loading__text'>" + treatedMessage + "</span></div></div>";
                if (n === undefined) {
                    $ionicLoading.show({
                        template: template
                    });
                } else {
                    $ionicLoading.show({
                        template: template,
                        duration: n
                    });
                }
            };

            this.hideLoading = function () {
                $ionicLoading.hide();
            };

            this.showInfoCallabackPopup = function (title, message, url, callBack) {
                var configPopup = {};
                var treatedMessage = (typeof $filter("translate")(message) !== 'undefined') ? $filter("translate")(message) : message;
                var template = "<p class='sl-text textCenter'>" + treatedMessage + "</p>";
                configPopup.title = $filter("translate")(title) || $filter("translate")("error");
                configPopup.template = template;
                if (url) {
                    configPopup.template += "<a onclick='window.open(\"" + config.services.hostFiltro + url + "\", \"_system\")' class='filter-anchor'>" + $filter("translate")("webLink") + "</a>";
                }
                configPopup.buttons = [{
                    text: $filter("translate")("ok"),
                    type: "sl-button",
                    onTap: function (e) {
                        // e.preventDefault();
                        this.hide();
                        if (callBack) {
                            return callBack();
                        }
                    }
                }];
                myPopup = $ionicPopup.show(configPopup);
                myPopupIsActive = true;
                return myPopup;
            };

            this.showErrorPopup = function (message, url, completeUrl, title) {
                var treatedMessage = (typeof $filter("translate")(message) !== 'undefined') ? $filter("translate")(message) : message;
                var template = "<p class='sl-text textCenter'>" + treatedMessage + "</p>";

                var configPopup = {};

                configPopup.title = $filter("translate")(title) || $filter("translate")("error");

                configPopup.template = template;

                if (url !== undefined && url !== null) {
                    configPopup.template += "<a href='#' onclick='window.open(\"" + config.services.hostFiltro + url + "\", \"_system\")' class='filter-anchor'>" + $filter("translate")("webLink") + "</a>";
                }

                if (completeUrl) {
                    configPopup.template += "<a onclick='window.open(\"" + completeUrl + "\", \"_system\")' class='filter-anchor'>" + $filter("translate")("perfilErrorPluginNoFotoText") + "</a>";
                }

                configPopup.okText = $filter("translate")("ok");
                configPopup.okType = "sl-button";
                myPopup = $ionicPopup.alert(configPopup);
                myPopupIsActive = true;
                return myPopup;
            };

            this.showBlockingErrorPopup = function (message, url) {
                var treatedMessage = (typeof $filter("translate")(message) !== 'undefined') ? $filter("translate")(message) : message;
                var template = "<p class='sl-text textCenter'>" + treatedMessage + "</p>";

                var configPopup = {
                    title: $filter("translate")("criticalError") || "Error crítico",
                    template: template
                };

                if (url !== undefined && url !== null) {
                    configPopup.template += "<a href='#' onclick='window.open(\"" + url + "\", \"_system\")' class='filter-anchor'>Enlace a la web</a>";
                }

                myPopup = $ionicPopup.show(configPopup);

                $ionicPlatform.registerBackButtonAction(function (event) {
                    navigator.app.exitApp();
                }, 500);

                myPopupIsActive = true;

                return myPopup;
            };

            this.showAppDisabledPopup = function () {
                var template = "<p class='sl-text textCenter'>" + $filter("translate")("appDisabledMessage") + "</p>";

                var configPopup = {
                    title: $filter("translate")("error"),
                    template: template
                };

                configPopup.template += "<a href='#' onclick='window.open(\"" + config.urls.web + "\", \"_system\")' class='filter-anchor'>Enlace a la web</a>";

                myPopup = $ionicPopup.show(configPopup);

                $ionicPlatform.registerBackButtonAction(function (event) {
                    navigator.app.exitApp();
                }, 500);

                myPopupIsActive = true;

                return myPopup;
            };

            this.showLoginErrorPopup = function (message, n) {
                var treatedMessage = "";
                if (message === undefined) {
                    treatedMessage = $filter("translate")("SAGA-JUE-ENTR-00006");
                } else {
                    treatedMessage = (typeof $filter("translate")(message) !== 'undefined') ? $filter("translate")(message) : message;
                }

                var template = "<p class='sl-text textCenter'>" + treatedMessage + "</p>";

                if (n !== undefined && n !== null) {
                    template += "<p class='sl-text textCenter'>" + $interpolate($filter("translate")("triesLeft"))({
                        n: n
                    }) + "</p>";
                }

                var configPopup = {};

                configPopup.title = $filter("translate")("error");

                configPopup.template = template;

                configPopup.okText = $filter("translate")("ok");
                configPopup.okType = "sl-button";
                myPopup = $ionicPopup.alert(configPopup);
                myPopupIsActive = true;
                return myPopup;
            };

            this.showConfirmPopup = function (message ,title) {
                var treatedMessage = (typeof $filter("translate")(message) !== 'undefined') ? $filter("translate")(message) : message;
                var template = "<p class='sl-text textCenter'>" + treatedMessage + "</p>";

                var config = {};

                config.title = $filter("translate")(title) || $filter("translate")("confirm");

                config.template = template;

                config.okText = $filter("translate")("yes");
                config.okType = "sl-button";
                config.cancelText = $filter("translate")("no");
                config.cancelType = "sl-button";
                myPopup = $ionicPopup.confirm(config);
                myPopupIsActive = true;
                return myPopup;
            };

            var that = this;

            this.showPopup = function (title, subtitle, templateUrl, buttons, template, cssClass, scope) {
                unregister = $ionicPlatform.registerBackButtonAction(function (event) {
                    that.close();
                    event.preventDefault();
                    event.stopPropagation();
                }, 401);

                if (myPopupIsActive) {
                    that.close();
                }
                myPopupIsActive = true;

                var config = {};
                config.scope = scope;
                config.title = (typeof $filter("translate")(title) !== 'undefined') ? $filter("translate")(title) : title;
                if (subtitle !== '') {
                    config.subTitle = (typeof $filter("translate")(subtitle) !== 'undefined') ? $filter("translate")(subtitle) : subtitle;
                }
                if (templateUrl !== '') {
                    config.templateUrl = templateUrl;
                }
                config.buttons = buttons;
                if (template !== '') {
                    config.template = template;
                }
                if (cssClass !== '') {
                    config.cssClass = cssClass;
                }

                myPopup = $ionicPopup.show(config);

                myPopup.then(function (res) {
                    unregister();
                });

            };

            this.close = function () {
                myPopupIsActive = false;
                myPopup.close();
                $ionicPopup._popupStack = [];
            };

            this.isActive = function () {
                return myPopupIsActive;
            };

            
            this.betsPopup = function(headerText, options) {
                // debugger;
                var config = {};

                config.title = headerText;
                // config.cssClass = 'sl-text textCenter';
                config.cssClass = 'betPopup sl-text textCenter';
                // config.template = '<div><span>'+headerText+'</span></div><div><button>asasasa</button><button>asasasa</button><button>tt</button></div>';
                // config.template = '<div><span>'+headerText+'</span></div>';
                config.buttons = options;

                mypopup = $ionicPopup.show(config);
                return mypopup;
            };

            this.showNewPopup = function(headerText, options) {
                // debugger;
                var config = {};

                // config.title = title;
                config.cssClass = 'newPopup';

                // config.template = '<div><span>'+headerText+'</span></div><div><button>asasasa</button><button>asasasa</button><button>tt</button></div>';
                config.template = '<div><span>'+headerText+'</span></div>';
                config.buttons = options;

                mypopup = $ionicPopup.show(config);
                return mypopup;
            };

            return {
                showLoading: this.showLoading,
                hideLoading: this.hideLoading,
                showErrorPopup: this.showErrorPopup,
                showBlockingErrorPopup: this.showBlockingErrorPopup,
                showAppDisabledPopup: this.showAppDisabledPopup,
                showLoginErrorPopup: this.showLoginErrorPopup,
                showPopup: this.showPopup,
                showConfirmPopup: this.showConfirmPopup,
                close: this.close,
                isActive: this.isActive,
                showInfoCallabackPopup: this.showInfoCallabackPopup,
                betsPopup: this.betsPopup,
                showNewPopup: this.showNewPopup
            };
        }
    ]);