angular.module('selae.core.services')

    .factory('requestSrv', ['$http', '$state', '$filter', '$q', '$ionicHistory', 'config', 'popupSrv', '$rootScope', '$interpolate',
        function ($http, $state, $filter, $q, $ionicHistory, config, popupSrv, $rootScope, $interpolate) {
            var localConfig = {};
            var that = this;
            var pending = [];

            this.logOut2 = function () {
                // debugger;
                
                var url = config.services.host + config.services.logout;
                console.info('<=================================LogOut: Pending=========================================>');
                $http({
                        method: 'POST',
                        url: url,
                        withCredentials: false
                    })
                    .then(function (res) {
                        var url = config.services.host + config.services.logout2ndStep;
                        $http({
                                method: 'POST',
                                url: url,
                                withCredentials: false
                            })
                            .then(function (res) {
                                 //if (res.data.logout) { popupSrv.showErrorPopup(this.errorHandler2(res)); }
                                    // console.log('Se cierra el interval Nº:', window.minCounter); clearInterval(window.minCounter);
                                    // console.log('Se cierra el interval Nº:', window.minCounterWithoutActivity); clearInterval(window.minCounterWithoutActivity);
                                    // window.timerInterval.map(function (i) {
                                    //     clearInterval(i);
                                    //     console.log('Limpiado intervalo:', i);
                                    //     return null;
                                    // }).filter(Boolean);

                                    //deleteTimeInHtml();
                                    $rootScope.logged = false;

                                    // popupSrv.hideLoading();
                                    console.info('<===================================LogOut: OK============================================>');
                            }.bind(this));
                    }.bind(this), function (err) { 
                        Console.log(err);
                    }.bind(this));

            };

            this.getBetConfig = function () {
                return localConfig;
            };

            this.setBetConfig = function (data) {
                localConfig = data;
            };

            this.get = function () {
                return pending;
            };

            this.add = function (request) {
                pending.push(request);
            };

            this.remove = function (request) {
                pending = $filter(pending, function (p) {
                    return p.url !== request;
                });
            };

            this.cancelAll = function () {
                angular.forEach(pending, function (p) {
                    p.canceller.resolve();
                });
                pending.length = 0;
            };


            this.request = function (url, method, params, headers) {
                var canceller = $q.defer();
                that.add({
                    url: url,
                    canceller: canceller
                });

                var requestPromise = null;

                if (method == "jsonp") {
                    requestPromise = $http.jsonp(url);
                } else {
                    if (params) {
                        for (var i = 0; i < params.length; i++) {
                            if (i === 0) {
                                url = url + '?';
                            } else {
                                url = url + '&';
                            }
                            url = url + params[i].name + '=' + params[i].value;
                        }
                    }

                    console.log(url);
                    var req = {
                        method: method,
                        url: url,
                        headers: headers !== undefined ? headers : {},
                        withCredentials: false,
                        timeout: canceller.promise
                    };

                    requestPromise = $http(req);
                }

                requestPromise.finally(function () {
                    that.remove(url);
                });
                return requestPromise;
            };


            this.login = function (url, method, params) {
                var canceller = $q.defer();
                that.add({
                    url: url,
                    canceller: canceller
                });

                var requestPromise = null;

                var req = {
                    method: method,
                    url: url,
                    withCredentials: false,
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded'
                    },
                    transformRequest: function (obj) {
                        var str = [];
                        for (var p in obj)
                            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
                        return str.join("&");
                    },
                    data: params,
                    timeout: canceller.promise
                };

                requestPromise = $http(req);

                requestPromise.finally(function () {
                    that.remove(url);
                });
                return requestPromise;
            };

            this.errorMapperServiceRest = function (res, storeData, callBack) {
               
                //se mapea el status del error a un 200 para que se traten como todos los demás errores de la app.
                //este Mapper solo se ejecuta para los servicios de servicios-rest.
                if(res.data.error === true) {
                    //se mapean los dtos de error para que vengan como en los demas servicios
                    if (res.status == 400 || res.status == 401) {
                        res.status = 200;
                    }
                    var fallo = {
                        error : res.data.error,
                        msgError : res.data.msgError
                    }
                    res.data.error = [];
                    res.data.error.push(fallo);
                    // res.data.error[0].error = res.data.error;
                    // res.data.error[0].msgError = res.data.msgError;
                } else {
                    res.status = 200;
                    res.data.filtro = res.data.filtroErrorNombre;
                    res.data.urlFiltro = res.data.urlFiltroDestino;
                }

                return this.errorHandler2(res, storeData, callBack)
            }

            /*******************************************************************************************************/
            /********************************* Nuevo sistema de errores ********************************************/
            this.errorHandler2 = function (res, storeData, callBack) {
                
                console.error('<======================================Sistema de Errores=====================================>');
                console.error('Servicio:', res);
                try {
                    if (res.status >= 200 && res.status <= 299) {
                        throw errorAplication(res);
                    }
                    else if (res.status) {
                        throw errorServer(res);
                    } else {
                        throw { type: "codeError", redirect: true };
                    }
                } catch (err) {
                    console.error('Error:', err);
                    console.error('<=============================================================================================>');
                    console.log($ionicHistory.currentView().stateName);
                    console.log(err.redirect);
                    if ($ionicHistory.currentView().stateName === 'landing' || $ionicHistory.currentView().stateName === 'app.home') {err.redirect = false;}
                    console.log(err.redirect);

                    if (err.notDefined) {console.warn('Cuidado, este error NO esta definido en los casos pre-diseñados');}
                    if (err.formatNotExpected) {console.warn('Cuidado, el FORMATO de este error NO viene como esperado');}
                    if (err.logOut) {logOut.bind(this)();}
                    if (err.redirect) {redirect(err.type);}
                    if (err.save) { $rootScope.lotoBolsaStore = storeData; }
                    if (err.callBack) {if (callBack) {callBack();}}

                    var error = $filter('translate')(err.type);
                    if (!error && err.link !== "RGPD") {return $filter('translate')('genericError') + ' ' + err.type;}
                    if (err.link && err.link === "RGPD") {
                        error = error + '<br>' + '<a href="#" onclick="window.open(\'' + config.services.hostFiltro + res.data.urlFiltro + '\', \'_system\')">' + $filter('translate')('webLink') + '</a>';
                    } else if ( err.link && err.link === 'filtroNoPermiteCarga' ) {
                        error = error + '<br>' + '<a onclick="window.open(\'' + $rootScope.selae.properties.urlFiltroNoPermiteCarga + '\', \'_system\')">' + $filter('translate')('webLink') + '</a>';
                    } else if ( err.link && err.link === 'avisoFiltroClubConmigo' ) {
                        error = error + '<br>' + '<a onclick="window.open(\'' + $rootScope.selae.properties.urlFiltroClubConmigo + '\', \'_system\')">' + $filter('translate')('webLink') + '</a>';
                    } else if ( err.link && err.link === 'filtroPendienteValoracion') {
                        error = error + '<br>' + '<a onclick="window.open(\'' + $rootScope.selae.properties.filtroPendienteValoracionUrl + '\', \'_system\')">' + $filter('translate')('webLink') + '</a>';
                    } else if ( err.link && err.link === 'filtroContramedidasFinancieras') {
                        error = error + '<br>' + '<a onclick="window.open(\'' + $rootScope.selae.properties.filtroContramedidasFinancierasUrl + '\', \'_system\')">' + $filter('translate')('webLink') + '</a>';
                    } else if ( err.link && err.link === 'contactaConElCAU') {
                        error = error + '<br>' + '<a onclick="window.open(\'' + $rootScope.selae.properties.contactaConElCAU + '\', \'_system\')">' + $filter('translate')('webLink') + '</a>';
                    } else if (err.link && err.link !== "RGPD") {
                        error = error + '<br>' + '<a href="#" onclick="window.open(\'' + config.services.hostFiltro + 'cas/configuracion/datos-cuenta/datos-cuenta-juegos' + '\', \'_system\')">' + $filter('translate')('webLink') + '</a>';
                    }
                    return error;
                }

                /////////////////////////////////////////////////
                //////////////////
                function errorServer(res) {
                    if (res.status == -1) {
                        return {
                            type: 'requestTimeout',
                            redirect: true
                        };
                    } //Si el servicio hace un timeOut, porque tarda en responder
                    if (res.status == 401 || res.status == 403) {
                        return {
                            type: 'loginAgain',
                            logOut: true,
                            redirect: true
                        };
                    } //Se accede a un sitio no permitido, deslogea al usuario
                    debugger;
                    if (res.status >= 500) {
                        return {type: 'connectionClosed',redirect: true};
                    } //Da un error en la peticion
                    return {
                        type: 'connectionClosed',
                        redirect: true
                    }; //Error de servidor no controlado
                }
                //////////////////
                function errorAplication(res) {
                    if (typeof res.data === 'string' || typeof res.data === 'boolean' || typeof res.data === 'number' || typeof res.data === 'function' || !res.data) {
                        return {
                            type: 'requestNoJson'
                        };
                    }
                    if (res.data.estadoPlataforma) {
                        return {
                            type: 'errorEstadoPlataforma'
                        };
                    } // la plataforma de  apuestas esta cerrada (se tiene que añadir los or porque si viene este tipo de filtro es prioritario)
                    if (res.data.filtroBean && (res.data.filtroBean[0].filtroErrorNombre === 'filtroNoPermiteCarga' 
                            || res.data.filtroBean[0].filtroErrorNombre === 'filtroNoPermiteDescarga'
                            || res.data.filtroBean[0].filtroErrorNombre === 'filtroContramedidasFinancieras'
                            || res.data.filtroBean[0].filtroErrorNombre === 'filtroPosibleFallecido')
                        ) {
                            res.data.filtro=res.data.filtroBean[0].filtroErrorNombre;
                        }
                    if (res.data.filtro || res.data.Filtro) {
                        try {
                            if (res.data.filtro[0] && res.data.filtro[0].filtroErrorNombre === 'filtroClubConmigoOnline') {
                                res.data.filtro = res.data.filtro[0].filtroErrorNombre;
                            }  
                        } catch (error) {
                            console.log("Error controlado en caso de no venir filtro:" +error);
                        } 
                        var filtro = res.data.Filtro || res.data.filtro;
                        switch (filtro) {
                            case "filtroNoPermiteCarga":
                                return {
                                    type: 'filtroNoPermiteCarga',
                                    link: 'filtroNoPermiteCarga',
                                    redirect: true
                                };
                            case "filtroPosibleFallecido":
                                return {
                                    type: 'filtroPosibleFallecido',
                                    redirect: true
                                };
                            case "filtroNoPermiteDescarga":
                                return {
                                    type: 'filtroNoPermiteDescarga',
                                    link: 'filtroNoPermiteDescarga',
                                    redirect: true
                                };
                            case "filtroPendienteValoracion":
                                return {
                                    type: 'filtroPendienteValoracion',
                                    link: 'filtroPendienteValoracionUrl',
                                };
                            case "filtroContramedidasFinancieras":
                                return {
                                    type: 'filtroContramedidasFinancieras',
                                    link: 'filtroContramedidasFinancierasUrl',
                                    redirect: true
                                };
                            case "filtroContratoJuegos":
                                return {
                                    type: 'avisoContratoJuegos',
                                };
                            case "filtroAvisoLegal":
                                return {
                                    type: 'noAvisoLegal',
                                    link: 'noAvisoLegal'
                                };
                            case "filtroContratoJuego":
                                return {
                                    type: "avisoContratoJuego",
                                    link: "RGPD"
                                };
                            case "filtroServiciosAdicionales":
                                return {
                                    type: "avisoFiltroServiciosAd",
                                    link: "RGPD"
                                };
                            case "filtroRegionFiscal":
                                return {
                                    type: 'filtroRegionFiscal'
                                }; // regionesFiscales
                            case "tiempoLogin":
                                return {
                                    type: 'tiempoInactividad'
                                };
                                // case "filtroRpvojRgjia": return {type: 'filtroRpvojRgjia', link: true, logOut: true};
                            case "filtroRpvojRgjia":
                                return {
                                    type: 'filtroRpvojRgjia',
                                    link: 'filtroRpvojRgjia'
                                };
                                // Nuevos filtros
                            case "plataforma":
                                return {
                                    type: 'errorEstadoPlataforma'
                                };
                            case "filtroEstadoCanales":
                                return {
                                    type: 'avisoEstadoCanales'
                                };
                            case "configuracionJuego":
                                return {
                                    type: 'avisoConfiguracionJuego'
                                };
                            case "filtroSorteos":
                                return {
                                    type: 'avisoFiltroSorteos'
                                };
                            case "estadoJuego":
                                return {
                                    type: 'avisoFiltroEstadoJuego'
                                };
                            case "filtroEstadoJuego":
                                return {
                                    type: 'avisoFiltroEstadoJuego'
                                };
                            case "EstadoParticipante":
                                return {
                                    type: 'avisoFiltroEstadoParticipante'
                                };
                            case "SaldoExcedido":
                                return {
                                    type: 'avisoFiltroSaldoExcedido'
                                };
                            case "filtroClubConmigoOnline":
                                return {
                                    type: 'avisoFiltroClubConmigo',
                                    link: 'avisoFiltroClubConmigo'
                                };
                            case "TiempoInactividad":
                                return {
                                    type: 'tiempoInactividad',
                                    redirect: true
                                };
                            case "filtroMensajesInternos":
                                return {
                                    type: 'filtroMensajesInternos',
                                    redirect: true
                                };
                            case "filtroSaldoCompra":
                                return {
                                    type: "chargeLotoBolsa",
                                    redirect: true,
                                    save: true
                                };
                            case "filtroAutoexclusion":
                                return {
                                    type: "Mensaje1",
                                    link: "contactaConElCAU",
                                    redirect: true
                                };
                            case "filtroPasswordIntentos":
                                return {
                                    type: "Mensaje1",
                                    link: "contactaConElCAU",
                                    redirect: true
                                };
                            case "filtroPasswordCuarentena":
                                return {
                                    type: "Mensaje1",
                                    link: "contactaConElCAU",
                                    redirect: true
                                };
                            case "filtroPasswordCuarentena":
                                return {
                                    type: "Mensaje1",
                                    link: "contactaConElCAU",
                                    redirect: true
                                };
                            case "filtroRGIAJ":
                                return {
                                    type: 'filtroRpvojRgjia',
                                    link: 'filtroRpvojRgjia'
                                };
                            case "filtroRPVOJ":
                                return {
                                    type: 'filtroRpvojRgjia',
                                    link: 'filtroRpvojRgjia'
                                };
                            case "filtroBajaSolicitud":
                                return {
                                    type: "Mensaje1",
                                    link: "contactaConElCAU",
                                    redirect: true
                                };
                            case "plataformaCerrada":
                                return {
                                    type: "Mensaje2",
                                    redirect: true
                                };
                            case "filtroConfiguracionJuego":
                                return {
                                    type: "Mensaje2",
                                    redirect: true
                                };
                            case "filtroOperativaInadecuada":
                                return {
                                    type: "Mensaje1",
                                    link: "contactaConElCAU",
                                    redirect: true
                                };
                            default:
                                return {
                                    type: filtro,
                                    notDefined: true
                                }; // si no encuentra filtro, erro generico de la palciacion y incluyesen codigo que duevulve
                                //default: return {type: filtro[0].msgErrorFiltro};// si no encuentra filtro, erro generico de la palciacion y incluyesen codigo que duevulve
                        }
                    }
                    try {
                        if (res.data.compraDto[0].ApuestaDto.msgError) {
                            return {
                                type: res.data.compraDto[0].ApuestaDto.msgError,
                                notDefined: true,
                                redirect: true
                            };
                        }
                    } catch (e) {}
                    if (res.data.error) {
                        if (res.data.error[0].error) {
                            return {type: res.data.error[0].msgError,redirect: true};
                        }
                        if (res.data.listaErrores) {
                            return {type: res.data.listaErrores,redirect: true};
                        }
                        return {type: res.data.error,formatNotExpected: true,redirect: true};
                    }
                    if (res.data.logout) {
                        return {
                            type: 'loginAgain',
                            logOut: true,
                            redirect: true
                        };
                    }
                    // Funcionalidad comprobacion loteria nacional 
                    if(res.data.disponibilidad && !res.data.disponibilidad[0]) { 
                        return {type: 'InvalidTicketError', redirect: true}; 
                    } 
                    if (res.data.urlActual) {
                        switch (res.data.urlActual) {
                            case "/jugar/cas/carga/carga-lotobolsa.json":
                                return {
                                    type: "chargeLotoBolsa",
                                    redirect: true,
                                    save: true
                                };
                            case "/jugar/cas/configuracion/datos-usuario.json":
                                return {
                                    type: "regionesFiscales"
                                };
                            case "/jugar/cas/configuracion/datos-cuenta/politicas.json":
                                if (data.avisoLegalVersion[0] === true) {
                                    return {
                                        type: "noAvisoLegal"
                                    };
                                } else {
                                    return {
                                        type: "avisoContratoJuegos"
                                    };
                                }
                            case "/jugar/cas/lotobolsa/opciones-lotobolsa.json":
                                return {
                                    type: "saldoExcedido"
                                };
                            case "/jugar/cas/lotobolsa/carga/carga-lotobolsa.json":
                                return {
                                    type: "chargeLotoBolsa",
                                    redirect: true,
                                    save: true
                                };
                            case "/jugar/canal.json":
                                return {
                                    type: "CONFIG_JUEGO_CERRADO"
                                };
                            case "/jugar/cas/login/tiempo-inactividad.json":
                                return {
                                    type: "tiempoInactividad",
                                    redirect: true
                                };
                        }
                    }
                    return {
                        type: "genericError",
                        notDefined: true,
                        formatNotExpected: true,
                        redirect: true
                    };
                }
                

                //////////////////
                function redirect(router) {
                    switch (router) {
                        case "badBet":
                            $ionicHistory.goBack();
                            break;
                        case "error.sorteo.no.activo":
                            $ionicHistory.goBack();
                            break;
                        case "chargeLotoBolsa":
                            $state.go("app.loadLotobolsa");
                            break;
                        case 'filtroNoPermiteCarga':
                            $ionicHistory.goBack();
                            break;
                        case 'filtroNoPermiteDescarga':
                            $ionicHistory.goBack();
                            break;
                        default:
                            $state.go("app.home");
                            break;
                    }
                }
                //////////////////
                function logOut() {
                    popupSrv.showLoading('loggingOut');
                    var url = config.services.host + config.services.logout;
                    console.info('<=================================LogOut: Pending=========================================>');
                    $http({
                            method: 'POST',
                            url: url,
                            withCredentials: false
                        })
                        .then(function (res) {
                            //if (res.data.logout) { popupSrv.showErrorPopup(this.errorHandler2(res)); }
                            var url = config.services.host + config.services.logout2ndStep;
                            $http({
                                    method: 'POST',
                                    url: url,
                                    withCredentials: false
                                })
                                .then(function (res) {
                                    //if (res.data.logout) { popupSrv.showErrorPopup(this.errorHandler2(res)); }
                                    //console.log('Se cierra el interval Nº:', window.minCounter); clearInterval(window.minCounter);
                                    //console.log('Se cierra el interval Nº:', window.minCounterWithoutActivity); clearInterval(window.minCounterWithoutActivity);
                                    window.timerInterval.map(function (i) {
                                        clearInterval(i);
                                        console.log('Limpiado intervalo:', i);
                                        return null;
                                    }).filter(Boolean);

                                    //deleteTimeInHtml();
                                    $rootScope.logged = false;

                                    popupSrv.hideLoading();
                                    console.info('<===================================LogOut: OK============================================>');
                                }.bind(this), function (err) {
                                    popupSrv.hideLoading();
                                    popupSrv.showErrorPopup(this.errorHandler2(err));
                                }.bind(this));
                        }.bind(this), function (err) {
                            popupSrv.hideLoading();
                            popupSrv.showErrorPopup(this.errorHandler2(err));
                        }.bind(this));

                    function deleteTimeInHtml() {
                        var elem = document.querySelectorAll('#iconUserMenu');
                        if (elem) {
                            for (var i = 0; i < elem.length; i++) {
                                elem[i].innerHTML = '';
                            }
                        }
                        var elem2 = document.querySelectorAll('#iconLotoBolsaMenu');
                        if (elem2) {
                            for (var i = 0; i < elem2.length; i++) {
                                elem2[i].innerHTML = '';
                            }
                        }
                    }
                }
            };
            /*******************************************************************************************************/
            /*******************************************************************************************************/






            /*******************************************************************************************************/
            /********************************* Sistema Cancelar apuestas ********************************************/
            this.cancelBet = function (gameId, betType, betId) {

                var gameId = Number(gameId);
                if (!gameId) {
                    throw 'El Servicio cancelBet necesita pasar el id de juego para cancelar la apuesta';
                }
                if ((gameId === 1 || gameId === 2 || gameId === 4) && !betType) {
                    throw 'El servicio cancelBet necesita pasar el tipo de apuesta para primitiva, quiniela bonoloto';
                }
                if ((gameId === 9 || gameId === 10) && !betId) {
                    throw 'El servicio cancelBet necesita pasar el id de la apuesta para cancelar loteria nacional';
                }

                var url = config.services.host + getDeleteUrl(gameId, betId, betType);

                // LLamada al servicio
                console.info('<==============================Cancel Bet: Pending================================>');
                $http({
                    method: 'POST',
                    url: url
                }).then(function (res) {
                    try {
                        if (res.data.filtro || res.data.Filtro || res.data.error) {
                            throw res;
                        }
                        console.info('Servicio', res);
                        console.info('<=================================Cancel Bet: OK==================================>');
                    } catch (err) {
                        //$rootScope.logged = false;
                        popupSrv.showErrorPopup(this.errorHandler2(res));
                    }
                }.bind(this), function (err) {
                    //$rootScope.logged = false;
                    popupSrv.showErrorPopup(this.errorHandler2(err));
                }.bind(this));
            };

            //////////////////////////////////////////////////
            //////////////////
            function getDeleteUrl(gameId, betId, betType) {
                switch (gameId) {
                    case 1:
                        if (betType === 'sencilla') {
                            return 'jugar/la-primitiva/apuesta.json?tipoPrimitiva=1&action=primitiva.limpiar';
                        } else {
                            return 'jugar/la-primitiva/apuesta.json?tipoPrimitiva=2&action=primitiva.limpiar';
                        }
                    case 2:
                        if (betType === 'sencilla') {
                            return 'jugar/la-quiniela/apuesta.json?tipoQuinielaEliminarTodo=simpleTab&action=quiniela.limpiar';
                        } else {
                            return 'jugar/la-quiniela/apuesta.json?tipoQuinielaEliminarTodo=multipleTab&action=quiniela.limpiar';
                        }
                    case 3:
                        return 'jugar/euromillones/apuesta.json?accionController=euromillon.limpiar';
                    case 4:
                        if (betType === 'sencilla') {
                            return 'jugar/bonoloto/apuesta.json?tipoBonoloto=1&action=bonoloto.limpiar';
                        } else {
                            return 'jugar/bonoloto/apuesta.json?tipoBonoloto=2&action=bonoloto.limpiar';
                        }
                    case 5:
                        return 'jugar/gordo-primitiva/apuesta.json?action=limpiar';
                    case 6:
                        return 'jugar/quinigol/apuesta.json?accion=quinigol.limpiar';
                    case 7:
                        return 'jugar/lototurf/apuesta.json?accionController=lototurf.limpiar';
                    case 8:
                        return "jugar/quintupleplus/apuesta.json?action=quintupleplus.limpiar";
                    case 9:
                    case 10:
                        return "jugar/loteria-nacional/decimo.json?idSorteo=" + betId + "&action=loteriaNacional.limpiar";
                }
            }
            /*******************************************************************************************************/
            /*******************************************************************************************************/

            this.serviceErrorHandler = function (e, noRedirect) {
                popupSrv.hideLoading();
                var err = this.errorHandler(e);
                popupSrv.showErrorPopup(err.typeError);
                if (!noRedirect) {
                    $rootScope.redirect(err.typeError);
                }
            };

            return {
                get: this.get,
                add: this.add,
                remove: this.remove,
                cancelBet: this.cancelBet,
                cancelAll: this.cancelAll,
                request: this.request,
                errorHandler: this.errorHandler,
                errorHandler2: this.errorHandler2,
                setBetConfig: this.setBetConfig,
                getBetConfig: this.getBetConfig,
                login: this.login,
                serviceErrorHandler: this.serviceErrorHandler,
                logOut2: this.logOut2,
                errorMapperServiceRest: this.errorMapperServiceRest
            };
        }
    ]);