angular.module('selae.games.controllers')

.controller('QuickBetCtrl', ['$scope', '$rootScope', '$stateParams', '$ionicHistory', '$state', 'popupSrv', '$timeout', 'config', 'requestSrv', '$filter', 'opSrv', 'analyticsSrv',
    function($scope, $rootScope, $stateParams, $ionicHistory, $state, popupSrv, $timeout, config, requestSrv, $filter, opSrv, analyticsSrv) {

        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
            viewData.enableBack = true;
        });
        $scope.gameId = $stateParams.game_id;
        $scope.voiceActive = $stateParams.voiceActive === "true" ? true : false;
        
        //inicializamos a false la variable que determina si hay que volver al ticket tras la recarga de lotobolsa
        if ($rootScope.ticket === true){
            $rootScope.ticket = false;
        }

        if (window.ga !== undefined) { 
            if ($scope.voiceActive === true) {
                analyticsSrv.trackView('Jugar por voz-Confirmar apuesta-' + analyticsSrv.setName($stateParams.game_id)); 
            } else {
                analyticsSrv.trackView('Automática-Confirmar apuesta-' + analyticsSrv.setName($stateParams.game_id)); 
            }
        }

        // Variable donde guardamos los datos de la vista actual
        $rootScope.aJuego = $ionicHistory.currentView();

        $scope.disableContinue = false;

        $scope.data = {};

        $scope.betSettings = {};

        $scope.record = function() {
            if ($scope.voiceActive === true){
                var recognition = new SpeechRecognition();
                recognition.lang = "es-ES";
                recognition.onresult = function(event) {
                    console.log("success",event);
                    if (event.results.length > 0) {
                        console.log("success",event.results[0][0].transcript);
                        $scope.recognizedText = event.results[0][0].transcript;
                        if ($rootScope.logged) {
                            if ($scope.recognizedText.indexOf("confirmar") !== -1 || $scope.recognizedText.indexOf("Confirmar") !== -1) {
                                $scope.buy();
                            } else if ($scope.recognizedText.indexOf("cancelar") !== -1|| $scope.recognizedText.indexOf("Cancelar") !== -1) {
                                $scope.cancel();
                            } else{
                                popupSrv.showErrorPopup("didNotUnderstandReturnHome").then(function(e) {
                                    deleteBet();
                                });

                            }
                        } else {
                            popupSrv.showErrorPopup("mustBeLogged");
                        }
                    }
                };


                recognition.onerror = function(event) {
                    popupSrv.showErrorPopup("voiceErrorReturnHome").then(function(e) {
                        deleteBet();
                    });
                };

                var listening = $filter('translate')('listening');

                document.querySelector('#textVoiceListening').innerHTML = '';
                setTimeout(function() {
                    document.querySelector('#textVoiceListening').innerHTML = listening;
                    recognition.start();
                }, 5000);
                
            }
        };


        


        $scope.cancel = function() {
            $rootScope.selaeGoBack();
        };
        $scope.buy = function() {
            requestSrv.setBetConfig($scope.betSettings);
            $ionicHistory.currentView($ionicHistory.backView());
            $state.go("app.ticket", { game_id: $scope.gameId });
        };

        $scope.getBet = function() {
            // debugger;
            popupSrv.showLoading("generatingBet");
            var confGame = opSrv.newGetConfigGame($scope.gameId);

            requestSrv.request(config.services.host + confGame, "post", [])
            .then(function(e) {
                if (e.data.compraDto !== undefined && e.data.compraDto !== null) {
                    requestSrv.setBetConfig({ sorteo: e.data.compraDto[0].ApuestaDto.listaSorteos[0] });
                    var params = [{
                        name: "apuestas",
                        value: $scope.gameId == 2 || ($scope.gameId == 4 && e.data.compraDto[0].ApuestaDto.sorteos == "DIARIA") ? 2 : 1
                    }, {
                        name: "idJuego",
                        value: $scope.gameId == 9 ? e.data.compraDto[0].ApuestaDto.listaSorteos[0].SorteoDto.idJuego : $scope.gameId
                    }, {
                        name: "tipoSorteo",
                        value: e.data.compraDto[0].ApuestaDto.sorteos
                    }, {
                        name: "solicitaJuegoAsociado",
                        value: false
                    }, {
                        name: "metodo",
                        value: "Sencillo"
                    }, {
                        name: "apuestasTriples",
                        value: 0
                    }, {
                        name: "apuestasDobles",
                        value: 0
                    }];

                    requestSrv.request(config.services.host + config.services.quickBet, "post", params)
                    .then(function(response) {
                        try {
                            $rootScope.cancelBetData = {
                              idJ: e.data.compraDto[0].ApuestaDto.idJuego || $rootScope.aJuego.stateParams.game_id,
                              metod: e.data.compraDto[0].ApuestaDto.metodo || "sencilla",
                              idS: e.data.compraDto[0].ApuestaDto.idSorteo || "no es loteria"
                            };
                            } catch(e) {/**/}

                        if (response.data.compraDto !== undefined && response.data.compraDto !== null) {
                            $scope.data = response.data.compraDto[0].ApuestaDto;
                            if ($scope.gameId == 2 || $scope.gameId == 6) {
                                $scope.data.partidos = e.data.partidos;

                              // Esta condición esta puesta porque para el Quinigol no hay que eliminar
                              // ningún elemento
                              if ($scope.gameId == 2) {
                                  $rootScope.partidosPleno = $scope.data.partidos[14];
                                $scope.data.partidos.pop();
                              }
                            }
                            if($scope.gameId == 3){
                                $scope.data.asociados = {};
                                $scope.data.asociados.tieneMillones = e.data.tieneMillones;
                                $scope.data.asociados.tieneLluvia = e.data.tieneLluvia;
                            }
                            console.log($scope.data);
                            $scope.record();
                        } else {
                            throw response;
                        }
                    })
                    .finally(function(){
                        popupSrv.hideLoading();
                    })
                    .catch(function(err) {
                        $scope.disableContinue = true;
                        popupSrv.hideLoading();
                        popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                    });
                } else {
                    throw e;
                }
            })
            .catch(function(err) {
                $scope.disableContinue = true;
                popupSrv.hideLoading();
                popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
            });
        };
        var deleteBet = function(){
            var deleteGame;
            var params = requestSrv.getBetConfig();

            switch ($stateParams.game_id) {
                case "1":
                    deleteGame = "jugar/la-primitiva/apuesta.json?tipoPrimitiva=1&action=primitiva.limpiar";
                    break;
                case "2":
                    deleteGame = "jugar/la-quiniela/apuesta.json?tipoQuinielaEliminarTodo=simpleTab&accion=quiniela.limpiar";
                    break;
                case "3":
                    deleteGame = "jugar/euromillones/apuesta.json?accionController=euromillon.limpiar";
                    break;
                case "4":
                    deleteGame = "jugar/bonoloto/apuesta.json?tipoBonoloto=1&action=bonoloto.limpiar";
                    break;
                case "5":
                    deleteGame = "jugar/gordo-primitiva/apuesta.json?action=limpiar";
                    break;
                case "6":
                    deleteGame = "jugar/quinigol/apuesta.json?accion=quinigol.limpiar";
                    break;
                case "7":
                    deleteGame = "jugar/lototurf/apuesta.json?accionController=lototurf.limpiar";
                    break;
                case "8":
                    deleteGame = "jugar/quintupleplus/apuesta.json?action=quintupleplus.limpiar";
                    break;
                case "9":
                    deleteGame = "jugar/loteria-nacional/decimo.json?idSorteo=" + params.sorteo.SorteoDto.sorteoId + "&action=loteriaNacional.limpiar";
                    break;
                default:
                    break;
            }
            popupSrv.showLoading("canceling");
            requestSrv.request(config.services.host + deleteGame, "post", [])
            .then(function(e) {
                if (e.data.compraDto) {
                    $ionicHistory.goBack();
                } else {
                    throw e;
                }
            })
            .finally(function(){
                popupSrv.hideLoading();
            })
            .catch(function(err) {
                popupSrv.hideLoading();
                popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
            });
        };
    }
]);
