angular.module('selae.games.controllers')

.controller('TicketCtrl', ['$scope', 'popupSrv', 'requestSrv', '$ionicHistory', 'config', '$stateParams', '$rootScope','$filter', '$state', '$ionicPlatform', 'analyticsSrv', '$http',
function($scope, popupSrv, requestSrv, $ionicHistory, config, $stateParams, $rootScope, $filter, $state, $ionicPlatform, analyticsSrv, $http) {
	if(window.ga !== undefined) {
		var anaGameName = analyticsSrv.setName($stateParams.game_id);
		try { analyticsSrv.trackView('Resguardo-' + anaGameName); } 
		catch(err) { console.error(err); }
	}
	$scope.gameId = $stateParams.game_id;
	$scope.betParams = requestSrv.getBetConfig();
	$scope.data = {};

	//en caso del gordo nuevo, el error salta en el ticket, por lo que no tenemos que volver a redirigir al ticket
	if ( $stateParams.serviceV2 == 'true' && $scope.gameId == '5' ) {
			$rootScope.ticket = false;
	} 


	//esta casuística no sabemos en qué caso se reproduce. Ante la duda, no borramos, mantenemos y creamos la excepción del gordo nuevo anterior.
	if ( $rootScope.ticket ) {
		$rootScope.ticket = false;
		$state.go("app.myBets");
	}

	if($ionicHistory.backView().stateName === "app.myFavouritesPlayAgain" || $ionicHistory.backView().stateName === "app.myBetDetail") {
		var deregisterHardBack = $ionicPlatform.registerBackButtonAction($rootScope.selaeGoBack, 101);
		$scope.$on('$destroy', deregisterHardBack);
	}

	backToBets = function() {
		$ionicHistory.clearCache().then(function() { $state.go('app.myBets'); });
	};

	var getConfigUrl = function(gameId){
        switch (gameId) {
            case "1":
                return config.services.buyPrimitiva;
            case "2":
                return config.services.buyQuiniela;
            case "3":
                return config.services.buyEuromillon;
            case "4":
                return config.services.buyBonoloto;
            case "5":
                return config.services.buyGordo;
            case "6":
                return config.services.buyQuinigol;
            case "7":
                return config.services.buyLototurf;
            case "8":
                return config.services.buyQuintuple;
            case "9":
                return config.services.buyLoteria;
            case "10":
                return config.services.buyLoteria;
            default:
                return '';
        }
    };
	$scope.buy = function() {
		console.info('<============================Finalizar Apuesta: Pending====================================>');
		popupSrv.showLoading("betting");
		var confGame = getConfigUrl($scope.gameId);
		
			if ($scope.betParams.subscribe === true) {
				//console.log($stateParams.favorite);
				///////////////////////////////////////////////

				if($stateParams.favorite == false) {

					if ($scope.gameId == "3" || $scope.gameId == "7") {
						var haveFavorite = true; 
						confGame = confGame + "?checkbox_suscripcion_config=true";
					} else {	
						confGame = confGame + "&checkbox_suscripcion_config=true";
					}
				}
				////////////////////////////////////////////////////
				if ($scope.betParams.automatic == true) {
					if ($scope.gameId == "3" || $scope.gameId == "7") {
						if (haveFavorite) {
							confGame = confGame + "&checkbox_aleatoria_config=true";
						} else {
							confGame = confGame + "?checkbox_aleatoria_config=true";
						}
					}else{	
						confGame = confGame + "&checkbox_aleatoria_config=true";
					}
					//confGame = confGame + "&checkbox_aleatoria_config=true";
				}
				/////////////////////////////////////////////////
			}

		requestSrv.setBetConfig({});
		requestSrv.request(config.services.host + confGame, "post", [])
	    .then(function(res) {
			try {
				console.log('Respuesta tercero servicio',res);
				if(res.data.error || res.data.Filtro || res.data.filtro || (res.data.disponibilidad && !res.data.disponibilidad[0]) ) { throw res; }
	        	$scope.data = res.data;
	        	requestSrv.request(config.services.host + config.services.header, "jsonp", null);
				popupSrv.hideLoading();
				console.info('<==============================Finalizar Apuesta: OK=======================================>');
			} catch(err) {
				popupSrv.hideLoading();
				popupSrv.showErrorPopup(requestSrv.errorHandler2(res));
			}
	    })
	    .catch(function(err) {
			popupSrv.hideLoading();
            popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
	    });
	};

	function buyV2Service () {
		// si se queire guardar como favorita, se llama al servicio de favorita con el id de la apuesta y le nombre
		popupSrv.showLoading("betting");

		// Se añade la cabecera aplication.json y tenemos que emter el dta vacío para que no la borre el $http
		var callConfig = {
			headers : {
				"Content-Type": "application/json",
			},
			data : ''
		};
		$http.post( config.services.host + config.services.buyGordoV2, callConfig )
		  .then(function (e) {
			 // $scope.data = e.data;
				$scope.data = e.data;
				$scope.data.detalleApuesta.listaSorteos = e.data.detalleApuesta.fechasSorteos;
				requestSrv.request(config.services.host + config.services.header, "jsonp", null);
				popupSrv.hideLoading();
				if ($stateParams.favoriteName !== '') {
					buyFavorite(e.data.detalleApuesta.apuestaId, $stateParams.favoriteName);
				}
				// betDetail (e.data.detalleApuesta.apuestaId);
		  })
	    .catch(function(err) {
			popupSrv.hideLoading();
			$ionicHistory.backView().stateName === "app.myFavouritesPlayAgain" ?   popupSrv.showErrorPopup(requestSrv.errorMapperServiceRest(err, {data: $rootScope.lotoBolsaStore.data, page:'app.myFavouritesPlayAgain'})): popupSrv.showErrorPopup(requestSrv.errorMapperServiceRest(err));
	    });
	}

	function betDetail (idApuesta) {
			$http.get( config.services.host + config.services.betDetail + idApuesta, callConfig)
			.then(function(e){
				$scope.data = e.data;
				$scope.data.detalleApuesta.listaSorteos = e.data.detalleApuesta.fechasSorteos;
				popupSrv.hideLoading();
			}).catch(function(err) {
				popupSrv.hideLoading();
				popupSrv.showErrorPopup(requestSrv.errorMapperServiceRest(err));
			});
	}

	function buyFavorite (idApuesta, name) {
		var params = [{
			name: 'idApuesta',
			value: idApuesta
		}, {
			name: 'nombre_favorita',
			value: name
		}];
		requestSrv.request(config.services.host + config.services.saveFavorite , "post", params)
		.then(function(res) {
			console.log('Favorita con exito');
	    })
	    .catch(function(err) {
			console.log('error favorita');
			popupSrv.hideLoading();
            popupSrv.showErrorPopup(requestSrv.errorMapperServiceRest(err));
	    });
	}

	$scope.checkService = function() {
		$stateParams.serviceV2 ? buyV2Service() : $scope.buy();

	};
}]);
