angular.module('selae.games.directives')

.directive('bonolotoTicketDrv', [function() {
    return {
        restrict: 'E',
        templateUrl: 'games/templates/bonoloto-ticket.html',
        scope: {
            data: '='
        },
        controller: ['$scope', '$filter', 'opSrv', 'gamesProvider', function($scope, $filter, opSrv, gamesProvider) {
            $scope.titleLogo = gamesProvider.getTicketIcon('4');
            var formatBet = function() {
                var bets = [];
                var arrayBets = $scope.data.detalleApuesta[0].combinacion.split(".");
                arrayBets.splice(0, 1);

                angular.forEach(arrayBets, function(value, key) {
                    var block = value.split("=");
                    var betAux = block[1].split(":");
                    var numbers = betAux[0].split(",");

                    bets[key] = {
                        "block": key + 1,
                        "numbers": numbers
                    };
                });

                return bets;
            };

            var formatDate = function() {
                var array=[];
                array.push($scope.data.detalleApuesta[0].listaSorteos[0]);
                if($scope.data.detalleApuesta[0].listaSorteos.length > 1){
                    array.push($scope.data.detalleApuesta[0].listaSorteos[$scope.data.detalleApuesta[0].listaSorteos.length -1]);
                }
                return opSrv.formatDatesForTicket(array);
            };

            $scope.init = function() {
                $scope.ticket = {
                    "numeroApuestas": $scope.data.detalleApuesta[0].napuestas,
                    "tipoDeApuesta": $scope.data.detalleApuesta[0].metodo,
                    "apuestas": formatBet(),
                    "fecha": formatDate(),
                    "precio": $scope.data.detalleApuesta[0].precioBoletoEuros,
                    "numeroDeSerie": $scope.data.detalleApuesta[0].numeroSerie,
                    "reintegro": $scope.data.detalleApuesta[0].reintegro
                };
            };
        }],
        link: function(scope) {
            scope.$watch("data", function(newValue, oldValue) {
                if (scope.data.detalleApuesta !== undefined){
                    scope.init();
                }
            });
        }
    };
}]);

