angular.module('selae.games.directives')

.directive('elGordoBetDrv', [function() {
    return {
        restrict: 'E',
        templateUrl: 'games/templates/el-gordo-bet.html',
        scope: {
            bet: '='
        },
        controller: ['$scope', function($scope) {
            $scope.bets = [];
            $scope.raffles = [];


            var formatBet = function() {
                $scope.serviceV2 = $scope.bet.serviceV2 || 'false';
                if ( $scope.serviceV2 == 'false' && $scope.bet.combinacionApuesta.indexOf(':') !== -1 ) {
                    $scope.serviceV2 = 'true';
                    $scope.bet.serviceV2 = 'true';
                }
                var arrayBets = $scope.bet.combinacionApuesta.split(".");
                arrayBets.splice(0, 1);

                angular.forEach(arrayBets, function(value, key) {
                    var block = value.split("=");
                    var betAux = getBetAux(block);
                    var numbers = betAux[0].split(",");
                    var keyNumber = (betAux[1] === undefined)?0:betAux[1].split(",");

                    $scope.bets[key] = {
                        "block": key,
                        "numbers": numbers,
                        "keyNumber": keyNumber
                    };
                    $scope.keyNumberGlobal = $scope.bets[key].keyNumber[0];
                });

                function getBetAux (block) {
                    var key = $scope.bet.serviceV2 == 'true' ? block[1].split(":") : block[1].split(";");
                    return key;
                }
            };

            var formatDays = function() {
                angular.forEach($scope.bet.listaSorteos, function(value, key) {
                    value.SorteoDto && value.SorteoDto.fecha ? this.push(value.SorteoDto.fecha) : this.push(value.fecha);
                }, $scope.raffles);
            };

            $scope.init = function() {
                $scope.bets = [];
                $scope.raffles = [];
                $scope.betType = ($scope.bet.metodo === 'Multiple')?'múltiple':'sencilla';
                formatBet();
                formatDays();
            };

        }],
        link: function(scope) {
            scope.$watch("bet", function(newValue, oldValue) {
                if (scope.bet.combinacionApuesta !== undefined) {
                    scope.init();
                }
            });
        }
    };
}]);

