angular.module('selae.games.directives')

.directive('elGordoTicketDrv', [function() {
    return {
        restrict: 'E',
        templateUrl: 'games/templates/el-gordo-ticket.html',
        scope: {
            data: '='
        },
        controller: ['$scope', 'opSrv', 'gamesProvider', function($scope, opSrv, gamesProvider) {
            $scope.titleLogo = gamesProvider.getTicketIcon('5');

            var formatBet = function(data) {

                var bets = [];
                var arrayBets = data.combinacion.split(".");
                arrayBets.splice(0, 1);

                angular.forEach(arrayBets, function(value, key) {
                    var block = value.split("=");
                    var betAux = getBetAux(block);
                    var numbers = betAux[0].split(",");
                    var keyNumber = (betAux[1] === undefined)?0:betAux[1].split(",");

                    bets[key] = {
                        "block": key + 1,
                        "numbers": numbers,
                        "keyNumber": keyNumber
                    };
                });

                function getBetAux (block) {
                    var key = block[1].indexOf(';') !== -1 ? block[1].split(";") : block[1].split(":");
                    return key;
                }

                return bets;
            };

            var formatDate = function(date) {
                return opSrv.formatDatesForTicket(date);
            };

            $scope.init = function(data,newService) {

                $scope.gordoV2 = newService;

                $scope.ticket = {
                    "numeroApuestas": data.napuestas,
                    "tipoDeApuesta": data.metodo,
                    "apuestas": formatBet(data),
                    "fecha": formatDate(data.listaSorteos),
                    "precio": String((data.precio/100).toFixed(2)).replace('.',','),
                    "numeroDeSerie": data.numeroSerie,
                    "reintegro": data.reintegro
                };

            };
        }],
        link: function(scope) {
            scope.$watch("data", function(newValue, oldValue) {
                if (scope.data.detalleApuesta !== undefined){

                    if (scope.data.detalleApuesta[0]) {
                        scope.data.detalleApuesta[0].combinacion.indexOf(':')!== -1 ?  scope.init(scope.data.detalleApuesta[0], 'true') :  scope.init(scope.data.detalleApuesta[0], 'false');
                    }
                    else {
                        scope.init(scope.data.detalleApuesta, 'true');
                    }
                    
                }
            });
        }
    };
}]);
