angular.module('selae.games.directives')

.directive('euromillonBetDrv', [function() {
    return {
        restrict: 'E',
        templateUrl: 'games/templates/euromillon-bet.html',
        scope: {
            bet: '='
        },
        controller: ['$scope', function($scope) {
            $scope.bets = [];
            $scope.raffles = [];

            var formatBet = function() {
                var arrayBets = $scope.bet.combinacionApuesta.split(".");
                arrayBets.splice(0, 1);

                angular.forEach(arrayBets, function(value, key) {
                    var block = value.split("=");
                    var betAux = block[1].split(":");
                    var numbers = betAux[0].split(",");
                    var stars = betAux[1].split(",");

                    $scope.bets[key] = {
                        "block": key + 1,
                        "numbers": numbers,
                        "stars": stars
                    };
                });
            };

            var formatDays = function() {
                if ($scope.bet.sorteos == "DIARIA"){
                    $scope.raffles.push($scope.bet.listaSorteos[0].SorteoDto.fecha);
                }else{
                    angular.forEach ($scope.bet.listaSorteos, function(value, key){
                        this.push(value.SorteoDto.fecha);
                    },$scope.raffles);
                }
            };

            $scope.init = function() {
	            $scope.bets = [];
            	$scope.raffles = [];
                $scope.betType = ($scope.bet.metodo === "Multiple")? 'multiple':'single';
                formatBet();
                formatDays();
                
                var fecha = $scope.bet.listaSorteos[0].SorteoDto.fecha.substring(0,11);
                fecha = fecha + $scope.bet.listaSorteos[0].SorteoDto.fecha.substring($scope.bet.listaSorteos[0].SorteoDto.fecha.length - 4);
                $scope.bet.asociados.fecha = fecha;
            };
        }],
        link: function(scope) {

        	scope.$watch("bet", function (newValue, oldValue) {
	  			if(scope.bet.combinacionApuesta !== undefined){
		            scope.init();
	  			}
            });
        }
    };
}]);

