angular.module('selae.games.directives')

.directive('euromillonTicketDrv', [function() {
    return {
        restrict: 'E',
        templateUrl: 'games/templates/euromillon-ticket.html',
        scope: {
            data: '='
        },
        controller: ['$scope','opSrv','$filter', 'gamesProvider', function($scope, opSrv, $filter, gamesProvider) {
            $scope.titleLogo = gamesProvider.getTicketIcon('3');

            var formatBet = function() {
                var bets = [];
                var arrayBets = $scope.data.detalleApuesta[0].combinacion.split(".");
                arrayBets.splice(0, 1);

                angular.forEach(arrayBets, function(value, key) {
                    var block = value.split("=");
                    var betAux = block[1].split(":");
                    var numbers = betAux[0].split(",");
                    var stars = betAux[1].split(",");

                    bets[key] = {
                        "block": key + 1,
                        "numbers": numbers,
                        "stars": stars
                    };
                });
                return bets;
            };

            var formatDate = function() {
                return opSrv.formatDatesForTicket($scope.data.detalleApuesta[0].listaSorteos);
            };

            $scope.init = function() {
                var millon = $filter('filter')($scope.data.detalleApuesta[0].rifas,{idJuego: 11})[0];
                var lluvia = $filter('filter')($scope.data.detalleApuesta[0].rifas,{idJuego: 12})[0];

                if (millon){
                    var millonParts = millon.rangos.split("-");
                    if (millonParts[0] == millonParts[1]){
                        millon.rangos = millonParts[0];
                    }
                    if (millon.fechaPrimerSorteo && millon.fechaUltimoSorteo) {
                        if ( millon.fechaPrimerSorteo !== millon.fechaUltimoSorteo ) { 
                            millon.fechaPrimerSorteoCorta = millon.fechaPrimerSorteo.substring(4) + " - " + millon.fechaUltimoSorteo.substring(4);
                         } else {millon.fechaPrimerSorteoCorta = millon.fechaPrimerSorteo.substring(4);}
                    } else {
                        millon.fechaPrimerSorteoCorta = millon.fechaPrimerSorteo.substring(4);
                    }
                    
                }
                if (lluvia){
                    var lluviaParts = lluvia.rangos.split("-");
                    if (lluviaParts[0] == lluviaParts[1]){
                        lluvia.rangos = lluviaParts[0];
                    }
                    lluvia.fechaPrimerSorteoCorta = lluvia.fechaPrimerSorteo.substring(4);
                }
                $scope.ticket = {
                    "numeroApuestas": $scope.data.detalleApuesta[0].napuestas,
                    "tipoDeApuesta": $scope.data.detalleApuesta[0].metodo,
                    "apuestas": formatBet(),
                    "fecha": formatDate(),
                    "precio": $scope.data.detalleApuesta[0].precioBoletoEuros,
                    "numeroDeSerie": $scope.data.detalleApuesta[0].numeroSerie,
                    "millon": millon,
                    "lluvia": lluvia
                };
            };
        }],
        link: function(scope) {
            scope.$watch("data", function(newValue, oldValue) {
                if (scope.data.detalleApuesta !== undefined){
                    scope.init();
                }
            });
        }
    };
}]);

