angular.module('selae.games.directives')

.directive('loteriaCombinationDrv', [function() {
	return {
		restrict: 'E',
		templateUrl: 'games/templates/loteria-combination.html',
		scope: {
			gameId: '=',
			block: '='
		},
		controller: ['$scope','config','requestSrv', 'popupSrv', function($scope, config, requestSrv, popupSrv){
			$scope.betConfig = requestSrv.getBetConfig();
			$scope.currentInput = 1;
			$scope.validated = false;

			$scope.$parent.$parent.$parent.continueDisabled = false;


			$scope.input = function(number){
				angular.element('input[name=number-' + $scope.currentInput +']').val(number);
				if ($scope.currentInput < 5){
					$scope.currentInput++;
				}
				else{
					$scope.currentInput = 1;
				}
			};

			$scope.select = function(number){
				$scope.currentInput = number;
			};


			$scope.getTimes = function(n){
				if(typeof n === "string")
					return new Array(parseInt(n,10));
				else
					return new Array(n);

			};

			$scope.clear = function(random){
				angular.forEach(angular.element('input[name^=number-]'), function(value, key) {
					angular.element(value).val("*");
					$scope.currentInput = 1;
				});
			};
			
			$scope.deleteTicket = function(){
				var params =  [
					{
						name: "action",
						value: "loteriaNacional.limpiar"
					},
					{
						name: "idSorteo",
						value: $scope.betConfig.sorteo.SorteoDto.sorteoId
					},
					{
						name: "idJuego",
						value: $scope.betConfig.sorteo.SorteoDto.idJuego
					}
				];
				popupSrv.showLoading("removingTicket");
				requestSrv.request(config.services.host + config.services.configLoteria, "post", params)
				.then(function() {
					$scope.clear();
					$scope.validated = false;
					$scope.$parent.continueDisabled = true;
				})
				.finally(function(){
					popupSrv.hideLoading();
				})
				.catch(function(err) {
					popupSrv.hideLoading();
                    popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
				});
			};


			$scope.init = function(){
				$scope.betConfig = requestSrv.getBetConfig();
			};

			function ticketNumbers(){
				var numbers = "";
				angular.forEach(angular.element('input[name^=number-]'), function(value, key) {
					numbers = numbers + angular.element(value).val();
				});
				return numbers;
			}

			function isTicketValid(){
				var pattern = new RegExp("\\*\\d+\\*");
				var ticket = ticketNumbers();

				return !pattern.test(ticket);
			}
		}],
		link: function(scope){
			scope.$watch("betConfig", function (/*newValue, oldValue*/) {
				scope.init();
			});
		}
	};
}]);
