angular.module('selae.games.directives')

.directive('lototurfTicketDrv', [function() {
	return {
		restrict: 'E',
		templateUrl: 'games/templates/lototurf-ticket.html',
		scope:{
			data: '='
		},
		controller: ['$scope','opSrv', 'gamesProvider', function($scope, opSrv, gamesProvider){
			$scope.titleLogo = gamesProvider.getTicketIcon('7');

			var formatBet = function(){
				var bets = [];

				angular.forEach ($scope.data.detalleApuesta[0].apuestasFormateadas, function(value, key){
					var bet = value.split(":");
					var	numbers = bet[0].split(",");
					var keyNumbers = bet[1].split(";")[0].split(",");

					bets.push({
						"block": key +1,
						"numbers": numbers,
						"keyNumber": keyNumbers
					});
				});
				return bets;
			};

			var formatDate = function(){
				return opSrv.formatDatesForTicket($scope.data.detalleApuesta[0].listaSorteos);
			};

			$scope.init = function(){
				$scope.ticket = {
					"numeroApuestas": $scope.data.detalleApuesta[0].napuestas,
					"tipoDeApuesta": $scope.data.detalleApuesta[0].metodo,
					"apuestas": formatBet(),
					"fecha": formatDate(),
					"precio": $scope.data.detalleApuesta[0].precioBoletoEuros,
					"numeroDeSerie":$scope.data.detalleApuesta[0].numeroSerie,
					"reintegro": $scope.data.detalleApuesta[0].reintegro
				};
			};
		}],
		link: function(scope){
			scope.$watch("data", function (newValue, oldValue) {
            	if (scope.data.detalleApuesta !== undefined){
	            	scope.init();
	            }
            });

		}
	};
}]);
