angular.module('selae.games.directives')

.directive('primitivaCombinationDrv', [function(config) {
	return {
		restrict: 'E',
		templateUrl: 'games/templates/primitiva-combination.html',
		scope: {
			gameId: '=',
			block: '=',
			protocoloReintegro: '=',
			betsRange: '='
		},
		controller: ['$scope','config','requestSrv', 'popupSrv', 'opSrv', '$ionicSlideBoxDelegate', '$rootScope',  
		function($scope,config,requestSrv, popupSrv, opSrv, $ionicSlideBoxDelegate, $rootScope){
			$scope.betConfig = requestSrv.getBetConfig();
			$scope.showReintegro = $scope.protocoloReintegro;
			$scope.itemsSelected = {}; //Items elegidos para un bloque concreto
			$scope.nItemsSelected = {}; //Numero de items elegidos para un bloque concreto
			$scope.blockedCombo = {}; //Estado de bloqueo de un bloque
			$scope.item = []; //elementos, pueden estar seleccionados o no
			//$scope.block = [];
			$scope.leftArrow = false;
			for(var i = 0; i < $scope.betsRange.maxBet ; i++){
				$scope.block[i+1] = new opSrv.Block();
				$scope.block[i+1].nBlock = 0;
			}
			$scope.rightArrow = ($scope.betsRange.maxBet == 1) ? false : true;

			$scope.$watch("block", function (newValue, oldValue) {
				if ($scope.betConfig.nNumbers > 0){
					for(var i = 0; i < $scope.betConfig.nBets ; i++){
						if ($scope.isFull(i + 1)){
							$scope.$parent.$parent.$parent.continueDisabled = true;
							break;
						} else{
							$scope.$parent.$parent.$parent.continueDisabled = false;
						}

					}
				}
			}, true);

			// $scope.slickBet = {
			// 	enabled: true,
			// 	autoplay: false,
			// 	swipeToSlide: true,
			// 	arrows: true,
			// 	infinite: false,
			// 	dots: true,
			// 	prevArrow: '<a class="slideBet-prev"><i class="ion-chevron-left"></i></a>',
			// 	nextArrow: '<a class="slideBet-next"><i class="ion-chevron-right"></i></a>',
			// 	dotsClass: 'slideBet-dots',
			// 	customPaging : function(slider, i) {
			//         return '<button type="button" data-role="none" role="button" tabindex="' + i +'" id="check' + i + '"><i class="icon-check"></i></button>';
			//     },
			// 	event: {
			// 		init: function(){
			// 			angular.element('.dots').prepend(angular.element('.slideBet-dots'));
			// 		}
			// 	}
			// };


			// Manejador del slide
			$scope.onMySlideChanged = function(index) {
				console.log("Usuario navega a la slide " + index);
				//Ctrl de la flecha izquierda.
				if(index === 0){
					$scope.leftArrow = false;
				}else{
					$scope.leftArrow = true;
				}

				//Ctrl de la flecha derecha.
				if(index === ($scope.betsRange.maxBet-1)){
					$scope.rightArrow = false;
				}else{
					$scope.rightArrow = true;
				}
			};

			$scope.nextSlide = function() {
				$ionicSlideBoxDelegate.next([100]);	
			};
			$scope.prevSlide = function() {
				$ionicSlideBoxDelegate.previous([100]);
			};

			$scope.toColumns = function(n){
				var elements = angular.element(".combinationItemFloat");
				for(var i = 0; i < elements.length; i+=n) {
					if(!angular.element(elements[i]).parent().hasClass('combination-item-column')){
						elements.slice(i, i+n).wrapAll("<div class='combination-item-column'></div>");
					}
				}
			};

			$scope.getTimes=function(n){
				if(typeof n === "string")
					return new Array(parseInt(n,10));
				else
					return new Array(n);

			};

			$scope.checkChanged = function(selection,item,index){
					//WATCH AQUI?
				$scope.block[index].automatic = false;
				opSrv.checkChanged($scope.block,selection,item,index,$scope.betConfig.nNumbers);
			};


			$scope.checkChangedExtra = function(selection,item,index){
				$scope.block[index].automatic = false;
				opSrv.checkChangedExtra($scope.block,selection,item,index,$scope.betConfig.nExtra);
			};


			$scope.checkBlocked = function(index,item,status){
				return opSrv.checkBlocked($scope.block,index,item,status,$scope.betConfig.nNumbers);
			};

			$scope.checkBlockedExtra = function(index,item,status){
				return opSrv.checkBlockedExtra($scope.block,index,item,status,$scope.betConfig.nExtra);
			};


			$scope.isFull = function(index){
				var nExtraAux =  0;
				return opSrv.isFull($scope.block,index,$scope.betConfig.nNumbers,nExtraAux);
			};


			$scope.addBlock = function(index){
				var end = opSrv.addBlock($scope.block,index,$scope.gameId,$scope.betConfig,$scope,$scope.block[index].automatic);
			};

			$scope.deleteBlock = function(index){
				opSrv.deleteBlock($scope.block,index,$scope.gameId, $scope);
			};

			$scope.randomPick = function(index){
				console.log($scope);
				$scope.block[index].automatic = true;
				opSrv.randomPick($scope.block,index,$scope.betConfig,$scope.gameId);
			};

			$scope.init = function(){
				$scope.betConfig = requestSrv.getBetConfig();

				//$scope.block = [];
				for(var i = 0; i < $scope.betConfig.nBets ; i++){
					$scope.block[i+1] = new opSrv.Block();
					$scope.block[i+1].nBlock = 0;
				}

				$scope.item = [];
				if($scope.betConfig.betModel != 'multiple'){
					$scope.betConfig.nNumbers = 6;
					$rootScope.borrarnNumbers = 6;
				}

				if ( $scope.protocoloReintegro === "true" ) {
					$scope.betConfig.nExtra = 1;
					$rootScope.borrarnExtra = 1;
				} else {
					$scope.betConfig.nExtra = 0;
					$rootScope.borrarnExtra = 0;
				}

				$rootScope.borrarnNumbers = $scope.betConfig.nNumbers;
				$scope.itemsSelected = {};
				$scope.itemsSelected = {};
				$scope.nItemsSelected = {};
				$scope.blockedCombo = {};
			};
		}],
		link: function(scope){
			scope.$watch("betConfig", function (newValue, oldValue) {
				scope.init();
			});
		}
	};
}]);
