angular.module('selae.games.directives')

.directive('quinielaCombinationDrv', [function() {
    return {
        restrict: 'E',
        templateUrl: 'games/templates/quiniela-combination.html',
        scope: {
    			gameId: '=',
                block: '=',
                betsRange: '='
    		},
        controller: ['$scope', 'config', 'requestSrv', 'popupSrv', 'opSrv','$filter', '$ionicSlideBoxDelegate', '$rootScope', 'analyticsSrv',
        function($scope, config, requestSrv, popupSrv, opSrv, $filter, $ionicSlideBoxDelegate, $rootScope, analyticsSrv) {
            $scope.betConfig = requestSrv.getBetConfig();
            $scope.partidos = $scope.betConfig.partidos;
            //$scope.block = [];
            $scope.plenoEl = $scope.partidos.pop();
            $scope.pleno = [$scope.plenoEl.nombreLocal, $scope.plenoEl.nombreVisitante];
            $scope.plenoSended = false;

            var pleno = '';

            var MAX_PARTIDOS = 14;
			$scope.leftArrow = false;
			for(var i = 0; i < $scope.betsRange.maxBet ; i++){
				$scope.block[i+1] = new opSrv.Block();
				$scope.block[i+1].nBlock = 0;
			}
			$scope.rightArrow = ($scope.betsRange.maxBet == 1) ? false : true;

            $scope.$watch("block", function (newValue, oldValue) {
                if ($scope.betConfig.nNumbers > 0 || $scope.betConfig.nExtra > 0){
                    for(var i = 0; i < $scope.betConfig.nBets ; i++){
                        if ($scope.isFull(i + 1)){
                            $scope.$parent.$parent.$parent.continueDisabled = true;
                            break;
                        } else{
                            $scope.$parent.$parent.$parent.continueDisabled = false;
                        }
                    }
                }
            }, true);

            /*
            $scope.slickBet = {
                enabled: true,
                autoplay: false,
                swipeToSlide: true,
                arrows: true,
                infinite: false,
                dots: true,
                prevArrow: '<a class="slideBet-prev"><i class="ion-chevron-left"></i></a>',
                nextArrow: '<a class="slideBet-next"><i class="ion-chevron-right"></i></a>',
                dotsClass: 'slideBet-dots',
                customPaging: function(slider, i) {
                    return '<button type="button" data-role="none" role="button" tabindex="' + i + '" id="check' + i + '"><i class="icon-check"></i></button>';
                },
                event: {
                    init: function() {
                        angular.element('.dots').prepend(angular.element('.slideBet-dots'));
                    }
                }
            };
            */

			// Manejador del slide
			$scope.onMySlideChanged = function(index) {
				console.log("Usuario navega a la slide " + index);
				//Ctrl de la flecha izquierda.
				if(index === 0){
					$scope.leftArrow = false;
				}else{
					$scope.leftArrow = true;
				}

				//Ctrl de la flecha derecha.
				if(index === ($scope.betsRange.maxBet-1)){
					$scope.rightArrow = false;
				}else{
					$scope.rightArrow = true;
				}
			};

			$scope.nextSlide = function() {
				$ionicSlideBoxDelegate.next([100]);
			};
			$scope.prevSlide = function() {
				$ionicSlideBoxDelegate.previous([100]);
			};

            $scope.getTimes = function(n) {
                if (typeof n === "string"){
                    return new Array(parseInt(n, 10));
                }
                else{
                    return new Array(n);
                }

            };

            $scope.checkChanged = function(selection,item,index){
                $scope.block[index].automatic = false;
				opSrv.checkChanged($scope.block,selection,item,index,$scope.betConfig.nNumbers);
			};

            $scope.checkChangedPleno = function(index){
                $scope.block[index].automatic = false;
            };

            $scope.isFull = function(index){
                if($scope.betConfig.betModel != 'multiple'){
                    return opSrv.isFull($scope.block,index,$scope.betConfig.nNumbers,2, $scope.gameId, $scope.betConfig.elige8);
                }
                else{
                    
                    for (var i=1; i<= MAX_PARTIDOS; i++){
                        if ($scope.block[index].item === undefined){
                            return true;
                        }
                        if ($scope.block[index].item[i] === undefined){
                            return true;
                        }
                        if ($scope.block[index].item[i].values === undefined){
                            return true;
                        }
                        if (($scope.block[index].item[i].values[1] === undefined || $scope.block[index].item[i].values[1].selected === false || $scope.block[index].item[i].values[1].selected === undefined) &&
                            ($scope.block[index].item[i].values[2] === undefined || $scope.block[index].item[i].values[2].selected === false || $scope.block[index].item[i].values[2].selected === undefined) &&
                            ($scope.block[index].item[i].values[3] === undefined || $scope.block[index].item[i].values[3].selected === false || $scope.block[index].item[i].values[3].selected === undefined)){
                            return true;
                        }

                        if ($scope.block[1].extraItem === undefined || $scope.block[1].extraItem[1] === undefined || $scope.block[1].extraItem[2] === undefined){
                            return true;
                        }
                    }

                    var extraItemLength = 0;

                    angular.forEach($scope.block[1].extraItem[1].values, function(value, key){
                        if (value.selected === true){
                            extraItemLength++;
                        }
                    });
                    angular.forEach($scope.block[1].extraItem[2].values, function(value, key){
                        if (value.selected === true){
                            extraItemLength++;
                        }
                    });

                    if (extraItemLength < 2){
                        return true;
                    }

                    if($scope.betConfig.elige8 && $scope.getElige8Selected() < 8) {
                        return true;
                    }

                    if ($scope.block[index].isBlocked === true){
                        return true;
                    }
                }
                return false;
			};

			$scope.randomPick = function(index) {
                $scope.block[index].automatic = true;

	            if ($scope.block[index].isBlocked === true) {
	                return;
	            }
                var i;
                var value;
                var match;

	            if($scope.betConfig.betModel != 'multiple'){
					for (i=1; i<= $scope.betConfig.nNumbers; i++){
						value = Math.floor((Math.random() * 3) + 1);
						$scope.block[index].item[i] = {};
						switch(value){
							case 1:
								$scope.block[index].item[i].selected = '1';
								break;
							case 2:
								$scope.block[index].item[i].selected = 'X';
								break;
							case 3:
								$scope.block[index].item[i].selected = '2';
								break;
							default:
						}
					}
				}
				else{
                    var set;

                    for (i=1; i<= MAX_PARTIDOS; i++){
                        $scope.block[index].item[i] = {};
                        $scope.block[index].item[i].values = [];
                        $scope.block[index].item[i].values[1] = {};
                        $scope.block[index].item[i].values[2] = {};
                        $scope.block[index].item[i].values[3] = {};
                    }

                    for (i=1; i<= MAX_PARTIDOS; i++){
                        value = Math.floor((Math.random() * 3) + 1);
                        $scope.block[index].item[i].values[value].selected = true;
                    }

                    for (i=1; i<= $scope.betConfig.nNumbers; i++){
                        set = false;
                        while(!set){
                            value = Math.floor((Math.random() * 3) + 1);
                            match = Math.floor((Math.random() * MAX_PARTIDOS) + 1);
                            if ($scope.block[index].item[match].values[value].selected !== true &&
                                $filter('filter')($scope.block[index].item[match].values,{selected:true}).length == 1){
                                    $scope.block[index].item[match].values[value].selected = true;
                                    set = true;
                            }
                        }
                    }

                    for (i=1; i<= $scope.betConfig.nExtra; i++){
                        set = false;
                        while(!set){
                            match = Math.floor((Math.random() * MAX_PARTIDOS) + 1);
                            if ($filter('filter')($scope.block[index].item[match].values,{selected:true}).length == 1){
                                    $scope.block[index].item[match].values[1].selected = true;
                                    $scope.block[index].item[match].values[2].selected = true;
                                    $scope.block[index].item[match].values[3].selected = true;
                                    set = true;
                            }
                        }
                    }
				}

				if (index == 1){
					for (i=1; i<= 2; i++){
						value = Math.floor((Math.random() * 4) + 1);
						$scope.block[index].extraItem[i] = {};
                        $scope.block[index].extraItem[i].values =[];
                        $scope.block[index].extraItem[i].values[value] = {};
                        $scope.block[index].extraItem[i].values[value].selected = true;
					}
				}
	        };

            $scope.checkBlocked = function(index, item, status) {
                if ($scope.block[index].isBlocked === true) {
                    return true;
                }
                return false;
            };

            $scope.deleteBlock = function(index) {
                if ($scope.block[index].isBlocked === false) {
                    $scope.block[index] = {
                        item: {},
                        extraItem: {},
                        isBlocked: false,
                        nBlock: 0
                    };
                    $scope.block[index].nBlock = 0;
                    $scope.$parent.$parent.$parent.continueDisabled = true;
                    return;
                }

                var refer = $scope.block[index].nBlock;

                popupSrv.showLoading("deletingBlock");

                confGame = config.services.configQuiniela;
                var params = [{
                    name: "columna",
                    value: refer
                }, {
                    name: "action",
                    value: "quiniela.borrarColumna"
                }];

                requestSrv.request(config.services.host + confGame, "post", params)
                .then(function() {
                    angular.forEach($scope.block[index].item, function(value, key) {
                        $('#number-' + key).prop('checked', false);
                        delete $scope.block[index].item[key];
                    });
                    var prev = $scope.block[index].nBlock;
                    $scope.block[index].nBlock = 0;

                    angular.forEach($scope.block, function(value, key) {
                        if (value.nBlock > 0 && value.nBlock > prev)
                            value.nBlock--;
                    });

                    angular.forEach($scope.block[index].extraItem, function(value, key) {
                        $('#number-' + key).prop('checked', false);
                        delete $scope.block[index].extraItem[key];
                    });

                    $scope.block[index].isBlocked = false;
                    angular.element("#check" + (index - 1)).removeClass("check");
                    $scope.$parent.$parent.$parent.continueDisabled = true;
                    if (index === 1){
                        $scope.plenoSended = false;
                        pleno = '';
                    }
                })
                .finally(function(){
                    popupSrv.hideLoading();
                })
                .catch(function(err) {
                    popupSrv.hideLoading();
                    popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                });
            };

            $scope.checkChangedElige8 = function(selection,item,index){
				$scope.block[index].automatic = false;
				opSrv.checkChangedElige8($scope.block,item,index);
			};

			$scope.checkBlockedElige8 = function(index,item,status){
				return opSrv.checkBlockedExtra($scope.block,index,item,status,8,$scope.gameId);
            };

            $scope.getElige8Selected = function () {
                if($scope.block[1].extraItem['elige8'] !== undefined) {
                    return Object.keys($scope.block[1].extraItem['elige8'].values).length;
                } else {
                    return 0;
                }
            };

            $scope.urlRadar = $rootScope.selae.properties.quinielaRadar || "false";

            $scope.onRadarClick = function (index) {
                window.open($scope.urlRadar + index,'_system');
            };

            $scope.init = function() {
                $scope.betConfig = requestSrv.getBetConfig();
                if($scope.betConfig.betModel != 'multiple'){
					$scope.betConfig.nNumbers = MAX_PARTIDOS;
				}
                $scope.partidos = $scope.betConfig.partidos;
                $scope.porcentajes = $scope.betConfig.porcentaje;
                if (typeof $scope.porcentajes === 'string' || $scope.porcentajes === undefined) {
                    $scope.porcentajes = {
                        "1": ['-','-','-'],
                        "2": ['-','-','-'],
                        "3": ['-','-','-'],
                        "4": ['-','-','-'],
                        "5": ['-','-','-'],
                        "6": ['-','-','-'],
                        "7": ['-','-','-'],
                        "8": ['-','-','-'],
                        "9": ['-','-','-'],
                        "10": ['-','-','-'],
                        "11": ['-','-','-'],
                        "12": ['-','-','-'],
                        "13": ['-','-','-'],
                        "14": ['-','-','-'],
                        "15": ['-','-','-'] 
                    };
                }
                $scope.porcentajes.showPercentages = false;

                $rootScope.borrarnNumbers = $scope.betConfig.nNumbers;
                $rootScope.borrarnExtra = 2;

                $scope.typeBet = $scope.betConfig.betModel === "sencilla" ? "radio" : "checkbox";
                $scope.raffles = [];
                $scope.bets = [];
                $scope.item = [];

                // Hacemos los dos plenos al 15
                for (i=1; i<= 2; i++) {
                $scope.block[1].extraItem[i] = {};
                $scope.block[1].extraItem[i].values =[];
                $scope.block[1].extraItem[i].values.value = {};
                $scope.block[1].extraItem[i].values.value.selected = false;
            }

            };
        }],
        link: function(scope) {
            scope.$watch("betConfig", function(newValue, oldValue) {
                scope.init();
            });
        }
    };
}]);
