angular.module('selae.games.directives')

.directive('quinigolCombinationDrv', [function(config) {
    return {
        restrict: 'E',
        templateUrl: 'games/templates/quinigol-combination.html',
        scope: {
    			gameId: '=',
    			block: '='
    		},
        controller: ['$scope', 'config', 'requestSrv', 'popupSrv', 'opSrv','$filter', 'analyticsSrv', function($scope, config, requestSrv, popupSrv, opSrv, $filter, analyticsSrv) {
            var automatic;
            $scope.betOptions = ["0-0", "1-0", "2-0", "M-0", "0-1", "1-1", "2-1", "M-1", "0-2", "1-2", "2-2", "M-2", "0-M", "1-M", "2-M", "M-M"];
            $scope.betConfig = requestSrv.getBetConfig();
            $scope.partidos = $scope.betConfig.partidos;
            $scope.item = []; //elementos, pueden estar seleccionados o no
            //$scope.block = [];
            for (var i = 0; i < $scope.betConfig.nBets; i++) {
                $scope.block[i + 1] = new opSrv.Block();
                $scope.block[i + 1].nBlock = 0;
            }

            $scope.$watch("block", function (newValue, oldValue) {
                if ($scope.betConfig.nNumbers > 0){
                    for(var i = 0; i < $scope.betConfig.nBets ; i++){
                        if ($scope.isFull(i + 1)){
                            $scope.$parent.$parent.$parent.continueDisabled = true;
                            break;
                        } else{
                            $scope.$parent.$parent.$parent.continueDisabled = false;
                        }
                    }
                }
            }, true);

            $scope.slickBet = {
                enabled: true,
                autoplay: false,
                swipeToSlide: true,
                arrows: true,
                infinite: false,
                dots: true,
                prevArrow: '<a class="slideBet-prev"><i class="ion-chevron-left"></i></a>',
                nextArrow: '<a class="slideBet-next"><i class="ion-chevron-right"></i></a>',
                dotsClass: 'slideBet-dots',
                customPaging: function(slider, i) {
                    return '<button type="button" data-role="none" role="button" tabindex="' + i + '" id="check' + i + '"><i class="icon-check"></i></button>';
                },
                event: {
                    init: function() {
                        angular.element('.dots').prepend(angular.element('.slideBet-dots'));
                    }
                }
            };

            $scope.getTimes = function(n) {
                if (typeof n === "string")
                    return new Array(parseInt(n, 10));
                else
                    return new Array(n);
            };

            $scope.toRows = function(n){
                var elements = angular.element(".combinationItemFloatInlineQuinigol");
                for(var i = 0; i < elements.length; i+=n) {
                    if(!angular.element(elements[i]).parent().hasClass('combination-item-row')){
                        elements.slice(i, i+n).wrapAll("<div class='combination-item-row'></div>");
                    }
                }
            };

            $scope.checkChanged = function(selection, item, index) {
                automatic = false;
                opSrv.checkChanged($scope.block, selection, item, index, $scope.betConfig.nNumbers);
            };


            $scope.checkBlocked = function(index, item, status) {
                return opSrv.checkBlocked($scope.block, index, item, status, $scope.betConfig.nNumbers);
            };


            $scope.isFull = function() {
                for (var i = 1; i <= 6; i++) {
                    if (Object.keys($scope.block[i].item).length >= 1 && $scope.block[i].isBlocked === false) {} else {
                        return true;
                    }
                }
                return false;
            };

            var sendBet1 = function(betSorted) {
                var bet = 0;
                var betString = "";
                for (var i = 1; i <= 6; i++) {
                    betString = betString + $scope.betOptions[(betSorted[i][0]) - 1];
                    for (var j = 1; j < betSorted[i].length; j++) {
                        bet = $scope.betOptions[(betSorted[i][j] - 1)];
                        betString = betString + ',' + bet;
                    }
                    if (i != 6) {
                        betString = betString + ':';
                    }
                }
                return betString;
            };

            $scope.deleteBlock = function(index) {

                if ($scope.block[index].isBlocked === false) {
                    for (var i = 1; i <= 6; i++) {
                        $scope.block[i] = new opSrv.Block();
                        $scope.block[i].nBlock = 0;
                    }
                    $scope.continueDisabled = true;
                    return;
                }

                var refer = $scope.block[index].nBlock;
                popupSrv.showLoading("deletingBlock");
                var params = [{
                    name: "columna",
                    value: 1
                }, {
                    name: "action",
                    value: "quinigol.borrarColumna"
                }];
                requestSrv.request(config.services.host + config.services.configQuinigol, "post", params)
                .then(function() {
                    var deleteKey = function(value, key) {
                        $('#number-' + key).prop('checked', false);
                        delete $scope.block[index].item[key];
                    };

                    var subtractBlock = function(value, key) {
                        if (value.nBlock > 0 && value.nBlock > prev)
                            value.nBlock--;
                    };

                    for (var index = 1; index <= 6; index++) {
                        angular.forEach($scope.block[index].item, deleteKey);
                        var prev = $scope.block[index].nBlock;
                        $scope.block[index].nBlock = 0;

                        angular.forEach($scope.block, subtractBlock);

                        $scope.block[index].isBlocked = false;
                    }
                    $scope.continueDisabled = true;
                })
                .finally(function(){
                    popupSrv.hideLoading();
                })
                .catch(function(err) {
                    popupSrv.hideLoading();
                    popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                });
            };

            var getRandom = function(size, amount) {
                return Array.apply(null, Array(amount)).map(
                    function(_, i) {
                        return Math.round(Math.random() * size) + 1;
                    });
            };

            var checkIfArrayIsUnique = function(array) {
                array.sort(function(a, b) {
                    return a - b; });
                for (var i = 1; i < array.length; i++) {
                    if (array[i - 1] == array[i])
                        return false;
                }
                return true;
            };

            $scope.randomPick = function() {
                automatic = true;

                var deleteBlock = function(value, key) {
                    $('#combo-' + index + '#number-' + key).prop('checked', false);
                    delete $scope.block[index].item[key];
                };

                var setValue = function(value, key) {
                    $('#combo-' + index + '#number-' + key).prop('checked', true);
                    if (!$scope.block[index].item[value]) {
                        $scope.block[index].item[value] = {};
                    }
                    $scope.block[index].item[value].selected = true;
                };


                for (var index = 1; index <= 6; index++) {
                    angular.forEach($scope.block[index].item, deleteBlock);

                    var randomArray = getRandom(15, 1);
                    while (checkIfArrayIsUnique(randomArray) !== true) {
                        randomArray = getRandom(15, 1);
                    }

                    angular.forEach(randomArray, setValue);
                }
            };

            $scope.init = function() {
                $scope.betConfig = requestSrv.getBetConfig();
                //$scope.block = [];
                for (var i = 0; i < 6; i++) {
                    $scope.block[i + 1] = new opSrv.Block();
                    $scope.block[i + 1].nBlock = 0;
                }
                $scope.item = [];
                $scope.betConfig.nNumbers = 16;
            };
        }],
        link: function(scope) {
            scope.$watch("betConfig", function(newValue, oldValue) {
                scope.init();
            });
        }
    };
}]);
