angular.module('selae.games.directives')

.directive('quintuplePlusCombinationDrv', [function(config) {
    return {
        restrict: 'E',
        templateUrl: 'games/templates/quintuple-plus-combination.html',
        scope: {
    			gameId: '=',
    			block: '='
    		},
        controller: ['$scope', 'config', 'requestSrv', 'popupSrv', 'opSrv','$filter', function($scope, config, requestSrv, popupSrv, opSrv, $filter) {
            $scope.betConfig = requestSrv.getBetConfig();
            $scope.carreras = [
                { "nombre": $filter('translate')('horseRace1'), caballos:$scope.betConfig.caballos[0] },
                { "nombre": $filter('translate')('horseRace2'), caballos:$scope.betConfig.caballos[1] },
                { "nombre": $filter('translate')('horseRace3'), caballos:$scope.betConfig.caballos[2] },
                { "nombre": $filter('translate')('horseRace4'), caballos:$scope.betConfig.caballos[3] },
                { "nombre": $filter('translate')('horseRace51'), caballos:$scope.betConfig.caballos[4] },
                { "nombre": $filter('translate')('horseRace52'), caballos:$scope.betConfig.caballos[4] }
            ];
            $scope.item = []; //elementos, pueden estar seleccionados o no
            //$scope.block = [];
            $scope.isBlockedYet = false;
            for (var i = 0; i < $scope.betConfig.nBets; i++) {
                $scope.block[i + 1] = new opSrv.Block();
                $scope.block[i + 1].nBlock = 0;
            }

            $scope.$watch("block", function (newValue, oldValue) {
                if ($scope.betConfig.nNumbers > 0){
                    for(var i = 0; i < $scope.betConfig.nBets ; i++){
                        if ($scope.isFull(i + 1)){
                            $scope.$parent.$parent.$parent.continueDisabled = true;
                            break;
                        } else{
                            $scope.$parent.$parent.$parent.continueDisabled = false;
                        }
                    }
                }
            }, true);

            $scope.slickBet = {
                enabled: true,
                autoplay: false,
                swipeToSlide: true,
                arrows: true,
                infinite: false,
                dots: true,
                prevArrow: '<a class="slideBet-prev"><i class="ion-chevron-left"></i></a>',
                nextArrow: '<a class="slideBet-next"><i class="ion-chevron-right"></i></a>',
                dotsClass: 'slideBet-dots',
                event: {
                    init: function() {
                        angular.element('.dots').prepend(angular.element('.slideBet-dots'));
                    }
                }
            };

            $scope.getTimes = function(n) {
                if (typeof n === "string")
                    return new Array(parseInt(n, 10));
                else
                    return new Array(n);
            };

            $scope.toRows = function(n){
                var elements = angular.element(".combinationItemFloatInline");
                for(var i = 0; i < elements.length; i+=n) {
                    if(!angular.element(elements[i]).parent().hasClass('combination-item-row')){
                        elements.slice(i, i+n).wrapAll("<div class='combination-item-row'></div>");
                    }
                }
            };

            $scope.checkChanged = function(selection, item, index) {
                opSrv.checkChanged($scope.block, selection, item, index, $scope.betConfig.nNumbers);
            };


            $scope.checkBlocked = function(index, item, status) {
                return opSrv.checkBlocked($scope.block, index, item, status, $scope.betConfig.nNumbers);
            };


            $scope.isFull = function() {
                for (var i = 1; i <= 6; i++) {
                    if (Object.keys($scope.block[i].item).length >= 1 && $scope.block[i].isBlocked === false) {} else {
                        return true;
                    }
                }
                return false;
            };

            var sendBet1 = function(betSorted) {
                var bet = 0;
                var betString = "";
                for (var i = 1; i <= 6; i++) {
                    betString = betString + (betSorted[i][0]);
                    for (var j = 1; j < betSorted[i].length; j++) {
                        bet = (betSorted[i][j]);
                        betString = betString + ',' + bet;
                    }
                    if (i != 6) {
                        betString = betString + ':';
                    }
                }
                return betString;
            };

            $scope.deleteBlock = function(index) {
                var clearBlock = function(value, key) {
                    $('#number-' + key).prop('checked', false);
                };

                var subtractBlock = function(value, key) {
                    if (value.nBlock > 0 && value.nBlock > prev)
                        value.nBlock--;
                };
                if ($scope.isBlockedYet) {
                    var refer = $scope.block[index].nBlock;
                    popupSrv.showLoading("deletingBlock");
                    var params = [{
                        name: "columna",
                        value: 1
                    }, {
                        name: "action",
                        value: "quintupleplus.borrarColumna"
                    }];
                    requestSrv.request(config.services.host + config.services.configQuintuple, "post", params)
                    .then(function() {
                        $scope.isBlockedYet = false;

                        for (var i = 1; i <= 6; i++) {
                            angular.forEach($scope.block[i].item, clearBlock);
                            $scope.block[i].item = [];
                            var prev = $scope.block[i].nBlock;
                            $scope.block[i].nBlock = 0;

                            $scope.block[i].isBlocked = false;
                        }
                        $scope.continueDisabled = true;
                    })
                    .finally(function(){
                        popupSrv.hideLoading();
                    })
                    .catch(function(err) {
                        popupSrv.hideLoading();
                        popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                    });
                } else {
                    $scope.isBlockedYet = false;
                    for (var i = 1; i <= 6; i++) {
                        angular.forEach($scope.block[i].item, clearBlock);
                        $scope.block[i].item = [];
                        var prev = $scope.block[i].nBlock;
                        $scope.block[i].nBlock = 0;

                        $scope.block[i].isBlocked = false;

                    }
                }
            };

            var getRandom = function(size, amount) {
                return Array.apply(null, Array(amount)).map(
                    function(_, i) {
                        return Math.round(Math.random() * size) + 1;
                    });
            };

            var checkIfArrayIsUnique = function(array) {
                array.sort(function(a, b) {
                    return a - b; });
                for (var i = 1; i < array.length; i++) {
                    if (array[i - 1] == array[i])
                        return false;
                }
                return true;
            };

            $scope.randomPick = function() {
                var clearBlock = function(value, key) {
                    $('#combo-' + index + '#number-' + key).prop('checked', false);
                    delete $scope.block[index].item[key];
                };

                var setBlockValue = function(value, key) {
                    if (!$scope.block[index].item[value]) {
                        $scope.block[index].item[value] = {};
                    }
                    $scope.block[index].item[value].selected = true;
                };

                for (var index = 1; index <= 6; index++) {
                    angular.forEach($scope.block[index].item, clearBlock);

                    var randomArray = getRandom(19, 1);
                    while (checkIfArrayIsUnique(randomArray) !== true) {
                        randomArray = getRandom(19, 1);
                    }

                    angular.forEach(randomArray, setBlockValue);
                }
            };

            $scope.init = function() {
                $scope.betConfig = requestSrv.getBetConfig();
                //$scope.block = [];
                for (var i = 0; i < 6; i++) {
                    $scope.block[i + 1] = new opSrv.Block();
                    $scope.block[i + 1].nBlock = 0;
                }
                $scope.item = [];
                $scope.betConfig.nNumbers = 20;
            };
        }],
        link: function(scope) {
            scope.$watch("betConfig", function(newValue, oldValue) {
                scope.init();
            });
        }
    };
}]);
