angular.module('selae.games.directives')

.directive('raffleDrv', [function() {
	return {
	    restrict: 'E',
	    templateUrl: 'games/templates/raffle.html',
	    scope:{
	    	data: '='
	    },
	    controller: ['$scope','$filter','config', '$rootScope', 'popupSrv','$state','opSrv', 'analyticsSrv', '$ionicHistory', 'gamesProvider',
        function($scope, $filter, config, $rootScope, popupSrv, $state, opSrv , analyticsSrv, $ionicHistory, gamesProvider){
		    $scope.init = function() {
                
                $scope.millonNuevo = $rootScope.selae.properties.millionIcon;
                $scope.showNewIconsGames = $rootScope.selae.properties.showNewIconsGames;

                if ($scope.data !== undefined) {
                    $scope.game_id="";
                    var fechaFinVentasMilis = opSrv.dateFromString($scope.data.cierre).getTime();
                    //console.log('Fecha cierrre', new Date($scope.data.cierre));
                    //console.log('lo que habia', fechaFinVentasMilis);
                    //var fechaFinVentasMilis2 = new Date($scope.data.cierre).getTime();
                    //console.log('Nativo', fechaFinVentasMilis2);
                    var fechaActualMilis = new Date().getTime();
                    //console.log('Fecha Actual', new Date());
                    //console.log('Actual', fechaActualMilis);
                    $scope.timeLeft = opSrv.dhm(fechaFinVentasMilis - fechaActualMilis, 1);
                    if (fechaFinVentasMilis <= fechaActualMilis) {
                        //$scope.timeLeft = "0h 00min";
                        $scope.timeLeft = "";
                    }
                    
                    // console.log($scope.data.game_id);
                    // console.log($scope.data);
    	    		switch ($scope.data.game_id) {
                        case "LNAC":
                            $scope.logoSrc = $filter('filter')(gamesProvider.getGames(), {idJuego: "9" })[0].img;
                            $scope.game_id = "9";
                            break;
                        case "EMIL":
                            $scope.logoSrc = $filter('filter')(gamesProvider.getGames(), {idJuego: "3" })[0].img;
                            $scope.game_id = "3";
                            break;
                        case "BONO":
                            $scope.logoSrc = $filter('filter')(gamesProvider.getGames(), {idJuego: "4" })[0].img;
                            $scope.game_id = "4";
                            break;
                        case "LAQU":
                            $scope.logoSrc = $filter('filter')(gamesProvider.getGames(), {idJuego: "2" })[0].img;
                            $scope.game_id = "2";
                            break;
                        case "QGOL":
                            $scope.logoSrc = $filter('filter')(gamesProvider.getGames(), {idJuego: "6" })[0].img;
                            $scope.game_id = "6";
                            break;
                        case "LAPR":
                            $scope.logoSrc = $filter('filter')(gamesProvider.getGames(), {idJuego: "1" })[0].img;
                            $scope.game_id = "1";
                            break;
                        case "ELGR":
                            $scope.logoSrc = $filter('filter')(gamesProvider.getGames(), {idJuego: "5" })[0].img;
                            $scope.game_id = "5";
                            break;
                        case "LOTU":
                            $scope.logoSrc = $filter('filter')(gamesProvider.getGames(), {idJuego: "7" })[0].img;
                            $scope.game_id = "7";
                            break;
                        case "QUPL":
                            $scope.logoSrc = $filter('filter')(gamesProvider.getGames(), {idJuego: "8" })[0].img;
                            $scope.game_id = "8";
                            break;
                        default:
                            break;
                    }
                }
	    	};

            $scope.playNow = function(){
                if(window.ga) {
                    var view = $ionicHistory.currentStateName();
                    var eventName = "";
                    if (view === 'app.resultsDetails') {
                        eventName = 'Resultados_Detalle';
                    } else {
                        eventName = 'Próximos_Sorteos';
                    }
                    var anaGameName = analyticsSrv.setName($scope.game_id);
                    analyticsSrv.trackEvent(eventName, 'Jugar', anaGameName);
                }
                if ($rootScope.logged){
                    $state.go("app.stepBet", { game_id: $scope.game_id});
                }
                else{
                    popupSrv.showErrorPopup("mustBeLogged");
                }
            };

            $scope.$watch('data',function(){
                $scope.init();
            });
	    }],
	  	link: function(scope){
            scope.init();
		}
  	};
}]);
