
angular.module('selae', ['ionic', 'slickCarousel', 'ksSwiper', 'selae.core', 'selae.games', 'selae.bets', 'selae.results',
		'selae.user', 'selae.core.services', 'selae.core.filters', 'selae.core.directives', 'ngFitText', 'ngDraggable'
	])

	.constant('config', {
		DEBUG: window.selae.debug,
		senderId: "1089833557305",
		androidTrackerId: "UA-3091897-4",
		iosTrackerId: "UA-3091897-5",
		notifId: "pnsdemo:pnsdemo",
		fingerprints: ["7f 23 3c 3a 6d ae f7 b5 21 73 30 28 35 22 67 df 88 bd da 46","60 5f 04 af 5c 9e f8 84 7d ff 6e 75 01 8c d5 31 8c 73 01 53"],
		certificate_sha1: "E2:48:0F:9E:F0:79:A5:1D:49:1B:4D:9D:B6:6E:02:35:3C:25:15:C4",
		//certificate_sha1_debug: "AB:26:5A:8D:AD:BF:0B:91:E5:DB:E9:93:19:64:35:59:91:35:38:74",
		certificate_sha1_debug: "BD:D0:69:EA:5F:90:9E:96:F7:BD:73:2F:4B:4A:79:CB:DF:9B:05:09",
		services: {
			host: window.selae.dataEntorno.host,
			hostFiltro: window.selae.dataEntorno.hostFiltro,
			cmsHost: window.selae.dataEntorno.cmsHost,

			register: "jugar/servicios-rest/registro/paso1",
			register2ndStep: "jugar/servicios-rest/registro/paso2",
			regionesFiscales: "loterias/estaticos/regionesFiscales.json",
			listaPaises: "jugar/servicios-rest/listadoPaises",
			listaProvincias: "jugar/servicios-rest/listadoProvincias",
			serviciosAdicionales: "jugar/servicios-rest/serviciosAdicionales?obligatorios=true",
			userDataQuery:"api/verifdoc/pub/verificacion/consulta/",

			contratoJuegos: window.selae.dataEntorno.host+"loterias/estaticos/html/contrato.html",

			login: "jugar/loginJson",
			header: "jugar/cabecera/cms",
			configPrimitiva: "jugar/la-primitiva/apuesta.json",
			configQuiniela: "jugar/la-quiniela/apuesta.json",
			configEuromillon: "jugar/euromillones/apuesta.json",
			configBonoloto: "jugar/bonoloto/apuesta.json",
			configGordo: "jugar/gordo-primitiva/apuesta.json",
			configQuinigol: "jugar/quinigol/apuesta.json",
			configLototurf: "jugar/lototurf/apuesta.json",
			configQuintuple: "jugar/quintupleplus/apuesta.json",
			configLoteria: "jugar/loteria-nacional/decimo.json",
			quickBet: "jugar/cas/apuestas/compra-rapida.json",
			logout: "jugar/cas/logout",
			logout2ndStep: "acceder/logout",
			statistics: "es/json/estadisticas",

			genericConfigGame: 'jugar/servicios-rest/configuracion',
			genericRaffle: 'jugar/servicios-rest/sorteos',
			genericSubscription: 'jugar/servicios-rest/apuesta/suscribir/generico',
			betState: 'jugar/servicios-rest/apuesta/estado',
			betName: 'jugar/servicios-rest/apuesta/nombre',
			saveFavorite: 'jugar/cas/servicios-rest/apuesta/guardar/favorita',
			betDetail : 'jugar/cas/servicios-rest/apuestas/',
			myBetsPlayAgain : 'jugar/cas/servicios-rest/apuesta/rejugar/',
			favPlayAgain: 'jugar/cas/servicios-rest/favoritas/',

			buyGordoV2 : 'jugar/cas/servicios-rest/compra/gordo-primitiva',

			profileUserData: "cas/configuracion/datos-usuario.json",
			profileUserTlf:"cas/mensajes/telefono-movil.json",
			profileIsVerificate: "participante/estado",
			profileVerify: "api/verifdoc/pub/verificacion/new",

			validateQuiniela: "jugar/la-quiniela/validar",
			validateElGordo: "jugar/servicios-rest/gordo-primitiva/validar",

			buyPrimitiva: "jugar/cas/apuestas/compra/la-primitiva.json?accionController=resguardoCompra",
			buyQuiniela: "jugar/cas/apuestas/compra/la-quiniela.json?accionController=resguardoCompra",
			buyEuromillon: "jugar/cas/apuestas/compra/euromillones.json",
			buyBonoloto: "jugar/cas/apuestas/compra/bonoloto.json?accionController=resguardoCompra",
			buyGordo: "jugar/cas/apuestas/compra/gordo-primitiva.json?accionController=resguardoCompra",
			buyQuinigol: "jugar/cas/apuestas/compra/quinigol.json?accionController=resguardoCompra",
			buyLototurf: "jugar/cas/apuestas/compra/lototurf.json",
			buyQuintuple: "jugar/cas/apuestas/compra/quintupleplus.json?accionController=resguardoCompra",
			buyLoteria: "jugar/cas/apuestas/compra/loteria-nacional.json?accionController=resguardoCompra",

			buyStepPrimitiva: "jugar/cas/la-primitiva/compra.json?checkbox_suscripcion_config=false&checkbox_aleatoria_config=false&checkbox_favorita_config=false&pasoCompra=4",
			buyStepQuiniela: "jugar/cas/la-quiniela/compra.json?checkbox_suscripcion_config=false&checkbox_aleatoria_config=false&checkbox_favorita_config=false&pasoCompra=4",
			buyStepEuromillon: "jugar/cas/euromillones/compra.json?checkbox_suscripcion_config=false&checkbox_aleatoria_config=false&checkbox_favorita_config=false&pasoCompra=4",
			buyStepBonoloto: "jugar/cas/bonoloto/compra.json?checkbox_suscripcion_config=false&checkbox_aleatoria_config=false&checkbox_favorita_config=false&pasoCompra=4",
			buyStepGordo: "jugar/cas/gordo-primitiva/compra.json?checkbox_suscripcion_config=false&checkbox_aleatoria_config=false&checkbox_favorita_config=false&pasoCompra=4",
			buyStepQuinigol: "jugar/cas/quinigol/compra.json?checkbox_suscripcion_config=false&checkbox_aleatoria_config=false&checkbox_favorita_config=false&pasoCompra=4",
			buyStepLototurf: "jugar/cas/lototurf/compra.json?checkbox_suscripcion_config=false&checkbox_aleatoria_config=false&checkbox_favorita_config=false&pasoCompra=4",
			buyStepQuintuple: "jugar/cas/quintupleplus/compra.json?checkbox_suscripcion_config=false&checkbox_aleatoria_config=false&checkbox_favorita_config=false&pasoCompra=4",
			buyStepLoteria: "jugar/cas/loteria-nacional/compra.json?check_jueves=on&check_sabado=on&checkbox_suscripcion_config=false&checkbox_aleatoria_config=false&checkbox_favorita_config=false&pasoCompra=4",

			buyStepFavPrimitiva: "jugar/cas/la-primitiva/compra.json",
			buyStepFavQuiniela: "jugar/cas/la-quiniela/compra.json",
			buyStepFavEuromillon: "jugar/cas/euromillones/compra.json",
			buyStepFavBonoloto: "jugar/cas/bonoloto/compra.json",
			buyStepFavGordo: "jugar/cas/gordo-primitiva/compra.json",
			buyStepFavQuinigol: "jugar/cas/quinigol/compra.json",
			buyStepFavLototurf: "jugar/cas/lototurf/compra.json",
			buyStepFavQuintuple: "jugar/cas/quintupleplus/compra.json",
			buyStepFavLoteria: "jugar/cas/loteria-nacional/compra.json",

			getHistorico: "jugar/cas/apuestas/historicos.json",
			getDetalleHistorico: "jugar/cas/apuestas/historicos/detalle/{idApuesta}.json",
			initCarga: "jugar/cas/lotobolsa/carga/carga-lotobolsa.json",
			cargaTPV: "jugar/cas/lotobolsa/carga/carga-lotobolsa.json",
			cargaNRL: "jugar/cas/lotobolsa/carga/carga-lotobolsa.json",
			registerNotifications: "http://www.loteriasyapuestas.es/prs/index.jsp",
			ultimosv4: "servicios/ultimosv4",
			ultimos2: "servicios/ultimos2",
			fecha2: "servicios/fecha2",
			fechav3: "servicios/fechav3",
			sorteov3: "servicios/sorteov3",
			sorteo2: "servicios/sorteo2",
			proximosv3: "servicios/proximosv3",
			contact: "jugar/cas/contacto",
			favoritas: "jugar/cas/apuestas/favoritas.json",
			favouriteAgain: "jugar/cas/apuestas/favoritas/detalle"
		},
		urls: {
			register: "https://juegos.loteriasyapuestas.es/jugar/registro/verificacion/",
			requestPassword: "https://juegos.loteriasyapuestas.es/jugar/solicitar-contrasena",
			editProfile: "https://juegos.loteriasyapuestas.es/jugar/cas/configuracion/datos-usuario",
			download: "https://www.loteriasyapuestas.es/es/paginas-informativas/actualizacion-de-la-app-de-loterias-y-apuestas-del-estado",
			web: "https://www.loteriasyapuestas.es"
		}
  })

	.config(['$httpProvider', '$ionicConfigProvider', '$provide', '$compileProvider', function ($httpProvider, $ionicConfigProvider, $provide, $compileProvider) {
		$httpProvider.defaults.withCredentials = true;
		$httpProvider.defaults.headers.post['Cache-Control'] = 'no-cache';
		$httpProvider.defaults.headers.post.Pragma = 'no-cache';
		$ionicConfigProvider.backButton.previousTitleText(false);
		$ionicConfigProvider.backButton.text('');
		$ionicConfigProvider.tabs.position('top');
		$ionicConfigProvider.views.swipeBackEnabled(false);
		$provide.decorator('$locale', ['$delegate', function ($delegate) {
			$delegate.NUMBER_FORMATS.GROUP_SEP = '.';
			$delegate.NUMBER_FORMATS.DECIMAL_SEP = ',';
			return $delegate;
		}]);
		$compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|file|blob|ionic):|data:image/);
	}])

	.run(['$ionicPlatform', '$http', '$rootScope', 'config', 'gamesProvider', '$ionicHistory', 'popupSrv', 'requestSrv', '$stateParams', '$state', '$filter', 'mobileSrv', '$ionicViewSwitcher', '$timeout', '$window', 'loginSrv', 'storageProvider', 'analyticsSrv',
		function ($ionicPlatform, $http, $rootScope, config, gamesProvider ,$ionicHistory, popupSrv, requestSrv, $stateParams, $state, $filter, mobileSrv, $ionicViewSwitcher, $timeout, $window, loginSrv, storageProvider, analyticsSrv) {
			$ionicPlatform.ready(function () {
				var waitingloginAccenggageParametersFunction = null;

				window.selae.waitingloginAccenggageParameters = function(boolean) {
					if(boolean) { waitingloginAccenggageParametersFunction = null; }
					if (waitingloginAccenggageParametersFunction) {
						console.log('Se ejecuta la redireccion enviada por parametros accenggage');
						waitingloginAccenggageParametersFunction();
						waitingloginAccenggageParametersFunction = null;
					} else {
						console.log('No hay evento de Notificaciones Accenggage en la cola');
					}
				}

				if (window.cordova && window.BMA4S) {
					BMA4S.setOptinData(true);
					BMA4S.setCustomParametersListener(function(event) {
						try { actionToReceiveParams(event); } catch(err) { console.log('actionToReceiveParams', err); }
					});
				}
				
				/**************************************************************************************************/
				// Esta funcion tiene toda la logica para notificaciones con parametros, el router esta en routerBM4
				function actionToReceiveParams(data) {
					if ( data.params.notificationParams ) {
						data.params["url"] = data.params.notificationParams.url;
						data.params["game_id"] = data.params.notificationParams.game_id;
						data.params["destino"] = data.params.notificationParams.destino;
					}
					try { console.groupCollapsed('Notificacion BM4'); } catch(err) {}
					// console.log('%c Evento recibido', 'background: #ffffff; color: #61209E', data);
					if (data.action === 'CLICKED') {
						console.log('%c se hizo click en la notificacion', 'background: #ffffff; color: #61209E');
						if (data.params.destino === 'app') {
							//console.log('%c El destino es la app', 'background: #ffffff; color: #61209E');
							try {routerBM4(data.params.url, data.params.game_id)} 
							catch(err) { console.error('routerBM4:', err); $state.go('app.home'); }
						} else if (data.params.destino === 'navegador') {
							console.log('%c No viene app como destino de la notificacion', 'background: #ffffff; color: #61209E');
						}
					}
					try { console.groupEnd(); } catch(err) {}

					
					/*******************************************************************/
					// El router que maneja los estados para notificaciones con parámetros
					function routerBM4(url, id) {
						var id = Number(id);
						if (id === 10) { id = 9; }
						console.log('%c El estado actuales es: ', 'background: #ffffff; color: #61209E', $ionicHistory.currentStateName());

						// este if saltara si el usuario se encuentra en alguna de los pasos de compra donde hay que borrar las apuestas.
						if (testIfDeleteGame($ionicHistory.currentStateName())) {
							// Borrar la apuesta realizada				
							console.log('%c Borra la apuesta anterior ', 'background: #ffffff; color: #61209E');
							console.log('%c CancelBet: ', 'background: #ffffff; color: #61209E', $rootScope.cancelBetData);
							// CUIDADO esta funcion devolvera error si $rootScope.cancelBetData no esta definido, y aun falta por implementarlo en algunos flujos.
							requestSrv.cancelBet($rootScope.cancelBetData.idJ, $rootScope.cancelBetData.metod, $rootScope.cancelBetData.idS);
							$rootScope.cancelBetData = null;
						}
						
						// Controla la redireccion cuando llega una notificacion.
						if (url === 'app.contact') {
								url = 'app.home';
								// var email = $rootScope.selae.properties !== undefined? $rootScope.selae.properties["contacto.enlace"] : "";
								window.open($rootScope.selae.properties.contactURL, '_system','location=no');
							
						}
						if (url === 'app.quickBet' || url === 'app.stepBet') {
							if ($rootScope.logged) {
								if (id) { $state.go(url, {game_id: id}); }
							} else {
								$state.go('app.home');
								loginSrv.showLogin(null, "Accengage");
								waitingloginAccenggageParametersFunction = function() {
									$state.go(url, {game_id: id});
								}
								// popupSrv.showErrorPopup("mustBeLogged"); 
							}
						} else if (url === 'app.myBets' || url === 'app.myFavourites' || url == 'app.loadLotobolsa') {
							if ($rootScope.logged) {
								$state.go(url);
							} else {
								$state.go('app.home');
								loginSrv.showLogin(null, "Accengage");
								waitingloginAccenggageParametersFunction = function() {
									$state.go(url);
								}
								// popupSrv.showErrorPopup("mustBeLogged"); 
							}
						} else {
							try {
								$state.go(url);
							} catch(e) {
								console.log('Parámetro no válido, redirigiendo a home');
								$state.go('app.home');
							}
							
						}

						/**********************************************************/
						// Devuelve true si el usuario esta en medio de una apuesta
						function testIfDeleteGame(state) {
							switch(state) {
								case 'app.quickBet': return true;
								case 'app.summaryBet': return true;
								case 'app.combinationBet': return true;
								default: return false;
							}
						}
					}
				}

				window.selae.accengaggeGetId = function() {
					BMA4S.getIDFV(function(res) {
						console.warn('-------------- Device ID --------------------')
						console.log('Tu DeviceID:', res);
						console.warn('-------------- Device ID --------------------')
					})
				}
				
				window.selae.accengagge = function(url, id) {
					actionToReceiveParams({
						action: "DISPLAYED",
						categories: ["PUSH_NOTIFICATIONS"],
						params: {
							a4sbadgecount: "",
							a4sbigcontent: "texto esto es una prueba de mensaje cpon parametros",
							a4sbigtemplate: "BigTextStyle",
							a4scontent: "Extended esto es una prueba de mensaje cpon parametros",
							a4sforeground: "y",
							a4sid: "100585_101578488_100355935_100070822",
							a4smultiplelines: "true",
							a4snotifsound: "default",
							a4ssysid: "373793355",
							a4stitle: "esto es una prueba de mensaje cpon parametros",
							collapse_key: "100355935",
							from: "680693615086",
							"google.message_id": "0:1513765652535019%761188c02087be99",
							"google.sent_time": 1513765652518,
							parametro1: "maria callejo",
							parametro2: "indra",
						}
					})
				
					setTimeout(function() {
						actionToReceiveParams({
							action: "CLICKED",
							categories: ["PUSH_NOTIFICATIONS"],
							params: {
								a4sbadgecount: "",
								a4sbigcontent: "texto esto es una prueba de mensaje cpon parametros",
								a4sbigtemplate: "BigTextStyle",
								a4scontent: "Extended esto es una prueba de mensaje cpon parametros",
								a4sforeground: "y",
								a4sid: "100585_101578487_100355935_100070822",
								a4smultiplelines: "true",
								a4snotifsound: "default",
								a4ssysid: "514144631",
								a4stitle: "esto es una prueba de mensaje cpon parametros",
								collapse_key: "100355935",
								displayed: true,
								from: "680693615086",
								"google.message_id": "0:1513765646347651%761188c02087be99",
								"google.sent_time": 1513765646337,
								url: url,
								destino: 'app',
								game_id: id,
							},
						})
					}, 1000)
				};

				window.selae.accengaggeIos = function(url, id) {
					actionToReceiveParams({
						action: "DISPLAYED",
						categories: ["PUSH_NOTIFICATIONS"],
						params: {}
					});
				
					setTimeout(function() {
						actionToReceiveParams({
							action: "CLICKED",
							categories: ["PUSH_NOTIFICATIONS"],
							params: {
								"notificationParams" : {
									url: url,
									destino: 'app',
									game_id: id,
								},
							},
						})
					}, 1000)
				};

				/*************************** Codigo de testing para el control de errores **********************************/
				if (window.selae.testErrHandler) {
					window.selae.errorHandler = function(url) {
						//var url = 'http://172.22.153.38:3000/';
						$http({method: 'GET',url: url,withCredentials: false}).then(function (res) {
							try {
								throw 'Envio de error controlado';
							} catch (err) {
								popupSrv.showErrorPopup(requestSrv.errorHandler2(res)); //Sistema de errores el servicio requestSrv
							}
						}, function (err) {
							popupSrv.showErrorPopup(requestSrv.errorHandler2(err)); //Sistema de errores el servicio requestSrv
						});
					};
				}
				/************************************************************************************************************/
				window.document.addEventListener('click', function(e) {
					window.timeInitConnectedActivity = Date.now()/60000;
				});
				/*
				window.addEventListener('scroll', function(e) {
					console.log('se mueveel scroll');
					window.timeConnectedWithoutActivity = Number(0);
				});
				*/

				try {cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);} catch(err) {console.warn(err);}
				window.addEventListener('native.keyboardshow', function(res) {
					setTimeout(function() {
						var el = document.querySelectorAll(".teclado-event");
						for(var i=0; i<el.length; i++) {
							var alt = Number(el[i].offsetHeight - 45).toString() + 'px';
							el[i].style.height = alt;
						}
					}, 800);
					
				});
				ionic.Platform.isFullScreen = true;

				if (window.MobileAccessibility) {
					window.MobileAccessibility.usePreferredTextZoom(false);
				}

				console.log('se va a cargar el codigo connectionLost')
				window.selae.connectionLost = true;
				document.addEventListener("online", function (event) { 
					window.selae.connectionLost = true; 
					console.log('event',event);
				});
				document.addEventListener("offline", function (event) {
					console.log('event',event);
					if(window.selae.connectionLost) { showPopUpConnectionLost(); }
					window.selae.connectionLost = false;
				});

				function showPopUpConnectionLost() {
					popupSrv.showErrorPopup($filter('translate')("connectionLost")); 
					if ($ionicHistory.currentStateName() !== 'landing') { 
						$state.go("app.home");
					}
				}

				// Se pisa la variable para no lanzar el servicio en todos los controladores
				window.ga = analyticsSrv.ga();

				if (window.ga !== undefined) {
					if (ionic.Platform.isAndroid()) {
						analyticsSrv.setId(config.androidTrackerId);
					} else {
						analyticsSrv.setId(config.iosTrackerId);
					}
				}
				
				//MAMOV-598
				var promiseGetReceiveNotifications = storageProvider.getData(storageProvider.KEY_STORAGE_PUSHENABLED);
				promiseGetReceiveNotifications.then(
					function(receiveNotifications){
						if (receiveNotifications === null) {
							var promiseSetReceiveNotifications = storageProvider.setData(storageProvider.KEY_STORAGE_PUSHENABLED, true);
							promiseSetReceiveNotifications.then(
								function(exito){
									Console.logGreen('Éxito al almacenar - app.js - KEY_STORAGE_PUSHENABLED', exito);
								},
								function(error){
									Console.logPurple('Fracaso al almacenar - app.js - KEY_STORAGE_PUSHENABLED', error);
								}
							);
						}
						//Aquí se ha cambiado el triple =, el NSDefaults y SharedPreferences trabajan con tipado fuerte. Pero JS no, lo que se almacenan son tipados.
						if (window.PushNotification !== undefined && receiveNotifications == true) {
							mobileSrv.loadPush();
						}
					},
					function(error){
						Console.logPurple('Fracaso al acceder a receiveNotifications - app.js - KEY_STORAGE_PUSHENABLED', error);
					}
				);

				$rootScope.logged = false;
				$rootScope.titleLogo = "./images/logoSelaeizq.svg";
				$rootScope.selae = {};

				$rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
					if (toState.name === "app.quickBet" || toState.name === "app.stepBet" ||
						toState.name === "app.summaryBet" || toState.name === "app.combinationBet" ||
						toState.name === "app.ticket" || toState.name === "app.myBetDetail" || toState.name === "app.resultsDetails") {
							$rootScope.titleLogo = gamesProvider.getHeaderIcon(toParams.game_id);
					} else {
						if (toState.name === "app.home") {
							$ionicHistory.nextViewOptions({
								disableBack: true
							});
						}
						$rootScope.titleLogo = "./images/logoSelaeizq.svg";
					}
				});

				$rootScope.$on('$stateChangeSuccess',
					function (event, toState, toParams, fromState, fromParams) {
						$timeout(function () {
							try {
								$window.dispatchEvent(new Event("resize"));
							} catch (e) {
								console.log(e);
							}
						});
					}
				);

				

				$rootScope.selaeGoBack = function () {
					if ($ionicHistory.currentStateName() == "app.myBets") {
						return $state.go("app.home");
					}

					if ($ionicHistory.currentView().stateName == "app.contact") {
						popupSrv.showConfirmPopup("deleteTextContact").then(function (res) {
							if(res) { $state.go("app.home"); }
						});
						return;
					}

					if ($ionicHistory.currentView().stateName == "app.summaryBet" || $ionicHistory.currentView().stateName == "app.combinationBet" || $ionicHistory.currentView().stateName == "app.quickBet" || $ionicHistory.currentView().stateName == "app.loadLotobolsa") {
												
						if ($ionicHistory.currentView().stateName === "app.loadLotobolsa") {
							if ($ionicHistory.backView().stateName === "app.summaryBet") {
								return $rootScope.cancelBet();
							}
							 else {
							return $state.go("app.home");
							}


						}
					}
					if ($ionicHistory.currentView().stateName == "app.summaryBet" || $ionicHistory.currentView().stateName == "app.combinationBet" || $ionicHistory.currentView().stateName == "app.quickBet" || $ionicHistory.currentView().stateName == "app.loadLotobolsa") {						

						var deleteGame;
						var params = requestSrv.getBetConfig();

						if ($stateParams.voiceActive === "true") {
							if ($ionicHistory.currentView().stateName == "app.summaryBet" || $ionicHistory.currentView().stateName == "app.combinationBet") {
								if (window.ga !== undefined) {
									console.log("Antigua analytica");
								}
							} else if ($ionicHistory.currentView().stateName == "app.quickBet") {
								// revisar
								var recognition = new SpeechRecognition();
								recognition.abort();
							}
							switch ($stateParams.game_id) {
								case "1":
									if ($ionicHistory.currentView().stateName == "app.quickBet" || params.betModel === "sencilla") {
										deleteGame = "jugar/la-primitiva/apuesta.json?tipoPrimitiva=1&action=primitiva.limpiar";
									} else {
										deleteGame = "jugar/la-primitiva/apuesta.json?tipoPrimitiva=2&action=primitiva.limpiar";
									}
									break;
								case "2":
									if ($ionicHistory.currentView().stateName == "app.quickBet" || params.betModel === "sencilla") {
										deleteGame = "jugar/la-quiniela/apuesta.json?tipoQuinielaEliminarTodo=simpleTab&action=quiniela.limpiar";
									} else {
										deleteGame = "jugar/la-quiniela/apuesta.json?tipoQuinielaEliminarTodo=multipleTab&action=quiniela.limpiar";
									}
									break;
								case "3":
									deleteGame = "jugar/euromillones/apuesta.json?accionController=euromillon.limpiar";
									break;
								case "4":
									if ($ionicHistory.currentView().stateName == "app.quickBet" || params.betModel === "sencilla") {
										deleteGame = "jugar/bonoloto/apuesta.json?tipoBonoloto=1&action=bonoloto.limpiar";
									} else {
										deleteGame = "jugar/bonoloto/apuesta.json?tipoBonoloto=2&action=bonoloto.limpiar";
									}
									break;
								case "5":
									deleteGame = "jugar/gordo-primitiva/apuesta.json?action=limpiar";
									break;
								case "6":
									deleteGame = "jugar/quinigol/apuesta.json?accion=quinigol.limpiar";
									break;
								case "7":
									deleteGame = "jugar/lototurf/apuesta.json?accionController=lototurf.limpiar";
									break;
								case "8":
									deleteGame = "jugar/quintupleplus/apuesta.json?action=quintupleplus.limpiar";
									break;
								case "9":
									if (params.sorteo) {deleteGame = "jugar/loteria-nacional/decimo.json?idSorteo=" +  params.sorteo.SorteoDto.sorteoId + "&action=loteriaNacional.limpiar";
									} else { deleteGame = "jugar/loteria-nacional/decimo.json?idSorteo=" +  $rootScope.aJuego.bet_id + "&action=loteriaNacional.limpiar";}
									break;
								default:
									break;
							}

							
							popupSrv.showLoading("canceling");
							requestSrv.request(config.services.host + deleteGame, "post", [])
								.then(function (e) {
									if (e.data.compraDto) {
										if ($ionicHistory.currentView().stateName == "app.quickBet") {
											// aqui si queremos ir a home
											$state.go("app.home");
										} else {
											$ionicHistory.currentView($ionicHistory.backView());
											$state.go("app.stepBet", {
												game_id: $stateParams.game_id
											});
										}
										popupSrv.hideLoading();
									} else {
										popupSrv.hideLoading();
										popupSrv.showErrorPopup(requestSrv.errorHandler2(e));
									}
								}, function (err) {
									popupSrv.hideLoading();
									popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
									$ionicHistory.goBack();
								});
						} else {
							popupSrv.showConfirmPopup("cancelBet").then(function (res) {
								if (res === true) {
									if ($ionicHistory.currentView().stateName == "app.summaryBet" || $ionicHistory.currentView().stateName == "app.combinationBet" || $ionicHistory.currentView().stateName == "app.myFavouritesPlayAgain") {
										if (window.ga !== undefined) {
											console.log("antigua analytica");
										}
									} else if ($ionicHistory.currentView().stateName == "app.quickBet") {
										if (window.ga !== undefined) {
											console.log("Antigua analytica");
										}
									}

									if ( $stateParams.dataTransfer ) {
										$stateParams.game_id = String( $stateParams.dataTransfer.gameId );
									}

									switch ($stateParams.game_id) {
										case "1":
											if ($ionicHistory.currentView().stateName == "app.quickBet" || params.betModel === "sencilla") {
												deleteGame = "jugar/la-primitiva/apuesta.json?tipoPrimitiva=1&action=primitiva.limpiar";
											} else {
												deleteGame = "jugar/la-primitiva/apuesta.json?tipoPrimitiva=2&action=primitiva.limpiar";
											}
											break;
										case "2":
											if ($ionicHistory.currentView().stateName == "app.quickBet" || params.betModel === "sencilla") {
												deleteGame = "jugar/la-quiniela/apuesta.json?tipoQuinielaEliminarTodo=simpleTab&action=quiniela.limpiar";
											} else {
												deleteGame = "jugar/la-quiniela/apuesta.json?tipoQuinielaEliminarTodo=multipleTab&action=quiniela.limpiar";
											}
											break;
										case "3":
											deleteGame = "jugar/euromillones/apuesta.json?accionController=euromillon.limpiar";
											break;
										case "4":
											if ($ionicHistory.currentView().stateName == "app.quickBet" || params.betModel === "sencilla") {
												deleteGame = "jugar/bonoloto/apuesta.json?tipoBonoloto=1&action=bonoloto.limpiar";
											} else {
												deleteGame = "jugar/bonoloto/apuesta.json?tipoBonoloto=2&action=bonoloto.limpiar";
											}
											break;
										case "5":
											deleteGame = "jugar/gordo-primitiva/apuesta.json?action=limpiar";
											break;
										case "6":
											deleteGame = "jugar/quinigol/apuesta.json?accion=quinigol.limpiar";
											break;
										case "7":
											deleteGame = "jugar/lototurf/apuesta.json?accionController=lototurf.limpiar";
											break;
										case "8":
											deleteGame = "jugar/quintupleplus/apuesta.json?action=quintupleplus.limpiar";
											break;
										case "9":
											if (params.sorteo) {deleteGame = "jugar/loteria-nacional/decimo.json?idSorteo=" +  params.sorteo.SorteoDto.sorteoId + "&action=loteriaNacional.limpiar";
										} else { deleteGame = "jugar/loteria-nacional/decimo.json?idSorteo=" +  $rootScope.aJuego.bet_id + "&action=loteriaNacional.limpiar";}
											break;
										default:
											break;
									}


									popupSrv.showLoading("canceling");
									requestSrv.request(config.services.host + deleteGame, "post", [])
										.then(function (e) {
											if (e.data.compraDto) {
												if ($ionicHistory.currentView().stateName == "app.quickBet" || $ionicHistory.currentView().stateName == "app.myFavouritesPlayAgain") {
													$ionicHistory.goBack();
												} else {
													$ionicHistory.currentView($ionicHistory.backView());
													$state.go("app.stepBet", {
														game_id: $stateParams.game_id
													});
												}
												popupSrv.hideLoading();
											} else {
												popupSrv.hideLoading();
												popupSrv.showErrorPopup(requestSrv.errorHandler2(e));
											}
										}, function (err) {
											popupSrv.hideLoading();
											popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
											$ionicHistory.goBack();
										});
								}
							});
						}

					} else if ($ionicHistory.currentView().stateName == "app.loadLotobolsa" ||
						$ionicHistory.currentView().stateName == "app.settings.favorites" ||
						$ionicHistory.currentView().stateName == "app.settings.notifications" ||
						$ionicHistory.currentView().stateName == "app.faq.ourgames" ||
						$ionicHistory.currentView().stateName == "app.faq.basics" ||
						$ionicHistory.currentView().stateName == "app.faq.playonline" ||
						$ionicHistory.currentView().stateName == "app.help.oneclick" ||
						$ionicHistory.currentView().stateName == "app.help.voice" ||
						$ionicHistory.currentView().stateName == "app.help.step") {

						$ionicViewSwitcher.nextDirection('back');
						$state.go("app.home");
					} else {
						if ($ionicHistory.currentView().stateName == "app.ticket") {

							if($ionicHistory.backView().stateName == "app.myFavouritesPlayAgain") {  
								$ionicHistory.clearCache().then(function() {
									$state.go('app.myFavourites');
								}); 
							  } else if ($ionicHistory.backView().stateName == "app.myBetDetail") { 
								$ionicHistory.clearCache().then(function() { 
									$ionicHistory.goBack(); 
								});
							  } else {
								$state.go("app.home"); 
							  }
						} else if($ionicHistory.currentView().stateName == "app.myFavourites") { 
								$state.go("app.home"); 
								$ionicHistory.clearHistory();
						} else if ( $ionicHistory.currentView().stateName == 'app.myFavouritesPlayAgain') {
								popupSrv.showLoading("canceling");
								$rootScope.aJuego = $ionicHistory.currentView();
								$rootScope.aJuego.stateParams = $stateParams.dataTransfer;
								console.log('$rootScope.aJuego.stateParams')
								$rootScope.cancelBet();
						} 
						 else { 
							$ionicHistory.goBack(); 
						} 
					}
				};

				/*
				$rootScope.lastBet = function () {
					$state.go($rootScope.aJuego.stateName, $rootScope.aJuego.stateParams);					
				};
				*/

				// Borrar la apuesta si le damos atrás al botón de la lotobolsa
				$rootScope.cancelBet = function () {
					// debugger;
					
					var deleteGame;
					params = $rootScope.aJuego.stateParams;
					console.log('cancelar Apuesta');
					// console.log('Params', params);
					$stateParams.game_id = $rootScope.aJuego.stateParams.game_id;

					if ($stateParams.dataTransfer) {
						$stateParams.game_id = String($stateParams.dataTransfer.gameId);
					}
					if ($stateParams.game_id === "10") {
						$stateParams.game_id = "9";
					}
					switch ($stateParams.game_id) {
						case "1":
							if ($rootScope.aJuego.stateName == "app.quickBet" || $rootScope.aJuego.betModel === "sencilla") {
								deleteGame = "jugar/la-primitiva/apuesta.json?tipoPrimitiva=1&action=primitiva.limpiar";
							} else {
								deleteGame = "jugar/la-primitiva/apuesta.json?tipoPrimitiva=2&action=primitiva.limpiar";
							}
							break;
						case "2":
							if ($rootScope.aJuego.stateName == "app.quickBet" || $rootScope.aJuego.betModel === "sencilla") {
								deleteGame = "jugar/la-quiniela/apuesta.json?tipoQuinielaEliminarTodo=simpleTab&action=quiniela.limpiar";
							} else {
								deleteGame = "jugar/la-quiniela/apuesta.json?tipoQuinielaEliminarTodo=multipleTab&action=quiniela.limpiar";
							}
							break;
						case "3":
							deleteGame = "jugar/euromillones/apuesta.json?accionController=euromillon.limpiar";
							break;
						case "4":
							if ($rootScope.aJuego.stateName == "app.quickBet" || $rootScope.aJuego.betModel === "sencilla") {
								deleteGame = "jugar/bonoloto/apuesta.json?tipoBonoloto=1&action=bonoloto.limpiar";
							} else {
								deleteGame = "jugar/bonoloto/apuesta.json?tipoBonoloto=2&action=bonoloto.limpiar";
							}
							break;
						case "5":
							deleteGame = "jugar/gordo-primitiva/apuesta.json?action=limpiar";
							break;
						case "6":
							deleteGame = "jugar/quinigol/apuesta.json?accion=quinigol.limpiar";
							break;
						case "7":
							deleteGame = "jugar/lototurf/apuesta.json?accionController=lototurf.limpiar";
							break;
						case "8":
							deleteGame = "jugar/quintupleplus/apuesta.json?action=quintupleplus.limpiar";
							break;
						case "9":
							// deleteGame = "jugar/loteria-nacional/decimo.json?idSorteo=" + $rootScope.aJuego.loteria_id + "&action=loteriaNacional.limpiar";
							// break;
							if (params.sorteo) {deleteGame = "jugar/loteria-nacional/decimo.json?idSorteo=" +  params.sorteo.SorteoDto.sorteoId + "&action=loteriaNacional.limpiar";
										} else { 
											if ( $rootScope.aJuego.bet_id ) {
												deleteGame = "jugar/loteria-nacional/decimo.json?idSorteo=" +  $rootScope.aJuego.bet_id + "&action=loteriaNacional.limpiar";
											} else {
												deleteGame = "jugar/loteria-nacional/decimo.json?idSorteo=" +  $rootScope.sorteo_id + "&action=loteriaNacional.limpiar";
											}
											
										}
											break;
						default:
							break;
					}

					// llamamos al servicio para borrar el juego
					requestSrv.request(config.services.host + deleteGame, "post", [])
						.then(function (e) {
							popupSrv.hideLoading();
							// cargamos la lotobolsa despues de borrar la apuesta para la que no tenemos dinero
							if ( $rootScope.aJuego.stateName == 'app.myFavouritesPlayAgain' ) {
								if ($ionicHistory.backView().stateName === 'app.loadLotobolsa') {
									$state.go('app.myFavourites'); 
								} else {
									$ionicHistory.goBack(); 
								}
							} else { $state.go("app.home"); }
							
						}, function (err) {
							popupSrv.hideLoading();
							popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
						});
				}

				if (window.cordova) {
					window.open = cordova.InAppBrowser.open;
					$rootScope.lockVersion = true;

					cordova.getAppVersion.getVersionNumber().then(function (version) {
						//MAMOV-598
						$rootScope.version = version;
						$rootScope.lockVersion = false;

						var promiseSetVersion = storageProvider.setData(storageProvider.KEY_STORAGE_VERSION, version);
						promiseSetVersion.then(
							function(exito){
								Console.logGreen('Éxito al almacenar - app.js - KEY_STORAGE_VERSION', exito);
							},
							function(error){
								Console.logPurple('Fracaso al almacenar - app.js - KEY_STORAGE_VERSION', error);
							}
						);
					});
				}

				// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
				// for form inputs)
				if (window.cordova && window.cordova.plugins.Keyboard) {
					cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
					cordova.plugins.Keyboard.disableScroll(true);
				}

				if (window.device) {
					// detectamos si es un iphoneX para añadir sus clases especiales porque si no, nos toca cambiar todas las vistas a vh
					//iPhone10,6 es el valor de device.model
					// alert(device.model);
					if ( String(device.model).search("i386") !== -1 || String(device.model).search("x86_64") !== -1 || String(device.model).search("iPhone10,6") !== -1 || String(device.model).search("iPhone11") !== -1 || String(device.model).search("iPhone12") !== -1 )   {
						$rootScope.iphoneX = true;
					} else {
						$rootScope.iphoneX = false;
					}
				}

				if (window.StatusBar) {
					// si es iphoneX mostramos barra con las siguientes características
					if ($rootScope.iphoneX) {
						StatusBar.styleDefault();
						StatusBar.backgroundColorByName("white");
						StatusBar.overlaysWebView(false);
						StatusBar.show();
					} else {
						StatusBar.hide();
					}
				}

				//MAMOV-598
				$rootScope.lockProperties = true;
				var promiseGetProperties = storageProvider.getData(storageProvider.KEY_STORAGE_PROPERTIES);
				promiseGetProperties.then(
					function(theproperties){
						$state.go('app.home');
						$rootScope.selae.properties = JSON.parse(theproperties);
						$rootScope.lockProperties = false;
						// Mostramos el popUp de sin conexión cuando tenemos el properties
						if(window.Connection) {
							if(navigator.connection.type == Connection.NONE) {
								console.log('connectionLost Lading');
								popupSrv.showErrorPopup($filter('translate')("connectionLost")); 
								window.selae.connectionLost = false;
							}
						}
						//Con el watcher de la landing, no hace falta hacer esto.
						/*try{
							$rootScope.$apply();
						}catch(applyError){
							Console.logPurple('Fracaso al aplicar rootScope.', applyError);
						}*/
						
						processIncomingProperties();
					},
					function(error){
						$rootScope.lockProperties = false;
						Console.logPurple('Fracaso al almacenar - app.js - KEY_STORAGE_PROPERTIES', error);
					}
				);

				// Funcion para actualizar la app
					function needUpdate() {
					if (selae.versionMismatch) {

							if (selae.updateRequired) {
								popupSrv.showConfirmPopup('requiredAppVersionTxt','reqAppVersionTitleTxt').then(function (res) {
									if (res === true) {
										updateApp(true);
									} else {
										ionic.Platform.exitApp();
									}	
								})
							} else {
								popupSrv.showConfirmPopup('optionalAppVersionTxt','optAppVersionTitleTxt').then(function (res) {
									if (res === true) {
										updateApp();
									}
								})
							}
						}
					}

				function updateApp(required) {
					popupSrv.showLoading('downloadingAppVersionTxt');
					
					var appUpdate = cordova.require('cordova-plugin-app-update.AppUpdate');
					var updateUrl = selae.UrlDownload;
			
					appUpdate.checkAppUpdate(onSuccess, onFail, updateUrl, {
						'skipPromptDialog' : true,
						'skipProgressDialog' : true,
						'packageName' : 'com.selae.misLoterias.movil',
						'dowloadUrl' : selae.UrlDownload,
						'versionConfig' : selae.versionConfig
					})
			
					function onSuccess () {
						popupSrv.hideLoading();
						ionic.Platform.exitApp();
					} 
			
					function onFail () {
						popupSrv.hideLoading();
						if (required) {
							popupSrv.showInfoCallabackPopup('forceDowloadFailAppVersionTitleTxt', 'forceDowloadFailAppVersionTxt', null, function () {
								popupSrv.showConfirmPopup('requiredAppVersionTxt','tituloPopUp').then(function (res) {
								if (res === true) {
									updateApp(true);
								} else {
									ionic.Platform.exitApp();
								}	
							})});

						} else {
							popupSrv.showErrorPopup('dowloadFailAppVersionTxt',null,null,'dowloadFailAppVersionTitleTxt');
						}
					}
				}
				
				/**
				 * Agrupa los procesamientos después de recuperar las propiedades y aplicarlas al rootScope.
				 */
				processIncomingProperties = function() {
					if ($rootScope.selae.properties.appDisabled !== null && $rootScope.selae.properties.appDisabled == "true") {
						popupSrv.showAppDisabledPopup();
					}

					needUpdate();

					gamesProvider.setGames();
	
					if (selae.error) {
						//alert(JSON.stringify(selae.error)); //sistema-error
						popupSrv.showBlockingErrorPopup('comunicationsError');
					}

					// geoLocationOn es asi por peticion del cliente, aunque no coincida con la entrada del properties (geoLocation). 
					if ($rootScope.selae.properties.geoLocationOn !== null && $rootScope.selae.properties.geoLocationOn == "true") {
						navigator.geolocation.getCurrentPosition(function (success) {
							var spain = {
								latIni: 27.4335426,
								lonIni: -18.3936844,
								latEnd: 43.9933088,
								lonEnd: 4.5918885
							};
							var pos = {
								lat: success.coords.latitude,
								lon: success.coords.longitude
							};
							var valid = false;
							if (spain.latIni <= pos.lat) {
								if (pos.lat <= spain.latEnd) {
									if (spain.lonIni <= pos.lon) {
										if (pos.lon <= spain.lonEnd) {
											valid = true;
										}
									}
								}
							}
							if (valid === false) {
								popupSrv.showBlockingErrorPopup("restrictedLocation");
							}
						},
						function (error) {
							popupSrv.showBlockingErrorPopup("noLocation");
						}, {
							enableHighAccuracy: true
						});
					}

					if (window.plugins !== undefined && window.plugins.sslCertificateChecker !== undefined && config.DEBUG === false) {
						window.plugins.sslCertificateChecker.check(
							function (message) {
								console.log(message);
							},
							function (message) {
								console.log(message);
								//alert(JSON.stringify(message)); //sistema-error
								popupSrv.showBlockingErrorPopup("invalidCert");
							},
							config.services.host,
							config.fingerprints);
					}

					if (ionic.Platform.isAndroid()) {
						try {
							rootdetection.isDeviceRooted(function (result) {
								if (result === 1) {
									popupSrv.showErrorPopup("deviceRooted");
								}
							}, null);
						} catch (e) {
							console.error(e);
						}
	
					} else if (ionic.Platform.isIOS()) {
						try {
							jailbreakdetection.isJailbroken(function (result) {
								if (result === 1) {
									popupSrv.showErrorPopup("deviceJailkbreaked");
								}
							}, null);
						} catch (e) {
							console.error(e);
						}
					}

				}

				setTimeout(function(){ 
					if (navigator.splashscreen !== undefined) {
						navigator.splashscreen.hide();
					}
				 }, 3000);

			});
		}

	]);