// Convierte un nuemero al formato de  usado por SELAE
Number.prototype.toMMSS = function () {
	var data = parseInt(this, 10);
	this.hours = Number(Math.floor(data / 3600)).toString();
	this.minutes = Number(Math.floor((data - (this.hours * 3600)) / 60)).toString();
	this.seconds = Number(data - (this.hours * 3600) - (this.minutes * 60)).toString();
	if (this.hours < 10) {this.hours = "0"+this.hours;}
	if (this.minutes < 10) {this.minutes = "0"+this.minutes;}
	if (this.seconds < 10) {this.seconds = "0"+this.seconds;}
	return this.minutes+':'+this.seconds;
};

// Funcion prototipada para comparar aciertos
Array.prototype.checkHitse = function(arr) {
	if(!arr) {throw 'Se te olvido pasar el array con el que comparar';}
    return this.filter(function(i) {
		return arr.filter(function(j) {
			return j === i; 
        })[0];
    });
};

// Sistema de cosola personalizado
try {
window.Console = {
	group: function(name) {
		if (selae.console && console.group) { console.group(name); }
	},
	groupCollapsed: function(name) {
		if (selae.console && console.groupCollapsed) { console.groupCollapsed(name); }
	},
	groupEnd: function() {
		if (selae.console && console.groupEnd) { console.groupEnd(); }
	},
	info: function(text, data) {
		if (selae.console && console.info) { console.info(text, data); }
	},
	trace: function(text, data) {
		if (selae.console && console.trace) { console.trace(text, data); }
	},
	log: function(text, data) {
		if (selae.console && console.log) { console.log(text, data); }
	},
	logBlue: function(text, data) {
		if (selae.console && console.log) { console.log('%c'+text, 'color: #0098D8;', data); }
	},
	logGreen: function(text, data) {
		if (selae.console && console.log) { console.log('%c'+text, 'color: #00C873;', data); }
	},
	logOrange: function(text, data) {
		if (selae.console && console.log) { console.log('%c'+text, 'color: #F38635;', data); }
	},
	logPurple: function(text, data) {
		if (selae.console && console.log) { console.log('%c'+text, 'color: #A25FB4;', data); }
	},
	dir: function(obj) {
		if (selae.console && console.dir) { console.dir(obj); }
	},
	table: function(objArr) {
		if (selae.console && console.table) { console.table(objArr); }
	},
	time: function(name) {
		if (selae.console && console.time) { console.time(name); }
	},
	timeEnd: function(name) {
		if (selae.console && console.timeEnd) { console.timeEnd(name); }
	},
	error: function(text, err) {
		if (selae.console && console.error) { console.error(text, err); }
	},
	warn: function(text, warn) {
		if (selae.console && console.warn) { console.warn(text, warn); }
	},
	titleError: function(name) {
		if (selae.console && console.error) { console.error('<-------------------- '+name.toUpperCase()+' -------------------->'); }
	},
	titleLog: function(name) {
		if (selae.console && console.error) { console.log('%c<-------------------- '+name.toUpperCase()+' -------------------->', 'color: #0098D8;'); }
	},
	titleWarn: function(name) {
		if (selae.console && console.error) { console.warn('<-------------------- '+name.toUpperCase()+' -------------------->'); }
	},
}
} catch(e) { /* el objeto window no existe en node */ }

/***********************************************************************************************************/
/***********************************************************************************************************/

var timerInterval = [];
//==================================================================================//


// Funcion autoejecutable para configuración y carga inicial del proyecto

(function() {
    Console.groupCollapsed('Bootstrap');
    var $http = angular.injector(["ng"]).get("$http");
    var $Promise = angular.injector(["ng"]).get("$q");

    // debugger;
    if (window.cordova) {
        document.addEventListener("deviceready", function() {
            /*Esta inyección es especial porque es un módulo nuestro, no del framework.
            Para más información:
            - https://docs.angularjs.org/api/auto/service/$injector
            - https://stackoverflow.com/questions/23745397/possible-to-use-a-custom-angular-service-before-bootstrap 

            Notar que si se hace tras el var $Promise antes del 'deviceready' da error
            Failed to instantiate module selae.core.services due to:
            Error: [$injector:nomod] Module 'selae.core.services' is not available! You either misspelled the module name or forgot to load it. If registering a module ensure that you specify the dependencies as the second argument.
            */
            var $storageProvider = angular.injector(['ng', 'selae.core.services']).get('storageProvider');
            // debugger;
            getMockProperties($storageProvider)
                .then(function() { return getVersion(window.selae.dataEntorno.versionApp) })
                .then(checkVersion)
                .then(function() { return selectUrlForDevice({android: window.selae.dataEntorno.propertiesVersionAndroid, ios: window.selae.dataEntorno.propertiesVersionIOS}) })
                .then(getPropertiesVersion)
                .then(checkPropertiesVersion)
                .then(function() { return selectUrlForDevice({android: window.selae.dataEntorno.propertiesAndroid, ios: window.selae.dataEntorno.propertiesIOS}) })
                .then(getProperties)
                .then(saveProperties)
                .catch(showError)
                .then(launchApp)
                .then( Console.groupEnd );
        });
    } else {
        window.onload = function() {
            /*Esta inyección es especial porque es un módulo nuestro, no del framework.
            Para más información:
            - https://docs.angularjs.org/api/auto/service/$injector
            - https://stackoverflow.com/questions/23745397/possible-to-use-a-custom-angular-service-before-bootstrap 

            Notar que si se hace tras el var $Promise antes del 'onload' da error
            Failed to instantiate module selae.core.services due to:
            Error: [$injector:nomod] Module 'selae.core.services' is not available! You either misspelled the module name or forgot to load it. If registering a module ensure that you specify the dependencies as the second argument.
            */
            var $storageProvider = angular.injector(['ng', 'selae.core.services']).get('storageProvider');

            getMockProperties($storageProvider)
                .then(function() { return getPropertiesVersion(window.selae.dataEntorno.propertiesVersionAndroid) })
                .then(checkPropertiesVersion)
                .then(function() { return getProperties(window.selae.dataEntorno.propertiesAndroid) })
                .then(saveProperties)
                .catch(showError)
                .then(launchApp)
                .then(Console.groupEnd());
        }
    }


/***********************************************************************************/
/*********************** Funciones Auxiliares **************************************/
/***********************************************************************************/
    
    function getMockProperties($storageProvider) { // debugger;
        return $Promise(function(resolve, reject) {
            var promiseGetProperties = $storageProvider.getData($storageProvider.KEY_STORAGE_PROPERTIES);
            promiseGetProperties.then(
                function(properties){
                    if(!properties || properties === 'null') {
                        try {
                            var obj = {};
                            Console.logBlue('getMockProperties:', window.selae.mock);
                            

                            if (window.mocks.properties.search('\r\n') != -1) {
                                window.mocks.properties.split("\r\n").forEach(function(i) {
                                    if(i.search('=') !== -1) {
                                        var arr = i.split(/=(.+)/).filter(Boolean);
                                        obj[arr[0]] = arr[1];   
                                    }
                                });
                            } else {
                                if (window.mocks.properties.search('\n') != -1) {
                                    console.log('Tiene salto de linea')
                                    window.mocks.properties.split('\n').forEach(function(i) {
                                        if(i.search('=') !== -1) {
                                            var arr = i.split(/=(.+)/).filter(Boolean);
                                            obj[arr[0]] = arr[1];   
                                        }
                                    });
                                } 
                            }

                            // debugger;
                            var promiseSetMockedProperties = $storageProvider.setData($storageProvider.KEY_STORAGE_PROPERTIES, JSON.stringify(obj));
                            promiseSetMockedProperties.then(
                                function(exito){
                                    Console.logGreen('Éxito al guardar mocked KEY_STORAGE_PROPERTIES - bootstrap.js', exito);
                                    window.mocks.properties = null;
                                    resolve();
                                },
                                function(error){
                                    Console.logPurple('Fracaso al guardar mocked KEY_STORAGE_PROPERTIES - bootstrap.js', error);
                                    window.mocks.properties = null; //TODO: revisar si esto realmente sería correcto.
                                    resolve();
                                }
                            );
                        } catch(err) { window.mocks.properties = null; reject(err); }
                    } else {
                        Console.logBlue('getMockProperties:', 'Ya existe un properties, no necesita mock');
                        window.mocks.properties = null;
                        resolve();
                    } 
                },
                function(error){
                    Console.logPurple('Fracaso al acceder a KEY_STORAGE_PROPERTIES - bootstrap.js', error);
                }
            );
        });
    }

    // Obtiene las versiones del servidor y del dispositivo.
    function getVersion(url) { // debugger;
        if(!cordova) { throw new Error('GetVersion no esta soportado en la version para navegador'); }
        if(!url || typeof url !== 'string') { throw new Error('getVersion necesita pasar una url como string para hacer la petecion'); }

        if (device.platform === "Android") {
            return $Promise.all([getVersionDevice(), getVersionService(url)]).then(function(res) {
                return res;
            });
        }
        Console.logOrange('getVersion:', 'No disponible para IOS');
        return $Promise.resolve([]);
        
        /*--------------------------*/
        function getVersionDevice() {
            return cordova.getAppVersion.getVersionNumber().then(function (version) {
                Console.logGreen('getVersionDevice:', version);
                return { version: version.split('.') }
            });
        }
        function getVersionService(url) {
            return $Promise(function(resolve) {
                $http.get(url).then(function(res) {
                    Console.logGreen('getVersionService:', res.data[0]);
                    try { resolve({ version: res.data[0].versionAppMovil.split('.'), url: res.data[0].urlVersionAppMovil, required : res.data[0].required }); }
                    catch(err) {
                        Console.error('getVersionService:', err);
                        resolve({ version: [], url: null }); 
                    }
                }, function(err) {
                    Console. error('getVersionService:', err);
                    resolve({ version: [], url: null });
                });
            });
        }
    }

/***********************************************************************************/
    
    // Compara las versiones para saber si hay una actualizacion(solo android).
    function checkVersion(arr) { // debugger;
        if(!cordova) { throw new Error('checkVersion no esta soportado en la version para navegador'); }
        if(!Array.isArray(arr)) { throw new Error('checkVersion necesita pasar un array de versiones para realizarse'); }
        if (device.platform === "Android") selae.versionConfig = arr[1].version.join('');

        return $Promise(function(resolve) {
            if (device.platform === "Android") {
                try {
                    if (compareVersion(arr[0].version, arr[1].version)) {
                        Console.logGreen('checkVersion:', 'Hay una nueva version');
                        selae.UrlDownload = arr[1].url;
                        selae.updateRequired = arr[1].required;
                        selae.versionMismatch = true;
                    } else { Console.logBlue('checkVersion:', 'Actualizado'); }
                } catch(err) { Console.error('checkVersion:', err); }
            } else { Console.logOrange('checkVersion:', 'No disponible para IOS'); }
            resolve();
        });

        /*--------------------------*/
        function compareVersion(a, b) {
            for(var i=0;i<3;i++) {
                a[i] = Number(a[i]) || 0;
                b[i] = Number(b[i]) || 0;
                if (a[i] < b[i]) { return true; }
                if (a[i] > b[i]) { return false; }
            }
            return false;
        }
    }

/***********************************************************************************/
    
    // Funcion para seleccionar la url del properties segun su sistema operativo.
    function selectUrlForDevice(obj) { // debugger;
        if(!cordova) { throw new Error('selectUrlForDevice no esta soportado en la version para navegador'); }
        if(!obj || typeof obj !== 'object') { throw new Error('selectUrlForDevice necesita pasar un objeto con los dispositivos y urls'); }

        return $Promise(function(resolve) {
            if (device.platform === "Android") {
                Console.logGreen('selectUrlForDevice:', obj.android);
                resolve(obj.android);
            } else {
                Console.logGreen('selectUrlForDevice:', obj.ios);
                resolve(obj.ios);
            }
        });
    }

/***********************************************************************************/
    
    // Funcion para se encarga de pedir la version del properties
    function getPropertiesVersion(url) { // debugger;
        if(!url || typeof url !== 'string') { throw new Error('getPropertiesVersion necesita pasar una url como string para hacer la petecion'); }

        return $Promise(function(resolve) {
            $http.get(url).then(function(res) {
                Console.logGreen('getPropertiesVersion:', res.data);
                try { resolve(Number(res.data.split('=')[1])) }
                catch(err) {
                    Console.error('getPropertiesVersion:', err);
                    resolve(Number(1));
                }
            }, function(err) {
                Console.error('getPropertiesVersion:', err);
                resolve(Number(1));
            });
        });
    }

/***********************************************************************************/

    // Funcion que compara las versiones del properties
    function checkPropertiesVersion(version) { // debugger;
        if(!version || typeof version !== 'number') { throw new Error('checkPropertiesVersion necesita pasar un numero para chekear la version'); }
        /*como se concatenan las promesas y se recibe como input el output del anterior
        si se hace esto en vez de lo que está, se recibe como version el properties y como properties null
            .then(getPropertiesVersion)
            .then(checkPropertiesVersion($storageProvider))
        TODO: partir las promesas del método principal para enviar como parámetro el storageProvider y que el código quede más limpio.
        */
        var $storageProvider = angular.injector(['ng', 'selae.core.services']).get('storageProvider');

        return $Promise(function(resolve, reject) {
            var promiseGetPropertiesVersion = $storageProvider.getData($storageProvider.KEY_STORAGE_PROPERIESVERSION);
            promiseGetPropertiesVersion.then(
                function(localStorageVersion){
                    if (localStorageVersion && localStorageVersion !== 'null') {
                        if (localStorageVersion == 'undefined' || localStorageVersion == null) {
                            localStorageVersion = 0
                        }
                        if (version > localStorageVersion) {
                            Console.logBlue('checkPropertiesVersion', 'Hay una nueva versión del properties');
                            var promiseSetPropertiesVersionTrue = $storageProvider.setData($storageProvider.KEY_STORAGE_PROPERIESVERSION, version);
                            promiseSetPropertiesVersionTrue.then(
                                function(exito){
                                    Console.logGreen('Éxito al guardar KEY_STORAGE_PROPERIESVERSION - bootstrap.js', exito);
                                    resolve();
                                },
                                function(error){
                                    Console.logPurple('Fracaso al guardar KEY_STORAGE_PROPERIESVERSION - bootstrap.js', error);
                                    resolve();
                                }
                            );
                        } else {
                            reject('La versión del Properties esta actualizada');
                        }
                    } else {
                        if (selae.localProperties) {
                            reject("usamos properties local");
                        }
                        Console.logBlue('checkPropertiesVersion', 'No hay version del Propeties, se produce la primera descarga');
                        var promiseSetPropertiesVersionFalse = $storageProvider.setData($storageProvider.KEY_STORAGE_PROPERIESVERSION, version);
                        promiseSetPropertiesVersionFalse.then(
                            function(exito){
                                Console.logGreen('Éxito al guardar KEY_STORAGE_PROPERIESVERSION - bootstrap.js', exito);
                                resolve();
                            },
                            function(error){
                                Console.logPurple('Fracaso al guardar KEY_STORAGE_PROPERIESVERSION - bootstrap.js', error);
                                resolve();
                            }
                        );
                    }
                },
                function(error){
                    Console.logPurple('Fracaso al acceder a KEY_STORAGE_PROPERIESVERSION - bootstrap.js', error);
                }
            );
        });
    }

/***********************************************************************************/

    // si el properties falla no continua
    function getProperties(url) { // debugger;
        if(!url || typeof url !== 'string') { throw new Error('getProperties necesita pasar una url como string para hacer la petecion'); }

        return $http.get(url).then(function(res) {
            Console.logGreen('getProperties', [res.data]);

            var obj = {};
            try {
                if (res.data.search('\r\n') != -1) {
                    res.data.split("\r\n").forEach(function(i) {
                        if(i.search('=') !== -1) {
                            var arr = i.split(/=(.+)/).filter(Boolean);
                            obj[arr[0]] = arr[1];   
                        }
                    });
                } else {
                    if (res.data.search('\n') != -1) {
                        console.log('Tiene salto de linea')
                        res.data.split('\n').forEach(function(i) {
                            if(i.search('=') !== -1) {
                                var arr = i.split(/=(.+)/).filter(Boolean);
                                obj[arr[0]] = arr[1];   
                            }
                        });
                    } 
                }
    
                return obj;
            } catch(err) { return err; } 
        });
    }

/***********************************************************************************/

    // Guarda el nuevo properties en el localStorage
    function saveProperties(obj) { // debugger;
        if(!obj || typeof obj !== 'object') { throw new Error('saveProperties necesita un objeto para añadir al localStorage'); }

        /*como se concatenan las promesas y se recibe como input el output del anterior
        si se hace esto en vez de lo que está, se recibe como version el properties y como properties null
            .then(getPropertiesVersion)
            .then(checkPropertiesVersion($storageProvider))
        TODO: partir las promesas del método principal para enviar como parámetro el storageProvider y que el código quede más limpio.
        */
       var $storageProvider = angular.injector(['ng', 'selae.core.services']).get('storageProvider');

        Console.logGreen('saveProperties', obj);
        return $Promise(function(resolve) {  // debugger;
            //Ojo con el JSON.stringify, siempre que haya un stringify hay que hacer la operación inversa.
            var promiseSetProperties = $storageProvider.setData($storageProvider.KEY_STORAGE_PROPERTIES, JSON.stringify(obj));
            promiseSetProperties.then(
                function(exito){
                    // debugger;
                    Console.logGreen('Éxito al guardar KEY_STORAGE_PROPERTIES - bootstrap.js', exito);
                    resolve();
                },
                function(error){
                    Console.logPurple('Fracaso al guardar KEY_STORAGE_PROPERTIES - bootstrap.js', error);
                    resolve();
                }
            );
        });
    }

/***********************************************************************************/

    // Control de errores que rompen la ejecucion de la promesa
    function showError(err) { // debugger;
        Console.titleError('Bootstrap Issue');
        if (typeof err === 'object') {
            Console.error('showError:', err); 
        } else {
            Console.warn('showError:', err)
        }
        Console.titleError('Bootstrap Issue');
        if (navigator.splashscreen) { navigator.splashscreen.hide(); }
    }

/***********************************************************************************/

    // lanza la App con angular, siempre siempre se ejecuta.
    function launchApp() { // debugger;
        Console.logBlue('launchApp:', 'Se inicia la App');
        Console.groupEnd();
        angular.bootstrap(document, ["selae"]);
    }

/***********************************************************************************/

    // Carga del Store Inicial por defecto


})()
