cordova.define("com.bma4s.sdk.plugins.cordova.BMA4S", function(require, exports, module) {


var currentPushCallback = null;
var currentCustomParamsCallback = null;

function callCordova (action) {
    var args = Array.prototype.slice.call(arguments, 1);
    cordova.exec(function callback(data) { },
                 function errorHandler(err) { },
                 'BMA4S',
                 action,
                 args
                 );
}

function callCordovaCallback (action, callback) {
    var args = Array.prototype.slice.call(arguments, 2);
    cordova.exec(callback,
                 function errorHandler(err) { callback({'error' : err}) },
                 'BMA4S',
                 action,
                 args
                 );
}

function customParamsCallback(data) {
    if (currentCustomParamsCallback != null) {
        currentCustomParamsCallback(data);
        BMA4S.setCustomParametersListener(currentCustomParamsCallback);
    }
}

function pushCallback(data) {
    if (currentPushCallback != null) {
        currentPushCallback(data);
        BMA4S.setPushNotificationListener(currentPushCallback);
    }
}

var BMA4S = {
disableTracking: function (forceFlush) {
    //Android
    callCordova('disableTracking', forceFlush);
},
displayInApp: function (id) {
    //Android
    callCordova('displayInApp', id);
},
enableTracking: function () {
    //Android
    callCordova('enableTracking');
},
    //return string
getA4SId: function (callback) {
    //Android + iOS
    callCordovaCallback('getA4SId', callback);
},
    //return bool
crashReporting: function (callback) {
    //Android + iOS
    callCordovaCallback('crashReporting', callback);
},
    //return string
getAndroidId: function (callback) {
    //Android
    callCordovaCallback('getAndroidId', callback);
},
    //return string
getIDFV: function (callback) {
    //Android + iOS
    callCordovaCallback('getIDFV', callback);
},
getInbox: function (callback) {
    //None
},
    //return array
getListOfSubscriptions: function (callback) {
    //Android + iOS
    callCordovaCallback('getListOfSubscriptions', callback);
},
    //return array
getSubscriptionStatusForLists: function (lists, callback) {
    //Android + iOS
    callCordovaCallback('getSubscriptionStatusForLists', callback, lists);
},
    //return bool
isInA4SProcess: function (callback) {
    //Android
    callCordovaCallback('isInA4SProcess', callback);
},
    //return bool
isInAppDisplayLocked: function (callback) {
    //Android + iOS
    callCordovaCallback('isInAppDisplayLocked', callback);
},
    //return bool
isPushEnabled: function (callback) {
    //Android
    callCordovaCallback('isPushEnabled', callback);
},
    //return bool
isPushNotificationLocked: function (callback) {
    //Android + iOS
    callCordovaCallback('isPushNotificationLocked', callback);
},
    //return bool
isRestrictedConnection: function (callback) {
    //Android + iOS
    callCordovaCallback('isRestrictedConnection', callback);
},
    //return bool
isTrackingEnabled: function (callback) {
    //Android + iOS
    callCordovaCallback('isTrackingEnabled', callback);
},
putState: function (key, value) {
    //Android
    callCordova('putState', key, value);
},
resetOverlayPosition: function () {
    //Android+iOS
    callCordova('resetOverlayPosition');
    resetDefaultBannerOriginForPortrait();
    resetDefaultBannerOriginForLandscape();
},
sendPushToken: function (token) {
    //Android
    callCordova('sendPushToken', token);
},
setInAppClickedCallback: function (callback, layouts) {
    //Android
    callCordovaCallback('setInAppClickedCallback', callback, layouts);
},
setInAppClosedCallback: function (callback, layouts) {
    //Android
    callCordovaCallback('setInAppClosedCallback', callback, layouts);
},
setInAppDisplayedCallback: function (callback, layouts) {
    //Android
    callCordovaCallback('setInAppDisplayedCallback', callback, layouts);
},
setInAppDisplayLocked: function (enabled) {
    //Android + iOS
    callCordova('setInAppDisplayLocked', enabled);
},
setInAppReadyCallback: function (manuallyAllowDisplay, callback, layouts) {
    //Android
    callCordovaCallback('setInAppReadyCallback', callback, manuallyAllowDisplay, layouts);
},
setOverlayPosition: function (marginLeft, marginRight, marginTop, marginBottom) {
    //Android
    callCordova('setOverlayPosition', marginLeft, marginRight, marginTop, marginBottom);
},
setPushEnabled: function (enabled) {
    //Android + iOS
    callCordova('setPushEnabled', enabled);
},
setPushNotificationLocked: function (enabled) {
    //Android + iOS
    callCordova('setPushNotificationLocked', enabled);
},
setRestrictedConnection: function (enabled) {
    //Android + iOS
    callCordova('setRestrictedConnection', enabled);
},
setView: function (view) {
    //Android + iOS
    callCordova('setView', view);
},
startActivity: function () {
    //Android + iOS (lk. trackWithPartnerId:PrivateKey:)
    callCordova('startActivity');
},
stopActivity: function () {
    //Android
    callCordova('stopActivity');
},
trackAddToCart: function (cartId, itemId, itemLabel, itemCategory, itemCurrency, itemPrice, itemQuantity) {
    //Android + iOS
    callCordova('trackAddToCart', cartId, itemId, itemLabel, itemCategory, itemCurrency, itemPrice, itemQuantity);
},
trackEvent: function (eventId, eventValue) {
    //Android + iOS
    callCordova('trackEvent', eventId, eventValue);
},
trackCustomEvent: function (eventId, eventValue) {
    //Android + iOS
    callCordova('trackCustomEvent', eventId, eventValue);
},
trackLead: function (leadLabel, leadValue) {
    //Android + iOS
    callCordova('trackLead', leadLabel, leadValue);
},
trackPurchase: function (purchaseId, purchaseCurrency, purchasePrice) {
    //Android + iOS (purchase with items not supported)
    callCordova('trackPurchase', purchaseId, purchaseCurrency, purchasePrice);
},
updateDeviceInfo: function (key, value) {
    //Android + iOS (multiple key/value pairs not supported)
    callCordova('updateDeviceInfo', key, value);
},
updateDeviceInformation: function (type, key, value) {
    //Android + iOS
    callCordova('updateDeviceInformation', type, key, value);
},
updateGeolocation: function (lat, lng, alt, acc) {
    //Android
    callCordova('updateGeolocation', lat, lng, alt, acc);
},
updateMessages: function () {
    //None
},
setCustomParametersListener: function (callback) {
    //Android + iOS
    currentCustomParamsCallback = callback;
    callCordovaCallback('setCustomParametersListener', customParamsCallback);
},
removeCustomParametersListener: function () {
    //Android + iOS
    currentCustomParamsCallback = null;
    callCordova('removeCustomParametersListener');
},
setPushNotificationListener: function (callback) {
    //Android + iOS
    currentPushCallback = callback;
    callCordovaCallback('setPushNotificationListener', pushCallback);
},
removePushNotificationListener: function () {
    //Android + iOS
    currentPushCallback = null;
    callCordova('removePushNotificationListener');
},
setDebugMode: function (debugMode) {
    //iOS
    callCordova('setDebugMode', debugMode);
},
setGeoLocEnabled: function (geoLocEnabled) {
    //iOS
    callCordova('setGeoLocEnabled', geoLocEnabled);
},
setBeaconServicesEnabled: function (beaconServicesEnabled) {
    //iOS
    callCordova('setBeaconServicesEnabled', beaconServicesEnabled);
},
setGeofenceServicesEnabled: function (geofenceServicesEnabled) {
    //iOS
    callCordova('setGeofenceServicesEnabled', geofenceServicesEnabled);
},
setDefaultBannerOriginForPortrait: function (x, y) {
    //iOS
    callCordova('setDefaultBannerOriginForPortrait', x, y);
},
setDefaultBannerOriginForLandscape: function (x, y) {
    //iOS
    callCordova('setDefaultBannerOriginForLandscape', x, y);
},
resetDefaultBannerOriginForPortrait: function () {
    //iOS
    callCordova('resetDefaultBannerOriginForPortrait');
},
resetDefaultBannerOriginForLandscape: function () {
    //iOS
    callCordova('resetDefaultBannerOriginForLandscape');
},
setNotificationDisplayTimeInterval: function (interval) {
    //iOS
    callCordova('setNotificationDisplayTimeInterval', interval);
},
setUserID: function (userID) {
    //iOS
    callCordova('setUserID', userID);
},
subscribeToLists: function (lists) {
    //Android + iOS
    callCordova('subscribeToLists', lists);
},
unsubscribeFromLists: function (lists) {
    //Android + iOS
    callCordova('unsubscribeFromLists', lists);
},
userID: function (callback) {
    //iOS
    callCordovaCallback('userID', callback);
},
setOptinData: function (optinData) {
    //Android + iOS
    callCordova('setOptinData', optinData);
},
setOptinGeoloc: function (optinGeoloc) {
    //Android + iOS
    callCordova('setOptinGeoloc', optinGeoloc);
},
getOptinDataStatus: function (callback) {
    //Android + iOS
    callCordovaCallback('getOptinDataStatus', callback);
},
getOptinGeolocStatus: function (callback) {
    //Android + iOS
    callCordovaCallback('getOptinGeolocStatus', callback);
},
setDeviceTag: function (key, value, params) {
    //Android + iOS
    callCordova('setDeviceTag', key, value, params);
},
deleteDeviceTag: function (key, value) {
    //Android + iOS
    callCordova('deleteDeviceTag', key, value);
}
    
};

function deviceIsReady () {
    BMA4S.startActivity();
}

function onResume () {
    BMA4S.startActivity();
}
function onPause () {
    BMA4S.stopActivity();
}

document.addEventListener('deviceready', deviceIsReady, false);
document.addEventListener('resume', onResume, false);
document.addEventListener('pause', onPause, false);
module.exports = BMA4S;




});
