angular.module('selae.results.controllers')

  .controller('ResultsCtrl', ['$scope', '$state', '$rootScope', 'config', 'popupSrv', '$filter', 'requestSrv', 'opSrv', '$ionicScrollDelegate', '$timeout','storageProvider', 'analyticsSrv', 'gamesProvider',
    function ($scope, $state, $rootScope, config, popupSrv, $filter, requestSrv, opSrv, $ionicScrollDelegate, $timeout, storageProvider, analyticsSrv, gamesProvider) {

      if (window.ga !== undefined) {
        analyticsSrv.trackView('Resultados');
      }

      $scope.gamesData = gamesProvider.getGames();

          switch ($scope.gamesData.length) {
            case 0:
              $scope.gamesData = gamesProvider.getGames();
              break;
            case 1:
              $scope.itemSelected = 0;
              break;
            default:
              $scope.itemSelected = -1;
          }
    
        //$scope.image = $rootScope.selae.properties !== undefined ? $rootScope.selae.properties["resultados.imagen.fuente"] : "";

        $rootScope.$watch('selae.properties', function (newValue, oldValue) {
          if ($rootScope.selae.properties !== undefined) {
            $scope.imageData = getImages();
          }
        });

        if ($rootScope.selae.properties !== undefined) {
          $scope.imageData = getImages();
        }


        function getImages() {
          return [
            {
              src: $rootScope.selae.properties["resultados.imagen.fuente"],
              link: $rootScope.selae.properties["resultados.imagen.url"],
              dest: $rootScope.selae.properties["resultados.imagen.destino"],
              game_id: $rootScope.selae.properties["resultados.imagen.game_id"]
            },
          ];
        }

        $scope.viewMoreDisabled = false;

        $scope.swiper = {};

        $scope.loading = false;

        $scope.onReadySwiper = function (swiper) {
          if ($scope.itemSelected === 0) {
            angular.element(".swiper-slide-active").addClass("carousel-active");
          }
          swiper.on('tap', function () {
            $scope.itemSelected = swiper.activeIndex;
            angular.element(".carousel-active").removeClass("carousel-active");
            angular.element(".swiper-slide-active").addClass("carousel-active");
            $scope.filtrar();
            $scope.$apply();
            $timeout(function () {
              $ionicScrollDelegate.resize();
            }, 100);
          });
        };

        $scope.carouselConfig = {
          'initialSlide': $scope.gamesData.length > 4 ? 2 : $scope.gamesData.length == 4 ? 1 : $scope.gamesData.length == 2 ? 0 : $scope.gamesData.length / 2,
          'slidesPerView': $(window).width() <= 320 ? 3 : $(window).width() > 480 ? 5 : 4,
          'freeMode': 'true',
          'centeredSlides': 'true',
          'freeModeSticky': 'true',
          'slideToClickedSlide': 'true',
          'speed': 300
        };

        $scope.unfilter = function () {
          requestSrv.cancelAll();
          $scope.itemSelected = -1;
          angular.element(".carousel-active").removeClass("carousel-active");
          getResults();
        };

        $scope.filtrar = function () {
          $scope.objetoFormateado = [];
          $scope.viewMoreDisabled = false;
          $scope.loading = true;
          popupSrv.showLoading('Cargando resultados');
          var params = [
            {
              name: "game_id",
              value: $scope.gamesData[$scope.itemSelected].text
            }
          ];
          requestSrv.request(config.services.cmsHost + config.services.ultimosv4, "GET", params)
            .then(function (e) {
              popupSrv.hideLoading();
              $scope.loading = false;
              //Resultados recibidos
              var responseData = e.data;
              creamosObjetoFormateado(responseData);
            }, function (err) {
              popupSrv.hideLoading();
              $scope.loading = false;
              popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
              $ionicHistory.goBack();
            });
        };

        // 1) RECIBIMOS TODOS LOS DATOS
        var getResults = function () {
          $scope.objetoFormateado = [];
          $scope.viewMoreDisabled = false;
          $scope.loading = true;
          popupSrv.showLoading('Cargando resultados');
          var params = [
            {
              name: "game_id",
              value: "TODOS"
            }
          ];
          requestSrv.request(config.services.cmsHost + config.services.ultimosv4, "GET", params)
            .then(function (e) {
              $scope.loading = false;
              //Resultados recibidos
              var responseData = e.data;
              creamosObjetoFormateado($filter('orderBy')(responseData, "-fecha_sorteo"));
              $timeout(function () {
                $ionicScrollDelegate.$getByHandle('results').resize();
              }, 100);
              popupSrv.hideLoading();
            }, function (err) {
              popupSrv.hideLoading();
              $scope.loading = false;
              popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
              $ionicHistory.goBack();
            });
        };
        getResults();

        var creamosObjetoFormateado = function (objetoSinFormatear) {
          angular.forEach(objetoSinFormatear, function (value, key) {
            if ($filter('filter')($scope.gamesData, {text: value.game_id}).length > 0) {
              switch (objetoSinFormatear[key].game_id) {
                case 'LNAC':
                  var fecha = $filter('date')(opSrv.dateFromString(objetoSinFormatear[key].fecha_sorteo), "yyyyMMdd");
                  var params = [
                    {
                      name: "game_id",
                      value: "LNAC"
                    },
                    {
                      name: "fecha_sorteo",
                      value: fecha
                    }
                  ];
                  requestSrv.request(config.services.cmsHost + config.services.fecha2, "GET", params)
                    .then(function (e) {
                      //Resultados recibidos
                      var responseData = $filter('filter')(e.data,{fecha_sorteo: objetoSinFormatear[key].fecha_sorteo});
                      formatearLoteriaNacional(responseData, key);
                      //popupSrv.hideLoading();
                    }, function (err) {
                      //popupSrv.hideLoading();
                      popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                      $ionicHistory.goBack();
                    });

                  break;
                case 'LAPR':
                  formatearPrimitiva(objetoSinFormatear[key], key);
                  break;
                case 'EMIL':
                  fecha = $filter('date')(opSrv.dateFromString(objetoSinFormatear[key].fecha_sorteo), "yyyyMMdd");
                  params = [
                    {
                      name: "game_id",
                      value: "EMIL"
                    },
                    {
                      name: "fecha_sorteo",
                      value: fecha
                    }
                  ];
                  requestSrv.request(config.services.cmsHost + config.services.fechav3, "GET", params)
                    .then(function (e) {
                      //Resultados recibidos
                      var responseData = e.data;
                      //formatearLoteriaNacional(e.data,key);
                      formatearEuromillon(e.data[0], key);
                      //popupSrv.hideLoading();
                    }, function (err) {
                      //popupSrv.hideLoading();
                      popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                      $ionicHistory.goBack();
                    });
                  break;
                case 'BONO':
                  formatearBonoloto(objetoSinFormatear[key], key);
                  break;
                case 'LAQU':
                  formatearLaQuiniela(objetoSinFormatear[key], key);
                  break;
                case 'QGOL':
                  formatearQuinigol(objetoSinFormatear[key], key);
                  break;
                case 'LOTU':
                  formatearLototurf(objetoSinFormatear[key], key);
                  break;
                case 'QUPL':
                  formatearQuintuplePlus(objetoSinFormatear[key], key);
                  break;
                case 'ELGR':
                  formatearElGordo(objetoSinFormatear[key], key);
                  break;
                default:
              }
            }
          });
        };

        var formatearLaQuiniela = function (quiniela, indice) {
          //formateamos combinación/complementario/reintegro
          var resultadosPartidos = quiniela.partidos;
          var combinacion = quiniela.partidos;
          var combinacionGanadora = [];
          angular.forEach(combinacion, function (value, key) {
            if (quiniela.partidos[key].signo !== undefined) {
              combinacionGanadora[key] = quiniela.partidos[key].signo;
            }
          });
          var ultimaposicion = combinacionGanadora.pop();
          var pleno = quiniela.partidos[14].signo || null;
          $scope.objetoFormateado.push({
            "id": 2,
            "game": quiniela.game_id,
            "fechaServicio": $filter('date')(opSrv.dateFromString(quiniela.fecha_sorteo), "yyyyMMdd"),
            "imagen": $filter('filter')(gamesProvider.getGames(), {idJuego: "2"})[0].imgText,
            "nombre": "LAQU",
            "sorteo": quiniela.id_sorteo,
            "fecha": quiniela.dia_semana + " " + $filter('dateToText')(quiniela.fecha_sorteo, 2),
            "combinacion": combinacionGanadora,
            "pleno": pleno,
            "resultadosPartidos": resultadosPartidos
          });
        };
        var formatearQuinigol = function (quinigol, indice) {

          //formateamos combinación/complementario/reintegro
          var combinacion = quinigol.partidos;
          var combinacionGanadora = {};

          angular.forEach(combinacion, function (value, key) {
            if (quinigol.partidos[key].signo !== undefined) {
              if (quinigol.partidos[key].signo.indexOf('-') !== -1) {
                combinacionGanadora[key] = quinigol.partidos[key].signo.split("-");
              } else {
                combinacionGanadora[key] = quinigol.partidos[key].signo.split(" ");
              }
            }
          });

          //creamos objeto combinación quinigol
          $scope.objetoFormateado.push({
            "id": 6,
            "game": quinigol.game_id,
            "fechaServicio": $filter('date')(opSrv.dateFromString(quinigol.fecha_sorteo), "yyyyMMdd"),
            "imagen": $filter('filter')(gamesProvider.getGames(), {idJuego: "6"})[0].imgText,
            "nombre": "QGOL",
            "sorteo": quinigol.id_sorteo,
            "fecha": quinigol.dia_semana + " " + $filter('dateToText')(quinigol.fecha_sorteo, 2),
            "combinacion": combinacionGanadora
          });
        };


        var formatearPrimitiva = function (primitiva, indice) {

          //formateamos combinación/complementario/reintegro
          var combinacion = primitiva.combinacion;
          var combinacionGanadora = combinacion.split(" - ");
          var ultimaposicion = combinacionGanadora[5].split(" ");
          combinacionGanadora[5] = ultimaposicion[0];
          var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
          var reintegro = ultimaposicion[2].replace("R(", "").replace(")", "");

          //creamos objeto combinación primitiva
          $scope.objetoFormateado.push({
            "id": 1,
            "game": primitiva.game_id,
            "fechaServicio": $filter('date')(opSrv.dateFromString(primitiva.fecha_sorteo), "yyyyMMdd"),
            "imagen": $filter('filter')(gamesProvider.getGames(), {idJuego: "1"})[0].imgText,
            "nombre": "LAPR",
            "sorteo": primitiva.id_sorteo,
            "fecha": primitiva.dia_semana + " " + $filter('dateToText')(primitiva.fecha_sorteo, 2),
            "combinacion": combinacionGanadora,
            "complementario": complementario,
            "reintegro": reintegro,
            "joker": primitiva.joker.combinacion
          });
        };

        var formatearEuromillon = function (euromillon, indice) {

          //formateamos combinación/complementario/reintegro
          var combinacion = euromillon.combinacion.split(" - ");
          var combinacionGanadora = combinacion.slice(0, 5);
          var estrellas = combinacion.slice(5);
          if (euromillon.millon) {
            var premiosmillon = euromillon.millon.combinacion;
          }  
          //formateamos millon para que se vea bien con 5
          if (premiosmillon) {
          var premioelmillon = premiosmillon.split(",");
        }
          //console.log($scope.premioelmillon,"$scope.premioelmillon");



          //creamos objeto combinación euromillon
          $scope.objetoFormateado.push({
            "id": 3,
            "game": euromillon.game_id,
            "fechaServicio": $filter('date')(opSrv.dateFromString(euromillon.fecha_sorteo), "yyyyMMdd"),
            "imagen": $filter('filter')(gamesProvider.getGames(), {idJuego: "3"})[0].imgText,
            "nombre": "EMIL",
            "sorteo": euromillon.id_sorteo,
            "fecha": euromillon.dia_semana + " " + $filter('dateToText')(euromillon.fecha_sorteo, 2),
            "combinacion": combinacionGanadora,
            "estrellas": estrellas,
            "millon": premioelmillon,
            "lluvia": euromillon.lluvia
          });
        };

        var formatearLoteriaNacional = function (loteria, indice) {

          //creamos objeto combinación loteria
          $scope.objetoFormateado.push({
            "id": 9,
            "game": loteria[0].game_id,
            "fechaServicio": $filter('date')(opSrv.dateFromString(loteria[0].fecha_sorteo), "yyyyMMdd"),
            "imagen": $filter('filter')(gamesProvider.getGames(), {idJuego: "9"})[0].imgText,
            "nombre": "LNAC",
            "sorteo": loteria[0].id_sorteo,
            "fecha": loteria[0].dia_semana + " " + $filter('dateToText')(loteria[0].fecha_sorteo, 2),
            "primero": loteria[0].combinacion.primer_premio,
            "segundo": loteria[0].combinacion.Segundo_premio,
            "reintegros": loteria[0].reintegros,
            "fechaRaw": loteria[0].fecha_sorteo
          });
        };
        var formatearBonoloto = function (bonoloto, indice) {

          //formateamos combinación/complementario/reintegro
          var combinacion = bonoloto.combinacion;
          var combinacionGanadora = combinacion.split(" - ");
          var ultimaposicion = combinacionGanadora[5].split(" ");
          combinacionGanadora[5] = ultimaposicion[0];
          var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
          var reintegro = ultimaposicion[2].replace("R(", "").replace(")", "");

          //creamos objeto combinación bonoloto
          $scope.objetoFormateado.push({
            "id": 4,
            "game": bonoloto.game_id,
            "fechaServicio": $filter('date')(opSrv.dateFromString(bonoloto.fecha_sorteo), "yyyyMMdd"),
            "imagen": $filter('filter')(gamesProvider.getGames(), {idJuego: "4"})[0].imgText,
            "nombre": "BONO",
            "sorteo": bonoloto.id_sorteo,
            "fecha": bonoloto.dia_semana + " " + $filter('dateToText')(bonoloto.fecha_sorteo, 2),
            "combinacion": combinacionGanadora,
            "complementario": complementario,
            "reintegro": reintegro
          });
        };

        var formatearLototurf = function (lototurf, indice) {

          //formateamos combinación/complementario/reintegro
          var combinacion = lototurf.combinacion;
          var combinacionGanadora = combinacion.split(" - ");
          var ultimaposicion = combinacionGanadora[5].split(" ");
          combinacionGanadora[5] = ultimaposicion[0];
          var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
          var reintegro = ultimaposicion[2].replace("R(", "").replace(")", "");

          //creamos objeto combinación lototurf
          $scope.objetoFormateado.push({
            "id": 7,
            "game": lototurf.game_id,
            "fechaServicio": $filter('date')(opSrv.dateFromString(lototurf.fecha_sorteo), "yyyyMMdd"),
            "imagen": $filter('filter')(gamesProvider.getGames(), {idJuego: "7"})[0].imgText,
            "nombre": "LOTU",
            "sorteo": lototurf.id_sorteo,
            "fecha": lototurf.dia_semana + " " + $filter('dateToText')(lototurf.fecha_sorteo, 2),
            "combinacion": combinacionGanadora,
            "complementario": complementario,
            "reintegro": reintegro
          });

        };

        var formatearQuintuplePlus = function (quintuple, indice) {

          //formateamos combinación/complementario/reintegro
          var combinacion = quintuple.combinacion;
          var combinacionGanadora = combinacion.split(" - ");
          var ultimaposicion = combinacionGanadora[4].split(" ");
          combinacionGanadora[4] = ultimaposicion[0];
          var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
          combinacionGanadora.push(complementario);

          //creamos objeto combinación quintuple
          $scope.objetoFormateado.push({
            "id": 8,
            "game": quintuple.game_id,
            "fechaServicio": $filter('date')(opSrv.dateFromString(quintuple.fecha_sorteo), "yyyyMMdd"),
            "imagen": $filter('filter')(gamesProvider.getGames(), {idJuego: "8"})[0].imgText,
            "nombre": "QUPL",
            "sorteo": quintuple.id_sorteo,
            "fecha": quintuple.dia_semana + " " + $filter('dateToText')(quintuple.fecha_sorteo, 2),
            "combinacion": combinacionGanadora,
            "complementario": complementario
          });
        };

        var formatearElGordo = function (gordo, indice) {

          //formateamos combinación/complementario/reintegro
          var combinacion = gordo.combinacion;
          var combinacionGanadora = combinacion.split(" - ");
          var ultimaposicion = combinacionGanadora[4].split(" ");
          combinacionGanadora[4] = ultimaposicion[0];
          var complementario = ultimaposicion[1].replace("R(", "").replace(")", "");

          //creamos objeto combinación gordo
          $scope.objetoFormateado.push({
            "id": 5,
            "game": gordo.game_id,
            "fechaServicio": $filter('date')(opSrv.dateFromString(gordo.fecha_sorteo), "yyyyMMdd"),
            "imagen": $filter('filter')(gamesProvider.getGames(), {idJuego: "5"})[0].imgText,
            "nombre": "ELGR",
            "sorteo": gordo.id_sorteo,
            "fecha": gordo.dia_semana + " " + $filter('dateToText')(gordo.fecha_sorteo, 2),
            "combinacion": combinacionGanadora,
            "complementario": complementario
          });

        };

        $scope.showSorteos = function (gameID) {
          if ($scope.gamesData[$scope.itemSelected] !== undefined && gameID === parseInt($scope.gamesData[$scope.itemSelected].idJuego)) {
            return true;
          }
          if ($scope.itemSelected == -1) {
            return true;
          }
          return false;
        };

        $scope.detalle = function (id, game, fechaSorteo, sorteo) {
          if (window.ga !== undefined) {
            var anaGameName = analyticsSrv.setName(id);
            analyticsSrv.trackEvent('Resultados', 'Información', anaGameName);
          }
          if (sorteo.nombre == "LNAC") {
            $state.go("app.resultsDetails", {game_id: id, id: game, fecha_sorteo: sorteo.fechaRaw, sorteoid : sorteo.sorteo});
          } else {
            $state.go("app.resultsDetails", {game_id: id, id: game, fecha_sorteo: fechaSorteo, sorteoid :sorteo.sorteo});
          }
        };

        $scope.loadMore = function () {
          $scope.viewMoreDisabled = true;
          popupSrv.showLoading('Cargando resultados');
          if ($scope.itemSelected === -1) {
            angular.forEach($scope.gamesData, function (value, key) {
              var params = [
                {
                  name: "game_id",
                  value: $scope.gamesData[key].text
                },
                {
                  name: "idsorteo",
                  value: $filter('filter')($scope.objetoFormateado, {nombre: $scope.gamesData[key].text})[0].sorteo
                },
                {
                  name: "num",
                  value: 3
                },
                {
                  name: "target",
                  value: "anterior"
                }
              ];
              requestSrv.request(config.services.cmsHost + config.services.sorteov3, "GET", params)
                .then(function (e) {
                  //Resultados recibidos
                  var responseData = e.data;
                  creamosObjetoFormateado(responseData);
                  $timeout(function () {
                    $ionicScrollDelegate.resize();
                  }, 100);
                  popupSrv.hideLoading();

                }, function (err) {
                  popupSrv.hideLoading();
                  popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                  $ionicHistory.goBack();
                });
            });
          } else {
            var params = [
              {
                name: "game_id",
                value: $scope.gamesData[$scope.itemSelected].text
              },
              {
                name: "idsorteo",
                value: $scope.objetoFormateado[0].sorteo
              },
              {
                name: "num",
                value: 2
              },
              {
                name: "target",
                value: "anterior"
              }
            ];
            requestSrv.request(config.services.cmsHost + config.services.sorteov3, "GET", params)
              .then(function (e) {
                //Resultados recibidos
                var responseData = e.data;
                creamosObjetoFormateado(responseData);
                $timeout(function () {
                  $ionicScrollDelegate.resize();
                }, 100);
                popupSrv.hideLoading();
              }, function (err) {
                popupSrv.hideLoading();
                popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                $ionicHistory.goBack();
              });
          }
        };
      
    }]);
