angular.module('selae.results.controllers')

.controller('ResultsDetailsCtrl', ['$scope', 'popupSrv', 'requestSrv', '$ionicHistory', 'config', '$stateParams', '$rootScope', '$filter', '$interval', '$ionicSlideBoxDelegate', '$timeout', 'opSrv', 'analyticsSrv',
    function($scope, popupSrv, requestSrv, $ionicHistory, config, $stateParams, $rootScope, $filter, $interval, $ionicSlideBoxDelegate, $timeout, opSrv, analyticsSrv) {

        $scope.$on('$ionicView.beforeEnter', function(event, viewData) {
            viewData.enableBack = true;

            if (window.ga && $stateParams.id) {
                analyticsSrv.trackView('Resultados-Detalle-' + analyticsSrv.setName($stateParams.game_id)); }
        });
        $scope.gameId = $stateParams.id;
        $scope.sorteoid = $stateParams.sorteoid

        if ($scope.gameId == "LNAC"){
            $scope.fecha_sorteo = $filter('date')(opSrv.dateFromString($stateParams.fecha_sorteo), "yyyyMMdd");
        } else {
            $scope.fecha_sorteo = $stateParams.fecha_sorteo;
        }
        $scope.id = $stateParams.game_id;

        var slideCounter = 3;
        var validator = true;
        $scope.oldIndex = 1;
        $scope.nextDateEnabled = false;

        $scope.data = {};
        $scope.idSorteoGlobal = "";

        $scope.getBetTemplateUrl = function(id) {
            return "results/templates/results-details-game-" + id + ".html";
        };

        var checkNext= function(){
            var service = $scope.gameId == 'LNAC' ? config.services.sorteo2 : config.services.sorteov3;
            var params = [{
                name: "game_id",
                value: $scope.gameId
            }, {
                name: "idsorteo",
                value: $scope.idSorteoGlobal
            }, {
                name: "target",
                value: "siguiente"
            }];

            requestSrv.request(config.services.cmsHost + service, "GET", params)
            .then(function(e) {
                if ($scope.gameId == 'LNAC'){
                    $scope.nextDateEnabled = e.data[0].combinacion.primer_premio !== null;
                }else{
                    $scope.nextDateEnabled = e.data[0].apuestas !== "0";
                }
            }, null);
        };

        var getRaffles = function(objetoSinFormatear) {
            requestSrv.request(config.services.cmsHost + config.services.proximosv3, "get", [{ name: "game_id", value: "TODOS" }])
            .then(function(e) {
                $scope.raffleData = $filter('filter')(e.data, { game_id: objetoSinFormatear.game_id })[0];
            }, function(err) {
                popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
            });
        };

        var getDataFirstElement = function() {
            popupSrv.showLoading('Cargando resultados');          
            var game_id = $scope.gameId;
            var fecha_sorteo = $scope.fecha_sorteo;
            var id = $scope.id;
            var service = game_id == 'LNAC' ? config.services.sorteo2 : config.services.sorteov3;
            //Sergio incidencias fechav3
            // para lite y completa
            // quitar fecha sorteo, y añadir 2 params: idsorteo y target=igual
            //El idsorte hay que cogerlo de una llamada anterior en la pagina anterior. 
            var params = [{
                name: "game_id",
                value: game_id
            }, {
                name: "idsorteo",
                value: $scope.sorteoid
            }, {
                name: "target",
                value: "igual"
            }];

            requestSrv.request( config.services.cmsHost + service, "GET", params)
            .then(function(e) {
                popupSrv.hideLoading();
                $scope.idSorteoGlobal = e.data[0].id_sorteo;

                // forzar a que el dato sea un numero y tenga dos decimales
                // e.data[0].recaudacion = Number(e.data[0].recaudacion)/100; 
                // e.data[0].fondo_bote = Number(e.data[0].fondo_bote)/100; 
                // e.data[0].premios  = Number(e.data[0].premios)/100;
                
                if (game_id === 'LNAC') {
                  creamosObjetoFormateado($filter('filter')(e.data,{fecha_sorteo: $stateParams.fecha_sorteo})[0]);
                }
                else{
                  creamosObjetoFormateado(e.data[0]);
                }
                getRaffles(e.data[0]);
                checkNext();
            }, function(err) {
                popupSrv.hideLoading();
                popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                $ionicHistory.goBack();
            });
        };

        getDataFirstElement();


        // var formatearConDecimales = function(valor) {
        // var result;
 
        //  try {
        //         var tamanyo = valor.length;
        //         var result = valor.substring(0,tamanyo -2) + '.' + valor.substring(tamanyo -2, tamanyo);
        //         return result;
        //     } catch(err) { console.error(err); }
        // }


        var creamosObjetoFormateado = function(objetoSinFormatear) {
            //añadimos la variable anyo para tomar el año del sorteo correctamente
            $scope.anyo=objetoSinFormatear.anyo;

            objetoSinFormatear.recaudacion = Number(objetoSinFormatear.recaudacion)/100;
            objetoSinFormatear.fondo_bote = Number(objetoSinFormatear.fondo_bote)/100;
            objetoSinFormatear.premios = Number(objetoSinFormatear.premios)/100;


            switch (objetoSinFormatear.game_id) {
                case 'LNAC':
                    formatearLoteriaNacional(objetoSinFormatear);
                    break;
                case 'LAPR':
                    formatearPrimitiva(objetoSinFormatear);
                    break;
                case 'EMIL':
                    formatearEuromillon(objetoSinFormatear);
                    break;
                case 'BONO':
                    formatearBonoloto(objetoSinFormatear);
                    break;
                case 'LAQU':
                    formatearLaQuiniela(objetoSinFormatear);
                    break;
                case 'QGOL':
                    formatearQuinigol(objetoSinFormatear);
                    break;
                case 'LOTU':
                    formatearLototurf(objetoSinFormatear);
                    break;
                case 'QUPL':
                    formatearQuintuplePlus(objetoSinFormatear);
                    break;
                case 'ELGR':
                    formatearElGordo(objetoSinFormatear);
                    break;
                default:
            }
        };

        $scope.getElement = function(target) {
            popupSrv.showLoading('Cargando resultados');
            var service = $scope.gameId == 'LNAC' ? config.services.sorteo2 : config.services.sorteov3;
            var params = [{
                name: "game_id",
                value: $scope.gameId
            }, {
                name: "idsorteo",
                value: $scope.idSorteoGlobal
            }, {
                name: "target",
                value: target
            }];
            requestSrv.request(config.services.cmsHost + service, "GET", params)
            .then(function(e) {
                popupSrv.hideLoading();
                $scope.idSorteoGlobal = e.data[0].id_sorteo;
                creamosObjetoFormateado(e.data[0]);
                if (target == "anterior"){
                    $scope.nextDateEnabled = true;
                }else{
                    checkNext();
                }
            }, function(err) {
                popupSrv.hideLoading();
                popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                $ionicHistory.goBack();
            });
        };

        var formatearLaQuiniela = function(quiniela) {
            $scope.objetoFormateado = {};

            console.log(quiniela,"quiniela");

            //formateamos combinación/complementario/reintegro
            var combinacion = quiniela.partidos;
            var combinacionGanadora = [];
            angular.forEach(combinacion, function(value, key) {
                if (quiniela.partidos[key].signo !== undefined) {
                    combinacionGanadora[key] = quiniela.partidos[key].signo;
                }
            });
            var ultimaposicion = combinacionGanadora.pop();
            // var pleno = ultimaposicion.split("-");
            var pleno = quiniela.partidos[14].signo || null;
            $scope.objetoFormateado.header = {
                "fecha": quiniela.dia_semana + " " + $filter('dateToText')(quiniela.fecha_sorteo, 2),
                "sorteo": quiniela.id_sorteo,
                "id": 2,
            };
            $scope.objetoFormateado.card1 = {
                "combinacion": combinacionGanadora,
                "apuestas": quiniela.apuestas,
                "premio": quiniela.premios,
                "pleno": pleno,
                "bote": quiniela.fondo_bote,
                "partidos": quiniela.partidos,
                "recaudacion": quiniela.recaudacion,
                "premio_bote": quiniela.premio_bote
            };

            $scope.objetoFormateado.card2 = {
                "tabla": quiniela.escrutinio,
            };

            $scope.objetoFormateado.card3 = {
                "tabla": quiniela.escrutinioElige8,
            };
        };

        var formatearQuinigol = function(quinigol) {
            $scope.objetoFormateado = {};

            //formateamos combinación/complementario/reintegro
            var combinacion = quinigol.partidos;
            var combinacionGanadora = [];
            angular.forEach(combinacion, function(value, key) {
                if (quinigol.partidos[key].signo !== undefined) {
                    combinacionGanadora[key] = quinigol.partidos[key].signo;
                }
            });
            var ultimaposicion = combinacionGanadora.pop();
            var pleno = ultimaposicion.split("-");
            $scope.objetoFormateado.header = {
                "fecha": quinigol.dia_semana + " " + $filter('dateToText')(quinigol.fecha_sorteo, 2),
                "sorteo": quinigol.id_sorteo,
                "id": 6,
            };
            $scope.objetoFormateado.card1 = {
                "combinacion": combinacionGanadora,
                "apuestas": quinigol.apuestas,
                "premio": quinigol.premios,
                "pleno": pleno,
                "bote": quinigol.fondo_bote,
                "partidos": quinigol.partidos,
                "recaudacion": quinigol.recaudacion,
                "premio_bote": quinigol.premio_bote

            };

            $scope.objetoFormateado.card2 = {
                "tabla": quinigol.escrutinio,
            };
        };


        var formatearPrimitiva = function(primitiva) {
            $scope.objetoFormateado = {};

            //formateamos combinación/complementario/reintegro
            var combinacion = primitiva.combinacion;
            var combinacionGanadora = combinacion.split(" - ");
            var ultimaposicion = combinacionGanadora[5].split(" ");
            combinacionGanadora[5] = ultimaposicion[0];
            var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
            var reintegro = ultimaposicion[2].replace("R(", "").replace(")", "");

            //creamos objeto combinación primitiva
            $scope.objetoFormateado.header = {
                "fecha": primitiva.dia_semana + " " + $filter('dateToText')(primitiva.fecha_sorteo, 2),
                "sorteo": primitiva.id_sorteo,
                "id": 1,
            };
            $scope.objetoFormateado.card1 = {
                "combinacion": combinacionGanadora,
                "complementario": complementario,
                "reintegro": reintegro,
                "joker": primitiva.joker.combinacion,
                "apuestas": primitiva.apuestas,
                "premio": primitiva.premios,
                "recaudacion": primitiva.recaudacion,
                "bote": primitiva.fondo_bote,
                "premio_bote": primitiva.premio_bote
            };

            $scope.objetoFormateado.card2 = {
                "tabla": primitiva.escrutinio,
                "tablaJoker": primitiva.escrutinio_joker
            };
        };

        var formatearEuromillon = function(euromillon) {
            $scope.objetoFormateado = {};

            //formateamos combinación/complementario/reintegro
            var combinacion = euromillon.combinacion.split(" - ");
            var combinacionGanadora = combinacion.slice(0, 5);
            var estrellas = combinacion.slice(5);

            $scope.objetoFormateado.header = {
                "fecha": euromillon.dia_semana + " " + $filter('dateToText')(euromillon.fecha_sorteo, 2),
                "sorteo": euromillon.id_sorteo,
                "id": 3,
            };
            $scope.objetoFormateado.card1 = {
                "combinacion": combinacionGanadora,
                "estrellas": estrellas,
                "apuestas": euromillon.apuestas,
                "premio": euromillon.premios,
                "recaudacion": euromillon.recaudacion,
                "bote": euromillon.fondo_bote,
                "premio_bote": euromillon.premio_bote
            };

            $scope.objetoFormateado.card2 = {
                "tabla": euromillon.escrutinio,
            };

            if (euromillon.millon !== null) {
                $scope.objetoFormateado.millon = {
                    "escrutinio_millon": euromillon.escrutinio_millon,
                    "datos": euromillon.millon
                };
            }

            if (euromillon.lluvia !== null) {
                $scope.objetoFormateado.lluvia = {
                    "escrutinio_lluvia": euromillon.escrutinio_lluvia,
                    "datos": euromillon.lluvia
                };
            }
        };

        var formatearLoteriaNacional = function(loteria) {
            $scope.objetoFormateado = {};

            $scope.objetoFormateado.header = {
                "fecha": loteria.dia_semana + " " + $filter('dateToText')(loteria.fecha_sorteo, 2),
                "sorteo": loteria.id_sorteo,
                "id": 9,
            };

            //creamos objeto combinación loteria
            $scope.objetoFormateado.card1 = {
                "primero": loteria.combinacion.primer_premio,
                "segundo": loteria.combinacion.Segundo_premio ? loteria.combinacion.Segundo_premio : loteria.combinacion.segundo_premio,
                "tercero": loteria.combinacion.Tercer_premio ? loteria.combinacion.Tercer_premio : loteria.combinacion.tercer_premio,
                "cuarto": loteria.combinacion.Cuarto_premio ? loteria.combinacion.Cuarto_premio : loteria.combinacion.cuarto_premio,
                "quinto": loteria.combinacion.Quinto_premio ? loteria.combinacion.Quinto_premio : loteria.combinacion.quinto_premio,
                "reintegros": loteria.reintegros
            };

            $scope.objetoFormateado.card2 = {
                "tabla": loteria.escrutinio,
            };
        };

        var formatearBonoloto = function(bonoloto) {
            $scope.objetoFormateado = {};

            //formateamos combinación/complementario/reintegro
            var combinacion = bonoloto.combinacion;
            var combinacionGanadora = combinacion.split(" - ");
            var ultimaposicion = combinacionGanadora[5].split(" ");
            combinacionGanadora[5] = ultimaposicion[0];
            var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
            var reintegro = ultimaposicion[2].replace("R(", "").replace(")", "");

            $scope.objetoFormateado.header = {
                "fecha": bonoloto.dia_semana + " " + $filter('dateToText')(bonoloto.fecha_sorteo, 2),
                "sorteo": bonoloto.id_sorteo,
                "id": 4,
            };
            $scope.objetoFormateado.card1 = {
                "combinacion": combinacionGanadora,
                "complementario": complementario,
                "reintegro": reintegro,
                "apuestas": bonoloto.apuestas,
                "premio": bonoloto.premios,
                "recaudacion": bonoloto.recaudacion,
                "bote": bonoloto.fondo_bote,
                "premio_bote": bonoloto.premio_bote
            };

            $scope.objetoFormateado.card2 = {
                "tabla": bonoloto.escrutinio,
            };
        };

        var formatearLototurf = function(lototurf) {
            $scope.objetoFormateado = {};

            //formateamos combinación/complementario/reintegro
            var combinacion = lototurf.combinacion;
            var combinacionGanadora = combinacion.split(" - ");
            var ultimaposicion = combinacionGanadora[5].split(" ");
            combinacionGanadora[5] = ultimaposicion[0];
            var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
            var reintegro = ultimaposicion[2].replace("R(", "").replace(")", "");

            $scope.objetoFormateado.header = {
                "fecha": lototurf.dia_semana + " " + $filter('dateToText')(lototurf.fecha_sorteo, 2),
                "sorteo": lototurf.id_sorteo,
                "id": 7,
            };
            $scope.objetoFormateado.card1 = {
                "combinacion": combinacionGanadora,
                "complementario": complementario,
                "reintegro": reintegro,
                "apuestas": lototurf.apuestas,
                "premio": lototurf.premios,
                "recaudacion": lototurf.recaudacion,
                "bote": lototurf.fondo_bote,
                "premio_bote": lototurf.premio_bote
            };

            $scope.objetoFormateado.card2 = {
                "tabla": lototurf.escrutinio,
            };

        };

        var formatearQuintuplePlus = function(quintuple) {
            $scope.objetoFormateado = {};

            //formateamos combinación/complementario/reintegro
            var combinacion = quintuple.combinacion;
            var combinacionGanadora = combinacion.split(" - ");
            var ultimaposicion = combinacionGanadora[4].split(" ");
            combinacionGanadora[4] = ultimaposicion[0];
            var complementario = ultimaposicion[1].replace("C(", "").replace(")", "");
            combinacionGanadora.push(complementario);
            var races = [
                $filter('translate')('horseRace1'),
                $filter('translate')('horseRace2'),
                $filter('translate')('horseRace3'),
                $filter('translate')('horseRace4'),
                $filter('translate')('horseRace51'),
                $filter('translate')('horseRace52')
            ];

            $scope.objetoFormateado.header = {
                "fecha": quintuple.dia_semana + " " + $filter('dateToText')(quintuple.fecha_sorteo, 2),
                "sorteo": quintuple.id_sorteo,
                "id": 8,
            };
            $scope.objetoFormateado.card1 = {
                "combinacion": combinacionGanadora,
                "races": races,
                "apuestas": quintuple.apuestas,
                "premio": quintuple.premios,
                "recaudacion": quintuple.recaudacion,
                "bote": quintuple.fondo_bote,
                "premio_bote": quintuple.premio_bote
            };

            $scope.objetoFormateado.card2 = {
                "tabla": quintuple.escrutinio,
            };
        };

        var formatearElGordo = function(gordo) {
            $scope.objetoFormateado = {};

            //formateamos combinación/complementario/reintegro
            var combinacion = gordo.combinacion;
            var combinacionGanadora = combinacion.split(" - ");
            var ultimaposicion = combinacionGanadora[4].split(" ");
            combinacionGanadora[4] = ultimaposicion[0];
            var complementario = ultimaposicion[1].replace("R(", "").replace(")", "");

            $scope.objetoFormateado.header = {
                "fecha": gordo.dia_semana + " " + $filter('dateToText')(gordo.fecha_sorteo, 2),
                "sorteo": gordo.id_sorteo,
                "id": 5,
            };
            $scope.objetoFormateado.card1 = {
                "combinacion": combinacionGanadora,
                "complementario": complementario,
                "apuestas": gordo.apuestas,
                "premio": gordo.premios,
                "recaudacion": gordo.recaudacion,
                "bote": gordo.fondo_bote,
                "premio_bote": gordo.premio_bote
            };

            $scope.objetoFormateado.card2 = {
                "tabla": gordo.escrutinio,
            };

        };

        var getObjectSlide = function(data) {
            $scope.slide = {};
            $scope.slide.header = {
                "fecha": data.fecha_sorteo,
                "sorteo": data.id_sorteo
            };
            $scope.slide.card1 = {
                "combinacion": data.combinacion,
                "joker": data.joker,
                "apuestas": data.apuestas,
                "premio": data.premios,
                "recaudacion": data.recaudacion,
                "bote": data.fondo_bote,
                "partidos": data.partidos,
                "premio_bote": data.premio_bote
            };
            $scope.slide.card2 = {
                "tabla": data.escrutinio,
                "tablaJoker": data.escrutinio_joker
            };
        };

$scope.moreInformationWeb = function(data) {

    if (window.ga) {
        var anaGameName = analyticsSrv.setName($scope.id);
        analyticsSrv.trackEvent('Resultados_Detalle', 'Información', anaGameName);
    };
	var date = $scope.anyo;
	var type = 'moreInfoSorteos' + $scope.gameId;
	var url = $rootScope.selae.properties[type] + date + '/' + $scope.idSorteoGlobal;
	window.open(url, '_system');
	};




}]);