angular.module('selae.user.controllers')

.controller('LoadLotobolsaCtrl', ['$scope', '$rootScope', 'requestSrv', 'config', '$http', 'popupSrv', '$ionicScrollDelegate', '$filter', '$ionicHistory', '$state', '$ionicPlatform', 'analyticsSrv',
    function($scope, $rootScope, requestSrv, config, $http, popupSrv, $ionicScrollDelegate, $filter, $ionicHistory, $state, $ionicPlatform, analyticsSrv) {
        if (window.ga !== undefined) { analyticsSrv.trackView('Carga de Lotobolsa'); }

        // console.log('Datos guardados de apuesta',$rootScope.lotoBolsaStore);

        var memory = $ionicHistory.backView().stateId;
        if ( memory.indexOf("ticket") !== -1 ) {
            $rootScope.ticket = true;
        }

        var deregisterHardBack = $ionicPlatform.registerBackButtonAction($rootScope.selaeGoBack, 101);
		$scope.$on('$destroy', deregisterHardBack);

    $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
        viewData.enableBack = true;
    });

    $scope.numeroActiva = '1';

    $scope.enabledServices = {
      tarjeta : $rootScope.selae.properties['lotobolsa.tarjetaBancaria'],
      traspaso : $rootScope.selae.properties['lotobolsa.traspaso'],
      "0049" : $rootScope.selae.properties['lotobolsa.santander'],
      "2100" : $rootScope.selae.properties['lotobolsa.caixaBank'],
      "0182" : $rootScope.selae.properties['lotobolsa.bbva'],
      "2038" : $rootScope.selae.properties['lotobolsa.bankia'],
      "2103" : $rootScope.selae.properties['lotobolsa.unicaja'],
      "2095" : $rootScope.selae.properties['lotobolsa.kutxaBank'],
      "0237" : $rootScope.selae.properties['lotobolsa.cajaSur'],
      "2108" : $rootScope.selae.properties['lotobolsa.espDuero'],
      "0487" : $rootScope.selae.properties['lotobolsa.bmn'],
      "3058" : $rootScope.selae.properties['lotobolsa.cajamar'],
      "2080" : $rootScope.selae.properties['lotobolsa.abanca'],
      "0075" : $rootScope.selae.properties['lotobolsa.popular'],
      "2085" : $rootScope.selae.properties['lotobolsa.ibercaja'],
      "0081" : $rootScope.selae.properties['lotobolsa.sabadell'],
      "2045" : $rootScope.selae.properties['lotobolsa.caixa'],
      "0238" : $rootScope.selae.properties['lotobolsa.pastor'],
    };
    console.log($scope.enabledServices);

    $scope.quantity = {};
    $scope.currentQuantity = 0;
    $scope.movimiento = false;
    $scope.form = {
        type: false
    };

    var MAX = 0;
    var saldo = 0;
    $scope.canCharge = false;
    $scope.tpv = {
        state: 0,
        max: 0,
        min: 0
    };

    $scope.nrl = {
        state: 0,
        max: 0,
        min: 0
    };
    $scope.bank = false;

    $scope.Banks = [];

    $scope.loaded = false;


    requestSrv.request(config.services.host + config.services.initCarga, "post", {})
        .then(function(response) {
            console.log(response);
            try {
            if (response.data.filtroBean && response.data.filtroBean[0].error === true) { throw response };
            $scope.loaded = true;
            $scope.tpv.state = (response.data.TPVEstado[0] == "ACTIVADO") ? 1 : 0;
            $scope.tpv.max = response.data.TPVLimiteMaximoCarga[0] / 100;
            $scope.tpv.min = response.data.TPVLimiteMinimoCarga[0] / 100;

            $scope.nrl.state = (response.data.NRLEstado[0] == "ACTIVADO") ? 1 : 0;
            $scope.nrl.max = response.data.NRLLimiteMaximoCarga[0] / 100;
            $scope.nrl.min = response.data.NRLimiteMinimoCarga[0] / 100;
            MAX = response.data.maxLotobolsa[0];
            saldo = response.data.saldoActual[0];
            $scope.Banks = $filter('filter')(response.data.listadoBancos,{estadoBanco : "ACTIVO"}, true);
            console.log($scope.Banks);
            console.log($scope.enabledServices);
            var banks=[];
            angular.forEach($scope.Banks, function(bank, key) {
              if($scope.enabledServices[bank.codigoBanco] == "true"){
                banks.push(bank);
              }
            });
            $scope.Banks = banks;
            // debugger;
            $scope.lastCard = response.data.tieneUltimaTarjeta[0] && $rootScope.selae.properties.useLastCard;
            if ($scope.lastCard) {
                $scope.check_tarjeta = true;
            } else { $scope.check_tarjeta = false; }
            if ($rootScope.selae.properties.useLastCard) {
                $scope.lastTarget = Number(response.data.tieneUltimaTarjeta[0]);
            } else { $scope.lastTarget = 0 };
        } catch(err) {
            setTimeout(function(){ popupSrv.showErrorPopup(requestSrv.errorHandler2(err)); }, 500);
        }

        }, function(err) {
            popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
        });

    var watchType = $scope.$watch('form.type', function () {
        if ($scope.form.type=="tpv"){
            // if(window.ga !== undefined) {analyticsSrv.trackEvent('Carga', 'TPV', 'TarjetaBancaria');}
        }
    });

    var _LoadLoto = function(idEntidad, urlBanco, metodo) {

        if ($scope.quantity.value != 'undefined' && $scope.quantity.value < $scope[$scope.form.type].min) {
            popupSrv.showErrorPopup("lotoBolsaNoMin");
            return false;
        } else {

            popupSrv.showLoading("accessTPV");
            var group2 = (typeof $scope.quantity.predefined != 'undefined') ? $scope.quantity.predefined : 0;
            var libre = (typeof $scope.quantity.value != 'undefined') ? $scope.quantity.value : 0;

            return [{
                name: "ingresoAux",
                value: 0
            }, {
                name: "idEntidad",
                value: idEntidad
            }, {
                name: "accionController",
                value: "realizarCargaLotobolsa"
            }, {
                name: "urlBanco",
                value: encodeURIComponent(urlBanco)
            }, {
                name: "vueltaCarga",
                value: ""
            }, {
                name: "radioMetodoPago_1",
                value: metodo
            }, {
                name: "group2",
                value: group2
            }, {
                name: "cantidadLibreInput",
                value: libre
            }, {
                name: "saldoInicial",
                value: saldo
            }, {
                name: "cantidadParaCargarHidden",
                value: parseFloat(group2) + parseFloat(libre)
            }, {
                name: "check_tarjeta",
                value: $scope.lastTarget
            }];
        }

    };

    $scope.setBank = function(codigoEntidad, url, nombre) {
        $scope.bank = {
            codigoEntidad: codigoEntidad,
            url: url,
            nombre: nombre
        };

        $ionicScrollDelegate.scrollBottom(true);
    };

    $scope.loadLoto = function() {
        if(window.ga !== undefined) {analyticsSrv.trackEvent('Carga_Lotobolsa', 'TPV', 'TPV');}
        var params = _LoadLoto("tpv", "", "cargaTPV");
        if (params !== false) {
            requestSrv.request(config.services.host + config.services.cargaTPV, "get", params)
                .then(function(response) {
                    console.log(response);
                    _executePay(response);

                }, function(err) {
                    popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                });
        }

    };

    $scope.loadLotoNRL = function() {

        if(window.ga) {
            analyticsSrv.trackEvent('Carga_Lotobolsa', 'NRL', $scope.bank.nombre);
        }

        console.log("loadLotoNRL");
        var params = _LoadLoto($scope.bank.codigoEntidad, $scope.bank.url, $scope.bank.codigoEntidad);
        if (params !== false) {
            requestSrv.request(config.services.host + config.services.cargaNRL, "get", params)
                .then(function(response) {
                    console.log(response);
                    _executePay(response);

                }, function(err) {
                    popupSrv.showErrorPopup(requestSrv.errorHandler2(err));
                });
        }

    };

    _executePay = function(response) {
        if (typeof response.data.error == 'undefined') {
            var payWindow = window.open("", '_blank', 'location=no' /*, 'hidden=yes'*/ );

            payWindow.addEventListener('loaderror', function(event) {
                console.log("loaderror");
                var host = event.url.split('?')[0];
                console.log(host);

            });
            payWindow.addEventListener('loadstart', function(event) {
                console.log("loadstart");
                var host = event.url.split('?')[0];
                console.log(host);

            });

            payWindow.addEventListener('exit', function(event) {
                popupSrv.hideLoading();
            });
            if (response.data.respuestaServicio[0] == "formularioNRL"){
                //capturo cuando se termina de cargar la pestaña
                payWindow.addEventListener('loadstop', function(event) {
                    //saco el host
                    console.log("loadstop");
                    var host = event.url.split('?')[0];
                    console.log(host);
                    var code = "";
                    if (host.match(/^file:\/\/*/g)) {

                        var form = '<form name="testigoForm" id="testigoForm" action="' + response.data.urlMedioPagoOK[0] + '" method="POST">';
                        var input ='<input type="hidden" name="C1" id="C1" type="text" value="' + response.data.transaccion[0].tipoMensaje + '" />';
                        form += input;
                        input ='<input type="hidden" name="C2" id="C2" type="text" value="' + response.data.transaccion[0].idTestigo + '" />';
                        form += input;
                        input ='<input type="hidden" name="C3" id="C3" type="text" value="' + response.data.transaccion[0].cdc + '" />';
                        form += input;
                        input ='<input type="hidden" name="C4" id="C4" type="text" value="' + response.data.transaccion[0].versionTestigo + '" />';
                        form += input;
                        input ='<input type="hidden" name="C5" id="C5" type="text" value="' + response.data.transaccion[0].tipoTestigo + '" />';
                        form += input;
                        input ='<input type="hidden" name="C6" id="C6" type="text" value="' + response.data.transaccion[0].longitudTestigo + '" />';
                        form += input;
                        input ='<input type="hidden" name="C7" id="C7" type="text" value="' + response.data.transaccion[0].algoritmoCifrado + '" />';
                        form += input;
                        input ='<input type="hidden" name="C8" id="C8" type="text" value="' + response.data.transaccion[0].algoritmoIntegridad + '" />';
                        form += input;
                        input ='<input type="hidden" name="C9" id="C9" type="text" value="' + response.data.transaccion[0].verificacionAutenticidad + '" />';
                        form += input;
                        input ='<input type="hidden" name="C10" id="C10" type="text" value="' + response.data.transaccion[0].indiceClaveCifrado + '" />';
                        form += input;
                        input ='<input type="hidden" name="C11" id="C11" type="text" value="' + response.data.transaccion[0].claveCifradoKTOK + '" size="' + response.data.transaccion[0].claveCifradoKTOK.length + '"/>';
                        form += input;
                        input ='<input type="hidden" name="C12" id="C12" type="text" value="' + response.data.transaccion[0].datosPago + '" size="' + response.data.transaccion[0].datosPago.length + '"/>';
                        form += input;
                        input ='<input type="hidden" name="C13" id="C13" type="text" value="' + response.data.transaccion[0].codigoAutenticacion + '" size="' + response.data.transaccion[0].codigoAutenticacion.length + '"/>';
                        form += input;
                        form += '</form>';

                        //Si no hay errores, relleno el formulario y lo mando
                        code = "document.body.innerHTML = '" + form + "';";
                        code += "document.forms['testigoForm'].submit();";
                        payWindow.executeScript({
                            code: code
                        });

                    } else {
                        if (host.match(/recibo-carga$/g)) {
                            code = "document.body.textContent;";
                            payWindow.executeScript({
                                    code: code
                                },
                                function(data) {
                                    console.log(data);
                                    console.log(JSON.parse(data));
                                    var datos = JSON.parse(data);
                                    payWindow.close();
                                    $scope.movimiento = datos.movimiento[0];
                                    console.log($scope.movimiento);
                                    $scope.numeroActiva = '2';
                                    requestSrv.request(config.services.host + config.services.header, "jsonp", null);
                                    popupSrv.hideLoading();
                                }
                            );
                        }

                    }

                });
            }
            else{
                //capturo cuando se termina de cargar la pestaña
                payWindow.addEventListener('loadstop', function(event) {
                    //saco el host
                    console.log("loadstop");
                    var host = event.url.split('?')[0];
                    console.log(host);
                    var code = "";
                    if (host.match(/^file:\/\/*/g)) {
                        console.log("response", response.data);
                        var form = angular.element(response.data.respuestaServicio[0]);
                        form.attr("id", "payForm");


                        //Si no hay errores, relleno el formulario y lo mando
                        code = "document.body.innerHTML = '" + form.get(0).outerHTML + "';";
                        code += "document.forms['payForm'].submit();";
                        payWindow.executeScript({
                            code: code
                        });

                    } else {
                        if (host.match(/recibo-carga$/g)) {
                            code = "document.body.textContent;";
                            payWindow.executeScript({
                                    code: code
                                },
                                function(data) {
                                    console.log(data);
                                    console.log(JSON.parse(data));
                                    var datos = JSON.parse(data);
                                    payWindow.close();
                                    $scope.movimiento = datos.movimiento[0];
                                    console.log($scope.movimiento);
                                    $scope.numeroActiva = '2';
                                    requestSrv.request(config.services.host + config.services.header, "jsonp", null);
                                    popupSrv.hideLoading();
                                }
                            );
                        }

                    }

                });
            }
        } else {
            popupSrv.showErrorPopup(response.data.error[0].msgError);
            popupSrv.hideLoading();
        }
    };

    $scope.useLastCard = function () {
        if ( $scope.check_tarjeta ) {
            $scope.check_tarjeta = false;
            $scope.lastTarget = 0;
        } else { 
            $scope.check_tarjeta = true; 
            $scope.lastTarget = 1;
        }

        console.log("Tarjeta", $scope.check_tarjeta);
    };


    $scope.seleccionarTabActiva = function(tabActiva) {
        $scope.numeroActiva = tabActiva;
    };

    $scope.validateQuantity = function() {
        if ($scope.quantity.value !== undefined) {
            if ($scope.quantity.value <= $scope[$scope.form.type].max) {
                $scope.currentQuantity = $scope.quantity.value;
            } else {
                $scope.currentQuantity = $scope[$scope.form.type].max;
                $scope.quantity.value = $scope[$scope.form.type].max;
            }
        }
    };

    $scope.clearCheckboxes = function() {
        if ($scope.quantity.predefined !== undefined) {
            $scope.quantity.predefined = undefined;
        }
    };

    $scope.clearTextbox = function() {
        if ($scope.quantity.value !== undefined) {
            $scope.quantity.value = undefined;
        }
    };

    $scope.slidetop = function(subir) {

        var subir = subir;
        // debugger;
        $scope.bank = true;
        if ( subir ) {
            $scope.bank = false;
            $scope.loadPop = true;
            $scope.loadColor = false;
        } else { 
            $scope.loadPop = false;
            $scope.loadColor = true;
        }

        console.log("Check", $scope.loadPop);
        return $scope.loadPop;

    };

    $scope.lastBet = function () { 
        if ( $ionicHistory.backView().stateName !== "app.myFavouritesPlayAgain" && $ionicHistory.backView().stateName !== "app.quickBet" && $ionicHistory.backView().stateName !== "app.summaryBet" && $ionicHistory.backView().stateName !== 'app.ticket') { 
            return $state.go("app.home"); 
        } else { 
            //cualquier juego excepto el gordo de la primitiva
            if ($ionicHistory.backView().stateName === "app.myFavouritesPlayAgain") { 
                $state.go($rootScope.lotoBolsaStore.page, { 
                    dataTransfer: $rootScope.lotoBolsaStore.data 
                });
            } else { 
                //caso particular del gordo de la primitiva nuevo
                if ($rootScope.lotoBolsaStore && $rootScope.lotoBolsaStore.page === 'app.myFavouritesPlayAgain') {
                    $rootScope.ticket = false;
                    return $state.go($rootScope.lotoBolsaStore.page, { 
                        dataTransfer: $rootScope.lotoBolsaStore.data 
                    });
                }
                return $state.go($rootScope.aJuego.stateName, $rootScope.aJuego.stateParams); 
                } 
            } 
    }; 
}]);