angular.module('selae.user.controllers')

.controller('RegisterFormCtrl', ['$scope', '$stateParams', '$rootScope', 'requestSrv', 'config', '$http', 'popupSrv', '$ionicScrollDelegate', '$filter', '$ionicHistory', '$state', '$ionicPlatform', 'htmlModalSrv', '$sce', 'loginSrv',
    function($scope, $stateParams, $rootScope, requestSrv, config, $http, popupSrv, $ionicScrollDelegate, $filter, $ionicHistory, $state, $ionicPlatform, htmlModalSrv, $sce, loginSrv) {

        // funcionalidad para mover el popUp de google recaptcha2
        if ( window.innerWidth <= 414 ) {
            setTimeout( function() {
                $scope.obs = true;
                // selecciona el nodo target
                var target = document.getElementsByClassName('g-recaptcha-bubble-arrow');
                if ( target.length <= 4 ) {
                    target = target[length-1].parentNode;
                } else if (target.length > 4 && target.length <= 8 ) {
                    target = target[length+1].parentNode;
                } else if ( target.length < 8 ) {
                    target = target[length].parentNode;
                }
                // Crea el listener del nodo para su modificación cuando se cree
                var observer = new MutationObserver(function(mutations) {
                    mutations.forEach(function(mutation) {
                        console.log(mutation);
                        if ( target.style.left != '0px' ) {
                            // Cuando detecta un cambio en el nodo le pone el left a cero para cuadrarlo en pantallas pequeñas
                            target.style.left = '0px';
                        }
                    });
                });
                // Configura el observer:
                var config = { 
                    attributes: true,
                    attributeOldValue: true,
                    characterData: true,
                    characterDataOldValue: false,
                    childList: true,
                    subtree: true
                };
                // pasa al observer el nodo y la configuracion
                observer.observe(target, config);
            }, 5000);
        }

        setTimeout(function(){ popupSrv.hideLoading(); }, 2000);

        if ($stateParams.ocrData) {
            $scope.ocr = true;
            $scope.user = $stateParams.ocrData.user;
            $scope.rData = $stateParams.ocrData.adress || {};
        } else {
            $scope.user = {};
            $scope.rData = {};
        }

        $scope.tabActiva = function(tab) {
            $scope.tabActivas = 1;
            return tab;
        };

        //Como estas propiedades de textos para la tabla pueden tener elementos html, hay que transformarlos primero para que
        //se interpreten correctamente.
        $scope.regDataProtect_Text15 = $sce.trustAsHtml($filter('translate')('regDataProtect_Text15'));
        $scope.regDataProtect_Text16 = $sce.trustAsHtml($filter('translate')('regDataProtect_Text16'));

        if ( ionic.Platform.isAndroid() ) {
            $scope.android = true;
        } else {
            $scope.android = false;
        }

        //Arrays para los combos de fechas
        $scope.range = function(start,end){
            var array = [];
            for(var i = start ; i <= end ; i++)
                array.push(i);
            return array;
        };

        // create array of timestamps for 12 month of thr current year
        $scope.months  = [{ value: '01', text: "Enero" },
                            { value: '02', text: "Febrero" },
                            { value: '03', text: "Marzo" },
                            { value: '04', text: "Abril" },
                            { value: '05', text: "Mayo" },
                            { value: '06', text: "Junio" },
                            { value: '07', text: "Julio" },
                            { value: '08', text: "Agosto" },
                            { value: '09', text: "Septiembre" },
                            { value: '10', text: "Octubre" },
                            { value: '11', text: "Noviembre" },
                            { value: '12', text: "Diciembre" }];
        // Por defecto, la fecha de nacimento será 01/01/2000
        if (!$scope.ocr) {
            $scope.user.birthdate = {
                day: 1,
                month: {value:'01'},
                year : 2000
            };    
            //activar por defecto el tratamiento Sr.
            $scope.user.trt="Sr.";
        } 

        // Se pone a false al recibir la respuesta del captcha
        $scope.hasCaptcha = true;

        $scope.update = function(user,form) {

            if ($scope.hasCaptcha) {
                $scope.uCaptcha=true;
            }
            // funciona para controlar que no hay ningun error de validacion de front
            if ( !form.$valid || $scope.userFormError || $scope.hasCaptcha ) return false;

            $scope.params = angular.copy(user);

            $scope.params.dni = $scope.params.dni.toUpperCase();

            $scope.params.fechaNacDia = user.birthdate.day < 10 ? "0"+user.birthdate.day : user.birthdate.day.toString();
            $scope.params.fechaNacMes = user.birthdate.month.value !== undefined ? user.birthdate.month.value : user.birthdate.month;
            $scope.params.fechaNacAnio = user.birthdate.year.toString();
            // debugger;
            if ( $scope.recaptcha ) {
                $scope.uCaptcha = false;
                $scope.params['grecaptcharesponse'] = $scope.recaptcha;
            } else {
                $scope.uCaptcha = true;
            }
            $scope.tipoDNI = 'nif';
            delete $scope.params.birthdate;
            //ejecutamos la funcion que realiza la llamada
            $scope.registerFirstStep();
        };

        // funcion para mostrar el error del formulario en caso de ser por malos caracetéres
        $scope.valid = function(value, node) {
            
            var expReg = /["%()+<>\\]/;
            $scope[node] = expReg.test(value);

            // variable para el botón del formulario 1 y 2 la ponemos a false
            $scope.userFormError= false;
            $scope.userDataError = false;
            // comprobamos si el nodo contiene algún error y si pertenece a la primera o la segunda parte del formulario
            if ( $scope[node] == true) {
                // comprobamos las letras para saber a que formulario pertenece y bloquear la llamada al servicio
                if (node.indexOf('u',0) === 0) {
                    $scope.userFormError = true;
                } else {
                    $scope.userDataError = true;
                }
            } 
            return expReg.test(value);
        };

        $scope.resetValid = function(node) {
            return $scope[node] = false;
        };

        $scope.checkDocument = function (value) {
            $scope.esDni = false;
            if (!value) {
                $scope.uDni = true;
                return false;
            } 

            var validChars = 'TRWAGMYFPDXBNJZSQVHLCKET';
            var nifRexp = /^[0-9]{8}[TRWAGMYFPDXBNJZSQVHLCKET]{1}$/i;
            var nieRexp = /^[XYZ]{1}[0-9]{7}[TRWAGMYFPDXBNJZSQVHLCKET]{1}$/i;
            var str = value.toString().toUpperCase();

            function correctDNI(dni) {
                numero = dni.substr(0,dni.length-1);
                letr = dni.substr(dni.length-1,1);
                numero = numero % 23;
                // letra='TRWAGMYFPDXBNJZSQVHLCKET';
                validChars=validChars.substring(numero,numero+1);
               if (validChars!=letr.toUpperCase()) {
                  console.log('Dni erroneo');
                  $scope.uDni = true;
                } else {
                  console.log('Dni correcto');
                  $scope.uDni = false;
                  return true;
                }
            }

            function correctNIE() {
                var nie = str
                    .replace(/^[X]/, '0')
                    .replace(/^[Y]/, '1')
                    .replace(/^[Z]/, '2');
            
                var letter = str.substr(-1);
                var charIndex = parseInt(nie.substr(0, 8)) % 23;
            
                if (validChars.charAt(charIndex) === letter) {
                    $scope.uDni = false;
                    return true;
                } else {
                    $scope.uDni = true;
                    return false;
                }
            }
          
            // comprobamos que el valor tiene formato NIF o NIE y ejecutamos la funcion correspondiente
            if ( nifRexp.test(str) || nieRexp.test(str) ) {
                if ( nifRexp.test(str)) {
                    // comprobamos funcion dni
                    $scope.esDni = true;
                    correctDNI(value);
                } else {
                    // ejecutamos funcion comprobar NIE
                    $scope.esDni = false;
                    correctNIE();
                }

            } else {
                // no es un dni ni nif
                $scope.uDni = true;
                return false;
            }
        };

        $scope.registerFirstStep = function () {
            popupSrv.showLoading('Cargando');
            $ionicScrollDelegate.scrollTop();
            $http({
                method: 'POST',
                url: config.services.host + config.services.register,
                data: JSON.stringify($scope.params)
            }).then(function (e) {
                if ( e.data.error === true ) {
                    popupSrv.hideLoading();
                    popupSrv.showErrorPopup(e.data.msgError);
                    $scope.calls(); 
                    // return false;
                } else { 
                    $scope.calls();
                }
            }, function (error) {
                popupSrv.hideLoading();
                if ( error.data.error === true ) {
                    popupSrv.hideLoading();
                    popupSrv.showErrorPopup(error.data.msgError);
                }
            });
        }; 

        // funcion que se ejecutará a la respuesta de la primera parte del formulario
        $scope.calls = function() {
            var callConfig = {
                headers : {
                    "Content-Type": "application/json",
                },
                data : ''
            };

            $http.get( config.services.host + config.services.listaPaises, callConfig)
                .then(function(e){
                    $scope.listaPises = e.data.listaPises;
                    for ( i = 0; i < $scope.listaPises.length; i++) {
                        if ( $scope.listaPises[i].nombre === 'España' ) {
                            $scope.rData.paisResidencia = $scope.listaPises[i];
                            
                            if ( $scope.esDni || $scope.ocr === true ) {
                                $scope.rData.nacionalidad = $scope.listaPises[i];
                            }
                            
                            break;
                        }
                    }

                    $scope.callOk = true;

                    // $scope.rData.paisResidencia = $scope.codigoPuntoVenta[0];
                }), function(error) {
                    console.log("error",error);
                    popupSrv.hideLoading();
                    popupSrv.showErrorPopup(requestSrv.errorHandler2(error));
                    return false;
                };

                $http.get( config.services.host + config.services.serviciosAdicionales, callConfig)
                .then(function(e){
                    $scope.serviciosAdicionales = e.data.listadointereses;

                    $scope.rData.addServices = [];
                    $scope.rData.serviciosAdicionales = [];

                    $scope.serviciosAdicionales.forEach(function(elm,index) {
                        $scope.rData.addServices[index];
                        $scope.rData.addServices[index] = {
                            'value' : 'none'
                        };
                        
                        var datosdetipo = {
                            "identificadorServicioAdicional" : elm.identificadorServicioAdicional
                        };

                        var obj = {
                            "aceptado" : null,
                            "tipo" : datosdetipo
                        };

                        $scope.rData.serviciosAdicionales.push(obj);
                        $scope.tabActivas = 2;
                        popupSrv.hideLoading();
                    });

                }), function(error) {
                    console.log("error",error);
                    popupSrv.hideLoading();
                    popupSrv.showErrorPopup(requestSrv.errorHandler2(error));
                    return false;
                };
            };

        $scope.noSpain = function() {
            if (  $scope.otherCountry ) {
                $scope.rData.otherCountry = false;
                $scope.otherCountry = false;
                for ( i = 0; i < $scope.listaPises.length; i++) {
                    if ( $scope.listaPises[i].nombre === 'España' ) {
                        $scope.rData.paisResidencia = $scope.listaPises[i];
                        break;
                    }
                }
            } else { 
                $scope.otherCountry = true;
                $scope.rData.codigoPostal = "98000";
                $scope.rData.paisResidencia = null;
                $scope.rData.cp = String(Math.round(Math.random()*(51999-1000)) + 1000);
                $scope.getClub($scope.rData.cp);
                $scope.rData.provincia = "98";
            }

        };
        
        $scope.regionesFiscalesCallback = function(data) {
            console.log("regionCalback",data);
        };
            
        $scope.validatePassword = function (pass) {
            // debugger;

            //Expresiones a evaluar en el password
            //1 número. 2 letra minúscula. 3 letra mayúscula. 4 caracteres especiales permitidos
            //la cadena tiene que contener al menos tres grupos de estos caracteres
            let expresiones = [ /[0-9]/, /[a-zñ]/, /[A-ZÑ]/, /[_$#!¡@\-?¿&]/];
            let positives = 0;

            for(let expr of expresiones) {
                if(expr.test(pass)) {
                    positives++;
                }
            }
            // punto 2
            if ( positives < 3) {
                $scope.rPassword = true;
                $scope.userDataError = true;
                return false;
            } else {
                $scope.passContainsData(pass);
            }
        };

        $scope.passContainsData = function(pass) {
            // Punto 3
            if( pass.indexOf($scope.params.nombre) !== -1 || pass.indexOf($scope.params.apellido1) !== -1 || pass.indexOf($scope.params.apellido2)!== -1 || pass.indexOf($scope.params.dni)!== -1 ){
                $scope.rPassword = true;
                $scope.userDataError = true;
            }

            // Punto 4
            var fullDia = $scope.params.fechaNacDia;
            var fullMes = $scope.params.fechaNacMes;
            var fullAnio = $scope.params.fechaNacAnio;

            var minMes;
            var minDia;
            var minAnio = fullAnio.slice(2,4);

            var birthdate = [];

            if ( Number(fullDia) < 10 ) {
                minDia = fullDia.slice(1,2);
            }

            if ( Number(fullMes) < 10 ) {
                minMes = fullMes.slice(1,2);
            }

            // punto 4
            birthdate.push(fullDia + fullMes + fullAnio);
            birthdate.push(fullDia + fullMes + minAnio);

            if ( minMes) {
                birthdate.push(fullDia + minMes + fullAnio);
                birthdate.push(fullDia + minMes + minAnio);
            }

            if ( minDia ) {
                birthdate.push(minDia + fullMes + fullAnio);
                birthdate.push(minDia + fullMes + minAnio);
                if ( minMes ) {
                    birthdate.push(minDia + minMes + fullAnio);
                    birthdate.push(minDia + minMes + minAnio);
                }
            }

            for ( i=0; i < birthdate.length; i++) {
                    if ( pass.indexOf(birthdate[i]) !== -1 ) {
                        $scope.rPassword = true;
                        break;
                    }
            }

            if(!$scope.rPassword) {
                $scope.userDataError = false;
            } else {
                $scope.userDataError = true;
            }
        };

        $scope.validateTelefoneNumber = function(tlf) {

            if ( isNaN(Number(tlf))) {
                $scope.userDataError = true;
                return $scope.rTelefono = true;
            } 

            var regExpMovil = /^[6]\d{8}$|^7[1-4]\d{7}$/;
            var regExpFijo = /^[8,9][1-9]\d{7}$/;
            if(regExpMovil.test(tlf) || regExpFijo.test(tlf)) {
                $scope.rTelefono = false;
                $scope.userDataError = false;
            } else {
                $scope.rTelefono = true; 
                $scope.userDataError = true;
                $scope.params2.tipoTelefono = null;
            }
        };
        
        $scope.randomNumber = function (max) {
            return Math.round(Math.random()*(max-0));
        };
        
        $scope.getClub = function(cp) {
    
            $http.get('https://www.loteriasyapuestas.es/servicios/puntoVentaPorCodigoPostal/?codigoPostal='+cp+'&aleatorio=0')
            .then(function(response) {
                // debugger;
                $scope.codigoPuntoVenta = response.data.listadoReceptores;

                // Lanzamos la funcion de random para que nos de algo dentro del rango.
                $scope.randomCPV = $scope.randomNumber( $scope.codigoPuntoVenta.length - 1 );

                $scope.rData.codigoPuntoVenta = $scope.codigoPuntoVenta[$scope.randomCPV].receptor;
                console.log("codigo punto de venta",$scope.rData.codigoPuntoVenta);

                $scope.getListaRegiones(cp);
                $scope.getProvincias(cp);

                console.log("Despues de lista de regiones");
                }, function(error) {
                console.log("error");
                });
        };

        $scope.getListaRegiones = function (cp) {
            cp = cp.slice(0,2);

            var callConfig = {
                headers : {
                    "Content-Type": "application/json",
                },
                data : ''
            };
            console.log("lanzamos regiones fiscales");
            //desco,entar para produccion
            // $http.get( 'https://www.loteriasyapuestas.es/f/loterias/multimedia/AppAndroid/regionesFiscales.json', callConfig)
            // llamada para int3
            $http.get( 'https://int3sagajuegos.loteriasyapuestas.es/loterias/estaticos/regionesFiscales.json', callConfig)
                .then(function(e){
                    console.log("respuesta de regiones fiscales")
                    $scope.regionFiscal = e.data.regionesFiscales;
                    for ( i=0; i< $scope.regionFiscal.length; i++ ) {
                        if( $scope.regionFiscal[i].codigo === cp ) {
                            $scope.rData.regionFiscal = $scope.regionFiscal[i].codigoRegionFiscal;
                            break;
                        } else {
                            $scope.rData.regionFiscal = $scope.regionFiscal[$scope.regionFiscal.length-1].codigoRegionFiscal;
                        }
                    }

                }), function(error) {
                    console.log("respuesta de regiones fiscales")
                    console.log("error",error);
                };

        };

        $scope.getProvincias = function(cp) {
            cp = cp.slice(0,2);
            var callConfig = {
                headers : {
                    "Content-Type": "application/json",
                },
                data : ''
            }
            $http.get(config.services.host+config.services.listaProvincias,callConfig)
            .then(function(response) {
                    $scope.listaProvincias = response.data.listaProvincias;
                    for ( i=0; i< $scope.listaProvincias.length; i++ ) {
                        if( $scope.listaProvincias[i].codigo === cp ) {
                            // $scope.provincia = $scope.listaProvincias[i];
                            $scope.rData.provincia = $scope.listaProvincias[i].codigo;
                            break;
                        }
                    }
                }, function(response) {
                // called asynchronously if an error occurs
                // or server returns response with an error status.
                console.log("error fallo provincias")
                });
            

            // $scope.rData.regionesFiscales
        };

        //  se borrará cuando SELAE nos confirme que solo necesitamos rellenar apartado uno del formulario
        // if ($scope.ocr) {
        //     $scope.getClub($scope.rData.codigoPostal);
        // }

        $scope.getContratoJuegos = function () {
            htmlModalSrv.show($scope, "contratoJuegos", null, null);
        };

        $scope.allAditionalServices = function () {
            $scope.serviciosAdicionales.forEach(function(elm, index) {
                $scope.addServices ( true, elm.identificadorServicioAdicional, index);
            });
        }

        $scope.addServices = function ( boolean, id, index ) {
            // debugger;
            if (!boolean) {
                $scope.rData.checkAddServices = false;
            }

            $scope.rData.serviciosAdicionales[index].aceptado = boolean;

            $scope.rData.addServices[index].value = boolean;
        }

        $scope.updateData = function ( rData, form ) {
            // comprobamos si hemos seleccionado todos los servicios adicionales
            for ( i = 0; i< $scope.rData.serviciosAdicionales.length; i++) {
               if ( $scope.rData.serviciosAdicionales[i].aceptado === null ) {
                   $scope.checkAddServices = false;
                   return
               } else { $scope.checkAddServices = true; }
            };

            // si falta algun servicio add
            if ( !$scope.checkAddServices || !form.$valid || $scope.userDataError ) return false;

            // hacemos copia del formulario y creamos datos para llamada 2
            $scope.params2 = angular.copy(rData);

            // añadimos los datos que faltan y que van por defecto
            $scope.params2.idioma = 'es';
            $scope.params2.nacionalidad = $scope.params2.nacionalidad.codigo;
            $scope.params2.paisResidencia = $scope.params2.paisResidencia.codigo;
            $scope.params2.contratoAceptado = 1;

            let regExpFijo = /^[8,9][1-9]\d{7}$/;
            $scope.params2.tipoTelefono = regExpFijo.test($scope.params2.telefono) ? "f" : "m"
            //Para int3 hay que poner el codigo del punto de venta a 11335, si no el servicio paso2 devolverá error
            $scope.params2.codigoPuntoVenta = selae.entorno === 'int3' ? "11335" : $scope.params2.codigoPuntoVenta; 
            $scope.params2.codTelefono = $scope.params2.codTelefono || "";
            $scope.params2.cb1 = "";
            $scope.params2.cb2 = "";
            $scope.params2.cb3 = "";
            $scope.params2.cb4 = "";
            $scope.params2.cb5 = "";

            delete $scope.params2.addServices;
            delete $scope.params2.checkAddServices;
            delete $scope.params2.checkAllServices;
            delete $scope.params2.otherCountry;
            delete $scope.params2.cp;

            $scope.registerSecondStep();
        }

        $scope.registerSecondStep = function() {
            popupSrv.showLoading('Cargando');
            $http({
                method: 'POST',
                url: config.services.host + config.services.register2ndStep,
                data: JSON.stringify($scope.params2)
            }).then(function (e) { 

                popupSrv.hideLoading();
                //Se hace login "oculto" si todo va bien.
                loginSrv.login($scope, $scope.params.dni, $scope.params2.password, "registro");
                             
            }, function (error) {
                // ocultamos el popUp
                popupSrv.hideLoading();
                // si viene campo de error a true
                if ( error.data.error === true ) {
                    // si es el error del telefono añadimos al formulario el campo codigo telefono
                    if ( error.data.msgError === "SAGA-USU-PART-12003" ) {
                        $scope.needTlfCode = true;
                    }

                    //Si el error no es un error que comience con el código SAGAWEB-REST-REG hay que volver a lanzar la llamada al paso 1 antes del 2
                    if( !error.data.msgError.startsWith('SAGAWEB-REST-REG') ) {
                        $http({
                            method: 'POST',
                            url: config.services.host + config.services.register,
                            data: JSON.stringify($scope.params)
                        }).then(function (e) {
                            if ( e.data.error === true ) {
                                popupSrv.showErrorPopup(e.data.msgError);
                            } 
                        }, function (error) {
                            if ( error.data.error === true ) {
                                popupSrv.showErrorPopup(error.data.msgError);
                            }
                        });
                    }

                    popupSrv.hideLoading();
                    popupSrv.showErrorPopup(error.data.msgError);
                }
            });
            //al error de codigo de telfono se muestra popUp de error y se pone la variabla true para msotrar en formulario
        }

        // para setear los servicios adicionales despues del paso 2 tenemos que hacer un login
        // POST: https:// int3sagajuegos.loteriasyapuestas.es /jugar/loginJson?dni_nie=XXXXXXX&password=XXXXXXXX
        
        
        
        //recaptcha web
        if ( $scope.android == false) {
            //<script src="https://www.google.com/recaptcha/api.js" async defer></script>
            tokenResponse = function () {
                return new Promise(function(resolve, reject) { 

                    var response = grecaptcha.getResponse();
                    console.log("response",response)

                    if (!response) {
                        grecaptcha.reset();
                        reject();
                    } else {
                        $scope.recaptcha = response;
                        $scope.hasCaptcha = false;
                        $scope.uCaptcha = false;
                        $scope.$apply();
                    }
                
                    resolve();
                
                });
            }

                var onloadCallback = function() {
                    grecaptcha.render('captcha', {
                        'sitekey' : '6LcHNyMTAAAAANnwGfZpd08d3ziDvgq2AQmf5SDJ',
                        'callback' : 'tokenResponse'
                    });
                };
                onloadCallback();
            } else {
                // plugin de android
                $scope.captcha = function() {
                    $scope.workingCaptcha = true;
                    window.plugins.recaptcha.verify('6LfFwZIUAAAAAGT9f9LFzTtU1jhy-1o61u3TsiEc', 
                        function(responseToken) {
                            // Do what you need to with responseToken
                            $scope.recaptcha = responseToken;
                            $scope.hasCaptcha = false;
                            $scope.$apply();
                            // console.log(responseToken)
                        }, function(error) {
                            // Do what you need to with the error
                            $scope.workingCaptcha = false;
                            // console.log(error);
                        });
                };
            }

            // ********* DATOS MOCKEADOS ***********/

        // $scope.listaRegiones = [{"identificador": 1,"codigo": "01","nombre": "Comunidad Autónoma de Andalucía"},{"identificador": 2,"codigo": "02","nombre": "Comunidad Autónoma de Aragón"},{"identificador": 3,"codigo": "03","nombre": "Comunidad Autónoma del Principado de Asturias"},{"identificador": 4,"codigo": "04","nombre": "Comunidad Autónoma de Canarias"},{"identificador": 5,"codigo": "05","nombre": "Comunidad Autónoma de Cantabria"},{"identificador": 6,"codigo": "06","nombre": "Comunidad Autónoma de Castilla - La Mancha"},{"identificador": 7,"codigo": "07","nombre": "Comunidad de Castilla y León"},{"identificador": 8,"codigo": "08","nombre": "Comunidad Autónoma de Cataluña"},{"identificador": 9,"codigo": "09","nombre": "Comunidad Autónoma de Extremadura"},{"identificador": 10,"codigo": "10","nombre": "Comunidad Autónoma de Galicia"},{"identificador": 11,"codigo": "11","nombre": "Comunidad Autónoma de las Illes Balears"},{"identificador": 12,"codigo": "12","nombre": "Comunidad Autónoma de La Rioja"},{"identificador": 13,"codigo": "13","nombre": "Comunidad de Madrid"},{"identificador": 14,"codigo": "14","nombre": "Comunidad Autónoma de la Región de Murcia"},{"identificador": 15,"codigo": "15","nombre": "Comunitat Valenciana"},{"identificador": 16,"codigo": "16","nombre": "Comunidad Foral de Navarra"},{"identificador": 17,"codigo": "17","nombre": "Territorio Histórico de Araba"},{"identificador": 18,"codigo": "18","nombre": "Territorio Histórico de Gipuzkoa"},{"identificador": 19,"codigo": "19","nombre": "Territorio Histórico de Bizkaia"},{"identificador": 20,"codigo": "20","nombre": "Ceuta"},{"identificador": 21,"codigo": "21","nombre": "Melilla"},{"identificador": 22,"codigo": "22","nombre": "No residentes"}];

        // $scope.listaPises = [{"idPais":126,"nombre":"ARY Macedonia","codigo":"MK"},{"idPais":1,"nombre":"Abjasia","codigo":"QM"},{"idPais":2,"nombre":"Acrotiri y Dhekelia","codigo":"QN"},{"idPais":3,"nombre":"Afganistán","codigo":"AF"},{"idPais":5,"nombre":"Albania","codigo":"AL"},{"idPais":6,"nombre":"Alemania","codigo":"DE"},{"idPais":7,"nombre":"Andorra","codigo":"AD"},{"idPais":8,"nombre":"Angola","codigo":"AO"},{"idPais":9,"nombre":"Anguila","codigo":"AI"},{"idPais":10,"nombre":"Antigua y Barbuda","codigo":"AG"},{"idPais":11,"nombre":"Antillas Neerlandesas","codigo":"AN"},{"idPais":247,"nombre":"Antártida","codigo":"AQ"},{"idPais":12,"nombre":"Arabia Saudita","codigo":"SA"},{"idPais":13,"nombre":"Argelia","codigo":"DZ"},{"idPais":14,"nombre":"Argentina","codigo":"AR"},{"idPais":15,"nombre":"Armenia","codigo":"AM"},{"idPais":16,"nombre":"Aruba","codigo":"AW"},{"idPais":18,"nombre":"Australia","codigo":"AU"},{"idPais":19,"nombre":"Austria","codigo":"AT"},{"idPais":20,"nombre":"Azerbaiyán","codigo":"AZ"},{"idPais":21,"nombre":"Bahamas","codigo":"BS"},{"idPais":22,"nombre":"Bahréin","codigo":"BH"},{"idPais":23,"nombre":"Bangladesh","codigo":"BD"},{"idPais":24,"nombre":"Barbados","codigo":"BB"},{"idPais":26,"nombre":"Belice","codigo":"BZ"},{"idPais":27,"nombre":"Benín","codigo":"BJ"},{"idPais":28,"nombre":"Bermudas","codigo":"BM"},{"idPais":29,"nombre":"Bielorrusia","codigo":"BY"},{"idPais":30,"nombre":"Bolivia","codigo":"BO"},{"idPais":248,"nombre":"Bonaire, San Eustaquio y Saba","codigo":"BQ"},{"idPais":31,"nombre":"Bosnia y Herzegovina","codigo":"BA"},{"idPais":32,"nombre":"Botsuana","codigo":"BW"},{"idPais":249,"nombre":"Bouvet, Isla","codigo":"BV"},{"idPais":33,"nombre":"Brasil","codigo":"BR"},{"idPais":34,"nombre":"Brunéi","codigo":"BN"},{"idPais":35,"nombre":"Bulgaria","codigo":"BG"},{"idPais":36,"nombre":"Burkina Faso","codigo":"BF"},{"idPais":37,"nombre":"Burundi","codigo":"BI"},{"idPais":38,"nombre":"Bután","codigo":"BT"},{"idPais":25,"nombre":"Bélgica","codigo":"BE"},{"idPais":39,"nombre":"Cabo Verde","codigo":"CV"},{"idPais":41,"nombre":"Camboya","codigo":"KH"},{"idPais":42,"nombre":"Camerún","codigo":"CM"},{"idPais":43,"nombre":"Canadá","codigo":"CA"},{"idPais":44,"nombre":"Chad","codigo":"TD"},{"idPais":45,"nombre":"Chile","codigo":"CL"},{"idPais":46,"nombre":"China","codigo":"CN"},{"idPais":47,"nombre":"Chipre","codigo":"CY"},{"idPais":48,"nombre":"Chipre Septentrional","codigo":"QO"},{"idPais":237,"nombre":"Ciudad del Vaticano","codigo":"VA"},{"idPais":50,"nombre":"Colombia","codigo":"CO"},{"idPais":51,"nombre":"Comoras","codigo":"KM"},{"idPais":55,"nombre":"Corea del Norte","codigo":"KP"},{"idPais":56,"nombre":"Corea del Sur","codigo":"KR"},{"idPais":58,"nombre":"Costa Rica","codigo":"CR"},{"idPais":57,"nombre":"Costa de Marfil","codigo":"CI"},{"idPais":59,"nombre":"Croacia","codigo":"HR"},{"idPais":60,"nombre":"Cuba","codigo":"CU"},{"idPais":250,"nombre":"Curaçao","codigo":"CW"},{"idPais":61,"nombre":"Dinamarca","codigo":"DK"},{"idPais":62,"nombre":"Dominica","codigo":"DM"},{"idPais":63,"nombre":"Ecuador","codigo":"EC"},{"idPais":64,"nombre":"Egipto","codigo":"EG"},{"idPais":65,"nombre":"El Salvador","codigo":"SV"},{"idPais":66,"nombre":"Emiratos Árabes Unidos","codigo":"AE"},{"idPais":67,"nombre":"Eritrea","codigo":"ER"},{"idPais":68,"nombre":"Eslovaquia","codigo":"SK"},{"idPais":69,"nombre":"Eslovenia","codigo":"SI"},{"idPais":70,"nombre":"España","codigo":"ES"},{"idPais":71,"nombre":"Estados Unidos","codigo":"US"},{"idPais":72,"nombre":"Estonia","codigo":"EE"},{"idPais":73,"nombre":"Etiopía","codigo":"ET"},{"idPais":75,"nombre":"Filipinas","codigo":"PH"},{"idPais":76,"nombre":"Finlandia","codigo":"FI"},{"idPais":77,"nombre":"Fiyi","codigo":"FJ"},{"idPais":78,"nombre":"Francia","codigo":"FR"},{"idPais":79,"nombre":"Gabón","codigo":"GA"},{"idPais":80,"nombre":"Gambia","codigo":"GM"},{"idPais":81,"nombre":"Georgia","codigo":"GE"},{"idPais":253,"nombre":"Georgia del Sur (la) y las Islas Sandwich del Sur","codigo":"GS"},{"idPais":82,"nombre":"Ghana","codigo":"GH"},{"idPais":83,"nombre":"Gibraltar","codigo":"GI"},{"idPais":84,"nombre":"Granada","codigo":"GD"},{"idPais":85,"nombre":"Grecia","codigo":"GR"},{"idPais":86,"nombre":"Groenlandia","codigo":"GL"},{"idPais":252,"nombre":"Guadeloupe","codigo":"GP"},{"idPais":87,"nombre":"Guam","codigo":"GU"},{"idPais":88,"nombre":"Guatemala","codigo":"GT"},{"idPais":251,"nombre":"Guayana Francesa","codigo":"GF"},{"idPais":89,"nombre":"Guernsey","codigo":"GG"},{"idPais":90,"nombre":"Guinea","codigo":"GN"},{"idPais":91,"nombre":"Guinea Ecuatorial","codigo":"GQ"},{"idPais":92,"nombre":"Guinea-Bissau","codigo":"GW"},{"idPais":93,"nombre":"Guyana","codigo":"GY"},{"idPais":94,"nombre":"Haití","codigo":"HT"},{"idPais":254,"nombre":"Heard (Isla) e Islas McDonald","codigo":"HM"},{"idPais":95,"nombre":"Honduras","codigo":"HN"},{"idPais":96,"nombre":"Hong Kong","codigo":"HK"},{"idPais":97,"nombre":"Hungría","codigo":"HU"},{"idPais":98,"nombre":"India","codigo":"IN"},{"idPais":99,"nombre":"Indonesia","codigo":"ID"},{"idPais":101,"nombre":"Iraq","codigo":"IQ"},{"idPais":102,"nombre":"Irlanda","codigo":"IE"},{"idPais":100,"nombre":"Irán","codigo":"IR"},{"idPais":134,"nombre":"Isla de Man","codigo":"IM"},{"idPais":152,"nombre":"Isla de Navidad","codigo":"CX"},{"idPais":103,"nombre":"Islandia","codigo":"IS"},{"idPais":40,"nombre":"Islas Caimán","codigo":"KY"},{"idPais":49,"nombre":"Islas Cocos","codigo":"CC"},{"idPais":54,"nombre":"Islas Cook","codigo":"CK"},{"idPais":74,"nombre":"Islas Feroe","codigo":"FO"},{"idPais":133,"nombre":"Islas Malvinas","codigo":"FK"},{"idPais":135,"nombre":"Islas Marianas del Norte","codigo":"MP"},{"idPais":137,"nombre":"Islas Marshall","codigo":"MH"},{"idPais":173,"nombre":"Islas Pitcairn","codigo":"PN"},{"idPais":189,"nombre":"Islas Salomón","codigo":"SB"},{"idPais":228,"nombre":"Islas Turcas y Caicos","codigo":"TC"},{"idPais":261,"nombre":"Islas Ultramarinas Menores de los Estados Unidos","codigo":"UM"},{"idPais":240,"nombre":"Islas Vírgenes Británicas","codigo":"VG"},{"idPais":241,"nombre":"Islas Vírgenes Estadounidenses","codigo":"VI"},{"idPais":104,"nombre":"Israel","codigo":"IL"},{"idPais":105,"nombre":"Italia","codigo":"IT"},{"idPais":106,"nombre":"Jamaica","codigo":"JM"},{"idPais":107,"nombre":"Japón","codigo":"JP"},{"idPais":108,"nombre":"Jersey","codigo":"JE"},{"idPais":109,"nombre":"Jordania","codigo":"JO"},{"idPais":110,"nombre":"Kazajistán","codigo":"KZ"},{"idPais":111,"nombre":"Kenia","codigo":"KE"},{"idPais":112,"nombre":"Kirguistán","codigo":"KG"},{"idPais":113,"nombre":"Kiribati","codigo":"KI"},{"idPais":115,"nombre":"Kuwait","codigo":"KW"},{"idPais":116,"nombre":"Laos","codigo":"LA"},{"idPais":117,"nombre":"Lesoto","codigo":"LS"},{"idPais":118,"nombre":"Letonia","codigo":"LV"},{"idPais":120,"nombre":"Liberia","codigo":"LR"},{"idPais":121,"nombre":"Libia","codigo":"LY"},{"idPais":122,"nombre":"Liechtenstein","codigo":"LI"},{"idPais":123,"nombre":"Lituania","codigo":"LT"},{"idPais":124,"nombre":"Luxemburgo","codigo":"LU"},{"idPais":119,"nombre":"Líbano","codigo":"LB"},{"idPais":125,"nombre":"Macao","codigo":"MO"},{"idPais":127,"nombre":"Madagascar","codigo":"MG"},{"idPais":128,"nombre":"Malasia","codigo":"MY"},{"idPais":129,"nombre":"Malawi","codigo":"MW"},{"idPais":130,"nombre":"Maldivas","codigo":"MV"},{"idPais":132,"nombre":"Malta","codigo":"MT"},{"idPais":131,"nombre":"Malí","codigo":"ML"},{"idPais":136,"nombre":"Marruecos","codigo":"MA"},{"idPais":256,"nombre":"Martinique","codigo":"MQ"},{"idPais":138,"nombre":"Mauricio","codigo":"MU"},{"idPais":139,"nombre":"Mauritania","codigo":"MR"},{"idPais":140,"nombre":"Mayotte","codigo":"YT"},{"idPais":142,"nombre":"Micronesia","codigo":"FM"},{"idPais":143,"nombre":"Moldavia","codigo":"MD"},{"idPais":145,"nombre":"Mongolia","codigo":"MN"},{"idPais":146,"nombre":"Montenegro","codigo":"ME"},{"idPais":147,"nombre":"Montserrat","codigo":"MS"},{"idPais":148,"nombre":"Mozambique","codigo":"MZ"},{"idPais":149,"nombre":"Myanmar","codigo":"MM"},{"idPais":141,"nombre":"México","codigo":"MX"},{"idPais":144,"nombre":"Mónaco","codigo":"MC"},{"idPais":150,"nombre":"Nagorno-Karabaj","codigo":"QP"},{"idPais":151,"nombre":"Namibia","codigo":"NA"},{"idPais":153,"nombre":"Nauru","codigo":"NR"},{"idPais":154,"nombre":"Nepal","codigo":"NP"},{"idPais":155,"nombre":"Nicaragua","codigo":"NI"},{"idPais":157,"nombre":"Nigeria","codigo":"NG"},{"idPais":158,"nombre":"Niue","codigo":"NU"},{"idPais":159,"nombre":"Norfolk","codigo":"NF"},{"idPais":160,"nombre":"Noruega","codigo":"NO"},{"idPais":161,"nombre":"Nueva Caledonia","codigo":"NC"},{"idPais":162,"nombre":"Nueva Zelanda","codigo":"NZ"},{"idPais":156,"nombre":"Níger","codigo":"NE"},{"idPais":163,"nombre":"Omán","codigo":"OM"},{"idPais":164,"nombre":"Osetia del Sur","codigo":"QQ"},{"idPais":166,"nombre":"Pakistán","codigo":"PK"},{"idPais":167,"nombre":"Palaos","codigo":"PW"},{"idPais":168,"nombre":"Palestina - ANP","codigo":"PS"},{"idPais":169,"nombre":"Panamá","codigo":"PA"},{"idPais":170,"nombre":"Papúa Nueva Guinea","codigo":"PG"},{"idPais":171,"nombre":"Paraguay","codigo":"PY"},{"idPais":165,"nombre":"Países Bajos","codigo":"NL"},{"idPais":172,"nombre":"Perú","codigo":"PE"},{"idPais":174,"nombre":"Polinesia Francesa","codigo":"PF"},{"idPais":175,"nombre":"Polonia","codigo":"PL"},{"idPais":176,"nombre":"Portugal","codigo":"PT"},{"idPais":177,"nombre":"Puerto Rico","codigo":"PR"},{"idPais":178,"nombre":"Puntland","codigo":"QR"},{"idPais":179,"nombre":"Qatar","codigo":"QA"},{"idPais":180,"nombre":"Reino Unido","codigo":"GB"},{"idPais":181,"nombre":"República Centroafricana","codigo":"CF"},{"idPais":182,"nombre":"República Checa","codigo":"CZ"},{"idPais":53,"nombre":"República Democrática del Congo","codigo":"CD"},{"idPais":183,"nombre":"República Dominicana","codigo":"DO"},{"idPais":52,"nombre":"República del Congo","codigo":"CG"},{"idPais":257,"nombre":"Reunión","codigo":"RE"},
        // {"idPais":184,"nombre":"Ruanda","codigo":"RW"},{"idPais":185,"nombre":"Rumania","codigo":"RO"},{"idPais":186,"nombre":"Rusia","codigo":"RU"},{"idPais":187,"nombre":"Sahara Occidental","codigo":"EH"},{"idPais":190,"nombre":"Samoa","codigo":"WS"},{"idPais":191,"nombre":"Samoa Americana","codigo":"AS"},{"idPais":192,"nombre":"San Bartolomé","codigo":"BL"},{"idPais":193,"nombre":"San Cristóbal y Nieves","codigo":"KN"},{"idPais":194,"nombre":"San Marino","codigo":"SM"},{"idPais":195,"nombre":"San Martín - Colectividad Francesa de Ultramar","codigo":"MF"},{"idPais":188,"nombre":"San Pedro y Miquelón","codigo":"PM"},{"idPais":196,"nombre":"San Vicente y las Granadinas","codigo":"VC"},{"idPais":197,"nombre":"Santa Elena, Ascensión y Tristán de Acuña","codigo":"SH"},{"idPais":198,"nombre":"Santa Lucía","codigo":"LC"},{"idPais":199,"nombre":"Santo Tomé y Príncipe","codigo":"ST"},{"idPais":200,"nombre":"Senegal","codigo":"SN"},{"idPais":201,"nombre":"Serbia","codigo":"RS"},{"idPais":202,"nombre":"Seychelles","codigo":"SC"},{"idPais":203,"nombre":"Sierra Leona","codigo":"SL"},{"idPais":204,"nombre":"Singapur","codigo":"SG"},{"idPais":259,"nombre":"Sint Maarten (parte neerlandesa)","codigo":"SX"},{"idPais":205,"nombre":"Siria","codigo":"SY"},{"idPais":206,"nombre":"Somalia","codigo":"SO"},{"idPais":207,"nombre":"Somalilandia","codigo":"QS"},{"idPais":208,"nombre":"Sri Lanka","codigo":"LK"},{"idPais":209,"nombre":"Suazilandia","codigo":"SZ"},{"idPais":210,"nombre":"Sudáfrica","codigo":"ZA"},{"idPais":211,"nombre":"Sudán","codigo":"SD"},{"idPais":258,"nombre":"Sudán del Sur","codigo":"SS"},{"idPais":212,"nombre":"Suecia","codigo":"SE"},{"idPais":213,"nombre":"Suiza","codigo":"CH"},{"idPais":214,"nombre":"Surinam","codigo":"SR"},{"idPais":215,"nombre":"Svalbard - Territorio de Noruega","codigo":"SJ"},{"idPais":216,"nombre":"Tailandia","codigo":"TH"},{"idPais":217,"nombre":"Taiwán","codigo":"TW"},{"idPais":218,"nombre":"Tanzania","codigo":"TZ"},{"idPais":219,"nombre":"Tayikistán","codigo":"TJ"},{"idPais":255,"nombre":"Territorio Británico del Océano Índico ","codigo":"IO"},{"idPais":260,"nombre":"Tierras Australes Francesas","codigo":"TF"},{"idPais":220,"nombre":"Timor Oriental","codigo":"TL"},{"idPais":221,"nombre":"Togo","codigo":"TG"},{"idPais":222,"nombre":"Tokelau","codigo":"TK"},{"idPais":223,"nombre":"Tonga","codigo":"TO"},{"idPais":224,"nombre":"Transnistria","codigo":"QT"},{"idPais":225,"nombre":"Trinidad y Tobago","codigo":"TT"},{"idPais":229,"nombre":"Turkmenistán","codigo":"TM"},{"idPais":230,"nombre":"Turquía","codigo":"TR"},{"idPais":231,"nombre":"Tuvalu","codigo":"TV"},{"idPais":227,"nombre":"Túnez","codigo":"TN"},{"idPais":232,"nombre":"Ucrania","codigo":"UA"},{"idPais":233,"nombre":"Uganda","codigo":"UG"},{"idPais":234,"nombre":"Uruguay","codigo":"UY"},{"idPais":235,"nombre":"Uzbekistán","codigo":"UZ"},{"idPais":236,"nombre":"Vanuatu","codigo":"VU"},{"idPais":238,"nombre":"Venezuela","codigo":"VE"},{"idPais":239,"nombre":"Vietnam","codigo":"VN"},{"idPais":242,"nombre":"Wallis y Futuna","codigo":"WF"},{"idPais":243,"nombre":"Yemen","codigo":"YE"},{"idPais":244,"nombre":"Yibuti","codigo":"DJ"},{"idPais":245,"nombre":"Zambia","codigo":"ZM"},{"idPais":246,"nombre":"Zimbabue","codigo":"ZW"},{"idPais":4,"nombre":"Åland","codigo":"AX"}]
            

        // $scope.serviciosAdicionales = 	
        // {"error":false,"msgError":"","listadointereses":[{"identificadorServicioAdicional":1400,"codigoServicioAdicional":"EMAIL_COMUNICACIONES","descripcionServicioAdicional":"Comunicaciones de próximos sorteos, resultados y servicios adicionales por correo electrónico","obligatorio":true},{"identificadorServicioAdicional":1401,"codigoServicioAdicional":"EMAIL_COMERCIAL","descripcionServicioAdicional":"Información comercial sobre nuevos productos y servicios por correo electrónico","obligatorio":true},{"identificadorServicioAdicional":1402,"codigoServicioAdicional":"EMAIL_ENCUESTAS","descripcionServicioAdicional":"Encuestas por correo electrónico","obligatorio":true},{"identificadorServicioAdicional":2400,"codigoServicioAdicional":"SMS_COMUNICACION","descripcionServicioAdicional":"Comunicaciones de próximos sorteos, resultados y servicios adicionales por SMS","obligatorio":true},{"identificadorServicioAdicional":2401,"codigoServicioAdicional":"SMS_COMERCIAL","descripcionServicioAdicional":"Información comercial sobre nuevos productos y servicios por SMS","obligatorio":true},{"identificadorServicioAdicional":2402,"codigoServicioAdicional":"SMS_INFO_SERVICIO","descripcionServicioAdicional":"Encuestas por SMS","obligatorio":true}]}
            $scope.openRecomendations = function () {
                window.open($filter('translate')('regRecomendacionesPasswUrl'));
            };

}]);