angular.module('selae.user.controllers')

.controller('RegisterRouteCtrl', ['$scope', '$rootScope', 'popupSrv', '$http', 'requestSrv', 'config','$state', '$ionicPlatform', 'analyticsSrv',
    function($scope, $rootScope, popupSrv, $http ,requestSrv, config, $state , $ionicPlatform, analyticsSrv) {

        $scope.$on('$ionicView.beforeEnter', function (event, viewData) {
            viewData.enableBack = true;
        });
        
        var vm = this;

        if(window.ga !== undefined) {analyticsSrv.trackView('Registro');}

        vm.regManual = $rootScope.selae.properties.regManual;
        vm.regExpress = $rootScope.selae.properties.regExpress;

        vm.registroManual = function() {
            popupSrv.showLoading('Cargando');
            $state.go("app.registerForm"); 
        };

        vm.registroAutomatico = function() {
            newVerifytransaction();
        };

        // Paso 1: Llamamos a newTransacción para obtener token y usuario
        function newVerifytransaction() {

            var params = { 
                "tipoFlujo": "1",
                "participanteId": ""
            };

            $http.post( config.services.host + config.services.profileVerify, params)
            .then(function(e) {
                console.log(e);
                return launchSDK(e.data.response);
                
            }, function(error) {
                console.log("Error en recopilacion de datos para verificación de perfil",error);
                return popupSrv.showErrorPopup(requestSrv.errorHandler2(error));
            });
        }

        // Paso 2: Configuramos y llamamos al plugin de IECISA
        function launchSDK(user) {
            var theme = {
                button_corner_radius: 25,
                button_border_width: 1,
                button_color: "FFFFFF",
                button_border_color: "0e3f62",
                button_font_color: "0e3f62",
                header: true,
                primary_color: "0e3f62", // HEX
                secondary_color: "6A6A6A",
                tertiary_color: "000000",
                frame1_color: "FFFFFF",
                frame2_color: "0e3f62",
                frame3_color: "008000",
                title1_color: "0e3f62",
                title2_color: "000000",
                primary_font: "Futura-Bold", // Font Name
                secondary_font: "OpenSans",
                tertiary_font: "OpenSans-Semibold",
                logo_color: "logo-color",
                id_front: "id_front",
                id_back: "id_back",
                user: "user",
                tick: "tick"
            };
            var texts = {
                step_initial_info: "REGISTRO CON DNI/NIE",
                agreement_button_text: "El proceso suele durar unos 10 minutos(<i>tiempo empleado en verificar la información que nos proporcionas</i>).Al pulsar el botón aceptas las condiciones de privacidad y das tu consentimiento para grabar el contenido de la pantalla durante el proceso<br><b>PASOS:</b><br>",
                start_button: "COMENZAR",
                step_card_title_front: "Parte delantera del DNI",
                step_card_title_reverse: "Parte trasera del DNI",
                step_middle_info: "Video de tu rostro",
                agreement_button_text_video: "<br>Colócate delante de tu móvil mirando hacia la pantalla para que podamos grabar en video tu rostro.<br>",
                middle_button: "ABRIR CÁMARA",
                step_video_title: "Video del rostro",
                info_face: "Colócate delante de tu movil mirando la pantalla para que podamos tomar un video de tu rostro.",
                info_face_turn_document_anverse: "Anverso del DNI",
                info_face_turn_document: "Da la vuelta al DNI",
                step_final_info: "",
                agreement_final_text: "<b>El proceso de captura ha concluido.Ahora debes completar tu perfil.</b>",
                end_button: "CONTINUAR",
                error_button: "ABRIR CÁMARA",
                help_button: "CERRAR"
            };
            var config = {
                upload_check: true,
                bearer: dinamicBearer(),
                clean_view_stack: true,
                identifiers: ["ESP"],
                environment: "PRE",
                texts: texts,
                theme: theme,
                flow: ["initial", "info_capture_card", "capture_card_front", "capture_card_reverse", "middle", "info_capture_face", "capture_face_call", "final"],
                show_card_frame: false,
                capture_rotation: false,
                show_cancel_error: false,
                min_bitrate: 500,
                videoDuration: 12.0,
                videoMessages: false
            };

            function dinamicBearer() {
                var bearer = {
                    "int3":"3e5df3d9-51c1-3832-bb65-03fecb130155",
                    "int7":"6264c015-e79c-3d5d-9175-b8fd81ebdc30",
                    "pro": "6264c015-e79c-3d5d-9175-b8fd81ebdc30"
                };
                return bearer[selae.entorno] || "6264c015-e79c-3d5d-9175-b8fd81ebdc30";
            }

            // Para que no falle el navegador y sigamos por el mock
            if (window.cordova) {
                startSdkDob.start({ 'config': config }, { 'uid': user.userID }, {'tokenDob':user.tokenDoB},
                function () {
                    console.log("Entramos por callback de exito.");
                    var delayTime = Number($rootScope.selae.properties.registerTimer) || 1000;
                    console.log("delay time= ",delayTime);
                    popupSrv.showLoading('Comprobando datos');
                    setTimeout( function() {
                        getUserData(user); 
                    }, delayTime);
                    console.log("We finish success!!");
                },
                function (error) {
                    console.log("Entramos por callback de Error.");
                    console.log(error);
                    popupSrv.showErrorPopup("registroErrorPlugin");
                },
                {});
            } else {
                popupSrv.showLoading('Comprobando datos');
                alert('Estamos en el navegador, simulamos vuelta de plugin de IECISA');
                getUserData(user);
            }
        }

        // Paso 3 Lanzamos la petición de datos de usuario al back de SELAE
        function getUserData(user) {

            var configHeaders = {
                "headers":{
                    "Authorization": user.tokenUID
                }
            };
                $http.get( config.services.host + config.services.userDataQuery + user.userID, configHeaders)
                .then(function (e) {
                    popupSrv.hideLoading();
                    if ( e.data.code != 0 ) {
                        return popupSrv.showInfoCallabackPopup("","verifyErrorPopUp","",function() { $state.go("app.registerForm");});
                    } else {
                        navigateRegister(e.data.response);
                    }
                }, function(error) {
                    popupSrv.hideLoading();
                    popupSrv.showErrorPopup(requestSrv.errorHandler2(error));
                });
        }


            function navigateRegister (ocr) {

            var form1 = {
                "nombre" : ocr.nombre,
                "apellido1" : ocr.apellido1,
                "apellido2" : ocr.apellido2,
                "dni" : ocr.docID,
                "trt" : userGender(ocr.sexo),
                "birthdate" : formatBirthdate(ocr.fechaNacimiento),
             };

             var form2 = {
                "domicilio" : ocr.domicilio
             };

            function formatBirthdate(birthdate) {
                birthdate = birthdate.split("-");
                var birthdateData = {
                    day : Number(birthdate[2]),
                    month : {value: birthdate[1]},
                    year : Number(birthdate[0])
                };
                return birthdateData;
            }

            function userGender(gender) {
                var sexValue = {
                    "M" : 'Sr.',
                    "F" : 'Sra.'
                };
                return sexValue[gender] || sexValue.M;
            }


            var ocrData = { "user" : form1 , "adress" : form2 };
            $state.go("app.registerForm", { ocrData });
        }
}]);